	PROGRAM PORTS

C	This program is used to show the activity of
C	ports on the system. It is used to find out
C	if anyone has connected to the system and neglected
C	to disconnect after logging out.
C
C		D. Cook
C	Ball Aerospace Systems Division
C		10/9/81
C
C	Modification History:
C
C	1) 1-July-82	Added foreign command input to allow user
C			select starting bank of ports for update.
C
C

	PARAMETER NPORTS = 64

	LOGICAL LPORTS (NPORTS)
	CHARACTER*12 OWNER (NPORTS), START_BANK

	INTEGER*2	DEV_LEN, SEC_LEN
	CHARACTER*80	DEV_BUF, SEC_BUF
	BYTE		DEV_BYT(40)
	INTEGER*4	DEV_LWORD(10)

	EQUIVALENCE	(DEV_BUF, DEV_BYT)
	EQUIVALENCE	(DEV_BYT, DEV_LWORD)

	CHARACTER*6	PORT, TERM_NAME
	INTEGER		TERM_NUMBER

C	The only thing we do is look at all the ports
C	and get the PID's.

	CALL IFERR (LIB$GET_FOREIGN (START_BANK,
	1	'First port ? ', NT),
	2	'GET_FOREIGN error.')

	CALL CUPPER (START_BANK)

	N_START = TERM_NUMBER (START_BANK) - 1

D	TYPE *, START_BANK, N_START, N_STOP

100	   DO I = 1, NPORTS
	      INDEX = N_START + I
	      PORT = TERM_NAME(INDEX)
	      CALL IFERR ( SYS$GETDEV ( PORT,
	1	DEV_LEN, DEV_BUF,
	2	SEC_LEN, SEC_BUF	),
	3	'GETDEV error.')

C	If the PID is zero, the port is not allocated.
C	Therefore, we make the owner field blank and
C	set it's logical state to .false.
C	Otherwise, get the owner name and set the state
C	to .true.

	      IF (DEV_LWORD(5) .EQ. 0) THEN
		LPORTS(I) = .FALSE.
		OWNER (I) = ' '
	      ELSE
		LPORTS (I) = .TRUE.
		CALL GETOWNER (DEV_LWORD(5), OWNER (I))
	      END IF

	   END DO

C	OK, the arrays are all full of exciting info.
C	We proceed to call a routine to display it.

	   CALL PORT_DSPY (LPORTS, OWNER, NPORTS, N_START)

C1	CALL WAIT (SECS)

	GO TO 100

	END
