	PROGRAM WATCH
C
C	Little program to use the GETJPI system service to find out which
C	users are logged on the system.....
C
C	NOTES :
C		Be sure to link in the macro JPIDEF.
C
C		Note that I pause for a second before I issue a
C		broadcast message. If you have used BRDCST before
C		you may have noticed that sometimes the output is
C		garbled on a VT100 at 9600 baud. This is because
C		the VT100 is only capable of running at an effective
C		rate of about 2400 baud when in smooth scroll mode and
C		sends an XOFF to the host when it needs to catch up.
C		BRDCST bypasses the XON/XOFF checking in the terminal
C		driver !!! So......we attempt to make sure that the screen
C		can handle it by waiting.
C
C	Note : This problem seems to have been repaired in Version 3
C		of VMS. I leave this note in for future referce.
C		D. Cook		20-Sep-83
C
C
C		The file manipulation here is really atrocious and I
C		apologize. I wrote this thing quite some time ago in
C		a furious frenzy of inspiration in order to play with
C		GETJPI, little realizing the ultimate usage. The way
C		it might be more efficient would be to read in the
C		list of users to monitor and their appropriate UAF
C		info and store this all in the program rather than
C		opening and closing the files all the time. However,
C		at this time it allows for modifications to the data files
C		dynamically while the program is running.
C
C				Dave Cook
C			Ball Aerospace Systems Division
C				23-Jan-81
C
	EXTERNAL JPI$_USERNAME
	EXTERNAL SS$_NORMAL
	EXTERNAL SS$_NOMOREPROC

	INTEGER*4 SYS$GETJPI
	INTEGER*4 SYS$BRDCST
	INTEGER*4 SS$_NORMAL
	INTEGER*4 SS$_NOMOREPROC

	INTEGER*4 PID
	CHARACTER*80 STRING, USERID, TIME, LINE
	CHARACTER UAF_OWNER*20, UC_USER*12
	INTEGER*2 ITMLST (8)
	INTEGER*4 ITMLST4 (4)
	EQUIVALENCE (ITMLST, ITMLST4)

	CHARACTER*10	INTERM	/'SYS$OUTPUT'/
	CHARACTER*10	TERM

	LOGICAL USERS (64) /64*.FALSE./
	DATA IBEL /7/

	PARAMETER UAF_USERNAME_OFFSET = 1
	PARAMETER UAF_USERNAME_LEN = 12
	PARAMETER UAF_USERNAME_KEY1 = 1
	PARAMETER UAF_USERNAME_KEYLE = UAF_USERNAME_KEY1 +
     1		  UAF_USERNAME_LEN - 1
	PARAMETER UAF_OWNER_OFFSET = 127
	BYTE UAF_RECORD (255)
	EQUIVALENCE (UAF_RECORD (UAF_OWNER_OFFSET), UAF_OWNER (1: ))

C
C	Initialization section.
C
C	What we need to do is get the terminal name for the quy who
C	want's to be notified of the user status change. This will
C	be used in the SYS$BRDCST service to send him messages.
C	Then we open up the UAF from which we will get the real names
C	of the people we are monitoring. Finally, we open up the
C	file containing the user id's of the people to watch.
C
C	Use Ray Bovet's wunnerful recursive logname translator.
C	Note that input and output strings have to be identical
C	length (way to go, Ray...).
C
	IF (.NOT. LOGTRANS (INTERM,TERM,NT)) STOP 'Logtrans error.'
D	TYPE*,'TERM =',TERM(1:NT)
C
C	Open the system UAF file.
C
5	OPEN (	UNIT = 21,
	1	TYPE = 'OLD',
	2	NAME = 'SYS$SYSTEM:SYSUAF.DAT',
	3	READONLY,
	4	ORGANIZATION = 'INDEXED',
	5	SHARED,
C	6	KEY = (UAF_USERNAME_KEY1:UAF_USERNAME_KEYLE:CHARACTER),
	7	ACCESS = 'KEYED',
	8	FORM = 'UNFORMATTED',
	9	ERR = 9999 )
C
C	Request the users to search for.
C
	OPEN (	UNIT=20,
	1	TYPE='OLD',
	2	NAME='WATCH',
	3	READONLY,
	4	ERR=9998)
	IUSER = 0

C
C	This is the main watch loop.
C	Fetch the name of a(nother) user to check for...
C
10	   READ (20, 2000, END = 100) USERID
2000	   FORMAT (A)
	   NU  = NBLANK (USERID)
D	   TYPE*,' USERID =',USERID (1:NU)
	   IUSER = IUSER + 1
C
C	Read in the username from the system UAF file.
C
	   UC_USER = USERID
D	   TYPE*,'UC_USER =',UC_USER
	   READ (21, KEY=UC_USER, IOSTAT=ISTAT, ERR=9997) UAF_RECORD
	   NP = NBLANK (UAF_OWNER)
C
C	Process information item list. This is a wildcard search of
C	all the processes currently on the system. We are looking
C	for one in particular so we will scan all the processes until
C	we either run out of processes to check or have found the
C	guy we are looking for.
C
	   PID = -1
	   ICODE = 0
C
C	Loop until either user found or no more processes to search.
C
20	      STRING = ' '
	      ITMLST (1) = 80
	      ITMLST (2) = %LOC(JPI$_USERNAME)
	      ITMLST4 (2) = %LOC(STRING)
	      ITMLST4 (3) = 0
	      ITMLST4 (4) = 0

	      ICODE = SYS$GETJPI (,PID,,ITMLST,,,)
	      IF (ICODE .EQ. %LOC ( SS$_NOMOREPROC ) ) THEN
C
C	We have scanned through all the current processes and haven't found
C	the guy we were looking for. He may have been on before and has
C	logged off since the last time we checked so see if this is a change
C	of status.
C
		IF (USERS(IUSER)) THEN
C
C	He logged off since the last time we checked...Send a message.
C
		   CALL IFERR (SYS$ASCTIM (LENT, TIME,,),
	1		'Convert time error.')
		   LINE = CHAR(7)//CHAR(7)//CHAR(7)//CHAR(7)//
	1		  USERID (1:NU)//' : '//UAF_OWNER (1:NP)//
	2		  ' just logged off. '//TIME (1:LENT)
		   CALL WAIT(1.)
		   CALL IFERR (SYS$BRDCST (LINE, TERM(1:NT)),
	1		'Log off broadcast error.')
		END IF

		USERS (IUSER) = .FALSE.
		GO TO 10
C
C	Otherwise, we have found a guy on the system. See if he is
C	the guy we are looking for.
C
	      ELSE IF (STRING(1:NU) .EQ. USERID(1:NU)) THEN
C
C	Indeed he is so since he may have just logged on since the last
C	time we checked see if this is a change of status.
C
		IF (.NOT. USERS(IUSER)) THEN
C
C	He's just logged on....Send the message.
C
		   CALL IFERR (SYS$ASCTIM (LENT, TIME,,),
	1		'Convert time error.')
		   LINE = CHAR(7)//CHAR(7)//CHAR(7)//CHAR(7)//
	1		  USERID (1:NU)//' : '//UAF_OWNER (1:NP)//
	2		  ' just logged on. '//TIME (1:LENT)
		   CALL WAIT(1.)
		   CALL IFERR (SYS$BRDCST (LINE, TERM(1:NT)),
	1		'Log on broadcast error.')
		END IF

		USERS (IUSER) = .TRUE.
		GO TO 10
C
C	For any other codes from GETJPI, print them.
C
	      ELSE IF (ICODE .NE. %LOC ( SS$_NORMAL ) ) THEN
		CALL ERRMES (ICODE)
	      END IF
C
C	End of process search, get another user ID.
C
	   GO TO 20
C
C	You get here when you hit the end of file.
C
100	CONTINUE
C
C	Normal exits shouldn't cause any file problems.
C
	CLOSE (UNIT = 20, STATUS = 'SAVE')
	CLOSE (UNIT = 21)
C
C	Wait a bit and do it again.
C
	CALL IFERR (SYS$HIBER(),'Hibernate error.')
	GO TO 5

C
C	File problems.....
C
9999	STOP	'UAF file open error.'

9998	STOP	'User list file open error.'

9997	TYPE *,'UAF file read error = ', ISTAT,' Entry = ',UC_USER
	STOP

9996	STOP	'User list file read error.'

	END
