	program who
C
C	Program to give cross references between username
C	and ownername in SYSUAF file.
C
C		Dave Cook
C	Ball Aerospace Systems Division
C		4-Mar-81
C
C	Completely rewritten 28-Oct-82 to allow keyed access
C	on more fields, and more info such as node and device
C	names.
C
	include		'uafdefpar.for'
	character*12	user_guy
	character*32	user_dog
	character*1051	char_uaf_rec
	equivalence	(uaf_record, char_uaf_rec)
	logical		first		/.true./
c
c	Input the guy to search for.
c
	icode = lib$get_foreign (user_dog, 'User ? ', nu)
c
c	See if he input ctrl-Z.
c
	if (icode .eq. 98938) then
	   go to 999
	else if (icode .ne. 1) then
	   call errmes (icode)
	   go to 999
	end if
c
c	Open the sysuaf file.
c
	call open_uaf_keyed
c
c	Look for wild carded user_name.
c
	if (user_dog(1:1) .eq. '*') then
	   user_dog = user_dog(2:)
	   nu = nblank(user_dog)
50	   read (1,fmt='(q,a)',iostat=istat,err=9998,end=999)
	1	len_rec, char_uaf_rec(1:len_rec)

	   ipos = index (uaf_t_owner(1:), user_dog(1:nu))
	   if (ipos .eq. 0) go to 50

	   if(first) then
	      first = .false.
	      type 1000
1000	      format(' User ID.',T14,'Username',
	1	T47,'Node',T55,'Device',T72,'Mail stop'/)
	   end if

	   nu = nblank(uaf_t_username)
	   no = nblank(uaf_t_owner)
	   nn = nblank(uaf_t_master_node)
	   nd = ichar(uaf_t_defdev(1:1))
	   nm = nblank(uaf_t_ms)
	   type 1010, uaf_t_username(1:nu), uaf_t_owner(1:no),
	1	uaf_t_master_node(1:nn), uaf_t_defdev(2:nd),
	2	uaf_t_ms(1:nm)
1010	   format (1h , a, t14, a, t47, a, '::', t55, a, ':', t72, a)
	   go to 50
	end if
c
c	Look for user id match.
c
	user_guy = user_dog(1:12)
	call cupper (user_guy)
	read (1,keyeq=user_guy,fmt='(q, a)',iostat=istat,err=100)
	1	len_rec, char_uaf_rec(1:len_rec)

	type 1000
	nu = nblank(uaf_t_username)
	no = nblank(uaf_t_owner)
	nn = nblank(uaf_t_master_node)
	nd = ichar(uaf_t_defdev(1:1))
	nm = nblank(uaf_t_ms)
	type 1010, uaf_t_username(1:nu), uaf_t_owner(1:no),
	1	uaf_t_master_node(1:nn), uaf_t_defdev(2:nd),
	2	uaf_t_ms(1:nm)
	go to 999
c
c	Uaf read error, check for user_name if non-existant record.
c
100	if (istat .ne. 36) then
	   type*,'User id read error =',istat
	   go to 999
	end if

	read (1,keyid=6,keyge=user_guy,fmt='(q, a)',
	1	iostat=istat,err=9998)
	2	len_rec, char_uaf_rec(1:len_rec)

	ng = nblank(user_guy)
	if (user_guy(1:ng) .ne. uaf_t_owner(1:ng)) go to 999

	type 1000
	nu = nblank(uaf_t_username)
	no = nblank(uaf_t_owner)
	nn = nblank(uaf_t_master_node)
	nd = ichar(uaf_t_defdev(1:1))
	nm = nblank(uaf_t_ms)
	type 1010, uaf_t_username(1:nu), uaf_t_owner(1:no),
	1	uaf_t_master_node(1:nn), uaf_t_defdev(2:nd),
	2	uaf_t_ms(1:nm)

110	read (1,fmt='(q, a)',iostat=istat,err=9998,end=999)
	2	len_rec, char_uaf_rec(1:len_rec)

	if (user_guy(1:ng) .ne. uaf_t_owner(1:ng)) go to 999

	nu = nblank(uaf_t_username)
	no = nblank(uaf_t_owner)
	nn = nblank(uaf_t_master_node)
	nd = ichar(uaf_t_defdev(1:1))
	nm = nblank(uaf_t_ms)
	type 1010, uaf_t_username(1:nu), uaf_t_owner(1:no),
	1	uaf_t_master_node(1:nn), uaf_t_defdev(2:nd),
	2	uaf_t_ms(1:nm)
	go to 110

9998	type*,'Username read error =',istat

999	close (1)
	end

	subroutine open_uaf_keyed

	open (	unit = 1,
	1	name = 'sys$system:sysuaf.dat',
	2	type = 'old',
	3	readonly,
	4	shared,
	5	organization = 'indexed',
	6	access = 'keyed',
	7	form = 'formatted',
	9	buffercount = 2 )

	return
	end
