$!  Procedure to delete and restructure BAT$MAIL:NOTICE.TXT
$TOP:
$ SPEC = F$SEARCH("BAT$MAIL:NOTICE.TXT;*", 1)
$ IF SPEC .EQS. "" THEN $GOTO NO_NOTICE
$ WRITE SYS$OUTPUT " "
$ WRITE SYS$OUTPUT "System Notice to be deleted: "
$ WRITE SYS$OUTPUT " "
$ TYPE 'SPEC'
$ WRITE SYS$OUTPUT " "
$ INQUIRE REPLY "Do you want this notice deleted?(END to quit) "
$ IF F$EXTRACT(0,3,REPLY) .EQS. "END" THEN GOTO NO_NOTICE
$ IF .NOT. REPLY  THEN GOTO TOP
$ SET PROTECTION=(W:D) 'SPEC'
$ DELETE 'SPEC'
$ GOTO TOP
$!  All notices processed.  Now we must remove the holes from the version
$!  numbers so NOTICE can find all the files
$NO_NOTICE:
$ HIGHEST_SPEC = F$SEARCH("BAT$MAIL:NOTICE.TXT;*", 1)
$ IF HIGHEST_SPEC .EQS. "" THEN $EXIT  ! No files to process
$ HIGHEST_VERS_STRING = F$PARSE(HIGHEST_SPEC,,,"VERSION")
$ HIGHEST_VERS = F$EXTRACT( 1, F$LENGTH(HIGHEST_VERS_STRING), HIGHEST_VERS_STRING)
$ NEXT_VERS = HIGHEST_VERS - 1
$!
$RENAME_LOOP:
$ NEXT_SPEC = F$SEARCH("BAT$MAIL:NOTICE.TXT;*",1)
$ IF NEXT_SPEC .EQS. "" THEN $EXIT   ! All done
$ NEXT_VERS_STRING = F$PARSE(NEXT_SPEC,,,"VERSION")
$ VERSION = F$EXTRACT( 1, F$LENGTH(NEXT_VERS_STRING), NEXT_VERS_STRING)
$ IF VERSION .NE. NEXT_VERS THEN -
RENAME 'NEXT_SPEC' BAT$MAIL:NOTICE.TXT;'NEXT_VERS'
$ NEXT_VERS = NEXT_VERS - 1
$ GOTO RENAME_LOOP
$!
$! Title:
$!	DELNOTICE delete the current system notices
$! Facility:
$!	System Notice processing as handled by LNOTICE and NOTICE
$! Description:
$!	Procedure allows operators to selectively delete the current system
$!	notices. The notice to be deleted is displayed at the terminal and
$!	the operator is asked if it is to be deleted. The procedure runs
$!	through all the notices and the restructures the notice files.
$! Environment:
$!	DCL command interpreter
$! Author:
$!	Peter W. Maurath, 17-Sep-1980 12:58
$! Modified by:
$!	1.00 -	Orginal Version
$!	1.01 -  15-Nov-1980  Gary L. Grebus
$!		Changed SYS$MAIL to BAT$MAIL
$!
$!	1.02 - 	17-Jul-1982	Gary L. Grebus
$!		Modified for VMS 3.0.  Changed notice file name.  
$!		Rewrote file handling to use V 3.0 lexicals and 
$!		eliminated DELNOTICE.TEC.
$!
