C
C  SHELL PROGRAM TO READ VERSION 3 ACCOUNTING FILE
C  FOR INFORMATION ON THE FORMAT OF THIS FILE SEE APPENDIX C OF
C  THE VAX UTILITIES REFERENCE MANUAL
C
C  CREATED 6/83 J.A.BECK
C ****************************************************************
C
C START OF RECORD TYPES  (ACR$K_)
C
      PARAMETER ACR_PRCDEL  = 1        !PROCESS DELETED RECORD
      PARAMETER ACR_IMGDEL  = 3        !IMAGE DELETED RECORD
      PARAMETER ACR_SYSINIT = 5        !SYSTEM WAS INITIALIZED RECORD
      PARAMETER ACR_LOGFAIL = 7        !LOGIN VALIDATION FAILED
      PARAMETER ACR_PRINT   = 8        !PRINT JOB QUEUED
      PARAMETER ACR_USER    = 9        !USER-SUPPLIED DATA RECORD
      PARAMETER ACR_FILEFL  = 13       !ACCOUNTING FILE FORWARD LINK
      PARAMETER ACR_FILEBL  = 14       !ACCOUNTING FILE BACKWARD LINK
C
C END OF-RECORD TYPE-RECORD TYPE-RECORD TYPE-RECORD TYPE-RECORD TYPE-RECORD TYPE
C
!
!
C
C START OF RECORD SUBTYPES  (ACR$K_)
C
      PARAMETER ACR_INTERACT = 1      !INTERACTIVE SUBTYPE
      PARAMETER ACR_SUBPROC  = 2      !SUBPROCESS SUBTYPE
      PARAMETER ACR_DETACHED = 3      !DETACHED SUBTYPE
      PARAMETER ACR_BATCH    = 4      !BATCH PROCESS SUBTYPE
      PARAMETER ACR_NETWORK  = 5      !NETWORK SUBTYPE
C
C END OF -PROCESS SUBTYPE-PROCESS SUBTYPE-PROCESS SUBTYPE-PROCESS SUBTYPE
C
!
!
C
C START OF PACKET TYPES  (ACR$K_)
C
      PARAMETER ACR_ID       = 1       !IDENTIFICATION PACKET
      PARAMETER ACR_RESRCE   = 2       !RESOURCE PACKET
      PARAMETER ACR_IMGNAM   = 3       !IMAGE NAME PACKET
C     PARAMETER ACR_PRINT    = 8       !PRINT RESOURCE PACKET
      PARAMETER ACR_FILNAM   = 4       !FILE NAME PACKET
      PARAMETER ACR_USRDAT   = 5       !USER DATA PACKET
C
C END OF-PACKET TYPE-PACKET TYPE-PACKET TYPE-PACKET TYPE-PACKET TYPE
C
!
!
C
C START OF SIZES  (ACR$S_)
C
      PARAMETER ACR_TYPSIZ  = 7        !SIZE IN BITS OF TYPE
      PARAMETER ACR_SUBSIZ  = 4        !SIZE IN BITS OF SUBTYPE
      PARAMETER ACR_VERSIZ  = 3        !SIZE IN BITS OF VERSION
C**************NOTE**** THERE ARE NO CORRESPONDING DIGITAL SYMBOLS FOR BELOW
      PARAMETER ACR_CUSSIZ  = 1        !SIZE IN BITS OF CUSTOMER
      PARAMETER ACR_HDRSIZ  = 1        !SIZE IN BITS OF HEADER
C
C FOLLOWING ARE FOR ID PACKETS
      PARAMETER ACR_PIDSIZ  = 4        !SIZE IN BYTES OF PID
      PARAMETER ACR_OWNSIZ  = 4        !SIZE IN BYTES OF OWNER
      PARAMETER ACR_UICSIZ  = 4        !SIZE IN BYTES OF UIC
      PARAMETER ACR_PRVSIZ  = 8        !SIZE IN BYTES OF PRIVILEGE
      PARAMETER ACR_PRISIZ  = 1        !SIZE IN BYTES OF PRIORITY
      PARAMETER ACR_USRSIZ  = 2        !SIZE IN BYTES OF USERNAME OFFSET
      PARAMETER ACR_ACCSIZ  = 2        !SIZE IN BYTES OF ACCOUNT OFFSET
      PARAMETER ACR_NODSIZ  = 2        !SIZE IN BYTES OF NODENAME OFFSET
      PARAMETER ACR_TRMSIZ  = 2        !SIZE IN BYTES OF TERMINAL OFFSET
      PARAMETER ACR_JOBSIZ  = 2        !SIZE IN BYTES OF JOBNAME OFFSET
      PARAMETER ACR_JIDSIZ  = 4        !SIZE IN BYTES OF JOB ID
      PARAMETER ACR_QUESIZ  = 2        !SIZE IN BYTES OF QUEUE OFFSET
      PARAMETER ACR_ADRSIZ  = 2        !SIZE IN BYTES OF NODE ADDRESS
      PARAMETER ACR_REMSIZ  = 2        !SIZE IN BYTES OF REMOTE ID OFFSET
C ENDING OF ID PACKET SIZES
C
C END OF-SIZES-SIZES-SIZES-SIZES-SIZES-SIZES-SIZES-SIZES-SIZES-SIZES
C
!
!
C
C START OF OFFSETS  (ACR$V_)
C
      PARAMETER ACR_CUSOFF  = 15       !OFFSET BIT POSITION OF CUSTOMER
      PARAMETER ACR_SUBOFF  = 8        !OFFSET BIT POSITION OF SUBTYPE
      PARAMETER ACR_VEROFF  = 12       !OFFSET BIT POSITION OF VERSION
      PARAMETER ACR_HDROFF  = 0        !OFFSET BIT POSITION OF HEADER(PACKET)
      PARAMETER ACR_TYPOFF  = 1        !OFFSET BIT POSITION OF TYPE
C
C START OF ID PACKET OFFSETS
      PARAMETER ACR_PIDOFF  = 1        !BYTE OFFSET OF PID
      PARAMETER ACR_OWNOFF  = 5        !BYTE OFFSET OF OWNER
      PARAMETER ACR_UICOFF  = 9        !BYTE OFFSET OF UIC
      PARAMETER ACR_PRVOFF  = 13       !BYTE OFFSET OF PRIVILEGE
      PARAMETER ACR_PRIOFF  = 21       !BYTE OFFSET OF PRIORITY
C********************************************************
C DON'T BE MISLED BY THE PICTURE(FIGURE C-4) ON PAGE C-8 OF THE
C UTILITIES REFERENCE MANUAL. THE OFFSET TO USERNAME REALLY STARTS
C ON A WORD BOUNDARY AND DOESN'T CROSS AS SHOWN IN THE PICTURE.
C IF THE PICTURE WAS CORRECT THE FOLLOWING OFFSETS WOULD BE 1 LESS
      PARAMETER ACR_USROFF  = 23       !BYTE OFFSET OF USERNAME OFFSET
      PARAMETER ACR_ACCOFF  = 25       !BYTE OFFSET OF ACCOUNT OFFSET
      PARAMETER ACR_NODOFF  = 27       !BYTE OFFSET OF NODENAME OFFSET
      PARAMETER ACR_TRMOFF  = 29       !BYTE OFFSET OF TERMINAL OFFSET
      PARAMETER ACR_JOBOFF  = 31       !BYTE OFFSET OF JOBNAME OFFSET
      PARAMETER ACR_JIDOFF  = 33       !BYTE OFFSET OF JOB ID
      PARAMETER ACR_QUEOFF  = 37       !BYTE OFFSET OF QUEUE OFFSET
      PARAMETER ACR_ADROFF  = 39       !BYTE OFFSET OF NODE ADDRESS
      PARAMETER ACR_REMOFF  = 41       !BYTE OFFSET OF REMOTE ID OFFSET
C END OF ID PACKET SIZES
C
C END OF-OFFSETS-OFFSETS-OFFSETS-OFFSETS-OFFSETS-OFFSETS-OFFSETS
C
!
!
C
C
      PARAMETER MAXBYTES=700   !MAXIMUM NUMBER OF BYTES IN RECORD(EXCLUDING 
!                               HEADER) BASED ON THE WORST CASE OF IMAGE DELETED
!                               RECORD WHICH CONTAINS 3 PACKET TYPES:
!                               RESOURCE       52 BYTES
!                               IMAGE         260 BYTES
!                               ID             42 BYTES + VARIABLE DATA
!                                          NOTE: SHOULD BE DIVISIBLE BY 4
      PARAMETER LUN  = 1       !LOGICAL UNIT OF ACCOUNTING FILE
C
      INTEGER*4 SYS$ASCTIM,LOGTIME(2),QUETIM(2),BEGTIM(2)
      INTEGER*4 DIRIO,FLTIOS,VOLMNT,BUFFIO,GETCNT
      INTEGER*4 PID,PRIV(2),OWNER,PAGFLT,WSPEAK,PAGFIL
      INTEGER*4 CALC_FILSIZ,CALC_IMGSIZ,CALC_USRDATSIZ
      INTEGER*4 PRTSTS,PRTPAG,PRTQIO
      INTEGER*2 CALC_JOBSIZ,CALC_TRMSIZ,CALC_USRSIZ,CALC_ACCSIZ,
     +          CALC_NODSIZ,CALC_QUESIZ,CALC_REMSIZ
      INTEGER*2 ACCOFF,USROFF,NODOFF,TRMOFF,JOBOFF,
     +     QUEOFF,REMOFF
      BYTE PRIOR
      CHARACTER*25 TIME,LOGIN_TIME,QUEUE_TIME,BEGIN_TIME
      CHARACTER*15 TERMINAL,REMOTEID,NODENAME
      CHARACTER*255 IMAGE,FILNAM,USERDATA
      INTEGER*2 ILENGTH,ITYPE,IPACKT,IPKLEN,ITIME(4),UIC(2)
      BYTE BYT(MAXBYTES)
      INTEGER*2 IWORD(MAXBYTES/2)
      INTEGER*4 ILONG(MAXBYTES/4)
      REAL*4 FLTLNG(MAXBYTES/4)        !FLOATING LONGWORD
      INTEGER*2 GRPUIC,MEMUIC
      EQUIVALENCE (UIC(1),MEMUIC),(UIC(2),GRPUIC)
      EQUIVALENCE (BYT,IWORD,ILONG,FLTLNG)
      EQUIVALENCE (USERDATA(65:72),STYPE),(USERDATA(73:88),SPROGRAM)
      EQUIVALENCE(USERDATA(17:20),IBUFDUM),(USERDATA(21:24),IDIRDUM)
      EQUIVALENCE(USERDATA(25:28),IVOLDUM),(USERDATA(5:8),IPAGDUM)
      CHARACTER QUEDUMM*15
      EQUIVALENCE(USERDATA(50:64),QUEDUMM),(USERDATA(9:12),ICPUDUM)
C     INTEGER*4 ITIMDUM(2)
      EQUIVALENCE(USERDATA(29:36),LOGTIME)
      CHARACTER*8 JNAME
      EQUIVALENCE (USERDATA(41:48),JNAME)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C    NOW WE ADD BYRON'S STUFF
	COMMON/OVFLOW/IER
C
C
        EXTERNAL HANDLIOF      !INTEGER OVERFLOW CONDITION HANDLER
C
	INTEGER*4 SYS$BINTIM
	CHARACTER ACCOUNT*8,USERNAME*12,JOBNAME*8,QUENAME*15,
	1 PRT_NAME,PRT_QUE,STYPE*8,SPROGRAM*16,SUSER*20
C	DATA STRUCTURES FOR HASHING LISTS
	CHARACTER LLIST(1023)*12,CLIST(1023)*8
	INTEGER*4 LPOINT(0:2000),CPOINT(0:2000)
	INTEGER*4 SIZ,LSIZ,CSIZ,ISTATE,OSTATE
	REAL*8 DLOGIN,DTERM
	CHARACTER CWA(1023)*8
	CHARACTER ASC*24,ASCSTART*24
	CHARACTER QUEE(5)*12,QTEMP*12,QUES*60,PRGNAM(10)*10
	EQUIVALENCE (QUES,QUEE)
	DATA QUEE /'SYS$HI','SYS$BATCH','SYS$LO','NAS$BATCH','SYS$LIM'/
        DATA NPRNAM,PRGNAM/5,'IAC       ','SUPERTAB  ',
     *  'EASY5   ','GEOMOD    ','SYSDESIGN ',5*' '/
C		NOW DIMENSIONS FOR TOTALS
C
	REAL*8 LCP(1023),LELP(1023),LTIO(1023),LTMU(1023)
	1,LPMUC(1023),LPMUI(1023),LNMU(1023),LNMUC(1023)
	2,LNMUI(1023),LPAG(1023),LROYAL(1023),LPMU(1023)
	3,LCNT(1023)
	REAL*8 CCP(1023),CELP(1023),CTIO(1023),CTMU(1023)
	1,CPMUC(1023),CPMUI(1023),CNMU(1023),CNMUC(1023)
	2,CNMUI(1023),CPAG(1023),CROYAL(1023),CPMU(1023)
	3,CCNT(1023)
	REAL*8 DAMU(366),DACP(366),DAMUU(366),DAMUP(366),
	1 DAMUPC(366),DAMUPI(366),DAMUN(366),DAMUNC(366),
	2 DAMUNI(366),DAPAG(366),DAROYAL(366),DACNT(366)
	3 ,WKMU,WKMUS,WKMUU,MONMU,MONMUS,MONMUU
	4 ,DAPAGP(366),DAPAGN(366),DAMUIP(366),DAMUIN(366)
	5 ,DAMUBP(366),DAMUBN(366)
C
        CALL LIB$ESTABLISH(HANDLIOF)      !ESTABLISH IOF HANDLER
C
C	PREPARE FILES FOR WORK
	OPEN(UNIT=1,NAME='ACCOUNT',STATUS='OLD',RECORDTYPE='VARIABLE')
	OPEN(UNIT=2,NAME='LOGINS',STATUS='OLD')
	OPEN(UNIT=3,NAME='CWAS',STATUS='OLD')
	OPEN(UNIT=4,NAME='REPORT',STATUS='NEW')
COPEN(UNIT=9,NAME='SUMUSER',STATUS='NEW')
	OPEN(UNIT=10,NAME='SUMROYAL',STATUS='NEW')
        OPEN(UNIT=11,NAME='PGRMS.USG',STATUS='NEW')
C		NOW LOOP ON FILES BUILDING HASHING LISTS
C		FIRST DO FOR LOGINS
	ISTATE = 0
	LSIZ = 0
	SIZ = 1023
10	READ(UNIT=2,FMT=1101,END=30) USERNAME,ACCOUNT
1101	FORMAT(A9,A8)
	USERNAME(10:12) = ' '
	CALL HASH(LLIST,LPOINT,SIZ,LSIZ,USERNAME,ISTATE,OSTATE)
	I = ABS(OSTATE)
	IF(I.NE.0) THEN
		CWA(I) = ACCOUNT
	ENDIF
	GOTO 10
30	READ(UNIT=3,FMT=1101,END=40) USERNAME,ACCOUNT
	CALL HASH(CLIST,CPOINT,SIZ,CSIZ,ACCOUNT,ISTATE,OSTATE)
	GOTO 30
40	ISTATE = 1   ! ONLY RECORDS WITH VALID LOGINS WILL BE ACCEPTED
	IISTATE = 0
C		QUERY USER FOR START TIME & END TIME
C		THESE TIMES ARE ACCEPTABLE FOR TERMINATION TIMES ONLY
41	WRITE(6,1201)
1201	FORMAT('$ ENTER START TIME (CR = ALL)')
	READ (5,1102) ASC
1102	FORMAT(A)
	IF(ASC.NE.' ') THEN
		ASCSTART = ASC
	I = SYS$BINTIM(ASCSTART,LOGTIME)
	IF(.NOT.I)GOTO 41
	CALL LIB$DAY(IDAY,LOGTIME,IMIL)
	DSTART = FLOAT(IDAY) + FLOAT(IMIL)*.1157407407407D-06
	ELSE
	DSTART = 1.
	ENDIF
C		NOW DO THE SAME FOR TERMINATION
51	WRITE(6,1202)
1202	FORMAT('$ ENTER LAST TIME (CR = ALL)')
	READ (5,1102) ASC
	IF(ASC.NE.' ') THEN
	ASCSTART = ASC
	I = SYS$BINTIM(ASCSTART,LOGTIME)
	IF(.NOT.I)GOTO 51
	CALL LIB$DAY(IDAY,LOGTIME,IMIL)
	DEND = FLOAT(IDAY) + FLOAT(IMIL)*.1157407407407D-06
	ELSE
	DEND = 200000.
	ENDIF
C
C		SOME INITIAL STUFF FOR REPORTS
C
	WRITE(UNIT=10,FMT=12299)
12299	FORMAT(1H0,'Username    Account   Job_Name       Date'
	1,'         Hrs '
	1, '       Gross        Net')
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C----------------------------------------------------------------------------
C
 100  READ(LUN,16,END=60,ERR=33)ITYPE,ILENGTH,ITIME,IPACKT,IPKLEN,
     +       NCHAR,(BYT(I),I=1,NCHAR)
  16  FORMAT(8A2,Q,<NCHAR>A1)
C
C----------------------------------------------------------------------
C
      LENTOT=-4          !4 BYTE OFFSET (FROM PACKET HEADER) TO BYT ARRAY
      CALL BITMOV(ITYPE,ACR_HDROFF,ACR_HDRSIZ,IHEADR,0)
      CALL BITMOV(ITYPE,ACR_TYPOFF,ACR_TYPSIZ,IRECTP,0)
      CALL BITMOV(ITYPE,ACR_SUBOFF,ACR_SUBSIZ,ISUBTP,0)
      CALL BITMOV(ITYPE,ACR_VEROFF,ACR_VERSIZ,IVERS,0)
      CALL BITMOV(ITYPE,ACR_CUSOFF,ACR_CUSSIZ,ICUST,0)
      ISTAT=SYS$ASCTIM(,TIME,ITIME,)
C
C
C
         IF(IRECTP.EQ.ACR_PRCDEL) THEN      !PROCESS DELETED
             NUMPAK=2
         ELSEIF(IRECTP.EQ.ACR_IMGDEL) THEN  !IMAGE DELETED
             NUMPAK=3
         ELSEIF(IRECTP.EQ.ACR_SYSINIT) THEN   !SYSTEM INITIALIZED
             NUMPAK=2
         ELSEIF(IRECTP.EQ.ACR_LOGFAIL)  THEN  !LOGIN FAILED
C            NUMPAK=2
             GO TO 100
         ELSEIF(IRECTP.EQ.ACR_PRINT)   THEN   !PRINT JOB QUEUED
             NUMPAK=2
         ELSEIF(IRECTP.EQ.ACR_USER)    THEN   !USER-SUPPLIED DATA
             NUMPAK=2
         ELSEIF(IRECTP.EQ.ACR_FILEFL)  THEN   !FORWARD LINK
C            NUMPAK=1
             GO TO 100
         ELSEIF(IRECTP.EQ.ACR_FILEBL)  THEN   !BACKWARD LINK
C            NUMPAK=1
             GO TO 100
         ELSE
C
C        ERROR OCCURED PROCESSING FILE
        GO TO 100
        ENDIF
C
C
C
      NUMPRO=0           !NUMBER OF PACKETS PROCESSED
 15   CONTINUE
      NUMPRO=NUMPRO+1
      LENTOT=LENTOT+IPKLEN             !POINTER INTO BYT ARRAY
      CALL BITMOV(IPACKT,ACR_HDROFF,ACR_HDRSIZ,IPKHDR,0)
      CALL BITMOV(IPACKT,ACR_TYPOFF,ACR_TYPSIZ,IPKTYP,0)
      CALL BITMOV(IPACKT,ACR_SUBOFF,ACR_SUBSIZ,IPKSUB,0)
      CALL BITMOV(IPACKT,ACR_VEROFF,ACR_VERSIZ,IPKVER,0)
      CALL BITMOV(IPACKT,ACR_CUSOFF,ACR_CUSSIZ,IPKCUS,0)
C
C
C
        IF(IPKTYP.EQ.ACR_ID) THEN        !ID PACKET
            PID=ILONG(1)
            OWNER=ILONG(2)
            UIC(1)=IWORD(5)
            UIC(2)=IWORD(6)
            PRIV(1)=ILONG(4)
            PRIV(2)=ILONG(5)
            PRIOR=BYT(ACR_PRIOFF)
            USROFF=IWORD(12)
            ACCOFF=IWORD(13)
            NODOFF=IWORD(14)
            TRMOFF=IWORD(15)
            JOBOFF=IWORD(16)
            JOBID=ILONG(9)
            QUEOFF=IWORD(19)
            NODADR=IWORD(20)
            REMOFF=IWORD(21)
C NOW WE STILL HAVE TO MUCK AROUND BECAUSE SOME OF THIS WAS OFFSETS
C
C EXPLANATION OF UPCOMING -3 
C DIGITAL PROBABLY STARTED THEIR ARRAY AT 0 AND OURS IS AT 1 SO
C DECOFFSET+1=OUROFFSET  BUT THEN WE HAVE TO SUBTRACT 4 BYTES FOR
C THE PACKET HEADER WHICH ISN'T IN THE ARRAY
C (ALL OF OUR BYTE OFFSETS ARE DECS-3 BUT OUR BIT OFFSETS ARE IDENTICAL)
C
            IF(USROFF.GT.0) THEN
            CALC_USRSIZ=BYT(USROFF-3)
            ELSE
            CALC_USRSIZ=0
            ENDIF
C
            IF(ACCOFF.GT.0) THEN
            CALC_ACCSIZ=BYT(USROFF-3)
            ELSE
            CALC_ACCSIZ=0
            ENDIF
C
            IF(NODOFF.GT.0) THEN
            CALC_NODSIZ=BYT(NODOFF-3)
            ELSE
            CALC_NODSIZ=0
            ENDIF
C
            IF(TRMOFF.GT.0) THEN
            CALC_TRMSIZ=BYT(TRMOFF-3)
            ELSE
            CALC_TRMSIZ=0
            ENDIF
C
            IF(JOBOFF.GT.0) THEN
            CALC_JOBSIZ=BYT(JOBOFF-3)
            ELSE
            CALC_JOBSIZ=0
            ENDIF
C
            IF(QUEOFF.GT.0)THEN
            CALC_QUESIZ=BYT(QUEOFF-3)
            ELSE
            CALC_QUESIZ=0
            ENDIF
C
            IF(REMOFF.GT.0) THEN
            CALC_REMSIZ=BYT(REMOFF-3)
            ELSE
            CALC_REMSIZ=0
            ENDIF
C
C
          USERNAME=' '
          ACCOUNT=' '
          NODNAME=' '
          TERMINAL=' '
          JOBNAME=' '
          QUENAME=' '
          REMOTEID=' '
          CALL STRMOV(BYT,USROFF-2,CALC_USRSIZ,%REF(USERNAME),1)
          CALL STRMOV(BYT,ACCOFF-2,CALC_ACCSIZ,%REF(ACCOUNT),1)
          CALL STRMOV(BYT,NODOFF-2,CALC_NODSIZ,%REF(NODENAME),1)
          CALL STRMOV(BYT,TRMOFF-2,CALC_TRMSIZ,%REF(TERMINAL),1)
          CALL STRMOV(BYT,JOBOFF-2,CALC_JOBSIZ,%REF(JOBNAME),1)
          CALL STRMOV(BYT,QUEOFF-2,CALC_QUESIZ,%REF(QUENAME),1)
          CALL STRMOV(BYT,REMOFF-2,CALC_REMSIZ,%REF(REMOTEID),1)
C
        ELSEIF(IPKTYP.EQ.ACR_RESRCE) THEN    !RESOURCE PACKET
            LOGTIME(1)=ILONG(1)         !TIME IS FIRST 8 BYTES
            LOGTIME(2)=ILONG(2)
            ISTAT=SYS$ASCTIM(,LOGIN_TIME,LOGTIME,)
            ISTATUS=ILONG(3)            !STATUS
            IMGCNT=ILONG(4)             !EXECUTION COUNT OR SEQUENCE # OF IMAGE
            CPUIMG=ILONG(5)*.01         !TOTAL CPU TIME OF PROCESS OR IMAGE(SECONDS)
            PAGFLT=ILONG(6)             !PAGE FAULT COUNT
            FLTIOS=ILONG(7)             !PAGE FAULT I/O COUNT
            WSPEAK=ILONG(8)             !PEAK WORKING SET
            PAGFIL=ILONG(9)             !PEAK PAGE FILE USAGE
            DIRIO =ILONG(10)            !DIRECT I/O COUNT
            BUFFIO=ILONG(11)            !BUFFERED I/O COUNT
            VOLMNT=ILONG(12)            !NUMBER OF VOLUMES MOUNTED
C
        ELSEIF(IPKTYP.EQ.ACR_IMGNAM) THEN    !IMAGE NAME PACKET
            CALC_IMGSIZ=BYT(1)             !SIZE IN BYTES OF IMAGENAME
            CALL STRMOV(BYT,2,CALC_IMGSIZ,%REF(IMAGE),1)
C
        ELSEIF(IPKTYP.EQ.ACR_PRINT)  THEN    !PRINT RESOURCE PACKET
            PRTSTS=ILONG(1)            !STATUS OF THE PRINTER JOB
            QUETIM(1)=ILONG(2)         !TIME THE JOB WAS QUEUED
            QUETIM(2)=ILONG(3)      
            ISTAT=SYS$ASCTIM(,QUEUE_TIME,QUETIM,)
            BEGTIM(1)=ILONG(4)         !TIME THE JOB WAS STARTED
            BEGTIM(2)=ILONG(5)
            ISTAT=SYS$ASCTIM(,BEGIN_TIME,BEGTIM,)
            SYMTIM=ILONG(6)*.01        !TOTAL SYMBIONT CPU TIME
            PRTPAG=ILONG(7)            !TOTAL NUMBER OF PAGES PRINTED
            PRTQIO=ILONG(8)            !TOTAL NUMBER OF QIOS ISSUED
            GETCNT=ILONG(9)            !TOTAL NUMBER OF GETS ISSUED
C
        ELSEIF(IPKTYP.EQ.ACR_FILNAM) THEN    !FILE NAME PACKET
            CALC_FILSIZ=BYT(1)            !SIZE IN BYTES OF FILENAME
            CALL STRMOV(BYT,2,CALC_FILSIZ,%REF(FILNAM),1)
C
        ELSEIF(IPKTYP.EQ.ACR_USRDAT) THEN    !USER DATA PACKET
C
C  THE FOLLOWING IS A CASE WHERE,IF YOU COULD TAKE THE BYTE WITHOUT
C  CONSIDERING IT TO BE NEGATIVE, IT WOULD BE CORRECT. FORTRAN,HOWEVER,
C  SAYS IT SHOULD BE NEGATIVE (TOO BAD WE CAN'T HAVE UNSIGNED BYTES)
C  THIS IS WHY WE ADD 256  (COULD ALSO USE IPKLEN-5)
            CALC_USRDATSIZ=BYT(1)+256               !TOTAL COUNT OF USER DATA
            CALL STRMOV(BYT,2,CALC_USRDATSIZ,%REF(USERDATA),1)
            JOBNAME=JNAME   !IS THIS REALLY IN USERDATA????????????
            QUENAME=QUEDUMM
            VOLMNT=IVOLDUM
            PAGFLT=IPAGDUM
            BUFFIO=IBUFDUM
            DIRIO=IDIRDUM
            CPUIMG=FLOAT(ICPUDUM)*.01
            SYMTIM=CPUIMG
        ELSE
C
C   ERROR OCCURRED PROCESSING FILE
C
      ENDIF
C
C
C
      IF(NUMPRO.LT.NUMPAK) THEN
C   MORE PACKETS TO PROCESS
      ITEMP=LENTOT+1
      CALL STRMOV(BYT,ITEMP,2,IPACKT,1)
      CALL STRMOV(BYT,ITEMP+2,2,IPKLEN,1)
      CALL STRMOV(BYT,ITEMP+4,IPKLEN-4,BYT,1)
      GO TO 15
      ELSEIF(NUMPRO.EQ.NUMPAK) THEN
C PROCESS DATA  HOWEVER WANTED
C
         IF(IRECTP.EQ.ACR_PRCDEL.OR.IRECTP.EQ.ACR_IMGDEL
     +      .OR.IRECTP.EQ.ACR_SYSINIT) THEN     !ADDED TO PROC OR IMG DEL
            IF(ISUBTP.NE.ACR_BATCH)  THEN
103	CALL DDTIME(LOGTIME,ITIME,DLOGIN,DTERM,IER)
        IF(IER.NE.0) THEN
	  CPTIME = CPUIMG
	  TIOCNT = DIRIO+BUFFIO
	  TYPE *, ' GARBAGE RECORD , USERNAME=',USERNAME,' CPU =',CPTIME
	  TYPE *, ' TOTAL I/O COUNT =',TIOCNT,'   BATCH'
	  IER=0
	  GO TO 100
	ENDIF
	IF(DTERM.GT.DEND.OR.DTERM.LT.DSTART) GOTO 100  ! OUT OF BOUNDS
C		CALCULATE FRACTION
	CALL NPRIME(DLOGIN,DTERM,FRACT,IDYR)
C	CALCULATE RAW MU  AND  FACTORED MU
	CPTIME = CPUIMG
	TIOCNT = DIRIO+BUFFIO
      CALL MU(FRACT,1,CPTIME,TIOCNT,FMU,FMUP,FMUPC,FMUPI,FMUN,FMUNC,
     +        FMNUI)
C		VALID USER ?
	CALL HASH(LLIST,LPOINT,SIZ,LSIZ,USERNAME,ISTATE,OSTATE)
	IF(OSTATE.LE.0) THEN
C		USER NOT IN DATABASE REMARK AND ADD
	CALL HASH(LLIST,LPOINT,SIZ,LSIZ,USERNAME,IISTATE,OSTATE)
	OSTATE = ABS(OSTATE)
	I = OSTATE
	CWA(I) = '******'
	CALL HASH(CLIST,CPOINT,SIZ,CSIZ,CWA(I),IISTATE,III)
	TYPE *,'ILLEGAL USER -- ',USERNAME,'     NONBATCH'
	ENDIF
		I = OSTATE
		LCP(I) = LCP(I) + CPTIME/3600.
		LTIO(I) = LTIO(I) + TIOCNT
		LTMU(I) = LTMU(I) + FMU
		LPMU(I) = LPMU(I) + FMUP
		LPMUC(I) = LPMUC(I) + FMUPC
		LPMUI(I) = LPMUI(I) + FMUPI
		LNMU(I) = LNMU(I) + FMUN
		LNMUC(I) = LNMUC(I) + FMUNC
		LNMUI(I) = LNMUI(I) + FMUNI
                IF(ISUBTP.EQ.ACR_INTERACT) THEN
                   LCNT(I)=LCNT(I)+1.
                   LELP(I)=LELP(I)+DTERM-DLOGIN
                ELSE   !WAS NETWORK OR DETACHED ETC
                ENDIF
C		GOT IT BY LOGIN NOW PUT BY CWA & BY DAY
		ACCOUNT = CWA(I)
		CALL HASH(CLIST,CPOINT,SIZ,CSIZ,ACCOUNT,ISTATE,J)
		CCP(J) = CCP(J) + CPTIME/3600.
		CTIO(J) = CTIO(J) + TIOCNT
		CTMU(J) = CTMU(J) + FMU
		CPMU(J) = CPMU(J) + FMUP
		CPMUC(J) = CPMUC(J) + FMUPC
		CPMUI(J) = CPMUI(J) + FMUPI
		CNMU(J) = CNMU(J) + FMUN
		CNMUC(J) = CNMUC(J) + FMUNC
		CNMUI(J) = CNMUI(J) + FMUNI
		DAMU(IDYR) = DAMU(IDYR) + FMU
		DACP(IDYR) = DACP(IDYR) + CPTIME/3600.
                IF(ISUBTP.EQ.ACR_INTERACT) THEN
                   CCNT(J)=CCNT(J)+1.
                   CELP(J)=CELP(J)+DTERM-DLOGIN
		   DACNT(IDYR) = DACP(IDYR) + 1.
                ELSE       !NETWORK, SUB ,ETC
                ENDIF
		IF(ACCOUNT.NE.'SYSTEM'.AND.ACCOUNT.NE.'******') THEN
			DAMUU(IDYR) = DAMUU(IDYR) + FMU
			DAMUIP(IDYR) = DAMUIP(IDYR) + FMUP
			DAMUIN(IDYR) = DAMUIN(IDYR) +FMUN
			DAMUP(IDYR) = DAMUP(IDYR) + FMUP
			DAMUPC(IDYR) = DAMUPC(IDYR) + FMUPC
			DAMUPI(IDYR) = DAMUPI(IDYR) + FMUPI
			DAMUN(IDYR) = DAMUN(IDYR) + FMUN
			DAMUNC(IDYR) = DAMUNC(IDYR) + FMUNC
			DAMUNI(IDYR) = DAMUNI(IDYR) + FMUNI
		ENDIF
	GOTO 100
            ELSEIF(ISUBTP.EQ.ACR_BATCH)  THEN

102	CALL DDTIME(LOGTIME,ITIME,DLOGIN,DTERM,IER)
        IF(IER.NE.0) THEN
	  CPTIME = CPUIMG
	  TIOCNT = DIRIO+BUFFIO
	  TYPE *, ' GARBAGE RECORD , USERNAME=',USERNAME,' CPU =',CPTIME
	  TYPE *, ' TOTAL I/O COUNT =',TIOCNT,'     BATCH'
	  IER=0
	  GO TO 100
	ENDIF
	IF(DTERM.GT.DEND.OR.DTERM.LT.DSTART) GOTO 100  ! OUT OF BOUNDS
C		CALCULATE FRACTION
	CALL NPRIME(DLOGIN,DTERM,FRACT,IDYR)
C	CALCULATE RAW MU  AND  FACTORED MU
	CPTIME = CPUIMG
	TIOCNT = DIRIO+BUFFIO
	QTEMP = QUENAME(:CALC_QUESIZ)
	II = INDEX(QUES,QTEMP)
	IF(II.EQ.0) II = 13
	K = (II+11)/12
      CALL MU(FRACT,K,CPTIME,TIOCNT,FMU,FMUP,FMUPC,FMUPI,FMUN,FMUNC,
     +        FMNUI)
C		VALID USER ?
	CALL HASH(LLIST,LPOINT,SIZ,LSIZ,USERNAME,ISTATE,OSTATE)
	IF(OSTATE.LE.0) THEN
C		USER NOT IN DATABASE REMARK AND ADD
	CALL HASH(LLIST,LPOINT,SIZ,LSIZ,USERNAME,IISTATE,OSTATE)
	OSTATE = ABS(OSTATE)
	I = OSTATE
	CWA(I) = '******'
	CALL HASH(CLIST,CPOINT,SIZ,CSIZ,CWA(I),IISTATE,III)
	TYPE *,'ILLEGAL USER -- ',USERNAME
	ENDIF
		I = OSTATE
		LCP(I) = LCP(I) + CPTIME/3600.
		LTIO(I) = LTIO(I) + TIOCNT
		LTMU(I) = LTMU(I) + FMU
		LPMU(I) = LPMU(I) + FMUP
		LPMUC(I) = LPMUC(I) + FMUPC
		LPMUI(I) = LPMUI(I) + FMUPI
		LNMU(I) = LNMU(I) + FMUN
		LNMUC(I) = LNMUC(I) + FMUNC
		LNMUI(I) = LNMUI(I) + FMUNI
C		GOT IT BY LOGIN NOW PUT BY CWA & BY DAY
		ACCOUNT = CWA(I)
		CALL HASH(CLIST,CPOINT,SIZ,CSIZ,ACCOUNT,ISTATE,J)
		CCP(J) = CCP(J) + CPTIME/3600.
		CTIO(J) = CTIO(J) + TIOCNT
		CTMU(J) = CTMU(J) + FMU
		CPMU(J) = CPMU(J) + FMUP
		CPMUC(J) = CPMUC(J) + FMUPC
		CPMUI(J) = CPMUI(J) + FMUPI
		CNMU(J) = CNMU(J) + FMUN
		CNMUC(J) = CNMUC(J) + FMUNC
		CNMUI(J) = CNMUI(J) + FMUNI
		DAMU(IDYR) = DAMU(IDYR) + FMU
		DACP(IDYR) = DACP(IDYR) + CPTIME/3600.
		IF(ACCOUNT.NE.'SYSTEM'.AND.ACCOUNT.NE.'******') THEN
			DAMUU(IDYR) = DAMUU(IDYR) + FMU
			DAMUBP(IDYR) = DAMUBP(IDYR) + FMUP
			DAMUBN(IDYR) = DAMUBN(IDYR) +FMUN
			DAMUP(IDYR) = DAMUP(IDYR) + FMUP
			DAMUPC(IDYR) = DAMUPC(IDYR) + FMUPC
			DAMUPI(IDYR) = DAMUPI(IDYR) + FMUPI
			DAMUN(IDYR) = DAMUN(IDYR) + FMUN
			DAMUNC(IDYR) = DAMUNC(IDYR) + FMUNC
			DAMUNI(IDYR) = DAMUNI(IDYR) + FMUNI
		ENDIF
	GOTO 100
1111    FORMAT(1X,A,2X,12Z2)
            ENDIF
         ELSEIF(IRECTP.EQ.ACR_SYSINIT) THEN   !SYSTEM INITIALIZED
  300	TYPE *,'ILLEGAL RECORD INIT',IRECTP
	GOTO 100
         ELSEIF(IRECTP.EQ.ACR_LOGFAIL)  THEN  !LOGIN FAILED
104	CONTINUE
	GOTO 100
         ELSEIF(IRECTP.EQ.ACR_PRINT)   THEN   !PRINT JOB QUEUED
116	CALL DDTIME(QUETIM,ITIME,DLOGIN,DTERM,IER)
        IF(IER.NE.0) THEN
	  CPTIME = CPUIMG
	  TIOCNT = DIRIO+BUFFIO
	  TYPE *, ' GARBAGE RECORD , USERNAME=',USERNAME,' CPU =',CPTIME
	  TYPE *, ' TOTAL I/O COUNT =',TIOCNT,'        PRINT'
	  IER=0
	  GO TO 100
	ENDIF
	IF(DTERM.GT.DEND.OR.DTERM.LT.DSTART) GOTO 100  ! OUT OF BOUNDS
	CALL NPRIME(DLOGIN,DTERM,FRACT,IDYR)
C		VALID USER ?
	CALL HASH(LLIST,LPOINT,SIZ,LSIZ,USERNAME,ISTATE,OSTATE)
	IF(OSTATE.LE.0) THEN
C		USER NOT IN DATABASE REMARK AND ADD
	CALL HASH(LLIST,LPOINT,SIZ,LSIZ,USERNAME,IISTATE,OSTATE)
	OSTATE = ABS(OSTATE)
	I = OSTATE
	CWA(I) = '******'
	CALL HASH(CLIST,CPOINT,SIZ,CSIZ,CWA(I),IISTATE,III)
	TYPE *,'ILLEGAL USER -- ',USERNAME,'      PRINT'
	ENDIF
		LPAG(OSTATE) = LPAG(OSTATE) + PRTPAG
		LTMU(OSTATE) = LTMU(OSTATE) +PRTPAG*.10
		ACCOUNT = CWA(OSTATE)
		CALL HASH(CLIST,CPOINT,SIZ,CSIZ,ACCOUNT,ISTATE,J)
		CPAG(J) = CPAG(J) + PRTPAG
		CTMU(J) = CTMU(J) + PRTPAG*.10
		DAMU(IDYR) = DAMU(IDYR) + PRTPAG*.10
		IF(ACCOUNT.NE.'SYSTEM'.AND.ACCOUNT.NE.'******')THEN
			DAPAG(IDYR) = DAPAG(IDYR) + PRTPAG
			DAMUU(IDYR) = DAMUU(IDYR) + PRTPAG*.10
		IF(FRACT.LT..8) THEN
			DAPAGN(IDYR) = DAPAGN(IDYR) + PRTPAG*.10
			DAMUN(IDYR) = DAMUN(IDYR) + PRTPAG*.10
		ELSE
			DAPAGP(IDYR) = DAPAGP(IDYR) + PRTPAG*.10
			DAMUP(IDYR) = DAMUP(IDYR) + PRTPAG*.10
		ENDIF
		ENDIF
	GOTO 100
         ELSEIF(IRECTP.EQ.ACR_USER)    THEN   !USER-SUPPLIED DATA
117	CALL DDTIME(LOGTIME,ITIME,DLOGIN,DTERM,IER)
        IF(IER.NE.0) THEN
	  CPTIME = CPUIMG
	  TIOCNT = DIRIO+BUFFIO
	  TYPE *, ' GARBAGE RECORD , USERNAME=',USERNAME,' CPU =',CPTIME
	  TYPE *, ' TOTAL I/O COUNT =',TIOCNT,'    USER'
	  IER=0
	  GO TO 100
	ENDIF
	IF(STYPE.NE.'ROYAL'.OR.SPROGRAM.NE.'NASTRAN') GOTO 120
	IF(DTERM.GT.DEND.OR.DTERM.LT.DSTART) GOTO 100  ! OUT OF BOUNDS
	CALL NPRIME(DLOGIN,DTERM,FRACT,IDYR)
C		VALID USER ?
	CALL HASH(LLIST,LPOINT,SIZ,LSIZ,USERNAME,ISTATE,OSTATE)
	IF(OSTATE.LE.0) THEN
C		USER NOT IN DATABASE REMARK AND ADD
	CALL HASH(LLIST,LPOINT,SIZ,LSIZ,USERNAME,IISTATE,OSTATE)
	OSTATE = ABS(OSTATE)
	I = OSTATE
	CWA(I) = '******'
	CALL HASH(CLIST,CPOINT,SIZ,CSIZ,CWA(I),IISTATE,III)
	TYPE *,'ILLEGAL USER -- ',USERNAME,'       USER'
	ENDIF
		ROYAL = (SYMTIM)/(3600.)*75. !75 DOLLARS /HR
		LROYAL(OSTATE) = LROYAL(OSTATE) + ROYAL
		ACCOUNT = CWA(OSTATE)
		CALL HASH(CLIST,CPOINT,SIZ,CSIZ,ACCOUNT,ISTATE,J)
		CROYAL(J) = CROYAL(J) + ROYAL
		IF(ACCOUNT.NE.'SYSTEM'.AND.ACCOUNT.NE.'******')THEN
			DAROYAL(IDYR) = DAROYAL(IDYR) + ROYAL
			WHEN = FLOAT(IDYR) + DTERM-INT(DTERM)
			WRITE(UNIT=10,FMT=12300) USERNAME,ACCOUNT,JOBNAME,
	1		WHEN,SYMTIM/3600.,ROYAL,ROYAL
		ENDIF
12300	FORMAT(1X,A,A,2X,A,F12.4,F12.4,F12.2,F12.2)
	GOTO 100
  120   CONTINUE
        IF(STYPE.NE.'TALLY') GO TO 100
C
C       THIS SECTION PROCESSES ACCOUNTNING RECORDS WHICH WERE
C       WRITTEN TO PROVIDE USAGE DATA FOR SELECTED PROGRAMS.
C
        DO NPR=1,NPRNAM
        IF(SPROGRAM.EQ.PRGNAM(NPR)) THEN
	CALL NPRIME(DLOGIN,DTERM,FRACT,IDYR)
        CPTIME=SYMTIM
        PAGFIL=0
        TIOCNT=DIRIO+BUFFIO
	QTEMP = QUENAME(:CALC_QUESIZ)
	II = INDEX(QUES,QTEMP)
	IF(II.EQ.0) II = 13
	K = (II+11)/12
      CALL MU(FRACT,K,CPTIME,TIOCNT,FMU,FMUP,FMUPC,FMUPI,FMUN,FMUNC,
     +        FMUNI)
C		VALID USER ?
	CALL HASH(LLIST,LPOINT,SIZ,LSIZ,USERNAME,ISTATE,OSTATE)
	IF(OSTATE.LE.0) THEN
C		USER NOT IN DATABASE REMARK AND ADD
	CALL HASH(LLIST,LPOINT,SIZ,LSIZ,USERNAME,IISTATE,OSTATE)
	OSTATE = ABS(OSTATE)
	I = OSTATE
	CWA(I) = '******'
	CALL HASH(CLIST,CPOINT,SIZ,CSIZ,CWA(I),IISTATE,III)
	TYPE *,'ILLEGAL USER -- ',USERNAME
	ENDIF
        IOPRIN=TIOCNT
C
C       GET CORRECT CWA
C
        CALL HASH(LLIST,LPOINT,SIZ,LSIZ,USERNAME,IISTATE,OSTATE)
        I=OSTATE
        WRITE(11,12400) USERNAME,CWA(I),SPROGRAM,CPTIME,IOPRIN,
     *                  FMUP,FMUN
12400   FORMAT(3(2X,A,2X),F8.2,2X,I8,2(2X,F8.2))
        ENDIF
        ENDDO
        GO TO 100
         ELSEIF(IRECTP.EQ.ACR_FILEFL)  THEN   !FORWARD LINK
	GOTO 100
         ELSEIF(IRECTP.EQ.ACR_FILEBL)  THEN   !BACKWARD LINK
	GOTO 100
         ELSE
   	TYPE *,'ILLEGAL RECORD',IRECTP
	GOTO 100
C
C        ERROR OCCURED PROCESSING FILE
        ENDIF
      GO TO 100
      ELSE
      ENDIF
  60  CONTINUE
9000	CONTINUE
C		WE HAVE TOTALS FOR EVERYTHING NOW WRITE IT OUT
	WRITE(UNIT=4,FMT=12004)
12004 FORMAT(1H0,'***********  TOTALS BY LOGIN ********** ',/,
     +' USER ID     CWA      # OF   CONN     CP     I/O   PRINTED   ',
     +'BILLED ROYALTY',/,'                     LOGIN   TIME   TIME',
     +'   COUNTS  PAGES     MU     ($)',/,
     +'                             (HR)   (HR)')
	DO LL = 1,LSIZ
	IF(LTMU(LL).NE.0.) THEN
		WRITE(UNIT=4,FMT=12005)LLIST(LL),CWA(LL),LCNT(LL),
	1	LELP(LL)*24.,LCP(LL),LTIO(LL)*.001,LPAG(LL),
     +    LTMU(LL),LROYAL(LL)
	ENDIF
	ENDDO
12005 FORMAT(1X,A10,A8,F7.0,F7.2,F8.3,F8.0,F8.0,F10.3,F7.2)
      WRITE(UNIT=4,FMT=12008)
	WRITE(UNIT=4,FMT=12006)
	WRITE(UNIT=10,FMT=12301)
12006 FORMAT(1H1,'**************  TOTALS BY CWA  **************** ',/
     +'    CWA     # OF  CONN     CP     I/O   PRINTED   ',
     +'BILLED ROYALTY',/,'           LOGIN  TIME    TIME',
     +'   COUNTS  PAGES     MU      ($)',/,
     +'                  (HR)    (HR)')
12301	FORMAT(1H1,' NASTRAN ROYALTY TOTALS BY CWA')
	DO I=1,CSIZ
	IF(CTMU(I).NE.0.) THEN
		WRITE(UNIT=4,FMT=12007)CLIST(I),CCNT(I),CELP(I)*24.,
	1	CCP(I),CTIO(I)*.001,CPAG(I),CTMU(I),CROYAL(I)
12007 FORMAT(1X,A8,F7.0,F7.2,F8.3,F8.0,F8.0,F10.3,F7.2)
12008 FORMAT(1X,'$$END$$')
		IF(CROYAL(I).NE.0.) WRITE(UNIT=10,FMT=12012)CLIST(I),CROYAL(I)
12012	FORMAT(1X,A8,F12.2)
	ENDIF
	ENDDO
C		NOW DO REPORT BY DAY
	ID = THISYR + 4
	WRITE(UNIT=4,FMT=12110)
C		ID IS DAY OF WEEK FOR DAY ONE ON REPORT
	DO I=1,366
	WKMU = WKMU+DAMU(I)
	MONMU = MONMU +DAMU(I)
	WKMUS = WKMUS + (DAMU(I)-DAMUU(I))
	MONMUS = MONMUS + (DAMU(I)-DAMUU(I))
	WKMUU = WKMUU + DAMUU(I)
	MONMUU = MONMUU + DAMUU(I)
	IF(DAMU(I).NE.0.)WRITE(UNIT=4,FMT=12100)I,DACP(I)
	1,DAMU(I),DAMU(I)-DAMUU(I),DAMUU(I),DAMUP(I)
	1,DAMUPC(I),DAMUPI(I),DAPAGP(I)
	1,DAMUN(I),DAMUNC(I),DAMUNI(I)
	1,DAPAGN(I)
	1,DAMUIP(I),DAMUBP(I),DAMUIN(I),DAMUBN(I)
	IF(MOD(ID,7).EQ.6) THEN
		IF(WKMU.NE.0)WRITE(UNIT=4,FMT=12101) WKMU,WKMUS,WKMUU
	1,MONMU,MONMUS,MONMUU
		WKMUU = 0.
		WKMU = 0.
		WKMUS = 0.
	ENDIF
	ID = ID + 1
	ENDDO
	IF(WKMUU.NE.0.) WRITE(UNIT=4,FMT=12101) WKMU,WKMUS,WKMUU,
	1 MONMU,MONMUS,MONMUU
12100	FORMAT(1X,I4,16F8.2)
12110	FORMAT(1H1,' TOTALS BY DAY AND TYPE ',/
	1,1X,'DAY   CP-HRS  TOT-MU  SYS-MU USER-MU   MU-P'
	1,'    MU-PC   MU-PI   MU-PP   MU-N    MU-NC   MU-NI'
	1,'   MU-NP   MU-INP  MU-BP   MU-INN  MU-BN')
12101	FORMAT(1H0,'WEEK TOTALS',3F10.3,'    MONTH TOTALS',3F10.3//)
      STOP
 33   TYPE 44,ITYPE,ILENGTH
 44    FORMAT( 'ERROR READING TYPE=',I6,5X,'LENGTH=',I6)
      GO TO 100
  50  WRITE(5,70)
  70  FORMAT(' ERROR OPENING FILE')
      END
