$!*****************************************************************************
$!*  This command procedure installs the utility EDIRECTORY.  The object      *
$!*  library, executable module, and command definition file are copied to    *
$!*  the logical device USR:.  If this logical name does not currently exist, *
$!*  you must either create one, or change all references of USR: to a valid  *
$!*  logical device on your system.                                           *
$!*                                                                           *
$!*  Additionally, this command procedure should reside in the same directory *
$!*  as the object library, executable module, etc., as no device or          *
$!*  directory name are specified in the copy.                                *
$!*****************************************************************************
$!
$! Check to see that USR is defined on this system.
$!
$ check_for_usr:
$	if "''f$logical ("USR")'" .nes. "" then -
		goto link_EDIR
$!
$	type sys$input
Logical device USR is not defined - contact your System Manager!!!
$!
$	goto get_out
$!
$!
$ link_edir:
$	on error then -
		goto link_error
$!
$	write sys$output "***  EDIRECTORY is currently being linked  ***"
$	current_uic	= f$user()
$	set uic [1,4]
$	link/notrace/exe=usr:edir.exe EDIRMAIN,EDIR.OLB/LIB
$	goto copy_edir_files
$!
$	link_error:
$		type sys$input:

An error while linking the EDIRECTORY module.  Contact your system manager!!!
$		goto get_out
$!
$!
$ copy_edir_files:
$	on error then -
		goto copy_error
$!
$	write sys$output "***  EDIRECTORY files are being copied  ***"
$	copy EDIRMAIN.OBJ,EDIR.OLB,EDIR.CLD USR:*.*
$	goto insert_help
$!
$	copy_error:
$		type sys$input
An error while copying the EDIRECTORY files.  Verify that all files are 
present, and contact your system manager.
$!
$!
$ insert_help:
$	on error then -
		goto help_error
$!
$	write sys$output "***  System help library is being updated  ***"
$	copy EDIR.HLP SYS$HELP
$	libr/ins SYS$HELP:HELPLIB.HLB SYS$HELP:EDIR.HLP
$	goto set_edir_command
$!
$	help_error:
$		type sys$input
An error while updating the system help library with the EDIRECTORY help file.
Contact your system manager.
$!
$!
$ set_edir_command:
$	set command USR:EDIR.CLD
$!
$	type sys$input

The EDIRECTORY utility has been installed, and the verb EDIRECTORY is active 
for this process.  In order for EDIR to be available to all users, the 
following line must be added to the site-wide login command procedure
(SYSLOGIN.COM):

"$ SET COMMAND USR:EDIR.CLD		! Set up EDIR verb in the DCL tables"

If you used a logical device other than USR, then it should be substituted in
the above statement also.

A help file for EDIR was copied to SYS$HELP, and installed in the system help
library.  If you do not wish EDIR to be available to all personnel, you
should remove the help from the system help library.

Good EDIRECTORing, and should troubles arise, remember Luke 23:34!
$!
$ get_out:
$	set uic 'current_uic'
$	exit
