$!*****************************************************************************
$!*  This command procedure installs the utility SCOPY.  The object library,  *
$!*  executable module, and command definition file are copied to the logical *
$!*  device USR:.  If this logical name does not currently exist, you must    *
$!*  either create one, or change all references of USR: to a valid logical   *
$!*  device on your system.                                                   *
$!*                                                                           *
$!*  Additionally, this command procedure should reside in the same directory *
$!*  as the object library, executable module, etc., as no device or          *
$!*  directory name are specified in the copy.                                *
$!*****************************************************************************
$!
$! Check to see that USR is defined on this system.
$!
$ check_for_usr:
$	if "''f$logical ("USR")'" .nes. "" then -
		goto link_scopy
$!
$	type sys$input
Logical device USR is not defined - contact your System Manager!!!
$!
$	goto get_out
$!
$!
$ link_scopy:
$	on error then -
		goto link_error
$!
$	write sys$output "***  SCOPY is currently being linked  ***"
$	current_uic	= f$user()
$	set uic [1,4]
$	link/notrace/exe=usr:scopy.exe SCOPYMAIN,SCOPY.OLB/LIB
$	goto copy_scopy_files
$!
$	link_error:
$		type sys$input:

An error while linking the SCOPY module.  Contact your system manager!!!
$		goto get_out
$!
$!
$ copy_scopy_files:
$	on error then -
		goto copy_error
$!
$	write sys$output "***  SCOPY files are being copied  ***"
$	copy SCOPYMAIN.OBJ,SCOPY.OLB,SCOPY.CLD USR:*.*
$	goto insert_help
$!
$	copy_error:
$		type sys$input
An error while copying the scopy files.  Verify that all files are present, and
contact your system manager.
$!
$!
$ insert_help:
$	on error then -
		goto help_error
$!
$	write sys$output "***  System help library is being updated  ***"
$	copy SCOPY.HLP SYS$HELP
$	libr/ins SYS$HELP:HELPLIB.HLB SYS$HELP:SCOPY.HLP
$	goto set_scopy_command
$!
$	help_error:
$		type sys$input
An error while updating the system help library with the SCOPY help file.
Contact your system manager.
$!
$!
$ set_scopy_command:
$	set command USR:SCOPY.CLD
$!
$	type sys$input

The SCOPY utility has been installed, and the verb SCOPY is active for this
process.  In order for SCOPY to be available to all users, the following
line must be added to the site-wide login command procedure (SYSLOGIN.COM):

"$ SET COMMAND USR:SCOPY.CLD		! Set up SCOPY verb in the DCL tables"

If you used a logical device other than USR, then it should be substituted in
the above statement also.

A help file for SCOPY was copied to SYS$HELP, and installed in the system help
library.  If you do not wish SCOPY to be available to all personnel, you
should remove the help from the system help library.

Good SCOPYing, and should troubles arise, remember Luke 23:34!
$!
$ get_out:
$	set uic 'current_uic'
$	exit
