$!*****************************************************************************
$!*  This command procedure installs the utility SORCERER.  The object        *
$!*  library, executable module, and command definition file are copied to    *
$!*  the logical device USR:.  If this logical name does not currently exist, *
$!*  you must either create one, or change all references of USR: to a valid  *
$!*  logical device on your system.                                           *
$!*                                                                           *
$!*  Additionally, this command procedure should reside in the same directory *
$!*  as the object library, executable module, etc., as no device or          *
$!*  directory name are specified in the copy.                                *
$!*****************************************************************************
$!
$! Check to see that USR is defined on this system.
$!
$ check_for_usr:
$	if "''f$logical ("USR")'" .nes. "" then -
		goto link_sorc
$!
$	type sys$input
Logical device USR is not defined - contact your System Manager!!!
$!
$	goto get_out
$!
$!
$ link_sorc:
$	on error then -
		goto link_error
$!
$	write sys$output "***  SORCERER is currently being linked  ***"
$	current_uic	= f$user()
$	set uic [1,4]
$	link/notrace/exe=usr:sorcerer.exe SORCERER,SORCERER.OLB/LIB
$	goto copy_sorc_files
$!
$	link_error:
$		type sys$input:

An error while linking the SORCERER module.  Contact your system manager!!!
$!
$		goto get_out
$!
$!
$ copy_sorc_files:
$	on error then -
		goto copy_error
$!
$	write sys$output "***  SORCERER files are being copied  ***"
$	copy SORCERER.OBJ,SORCERER.OLB,SORCERER.CLD USR:*.*
$	goto insert_help
$!
$	copy_error:
$		type sys$input

An error while copying the SORCERER files.  Verify that all files are 
present, and contact your system manager.
$!
$		goto get_out
$!
$!
$ insert_help:
$	on error then -
		goto help_error
$!
$	write sys$output "***  System help library is being updated  ***"
$	copy SORCERER.HLP SYS$HELP
$	libr/ins SYS$HELP:HELPLIB.HLB SYS$HELP:SORCERER.HLP
$	goto set_up_tab_files
$!
$	help_error:
$		type sys$input

An error occurred while updating the system help library with the SORCERER help
file.  Contact your system manager.
$!
$		goto get_out
$!
$!
$ set_up_tab_files:
	on error then -
		goto tab_error
$!
$	write sys$output "Setting up SORCERER's default tab files"
$	copy *.tab usr:*.*
$	assign/system usr:sorcerdef.tab	SORC$DEFTAB
$	assign/system usr:sorcercob.tab	SORC$COBTAB
$	goto set_sorc_command
$!
$	tab_error:
$		type sys$input

An error occurred while trying to set up SORCERER'S tab files.  Contact your
system manager.
$!
$		goto get_out
$!
$!
$ set_sorc_command:
$	set command USR:SORCERER.CLD
$!
$	type sys$input

The SORCERER utility has been installed, and the verb SORCERER is active 
for this process.  In order for SORCERER to be available to all users, the 
following line must be added to the site-wide login command procedure
(SYSLOGIN.COM):

"$ SET COMMAND USR:SORCERER.CLD	      ! Set up SORCERER verb in the DCL tables"

If you used a logical device other than USR, then it should be substituted in
the above statement also.

A help file for sorc was copied to SYS$HELP, and installed in the system help
library.  If you do not wish SORCERER to be available to all personnel, you
should remove the help from the system help library.

Good sorcerering, and should troubles arise, remember Luke 23:34!
$!
$ get_out:
$	set uic 'current_uic'
$	exit
