$!***************************************************************************
$!									    *
$!  COPYRIGHT (c) 1983                                                      *
$!  By TECHNOLOGY DEVELOPMENT OF CALIFORNIA, INCORPORATED.		    *
$!     Defense Systems Group						    *
$!     624 Six Flags Drive, 						    *
$!     Arlington, Tx.							    *
$!     76012								    *
$!     (817) 461-1242							    *
$! 									    *
$!  THIS SOFTWARE IS FURNISHED WITHOUT LICENSE AND MAY BE USED AND  COPIED  *
$!  ONLY WITH THE INCLUSION OF THE ABOVE COPYRIGHT NOTICE.		    *
$! 									    *
$!  THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE  WITHOUT  NOTICE  *
$!  AND  SHOULD  NOT  BE  CONSTRUED  AS  A COMMITMENT BY T.D.C.		    *
$! 									    *
$!  TECHNOLOGY DEVELOPMENT OF CALIFORNIA ASSUMES NO RESPONSIBILITY FOR THE  *
$!  USE OR RELIABILITY OF THIS SOFTWARE. 				    *
$!									    *
$!***************************************************************************
$ SAVE_VERIF = 'F$VERIFY(0)'
$ !
$ ! This module called by SNAPSHOT.COM reads the file SYS$SNAP:SNAPFIL.LST
$ ! to get the list of file throughout the system that you wish monitored.
$ ! Files to be monitored should be added to SYS$SNAP:SNAPFILE.LST
$ !
$ OPEN SNAP_FILES SYS$SNAP:SNAPFIL.LST		!Open the File of files
$ OPEN/WRITE SNAP_OUT SYS$SNAP:SNAPFIL.OLD	!Open the output file
$ OOPS_COUNT = 0				!Error count (so who's counting?)
$ !
$READ_LOOP:
$ READ/END=DONE SNAP_FILES LINE			!Get a file name
$ LEN = 'F$LENGTH(LINE)	
$ NAME = F$EXTRACT(0,LEN,LINE)			!Extract the name
$ FULL_NAME = F$SEARCH(NAME)			!See if the file exists
$ IF FULL_NAME .EQS. "" THEN GOTO OOPS		!If not go to 'OOPS'
$   PROT = F$FILE_ATTRIBUTES(FULL_NAME,"PRO")	!Extract the protection code
$   REV_DATE = F$FILE_ATTRIBUTES(FULL_NAME,"RDT") !Extract revision date
$ !
$ ! If the file being checked is SYSUAF don't include the revision date since
$ ! any time the MAIL utility is accessed it updates the SYSUAF file.
$ !
$   IF "''NAME'" .EQS. "SYS$SYSTEM:SYSUAF.DAT" THEN REV_DATE = ""
$     WRITE SNAP_OUT "     FILE NAME~FILE PROTECTION~REVISION-DATE"
$     WRITE SNAP_OUT "''NAME'~''PROT'~''REV_DATE'"!Write file name,protection,
$     GOTO READ_LOOP				!and revision date then continue
$ !
$ ! At this point you have asked me to check the protection of a file which
$ ! I cannot find. Make a note of it and notify SNAP$RECIPIENT.
$ !
$OOPS:
$ IF OOPS_COUNT .EQ. 0 THEN OPEN/WRITE OOPS_FILE SYS$SNAP:SNAPOOP.TMP
$ OOPS_COUNT = OOPS_COUNT + 1
$ WRITE OOPS_FILE "Could not find ''NAME' where you said it was..."
$ GOTO READ_LOOP
$ !
$DONE:
$ CLOSE SNAP_OUT				!Close output file
$ CLOSE SNAP_FILES				!Close input file
$ IF OOPS_COUNT .EQ. 0 THEN EXIT		!if no errors... exit
$   CLOSE OOPS_FILE				  !else write a note...
$   MAIL/SUBJECT="SNAPSHOT FILE_CHECK ERROR" SYS$SNAP:SNAPOOP.TMP SNAP$RECIPIENT
$   DELETE/NOCONFIRM SYS$SNAP:SNAPOOP.TMP;0
$   EXIT
