$ SET NOVERIFY
$!***************************************************************************
$!									    *
$!  COPYRIGHT (c) 1983                                                      *
$!  By TECHNOLOGY DEVELOPMENT OF CALIFORNIA, INCORPORATED.		    *
$!     Defense Systems Group						    *
$!     624 Six Flags Drive, 						    *
$!     Arlington, Tx.							    *
$!     76012								    *
$!     (817) 461-1242							    *
$! 									    *
$!  THIS SOFTWARE IS FURNISHED WITHOUT LICENSE AND MAY BE USED AND  COPIED  *
$!  ONLY WITH THE INCLUSION OF THE ABOVE COPYRIGHT NOTICE.		    *
$! 									    *
$!  THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE  WITHOUT  NOTICE  *
$!  AND  SHOULD  NOT  BE  CONSTRUED  AS  A COMMITMENT BY T.D.C.		    *
$! 									    *
$!  TECHNOLOGY DEVELOPMENT OF CALIFORNIA ASSUMES NO RESPONSIBILITY FOR THE  *
$!  USE OR RELIABILITY OF THIS SOFTWARE. 				    *
$!									    *
$!***************************************************************************
$ !
$ !	Called by SNAPSHOT
$ !
$ !
$ SET NOON
$ TEST = F$SEARCH("SYS$SNAP:SNAPLFAIL.DAT")		!Data file created?
$ IF TEST .NES. "" THEN GOTO DATA_FILE_EXISTS
$   CREATE/FDL=SYS$SNAP:SNAPLFAIL.FDL SYS$SNAP:SNAPLFAIL.DAT !Create ISAM file
$   INIT_DATE = F$TIME()				   
$   SP = F$LOCATE(" ",INIT_DATE)		!Locate the space after the yr.
$   INIT_DATE[SP,1] := ":"			!Replace space with ':'
$ !
$   OPEN/READ/WRITE/ERROR=OUT USER SYS$SNAP:SNAPLFAIL.DAT
$   WRITE USER "****DATE****''INIT_DATE'"		!Initialize data file
$   MAIL/SUBJECT="SYS$SNAP:SNAPLFAIL.DAT file created" SYS$INPUT SNAP$RECIPIENT
                This file is created the first time that the SNAPSHOT
                procedure is run. Once created, it will hold the date
                and time of the last  Logfail check along with a list
                of the fat-fingered people on your System.
$   CLOSE USER
$ !
$DATA_FILE_EXISTS:
$ CURRENT_DATE := 'F$TIME()			!Get current date and time
$ SP = F$LOCATE(" ",CURRENT_DATE)		!Locate the space after the yr.
$ CURRENT_DATE[SP,1] := ":"			!Replace space with ':'
$ !
$ OPEN/READ/WRITE/ERROR=OUT USER SYS$SNAP:SNAPLFAIL.DAT
$ READ/ERROR=READ_ERROR/END_OF_FILE=EOF/KEY="****DATE****" USER FILE !Read date
$ PREV_DATE := 'F$EXTRACT(12,23,FILE)		!Extract date of previous run
$ !
$ ACCOUNTING/OUTPUT=SYS$SNAP:LOGFAIL.TMP/TYPE=LOGFAIL/SUMMARY -
            /BEFORE='CURRENT_DATE'/SINCE='PREV_DATE' !Check for log-fails
$ !
$ READ/DELETE/KEY="****DATE****" USER FILE	!Delete 'previous' date
$ WRITE USER "****DATE****''CURRENT_DATE'"	!Write in 'current' date for
$						! next time.
$ MAIL_FLAG = 0					!Initialize Mail flag
$ !
$ OPEN FAIL SYS$SNAP:LOGFAIL.TMP		!Open the log-fail file
$ READ/END_OF_FILE=CHECK_FINISHED FAIL RECORD	!Sluff
$ READ/END_OF_FILE=CHECK_FINISHED FAIL RECORD	!  Log fail
$ READ/END_OF_FILE=CHECK_FINISHED FAIL RECORD	!     file
$ READ/END_OF_FILE=CHECK_FINISHED FAIL RECORD	!        headings
$ !
$LOGLOOP:
$ READ/END_OF_FILE=CHECK_FINISHED FAIL RECORD	!Read a log-fail entry
$ NAME[0,12] := "''F$EXTRACT( 0, 12, RECORD)"	!Extract the Username
$ FAIL_ATMPS = F$INTEGER('F$EXTRACT(12, 21, RECORD)) !Extract total logfails
$ !
$   READ/ERROR=KEY_NOT_FOUND/KEY="''NAME'" USER LINE !Read User from datafile
$   MARK = F$LOCATE("-",LINE)			!Find marker
$   OFFSET = MARK - 12				!Calculate offset value 
$   FAIL_SUM = F$INTEGER('F$EXTRACT(12,OFFSET,LINE)) !Extract total logfails
$   FAIL_COUNT = F$INTEGER('F$EXTRACT(MARK+1,999,LINE)) !Extract interval count
$ !
$   FAIL_AVG = FAIL_SUM / FAIL_COUNT		!Calculate new average
$ !
$   FAIL_TOTAL = FAIL_SUM + FAIL_ATMPS		!Calculate new sum
$   COUNT_TOTAL = FAIL_COUNT + 1		!Bump interval count by one
$ !
$   IF FAIL_ATMPS .LE. FAIL_AVG THEN GOTO CONTINUE !Current fail > AVG fail?
$     MAIL_FLAG = MAIL_FLAG + 1			!We have 'output'
$     IF MAIL_FLAG .GE. 2 THEN GOTO WRITE_MAIL	!First time thru?
$	OPEN/WRITE MAIL SYS$SNAP:MAIL.TMP	!Create output file
$ !
$	WRITE MAIL "    Name    Fail Avg.   Actual Fail"
$	WRITE MAIL " "
$ !
$WRITE_MAIL:					!Note offender
$     WRITE MAIL "''NAME'     ''FAIL_AVG'           ''FAIL_ATMPS'"
$ !
$CONTINUE:
$     READ/DELETE/KEY="''NAME'" USER LINE	!Delete old values for user
$ !
$ !	           User   Log fail total  'Interval' total
$ !
$     WRITE USER "''NAME' ''FAIL_TOTAL'-''COUNT_TOTAL'"	!Replace with current
$ !
$ GOTO LOGLOOP					!Go check the next user
$ !
$KEY_NOT_FOUND:					!New offender, add to datafile
$ WRITE USER "''NAME' ''FAIL_ATMPS'-1"
$ !
$ GOTO LOGLOOP					!Go check the next user
$ !
$READ_ERROR:					!Should not get this error
$ MAIL/SUBJECT="SYS$SNAP:SNAPLFAIL.DAT initialization failure" SYS$INPUT SNAP$RECIPIENT
           The date of the last Logfail check is missing from SNAPLFAIL.DAT. 
           This should have been created when the SNAPLFAIL.DAT file was created.
$ GOTO LOGLOOP
$ !
$OUT:						!Can't open the data file
$ CLOSE USER
$ EXIT
$ !
$EOF:
$ CLOSE USER
$ EXIT
$ !
$CHECK_FINISHED:				!All users checked
$ CLOSE FAIL					!Close logfail file
$ CLOSE USER					!Close datafile
$ IF MAIL_FLAG .EQ. 0 THEN GOTO ACCOUNT_CHECK	!Do we have something to tell
$   CLOSE MAIL
$   MAIL/SUBJECT="EXCESSIVE SYSTEM LOG-FAIL ENTRIES" SYS$SNAP:MAIL.TMP SNAP$RECIPIENT
$   DELETE/NOCONFIRM SYS$SNAP:MAIL.TMP;0
$ !
$ ! Now let make sure that the Users we have in the Log-fail datafile still
$ ! have accounts on the System.
$ !
$ACCOUNT_CHECK:
$ OPEN/READ/WRITE/ERROR=OUT USER SYS$SNAP:SNAPLFAIL.DAT !Open datafile
$ OPEN/READ/ERROR=LOCKED/SHARE=READ  UAF  SYS$SYSTEM:SYSUAF.DAT !Open SYSUAF
$ !
$ACCOUNT_LOOP:
$ READ/END_OF_FILE=FINI USER RECORD		!Read from the datafile
$ NAME[0,12]:= "''F$EXTRACT( 0, 12, RECORD)"	!Pull out the username
$ IF (NAME .EQS. "****DATE****") .OR. (NAME .EQS. "<login>     ") THEN GOTO ACCOUNT_LOOP
$ READ/ERROR=ACCOUNT_REMOVED/KEY="''NAME'" UAF UAF_REC !Read from SYSUAF
$ !
$ ! If the 'read' was sucessful, the User exists in SYSUAF, therefore continue
$ !
$ GOTO ACCOUNT_LOOP
$ !
$ACCOUNT_REMOVED:				!Error return = No user in SYSUAF
$ READ/DELETE/KEY="''NAME'" USER RECORD		!Well if SYSUAF doesn't want 
$						! him, we don't either.
$ GOTO ACCOUNT_LOOP
$ !
$FINI:
$ CLOSE UAF
$ !
$LOCKED:
$ CLOSE USER
$ DELETE/NOCONFIRM SYS$SNAP:LOGFAIL.TMP;0
$ !
$ EXIT
