$ SAVE_VERIF = 'F$VERIFY(0)'
$!***************************************************************************
$!									    *
$!  COPYRIGHT (c) 1983                                                      *
$!  By TECHNOLOGY DEVELOPMENT OF CALIFORNIA, INCORPORATED.		    *
$!     Defense Systems Group						    *
$!     624 Six Flags Drive, 						    *
$!     Arlington, Tx.							    *
$!     76012								    *
$!     (817) 461-1242							    *
$! 									    *
$!  THIS SOFTWARE IS FURNISHED WITHOUT LICENSE AND MAY BE USED AND  COPIED  *
$!  ONLY WITH THE INCLUSION OF THE ABOVE COPYRIGHT NOTICE.		    *
$! 									    *
$!  THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE  WITHOUT  NOTICE  *
$!  AND  SHOULD  NOT  BE  CONSTRUED  AS  A COMMITMENT BY T.D.C.		    *
$! 									    *
$!  TECHNOLOGY DEVELOPMENT OF CALIFORNIA ASSUMES NO RESPONSIBILITY FOR THE  *
$!  USE OR RELIABILITY OF THIS SOFTWARE. 				    *
$!									    *
$!***************************************************************************
$ !
$ ! Let's be SURE that we're not going to echo all this stuff to the
$ ! printer
$ !
$ IF "''F$MODE()'" .EQS. "BATCH" THEN $SET NOVERIFY
$ !
$ ! This is a 'Let's see what's changed on the System that maybe shouldn't
$ !            have' program.
$ !
$ !	Written by: Eric S. Zipp
$ !	Date      : 3/16/83
$ !     Date      : 3/26/83  (rrw) minor mod; added set to noverify
$ !     Date      : 7/6/83   added /CONFIG  and /ADAPTER to SYSGEN,
$ !                          no Rev-date for SYSUAF.DAT
$ !
$ ! This command  file  is  executed  at  periodic  intervals  and   will  run
$ ! a  'current'  listing  of  the  images  which are INSTALLED  on the System
$ ! as  well  as  lists  of the LOGICAL symbols (Group/System)  and  currently
$ ! defined  SYMBOLS  (/ALL/GLOABL) into two files INSTALL.DAT and SYMLOG.DAT.
$ ! The  SNAPREFMT.COM  file takes the 'full' Install listing and  trims  it so
$ ! that only the 'file ID' line of information and any 'Installed Privileges'
$ ! information is   written  to a  new  file  SNAPINS.OLD.  The SNAPCHECK.COM
$ ! program, in each case will compair the new .OLD file with the previous .OLD
$ ! file and check for differences. If any are found, the SNAP$RECIPIENT will
$ ! be notified by MAIL that a difference was detected.
$ !
$ !
$ !DEFINE SYS$SNAP SYS$SYSROOT:[SYSMGR.SNAP]	!Example SYS$SNAP definition
$ !
$ SYM := 'F$LOGICAL("SNAP$RECIPIENT")		!Is SNAP$RECIPIENT defined?
$ IF SYM .NES. "" THEN GOTO CHECK_SYM
$   DEFINE SNAP$RECIPIENT SYSTEM		!Define where the Mail is to go
$ !
$CHECK_SYM:
$ SYM := 'F$LOGICAL("SYS$SNAP")			!Is SYS$SNAP defined?
$ IF SYM .NES. "" THEN GOTO CONTINUE
$   MAIL/SUBJECT="SYS$SNAP: SYMBOL" SYS$INPUT SNAP$RECIPIENT
            The Logical symbol SYS$SNAP: must be defined to the area in which
            the SNAPSHOT files are to reside prior to running the command file.
$ EXIT
$ !
$CONTINUE:
$ @SYS$SNAP:SNAPINS/OUTPUT=SYS$SNAP:SNAPINS.DAT	!Get 'installed' images then
$ @SYS$SNAP:SNAPREFMT				!keep only file-names and priv.
$ @SYS$SNAP:SNAPCHECK SNAPINS			!Check for differences
$ !
$ @SYS$SNAP:SNAPSYM/OUTPUT=SYS$SNAP:SNAPSYM.OLD	!Get current defined symbols
$ @SYS$SNAP:SNAPCHECK SNAPSYM			!Check for differences
$ !
$ @SYS$SNAP:SNAPLOG/OUTPUT=SYS$SNAP:SNAPLOG.OLD	!Get current defined logicals
$ @SYS$SNAP:SNAPCHECK SNAPLOG			!Check for differences
$ !
$ @SYS$SNAP:SNAPDEV/OUTPUT=SYS$SNAP:SNAPDEV.OLD	!Get device protections
$ @SYS$SNAP:SNAPCHECK SNAPDEV			!Check for differences
$ !
$ @SYS$SNAP:SNAPGEN/OUTPUT=SYS$SNAP:SNAPGEN.OLD	!Get sysgen parameters
$ @SYS$SNAP:SNAPCHECK SNAPGEN			!Check for differences
$ !
$ @SYS$SNAP:SNAPUAF/OUTPUT=SYS$SNAP:SNAPUAF.OLD	!Get SYSUAF list
$ @SYS$SNAP:SNAPCHECK SNAPUAF			!Check for differences
$ !
$ @SYS$SNAP:SNAPFIL				!Get files to be checked
$ @SYS$SNAP:SNAPCHECK SNAPFIL			!Check for differences
$ !
$ @SYS$SNAP:SNAPLFAIL				!Check for excessive Log-fails
$ !
$ !SYS$SNAP:SNAPNET				!Check DECnet related stuff
$ !SYS$SNAP:SNAPCHECK SNAPNET			!*** not implemented yet    ***
$ !						!*** stay tuned for more... ***
$ !
$ SET PROTECTION=WORLD SYS$SNAP:SNAP*.*		!Let's control who can snoop
$ EXIT
