$!..InstalFin.com			Install Finger system
$!..					R. Garland / C.U.Chemistry / 13-Oct-1983
$ Save_verify	:=	'F$Verify(0)
$ On 	Error	Then GoTo Exit
$ Type		Sys$Input

	This procedure installs the Finger program and associated
	programs on your system.   For each question asked by this
	procedure, a default answer is given in parentheses after
	the question.  Just hit <RETURN> and the default will be used.

	This procedure copies files into system directories and uses
	the INSTALL utility, so you need to be logged on with system
	privileges to proceed.

	Before running this procedure you should review the installation
	document ( FINGER.DOC ) and decide if any changes need to be
	made to the source file ( FINGER.FOR ) or the command definition
	file ( FINGERCLD.CLD ).  If these changes are deemed unnecessary,
	or if you have already made them to suit your site, you may proceed.

	If you have more than 100 terminals, or more than 200 users, or
	more than 100 network hosts, review the installation document
	as relates to increasing these limits.

	If you plan to install the Finger network object at this time
	( Optional ) you must edit the file FINGERNET.COM first.  Note
	if you already run Finger as a network object, no changes to
	the network stuff are necessary.

$ Inquire	Ans	" Shall we proceed? (YES) "
$ If	Ans .eqs. ""	Then GoTo Proceed
$ If	Ans		Then GoTo Proceed
$ GoTo		Exit
$ Proceed:
$ Type		Sys$Input

	The parts of the finger system go into several directories.  The
	help files will be put into SYS$HELP.  If there is a particular
	directory where executable programs for general use are kept
	at your site ( a public library ), then finger will be put
	there.  Otherwise it will be put in SYS$SYSTEM.  (In some of the
	commands in this procedure, the chosen directory will be given
	the logical name "Finger$Directory".  This name is not needed
	once the installation is complete.)

$ Inquire	Ans	" Give name of directory to be used (SYS$SYSTEM) "
$ If		Ans .eqs. ""		Then Ans := Sys$System
$ LogAns	:=			'F$Log(Ans)'
$ If		LogAns .eqs. ""		Then LogAns := 'Ans'
$ Type		Sys$Input

	Ignore possible "Previous logical name assignment replaced" message.

$ Define	Finger$Directory	'LogAns'
$ Type		Sys$Input

	If you have an old version of finger on your system, it
	should be deinstalled now.

$ OldVersion	=	0
$ Inquire	Ans	" Is there an old version on your system? (NO) "
$ If	Ans .eqs. ""	Then GoTo NoOld
$ If 	.not. Ans	Then GoTo NoOld
$ OldVersion	=	1
$ Type		Sys$Input

	This procedure may produce several error messages: 
		"No logical name match", or 
		"No known file entry found", or 
		"File not found". 
	These messages can be ignored.

$ Set	NoOn
$ Set Verify
$ Deasign/System	FingerShr
$ Deasign		FingerShr
$ Run Sys$System:Install
Finger$Directory:Finger		/Delete
Finger$Directory:FingerShr	/Delete
$ NoOld:	! 'F$Verify(0)
$ On 	Error	Then GoTo Exit
$ Type		Sys$Input

	If you have changed the source file ( FINGER.FOR ) we must
	recompile it now.  If no changes have been made we can skip 
	the compilation.

$ Inquire	Ans	" Should we compile FINGER.FOR? (NO) "
$ compilefor	=	0
$ If	.not. Ans	Then GoTo NoFortran
$ compilefor	=	1
$ Type		Sys$Input

	The compiler may produce several warning messages: 
		"mixed character and numeric elements in common".
	These messages can be ignored.  

$ Set Verify
$ Fortran	Finger
$ NoFortran:	! 'F$Verify(0)
$ Type		Sys$Input

	If you have changed the command definition file ( FINGERCLD.CLD )
	we must recompile it now.  If no changes have been made we can
	skip this compilation.

$ Inquire	Ans	" Should we compile FINGERCLD.CLD? (NO) "
$ compilecld	=	0
$ If	.not. Ans	Then GoTo NoSetCommand
$ compilecld	=	1
$ Type			Sys$Input

$ Set Verify
$ Set Command Fingercld/Obj
$ NoSetCommand:	! 'F$Verify(0)
$ Type		Sys$Input

	The finger program and the database maintenance program
	will now be linked and moved to the appropriate directory.

$ Set Verify
$ Link		FingerShr.Obj/Share='F$Log("Finger$Directory")'
$ Link/NoTrace	Finger,Fingercld,Idle,Sys$System:Sys.Stb/Sel, -
		Sys$Input/Options/Exe='F$Log("Finger$Directory")'
Finger$Directory:FingerShr/Share
$ Link		FingMaint,MaintCld, -
		Sys$Input/Options/Exe='F$Log("Finger$Directory")'
Finger$Directory:FingerShr/Share
$ Type		Sys$Input	! 'F$Verify(0)

	The help files will now be installed in SYS$HELP.  This
	step may fail if someone else is using the HELP utility.
	If it does, just repeat the LIB command (below) at a
	later time.

$ Set 		NoOn
$ Set Verify
$ Copy		FingMaint.Hlb		Sys$Help
$ Lib		Sys$Help:Helplib/Help	Finger
$ On 	Error	Then GoTo Exit	! 'F$Verify(0)
$ Type		Sys$Input	

	If you run DECnet, the Finger network object must be
	defined and the finger object command file must be
	copied to SYS$SYSTEM.  The file FINGERNET.COM  must
	already be edited for this purpose.  If you do not run 
	DECnet, or if you want to do this later, we can skip this step.

	If you already run Finger as a network object, skip this step.

$ Inquire	Ans	" Do you want the DECnet finger object defined? (NO) "
$ NetFinger	=	0
$ If	Ans .eqs. ""	Then GoTo NoDECnet
$ If	.not.	Ans	Then GoTo NoDECnet
$ Type			Sys$Input

$ NetFinger	=	1
$ Set Verify
$ Run Sys$System:NCP
DEFINE  OBJECT FINGER	FILE FINGER	NUMBER 117
SET	OBJECT FINGER	FILE FINGER	NUMBER 117
$ Copy	FingerNet.Com	Sys$System:Finger.Com
$ NoDECnet:	! 'F$Verify(0)
$ Type		Sys$Input

	We will now optionally purge old versions of the files 
	which have just been installed.

$ If	.not.	OldVersion	Then GoTo PurgeNoDefault
$ Inquire	Ans	" Purge files just installed? (YES) "
$ If		Ans .eqs. ""	Then GoTo Purge
$ If		Ans 		Then GoTo Purge
$ GoTo		NoPurge
$ PurgeNoDefault:
$ Inquire	Ans	" Purge files just installed? (NO) "
$ If		Ans .eqs. ""	Then GoTo NoPurge
$ If		.not. Ans	Then GoTo NoPurge
$ Purge:
$ Type			Sys$Input

	Ignore any "Error searching for ... File not found." messages.

$ Set Verify
$ Purge/Log	Sys$Help:FingMaint.Hlb
$ Purge/Log	'F$Log("Finger$Directory")'Finger.exe
$ Purge/Log	'F$Log("Finger$Directory")'FingerShr.exe
$ Purge/Log	'F$Log("Finger$Directory")'FingMaint.exe
$ If	.not. Compilefor	Then GoTo Purge1	! 'F$Verify(0)'
$ Set Verify
$ Purge/Log	Finger.Obj
$ Purge1:	! 'F$Verify(0)'
$ If	.not. Compilecld	Then GoTo Purge2
$ Set Verify
$ Purge/Log	Fingercld.Obj
$ Purge2:	! 'F$Verify(0)'
$ If	.not. NetFinger		Then GoTo Purge3
$ Set Verify
$ Purge/Log	Sys$System:Finger.Com
$ Purge3:	! 'F$Verify(0)'
$ NoPurge:	! 'F$Verify(0)'
$ Type		Sys$Input

	The program will now be installed with the privileges needed.

$ Set Verify
$ Set Prot=(W:rwe)	'F$Log("Finger$Directory")'FingerShr.Exe
$ Run Sys$System:Install
Finger$Directory:Finger /Shared /Header /Priv=(SYSPRV,WORLD,CMKRNL)
Finger$Directory:FingerShr /Open /Shared /Header /Write /Priv=(SYSPRV,SYSGBL)
$ Define/System	FingerShr	'F$Log("Finger$Directory")'FingerShr
$ Set Prot=(W:re)	'F$Log("Finger$Directory")'FingerShr.Exe
$ Type		Sys$Input	! 'F$Verify(0)

	The installation procedure is now complete.  However you must
	do several things more:

	1) You must put the Finger start-up code, STARTFING.COM,
	   into the system startup file, SYS$MANAGER:SYSTARTUP.COM,
	   (or better, call STARTFING from the startup file) so that
	   the program will work after rebooting. STARTFING.COM must
	   be edited for your site.

	2) If you run DECnet, you should put the NCP code, FINGERNCP.COM,
	   into your network configuration file: SYS$MANAGER:CONFIGNET.COM

	3) Finger must be defined as a foreign command for users.  The
	   following line should be put into your system wide login command
	   file:

$ Set Verify
$ F*INGER	:==	$'F$Log("Finger$Directory")'Finger
$! 'F$Verify(0)
$ Type	Sys$Input 

	4) If you want a file containing a system message ("message of the
	   day") displayed as part of the FINGER output, create the file
	   and assign it the logical name "Finger$Message".  This can be
	   done via a /SYSTEM logical name at BOOT time.

	5) You must use the FINGMAINT program which was copied to the des-
	   ignated directory, to define the database for personal names, 
	   terminal locations and network hosts.  There is a sample file,
	   SHRBUILD.COM, which you can use as a model for this.  These 
	   definitions can also be put into STARTFING if you desire to
	   reconstruct the database after each system Boot. One option 
	   of the FINGMAINT program is to use the OWNER field in the 
	   system UAF for personal names.  If you wish, this can be done now.

$ Inquire	Ans	" Set up names from the UAF? (YES) "
$ If	Ans .eqs. ""	Then GoTo UAF
$ If	.not. Ans	Then GoTo NoUAF
$ Uaf:
$ Type			Sys$Input

$ Set Verify
$ Run	'F$Log("Finger$Directory")'FingMaint
Add	/User	/UAF
Exit
$ NoUAF:	! 'F$Verify(0)
$ Type		Sys$Input

	Finger will now be run as a test.  If the results do not correspond
	to the sample output in the installation document, please review
	the procedure and start over.

$ Set Verify
$ FINGER
$ Exit:		! 'F$Verify(0)
$ Exit		! 'F$Verify(Save_Verify)
