1!***	PROGRAM     : FORCE
 !***	Purpose     : Force input to keyboard
 !***	Package     : Personal.
 !***	Programmer  : Daniel A. Cook
 !***	Written on  : 03-APR-83
 !***	Written for : NCCS, Inc., 2235 Meyers Ave., Escondido, CA  92025
 !
 !***	Important note:
 !
 !		This program should be linked with the version of the FORCE
 !		module that does NOT require U11RTL.  The force module has
 !		a symbol (U11RTL) that determines which version is assembled.
 !
 !		If you follow the note above and also do not link against
 !		U11RTL, this program will run independent of USER11.

700	! D e c l a r a t i o n s

710	!XF> LIB$GET_FOREIGN = Get foreign command line library function.
	!XF> SYS$PUTMSG      = Put message system service.
	!XF> SYS$SETPRV      = Set privilege system service.
	!XF> FORCE           = Force input to terminal.
	!
	EXTERNAL LONG FUNCTION	LIB$GET_FOREIGN, &
				SYS$PUTMSG, &
				SYS$SETPRV, &
				U11_FORCE
	!
	!XC> SS$_BUFFEROVF   = Buffer overflow.
	!XC> SS$_NORMAL      = Normal successful completion return status.
	!XC> PRV$V_CMKRNL    = Change mode kernel privilege bit.
	!
	EXTERNAL LONG CONSTANT	SS$_BUFFEROVF, &
				SS$_NORMAL, &
				PRV$V_CMKRNL

800	! M a p p e d   a n d   c o m m o n   a r e a s

810	!
	!> SYS_INPUT$ = Buffer for data from SYS$INPUT.
	!
	MAP         (SYS_INPUT) FILL$ = 32767%
	MAP DYNAMIC (SYS_INPUT) TT1$, FORCE1$

830	! U t i l i t y   m a p s   a n d   c o m m o n   a r e a s

900	! D i m e n s i o n e d   a r r a y s

910	!
	!> PRVPRV%() = Previous privileges as a quadword broken into two
	!              longwords.
	!> MSGVEC%() = Message argument vector array for SYS$PUTMSG.
	!
	DIM	PRVPRV%(1%)
	DIM	MSGVEC%(3%)

1000	! S e t   u p   p r o g r a m   p a r a m e t e r s

1005	! Enable the error handler.
	!
	ON ERROR GOTO 19000

1006	! Get any foreign command line.
	!
	STATUS% = LIB$GET_FOREIGN(FOREIGN$,, FOR_LEN%,)
	IF	STATUS% AND SS$_NORMAL
	THEN	IF	FOR_LEN%
		THEN	Z% = INSTR(1%, FOREIGN$ + " ", " ")
			TT$    = LEFT(FOREIGN$, Z%-1%)
			FORCE$ = RIGHT(FOREIGN$, Z%+1%)
			FM.EP% = 2%
		END IF
	END IF

1010	! If we were run (as apposed to a foreign command entry)
	! then move carriage to far left,
	! show program name, purpose, and current time of day.
	!
	IF	FM.EP% <= 0%
	THEN	PRINT  IF  CCPOS(0%)
		PRINT 'FORCE - Force input to keyboard'; TAB(60%); TIME$(0%)
	END IF

1049	! I n i t i a l i z e   u s e r   v a r i a b l e s

1050	! Open up an input channel with a big buffer.
	!
	OPEN "SYS$INPUT" FOR INPUT AS FILE #1%, &
		MAP SYS_INPUT

1999	! M a j o r   l o g i c   f l o w   a r e a

2000	! If we didn't get the target terminal as a parameter on a foreign
	! command line then prompt for it.
	!
	IF	TT$ = NULL$
	THEN	PRINT  IF  CCPOS(0%)
		PRINT "Terminal:  ";
		GET #1%
		REMAP (SYS_INPUT) TT1$ = RECOUNT
		!
		! Back up if escape terminator.
		!
		GOTO 9000  IF  RIGHT(TT1$, LEN(TT1$)) = D'27'C
		!
		! Extract terminal name and possible data on same line.
		!
		Z% = INSTR(1%, TT1$ + " ", " ")
		TT$    = EDIT$(LEFT(TT1$, Z%-1%), 447%)
		FORCE$ = RIGHT(TT1$, Z%+1%)
		GOTO 2000  IF  TT$ = NULL$
	END IF

2010	! If we didn't get the data to force to the target terminal as a
	! parameter on a foriegn command line then prompt for it.
	!
	IF	FORCE$ = NULL$
	THEN	PRINT  IF  CCPOS(0%)
		PRINT "String:  ";
		GET #1%
		REMAP (SYS_INPUT) FORCE1$ = RECOUNT
		!
		! Back up if escape terminator.
		!
		IF	RIGHT(FORCE1$, LEN(FORCE1$)) = D'27'C
		THEN	TT$ = NULL$
			GOTO 2000
		END IF
		!
		! Strip off parity, trailing spaces and tabs, and
		! excess characters:  cr, ff, esc, rubout, null.
		! If nothing was entered then go back and re-prompt.
		!
		FORCE$ = EDIT$(FORCE1$, 133%)
		GOTO 2010  IF  FORCE$ = NULL$
		!
		! If the whole string is nothing but a "^" character
		! then that means that we should just force a single
		! control-c character to the terminal.  (Like RSTS/E
		! UTILTY force subcommand.)
		!
		IF	FORCE$ = "^"  AND  LEN(FORCE$) = 1%
		THEN	FORCE$ = D'3'C
			GOTO 6000
		END IF
	END IF
	Z% = 1%

2020	! Convert all the up-arrow character combinations in the
	! string into actual control characters.
	!
	Z% = INSTR(Z%, FORCE$, "^")
	IF	Z%
	THEN	IF	MID(FORCE$, Z%+1%, 1%) = "^"
		THEN	FORCE$ = LEFT(FORCE$, Z%) + RIGHT(FORCE$, Z%+2%)
		ELSE	FORCE$ = LEFT(FORCE$, Z%-1%) + &
				CHR$(ASCII(EDIT$(MID(FORCE$, Z%+1%, 1%), 32%)) AND NOT 64%) + &
				RIGHT(FORCE$, Z%+2%)
		END IF
		Z% = Z% + 1%
		GOTO 2020
	END IF
	!
	! Remove trailing nulls caused by converting up-arrow "nothing"
	! into a control character.
	!
	FORCE$ = LEFT(FORCE$, Z%-1%)  IF  RIGHT(FORCE$, Z%) = D'0'C &
				FOR Z% = LEN(FORCE$) TO 1% STEP -1%
	!
	! Count the number of semi-colons on the end of the string.
	!
	Z1% = 0%
	FOR Z% = LEN(FORCE$) TO 1% STEP -1%
		IF	MID(FORCE$, Z%, 1%) = ";"
		THEN	Z1% = Z1% + 1%
		ELSE	GOTO 2025
		END IF
	NEXT Z%

2025	! Substitute one trailing semi-colon for every two.
	!
	! An odd number of semi colons means force this string without
	! a carriage-return and strip off the trailing semicolon.
	!
	! An even number of semi colons means they are real.
	!
	FORCE$ = LEFT(FORCE$, LEN(FORCE$) - (Z1% / 2%))
	IF	Z1% AND 1%
	THEN	FORCE$ = LEFT(FORCE$, LEN(FORCE$) - 1%)
	ELSE	FORCE$ = FORCE$ + CR
	END IF

2030	! Make sure we have Change Mode to Kernel (CMKRNL) privilege.
	!
	STATUS% = SYS$SETPRV(,,, PRVPRV%() BY REF)
	IF	(STATUS% AND SS$_NORMAL) = 0%
	THEN	PRINT BEL; "?Error attempting to obtain process privileges..."
		CALL SYS$EXIT(STATUS% BY VALUE)
	END IF
	!
	! If the user doesn't have it authorized then we had better
	! have been installed with it.  (The force module tries to
	! change mode to kernel.)
	!
	IF	PRV$V_CMKRNL < 32%
	THEN	CMKRNL% = 2 ^ PRV$V_CMKRNL
		IF	(PRVPRV%(0%) AND CMKRNL%) = 0%
		THEN	PRINT BEL; "FORCE must be installed with "; &
					"CMKRNL privilege."
			GOTO 32767
		END IF
	ELSE	CMKRNL% = 2 ^ (PRV$V_CMKRNL - 32%)
		IF	(PRVPRV%(1%) AND CMKRNL%) = 0%
		THEN	PRINT BEL; "FORCE must be installed with "; &
					"CMKRNL privilege."
			GOTO 32767
		END IF
	END IF

5999	! F i n a l   l o g i c   f l o w   a r e a

6000	! Do the actual force.
	!
	STATUS% = U11_FORCE(NF%, TT$, FORCE$, FLAG%)
	IF	(STATUS% AND SS$_NORMAL) = 0%
	THEN	!
		! We failed.  Let the user know what happened.
		!
		MSGVEC%(0%) = 2%
		MSGVEC%(1%) = STATUS%
		MSGVEC%(2%) = 0%
		STATUS% = SYS$PUTMSG(MSGVEC%() BY REF,,"FORCE",)
		CALL SYS$EXIT(STATUS% BY VALUE)  IF  (STATUS% AND SS$_NORMAL) = 0%
		!
		! Try not to repeat the same mistake this time.
		!
		TT$    = NULL$
		FORCE$ = NULL$
		GOTO 2000
	END IF

9000	! P r o g r a m   t e r m i n a t i o n

9100	! C l o s e   f i l e s

9500	! F i n i s h   u p

9550	! If we were run then loop asking for more data to force.
	!
	IF	FM.EP% <> 2%
	THEN	FORCE$ = ""
		GOTO 2010  UNLESS  TT$ = NULL$
	END IF

9998	GOTO 32767

9999	!>
		!   1 0 0 0 0 - 1 6 9 9 0  
		!
		! U s e r   s u p p l i e d   r o u t i n e s  

16999	!>
		!   1 7 0 0 0 - 1 8 9 9 0  
		!
		! U s e r   s u p p l i e d   f u n c t i o n s  

19000	!>
		!
		! E r r o r   h a n d l e r  

19100	! E r r o r s   r e q u i r i n g   R E S U M E   (n o   l i n e #)

19199	RESUME 19200
		! Clear "error pending" flag

19200	! E r r o r s   r e q u i r i n g   G O T O   L I N E  #

19220	IF	ERR = 11%
	THEN	GOTO 32767

19990	! U n e x p e c t e d   e r r o r s

19998	! Report the fatal error.
	!
	PRINT "Error ("; NUM1$(ERR); ") "; EDIT$(ERT$(ERR), 128%); &
		'at line '; NUM1$(ERL); ' in module '; EDIT$(ERN$, 447%); "."

32767	END
