	PROGRAM KEY_DRIVER
	IMPLICIT NONE

	PARAMETER	UNIT_BOARD=1, UNIT_OPTION=2, UNIT_WORD=3

	EXTERNAL	RANDOM
	INTEGER*4	RANDOM
	INTEGER*4	KEY_GET_BOARD, KEY_DRAW_BOARD, KEY_USER

	PARAMETER	HICHAR=127, MAXWORDS=50
	PARAMETER	CTRL_W=23, CTRL_Z=26
	INTEGER*4	ROW(HICHAR), COL(HICHAR), LEN(HICHAR)
	CHARACTER*40	WORD(MAXWORDS)
	CHARACTER*1	BEEP_RIGHT, BEEP_WRONG

	CHARACTER*80	RECORD(24)
	INTEGER*4	NRECS, KEY, TERM, COURSE, NWORDS

	OPEN ( UNIT=UNIT_OPTION, STATUS='OLD', READONLY )
	READ ( UNIT=UNIT_OPTION, FMT=* ) COURSE
	READ ( UNIT=UNIT_OPTION, FMT='(A)' ) BEEP_RIGHT
	READ ( UNIT=UNIT_OPTION, FMT='(A)' ) BEEP_WRONG
	CLOSE ( UNIT=UNIT_OPTION )

	IF (COURSE.EQ.3) CALL KEY_GET_WORDS( UNIT_WORD, WORD, MAXWORDS,NWORDS )

	CALL KEY_GET_BOARD( UNIT_BOARD,RECORD,NRECS,ROW,COL,LEN,HICHAR )
	CALL KEY_DRAW_BOARD( RECORD, NRECS )

	DO WHILE (KEY.NE.CTRL_Z)
	  CALL KEY_PICK( COURSE, LEN, HICHAR, WORD, NWORDS, KEY )
	  CALL KEY_USER( RECORD, NRECS, KEY, 
	1		ROW(KEY), COL(KEY), LEN(KEY), 
	1		(BEEP_RIGHT.EQ.'Y'), (BEEP_WRONG.EQ.'Y'), TERM )
	  IF (TERM.EQ.CTRL_W) THEN
	    CALL KEY_DRAW_BOARD( RECORD, NRECS )
	  ELSE IF (TERM.EQ.CTRL_Z) THEN
	    GOTO 1000
	  END IF
	END DO

1000	CONTINUE
	END

************************************************************************

	SUBROUTINE KEY_GET_WORDS( UNIT, WORD, MAXWORDS, NWORDS )
	IMPLICIT NONE
	INTEGER*4	UNIT, MAXWORDS, NWORDS
	CHARACTER*(*)	WORD(MAXWORDS)

	INTEGER		I

	OPEN ( UNIT=UNIT, STATUS='OLD', READONLY )
	NWORDS = 0
	DO I = 1, MAXWORDS
	  READ ( UNIT=UNIT, FMT='(A)', END=1000 ) WORD(NWORDS+1)
	  NWORDS = NWORDS + 1
	END DO
1000	CONTINUE
	CLOSE ( UNIT=UNIT )

	RETURN
	END

************************************************************************

	SUBROUTINE KEY_PICK( COURSE, REAL, HICHAR, WORD, NWORDS, KEY )
	IMPLICIT NONE
	INTEGER*4	COURSE, HICHAR, REAL(HICHAR), NWORDS, KEY
	CHARACTER*(*)	WORD(MAX(NWORDS,1))

	INTEGER*4	RANDOM

	PARAMETER	RETURN_KEY=13
	PARAMETER	TEXT_ROW=22
	PARAMETER	DOUBLE_WIDE=CHAR(27)//'#6'
	PARAMETER	DOUBLE_HIGH_TOP=CHAR(27)//'#3'
	PARAMETER	DOUBLE_HIGH_BOTTOM=CHAR(27)//'#4'
	PARAMETER	ERASE_EOL=CHAR(27)//'[K'
	CHARACTER*1	CH
	INTEGER*4	LASTKEY, LASTWORD, WORDPOS, CURWORD
	SAVE		LASTKEY, LASTWORD, WORDPOS, CURWORD
	SAVE		CH

1000	CONTINUE
	  IF (COURSE.EQ.1) THEN
			! alpha & numeric
	    KEY = RANDOM( 10 + 26 )
	    IF (KEY.LE.9) THEN
	      KEY = KEY + ICHAR('0')
	    ELSE
	      KEY = KEY - 10 + ICHAR('A')
	    END IF
	    IF (KEY.EQ.LASTKEY) GOTO 1000
	  ELSE IF (COURSE.EQ.2) THEN
			! any key
	    KEY = RANDOM( HICHAR ) + 1
	    IF (KEY.EQ.LASTKEY) GOTO 1000
	  ELSE IF (COURSE.EQ.3) THEN
	    IF (WORDPOS.GT.0) THEN
	      CALL PUT_STRING( TEXT_ROW, WORDPOS, CH )
	      CALL PUT_STRING( TEXT_ROW+1, WORDPOS, CH )
	    ELSE
	      CALL PUT_STRING( TEXT_ROW, 1, ERASE_EOL//DOUBLE_HIGH_TOP )
	      CALL PUT_STRING( TEXT_ROW+1, 1, ERASE_EOL//DOUBLE_HIGH_BOTTOM )
	      CALL PUT_STRING( 1, 1, CHAR(0) )	! circumvents bug in vt100.
	    END IF
	    IF (CURWORD.LE.0) THEN
	      DO WHILE (CURWORD.LE.0.OR.CURWORD.EQ.LASTWORD)
		CURWORD = RANDOM( NWORDS ) + 1
	      END DO
	      WORDPOS = 0
	      LASTWORD = CURWORD
	      KEY = RETURN_KEY
	      CH = CHAR( RETURN_KEY )
	    ELSE
	      WORDPOS = WORDPOS + 1
	      CH = WORD(CURWORD)(WORDPOS:WORDPOS)
	      KEY = ICHAR( CH )
	      IF (WORD(CURWORD)(WORDPOS+1:).EQ.' ') CURWORD = 0
	    END IF
	  ELSE
	    TYPE *, 'NO SUCH COURSE AS ', COURSE
	  END IF
	  IF (REAL(KEY).LE.0) GOTO 1000
	CONTINUE
	LASTKEY = KEY

	RETURN
	END

************************************************************************

	SUBROUTINE KEY_GET_BOARD( UNIT, RECORD, NRECS,
	1					ROW, COL, LEN, HICHAR )
	IMPLICIT NONE
	INTEGER*4	UNIT, NRECS, HICHAR
	CHARACTER*(*)	RECORD(24)
	INTEGER*4	ROW(HICHAR), COL(HICHAR), LEN(HICHAR)

	PARAMETER	ASCII='(A)'
	PARAMETER	LOCAL_SIZE=127
	INTEGER*4	I
	INTEGER*2	LOCAL_ROW(LOCAL_SIZE), LOCAL_COL(LOCAL_SIZE)
	INTEGER*2	LOCAL_LEN(LOCAL_SIZE)

!(0
!xSETUPx                                                x ^ xx V xx < xx > x
!xESCxx 1 xx 2 xx 3 xx 4 xx 5 xx 6 xx 7 xx 8 xx 9 xx 0 xx - xx = xx ` xxBSPxxBRKx
! x TAB xx Q xx W xx E xx R xx T xx Y xx U xx I xx O xx P xx [ xx ] x x  xxDELx
!xCTLxxCAPxx A xx S xx D xx F xx G xx H xx J xx K xx L xx ; xx ' xxRETURNxx \ x
!xSCRxxSHIFTxx Z xx X xx C xx V xx B xx N xx M xx , xx . xx / xxSHIFTxx LF x
!..........''''''''''..........''''''''''..........''''''''''..........''''''''''
!             lqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqk
!             x                                            x
!             mqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqj

	DATA LOCAL_ROW /7*0, 2, 3, 5,2*0, 4,13*0, 2, 4*0,
	1		 6,6*0, 4,4*0, 5, 2, 5, 5, 10*2,
	1		 0, 4, 0, 2,3*0,
	1		 4, 5, 5, 4, 3, 4, 4, 4, 3, 4, 4, 4, 5,
	1		 5, 3, 3, 3, 3, 4, 3, 3, 5, 3, 5, 3, 5,
	1		 3, 4, 3,2*0, 0,26*0,4*0, 3 /

	DATA LOCAL_COL /7*0,72, 3,71,2*0,67,13*0, 2, 4*0,
	1		15,6*0,62,4*0,49,57,54,59,52,7,12,17,22,27,32,37,42,47,
	1		 0,57, 0,62,3*0,
	1		12,34,24,22,20,27,32,37,45,42,47,52,44,
	1		39,50,55,10,25,17,30,40,29,15,19,35,14,
	1		60,75,65,2*0, 0,26*0,4*0,75 /

	DATA LOCAL_LEN /7*0, 3, 5, 4,2*0, 6,13*0, 3, 4*0,
	1		44,6*0, 3,4*0, 3, 3, 3, 3, 10*3,
	1		 0, 3, 0, 3,3*0,
	1		13*3,
	1		13*3,
	1		 3, 3, 3,2*0, 0,26*0,4*0, 3 /


	OPEN (UNIT=UNIT,STATUS='OLD',READONLY)
	NRECS = 0
	DO I = 1, 24
	  READ (UNIT=UNIT,FMT=ASCII,END=2000) RECORD(I)
	  NRECS = NRECS + 1
	END DO
	CLOSE (UNIT=UNIT)

2000	CONTINUE

	DO I = 1, MIN(HICHAR,LOCAL_SIZE)
	  ROW(I) = LOCAL_ROW(I)
	  COL(I) = LOCAL_COL(I)
	  LEN(I) = LOCAL_LEN(I)
	END DO
	DO I = MIN(HICHAR,LOCAL_SIZE) + 1, HICHAR
	  ROW(I) = 0
	  COL(I) = 0
	  LEN(I) = 0
	END DO

	RETURN
	END

************************************************************************

	SUBROUTINE KEY_DRAW_BOARD( RECORD, NRECS )
	IMPLICIT NONE
	INTEGER*4	NRECS
	CHARACTER*(*)	RECORD(NRECS)

	INTEGER*4	PUT_STRING
	INTEGER*4	I

	DO I = 1, NRECS
	  CALL PUT_STRING( I, 1, RECORD(I) )
	END DO

	RETURN
	END

************************************************************************

	SUBROUTINE KEY_USER( RECORD, NRECS, KEY, 
	1			ROW, COL, LEN, 
	1			BEEP_IF_RIGHT, BEEP_IF_WRONG, TERM )
	IMPLICIT NONE

	INTEGER*4	NRECS
	CHARACTER*(*)	RECORD(NRECS)
	INTEGER*4	KEY, ROW, COL, LEN, TERM
	LOGICAL*4	BEEP_IF_RIGHT, BEEP_IF_WRONG

	INTEGER*4	PUT_STRING, VTGETT

	PARAMETER	CTRL_W=23, CTRL_Z=26
	PARAMETER	BEEP=CHAR(7), NO_BEEP=CHAR(0), ESCAPE=CHAR(27)
	PARAMETER	REVERSE=ESCAPE//'[7m'		! reverse video
	PARAMETER	FORWARD=ESCAPE//'[0m'		! normal video
	PARAMETER	UPPERCASE=1, NOECHO=2, U_R_DEL=4, PURGE=8
	PARAMETER	OPTIONS = UPPERCASE+NOECHO+U_R_DEL+PURGE
	PARAMETER	TERMS=CHAR(CTRL_W)//CHAR(CTRL_Z)
	INTEGER*4	RECN, COLN, COLM, LASTKEY, KEYNUM
	INTEGER*4	SEC, COUNT
	CHARACTER*1	BUF, BEEP_RIGHT, BEEP_WRONG

	IF (BEEP_IF_RIGHT) THEN
	  BEEP_RIGHT = BEEP
	ELSE
	  BEEP_RIGHT = NO_BEEP
	END IF
	IF (BEEP_IF_WRONG) THEN
	  BEEP_WRONG = BEEP
	ELSE
	  BEEP_WRONG = NO_BEEP
	END IF
	RECN = ROW * 3
	COLN = COL
	COLM = COLN + LEN - 1
	LASTKEY = 0
2000	CONTINUE
	  CALL PUT_STRING( RECN, COLN, 
	1		REVERSE // RECORD(RECN)(COLN:COLM) // FORWARD )
2002	  CONTINUE
	    CALL GET_KEY( 24, 1, KEYNUM )
	    IF (KEYNUM.GE.ICHAR('a').AND.KEYNUM.LE.ICHAR('z'))
	1		KEYNUM = KEYNUM - ICHAR('a') + ICHAR('A')
	    IF (KEYNUM.EQ.CTRL_W.OR.KEYNUM.EQ.CTRL_Z) GOTO 2004
	    IF (KEYNUM.EQ.LASTKEY) GOTO 2002
	    LASTKEY = KEYNUM
	    IF (KEYNUM.EQ.KEY) THEN
		CALL PUT_STRING( RECN, COLN,
	1		BEEP_RIGHT // RECORD(RECN)(COLN:COLM) )
		GOTO 2004
	    ELSE
		IF (BEEP_IF_WRONG) CALL PUT_STRING( 24, 1, BEEP )
		GOTO 2000
	    END IF
	  CONTINUE
2004	CONTINUE
	TERM = KEYNUM

	RETURN
	END

************************************************************************

	integer function random( lessthan )
	integer seed
	common /random_seed/ seed
	if (seed.eq.0) seed = ifix( secnds(0.0) * 123.0 )
	random = ifix( ran(seed) * float(lessthan) )
	return
	end

