	program monster_main
	implicit integer (a-z)

	parameter maze_unit=1
	parameter min_monsters=2, max_monsters=10
	parameter clear_eos=char(27)//'[J'
	logical living, quit
	integer n_monsters
	integer maze(40,20), position(6,max_monsters)

	carry = 0	! number of missiles unused in last turn.
	open( unit=maze_unit, status='old', readonly )
	do n_monsters = min_monsters, max_monsters
2222	  continue
	  read (unit=maze_unit,fmt=*,end=1111) nr, nc
	  call readmaze( maze_unit, maze, nr, nc )
	  call monster( maze,nr,nc, position, n_monsters, living, quit, carry )
	  if (quit.or..not.living) goto 3333
	end do
3333	continue
	call put_string( 22, 1, clear_eos )
	if (n_monsters-1.ge.min_monsters) then
	  if (living) then
	    type *, 'you triumphed over ',n_monsters-1,' monsters!'
	  else
	    type *, n_monsters,' monsters were too much for you!'
	  end if
	else
	  type *, 'too bad.'
	end if
	call exit
		! if we hit the end of the maze file then
		! close the file and open it so we can read the mazes again.
1111	continue
	close ( unit=maze_unit )
	open ( unit=maze_unit,status='old',readonly )
	goto 2222

	end

********

	subroutine monster( maze, nr, nc, p, n_monsters, living, quit, carry )
	implicit integer (a-z)
	integer maze(nc,nr), p(6,0:n_monsters)
	logical living, quit

	parameter ctrlz=26
	integer nm, nb

	nm = n_monsters
		! give hero one bolt for every monster,
		! plus the number of bolts left over from previous round,
		! and make sure it's at least 3.
	nb = max(nm,3) + carry
	addanother = 0
	call drawmaze( maze, nr, nc, nb )
	call initposi( maze, nr, nc, p, nm )
	quit = .false.
	living = .true.
	do while (living.and..not.quit.and.nm.gt.0)
	  call userinput( maze,nr,nc,p,nm,nb,living,quit )
	  if (living.and..not.quit) then
	    call movebolts( maze,nr,nc,p,nm,living )
	    call compress( p, nm )
	    call movemonster( maze,nr,nc,p,nm,living )
	    call firebolts( maze,nr,nc,p,nm )
	    call movebolts( maze,nr,nc,p,nm,living )
	    call compress( p, nm )
			! if we're in the middle of a lecture then ramble on.
	    if (addanother.gt.0) goto 1001	
			! if things look boring then generate another monster:
			! if there is one monster and the player is living and
			! has not quit and is out of insults and the player's
			! insult is not in flight and the remaining monster
			! isn't dead then give player an insult and ...
	    if (nm.eq.1.and.nb.eq.0.and.living.and..not.quit) then
	      if (p(6,0).eq.0.and.p(5,0).eq.0) then
		if (p(1,1).gt.0.and.p(2,1).gt.0) then
1001		  continue
		  addanother = addanother + 1
		  call lecture( addanother )
	          if (addanother.eq.2) then
		    nb = nb + 1
	            call insult_count( nb )
		  end if
		  if (addanother.eq.4) then
	            call genmonster( maze, nr, nc, p, nm )
		  end if
		  if (addanother.ge.5) addanother = 0
		end if
	      end if
	    end if
	  end if
	end do
	if (living.and..not.quit) call winmess
	carry = nb
	return
	end

********

	subroutine winmess
	implicit integer (a-z)
	parameter open=0, wall=1, hero=2, monster=3, dead=4, bolt=5
	do i = 1, 5
	  call message( hero )
	  call delay( 300 )
	  call message( open )
	  call delay( 100 )
	end do
	return
	end
	
********

	subroutine readmaze( maze_unit, maze, nr, nc )
	integer maze_unit, nr, nc
	integer maze(nc,nr)

	parameter open=0, wall=1, hero=2, monster=3, dead=4, bolt=5
	byte rec(80)

	do i = 1, nr
	  read (unit=maze_unit,fmt='(80a)') rec
	  do j = 1, nc
	    if (rec(j).gt.' ') then
	      maze(j,i) = wall
	    else
	      maze(j,i) = open
	    end if
	  end do
	end do
	return
	end

********

	subroutine drawmaze( maze, nr, nc, nb )
	implicit integer (a-z)
	integer maze(nc,nr)

	parameter open=0, wall=1, hero=2, monster=3, dead=4, bolt=5
	parameter inverse=char(27)//'[7m', normal=char(27)//'[0m'
	parameter doublewide=char(27)//'#6'
	parameter clear_eos=char(27)//'[J'
	character*40 spaces

	row_off = (24-nr)/3+1
	col_off = (40-nc)/2
	spaces = ' '
	call put_string( 1, 1, clear_eos )
	call put_string( 2, 57, 'arrow keys = hurl insult' )
	call put_string( 2, 1, '7,8,9 = up  1,2,3 = down' )
	call put_string( 2, 27, '1,4,7 = left  3,6,9 = right' )
	do i = 1, nr
	  call put_string( row_off+i, col_off+1, doublewide//inverse )
	  count = 0
	  do j = 1, nc
	    if (maze(j,i).eq.wall) then
	      if (count.eq.0) col = j
	      count = count + 1
	    else
	      if (count.gt.0) then
		call put_string( row_off+i, col_off+col, spaces(1:count) )
		count = 0
	      end if
	    end if
	  end do
	  if (count.gt.0) then
	    call put_string( row_off+i, col_off+col, spaces(1:count) )
	  end if
	end do
	call put_string( 1, 1, doublewide//normal )
	call insult_count( nb )

	return
	end

********

	subroutine redraw( maze, nr, nc, p, nm, nb )
	implicit integer (a-z)
	integer maze(nc,nr), p(6,0:nm)
	parameter open=0, wall=1, hero=2, monster=3, bolt=5, two_bolts=8
	call drawmaze( maze, nr, nc, nb )
	do i = 1, nm
	  if (p(1,i).gt.0.and.p(2,i).gt.0) 
	1	call putit( maze, nr, nc, p(1,i), p(2,i), monster)
	  if (p(3,i).gt.0.and.p(4,i).gt.0) 
	1	call putit( maze, nr, nc, p(3,i), p(4,i), bolt )
	end do
	if (p(3,0).gt.0.and.p(4,i).gt.0) 
	1	call putit( maze, nr, nc, p(3,i), p(4,i), bolt )
	call putit( maze, nr, nc, p(1,0), p(2,0), hero )
	return
	end

********

	subroutine initposi( maze, nr, nc, p, n_monsters )
	implicit integer (a-z)
	integer maze(nc,nr), p(6,0:n_monsters)

	parameter open=0, wall=1, hero=2, monster=3, dead=4, bolt=5

1	continue
	  herow = random( nr-2 ) + 2
	  hecol = random( nc-2 ) + 2
	if (maze(hecol,herow).ne.open) goto 1
	call putit( maze, nr, nc, herow, hecol, hero )
	p(1,0) = herow
	p(2,0) = hecol
	call deletebolt( p, 0, 0 )

	nm = 0
	do m = 1, n_monsters
	  call genmonster( maze, nr, nc, p, nm )
	end do

	return
	end

********

	subroutine genmonster( maze, nr, nc, p, nm )
	implicit integer (a-z)
	integer maze(nc,nr), p(6,0:nm+1)
	parameter open=0, wall=1, hero=2, monster=3, dead=4, bolt=5
2	continue
	r = random( nr-2 ) + 2
	if (r.eq.p(1,0)) goto 2
	c = random( nc-2 ) + 2
	if (c.eq.p(2,0)) goto 2
	if (maze(c,r).ne.open) goto 2
	nm = nm + 1
	p(1,nm) = r
	p(2,nm) = c
	call initbolt( p(1,nm), 0,0,0,0 )
	call putit( maze, nr, nc, r, c, monster )
	return
	end

********

	subroutine putit( maze, nr, nc, r, c, t )
	implicit integer (a-z)
	integer maze(nc,nr)
	parameter open=0, wall=1, hero=2, monster=3, dead=4, bolt=5, munch=6
	parameter escape=char(27)
	parameter forward=escape//'[m', reverse=escape//'[7m'
	parameter graphics=escape//'(0', ascii=escape//'(B'
	parameter smash='#'//char(8)
	character*9 dude /'  *M%~m :'/
	row_off = (24-nr)/3+1
	col_off = (40-nc)/2
	t1 = t + 1
	if (t.eq.wall) then
	  call put_string( row_off+r, col_off+c, smash )
	  call delay( 250 )
	  call put_string( row_off+r,col_off+c,reverse//dude(t1:t1)//forward )
	else if (t.eq.bolt) then
	  call put_string( row_off+r, col_off+c, graphics//dude(t1:t1)//ascii )
	else
	  call put_string( row_off+r, col_off+c, dude(t1:t1) )
	end if
	maze( c,r ) = t
	return
	end

********

	integer function random( lessthan )
	implicit integer*4 (a-z)
	common /random_seed/ seed
	if (seed.eq.0) then
	  call lib$day(seed)
	  if (seed) seed = seed + 1
	end if
	random = ran(seed) * float(lessthan)
	return
	end

********

	subroutine insult_count( nb )
	implicit integer (a-z)
	parameter msgrow=1, msgcol=31
	character*2 chars
	if (nb.le.0) then
	  call put_string( msgrow, msgcol, 'No insults' )
	else
	  call ots$cvt_l_ti( nb, chars, %val(1), %val(4), )
	  if (nb.eq.1) call put_string( msgrow, msgcol, chars//' insult ' )
	  if (nb.gt.1) call put_string( msgrow, msgcol, chars//' insults' )
	end if
	return
	end

********

	subroutine lecture( what )
	implicit integer (a-z)
	parameter msgrow=24, msgcol=1
	parameter minmsg=0, maxmsg=5
	character*50 msg(minmsg:maxmsg)
	data msg /	' ',
	1	'you appear to have used up all of your insults ...',
	2	'... you may have another one ...',
	3	'but just to make things challenging ...',
	4	'... you get another monster, too !!!',
	5	' ' /
	if (what.ge.minmsg.and.what.le.maxmsg) then
	  call put_string( msgrow, msgcol, msg(what) )
	end if
	end

********

	subroutine hurl_insult( n )
	implicit integer (a-z)
	parameter n_insults=10, row=23
	parameter erase_eol=char(27)//'[K'
	character*40 text(2,n_insults) /
	1	'Hey, monster! You''re so ugly you could s',
	2	'care a banana out of its peel!',
	1	'Hey, Ugly!', ' ',
	1	'Hey, Stupid!', ' ',
	1	'You look really bad in Polyester suits. ',
	2	'Maybe you should try aluminum siding!',
	1	'I bet you could get a job posing for Ink',
	2	' Blot tests!',
	1	'Is that your fur, or did they have an ac',
	2	'cident at the Astro-Turf factory?',
	1	'Your family moved a lot when you were yo',
	2	'ung but you caught up with them anyway!',
	1	'Is that your nose or are you smoking a b',
	2	'anana?',
	1	'You were so ugly when you were born that',
	2	' the doctor slapped your mother!',
	1	'Hey Fur-face! Is it true you flunked you',
	2	'r I.Q. test?' /
	if (n.gt.0) then
	  msgn = random(n_insults) + 1
	  call put_string( row, 1, text(1,msgn)//text(2,msgn) )
	else
	  call put_string( row, 1, erase_eol )
	end if
	return
	end

********

	subroutine message( t )
	implicit integer (a-z)
	parameter open=0, wall=1, hero=2, monster=3, dead=4, bolt=5, munch=6
	parameter tooclose=7
	parameter msgrow=1, msgcol=1
	character*15 text(-bolt:tooclose) / 'none left',' ',' ',' ',' ',
	1	' ', 'ouch!', 'Yeee-Haah!','gotcha!', 'Too Bad!', 
	1	'aaargh!', 'MunchMunchMunch', 'too close!' /
	call put_string( msgrow, msgcol, text(t) )
	return
	end

********

	subroutine chowdown( maze, nr, nc, r, c )
	implicit integer (a-z)
	integer maze(nc,nr)
	parameter open=0, wall=1, hero=2, monster=3, dead=4, bolt=5, munch=6
	do i = 1, 5
	  dummy = delay(300) + putit( maze, nr, nc, r, c, munch )
	  dummy = delay(300) + putit( maze, nr, nc, r, c, monster )
	end do
	return
	end

********

	subroutine userinput( maze, nr, nc, p, nm, nb, living, quit )
	implicit integer (a-z)
	integer maze(nc,nr), p(6,0:nm)
	logical living, quit

	parameter uparrow=193, downarrow=194, rightarrow=195, leftarrow=196
	parameter pf1=208, pf2=209, pf3=210, pf4=211, ctrlz=26, ctrlw=23
	parameter ordzero=48, ordone=49, ordnine=57
	parameter open=0, wall=1, hero=2, monster=3, dead=4, bolt=5, munch=6
	parameter tooclose=7, two_bolts=8
	integer dr(1:9) /1,1,1,0,0,0,-1,-1,-1/
	integer dc(1:9) /-1,0,1,-1,0,1,-1,0,1/
	integer bdr(uparrow:leftarrow) /-1,1,0,0/
	integer bdc(uparrow:leftarrow) /0,0,1,-1/

	r = p(1,0)
	c = p(2,0)
1	continue
	  call get_key( 2, 55, key )
	  if (key.ge.ordone.and.key.le.ordnine) then
	    r = r + dr( key - ordzero )
	    c = c + dc( key - ordzero )
	    if (maze(c,r).eq.wall) then
	      call message( wall )
	    else
	      call putit( maze, nr, nc, p(1,0), p(2,0), open )
	      p(1,0) = r
	      p(2,0) = c
	      living = (maze(c,r).eq.open)
	      if (maze(c,r).eq.bolt.or.maze(c,r).eq.two_bolts) then
	        call message( bolt )
		call putit( maze, nr, nc, r, c, dead )
	      else if (maze(c,r).eq.monster) then
	        call message( munch )
		call chowdown( maze, nr, nc, r, c )
	      else
	        call message( open )
		call putit( maze, nr, nc, r, c, hero )
	      end if
	    end if
	    goto 2
	  end if
	  if (key.eq.ctrlz) then
	    quit = .true.
	    goto 2
	  end if
	  if (key.eq.ctrlw) call redraw( maze,nr,nc,p,nm,nb )
	  if (key.ge.uparrow.and.key.le.leftarrow) then
	    if (nb.gt.0) then
	      if (p(5,0).eq.0.and.p(6,0).eq.0) then
			! don't let them fire at point-blank range.
		if (maze( p(2,0)+bdc(key), p(1,0)+bdr(key) ) .eq. monster) then
		  call message( tooclose )
		else
		  call initbolt( p(1,0), p(1,0), p(2,0), bdr(key), bdc(key) )
		  call hurl_insult( nb )
		  nb = nb - 1
		  call insult_count( nb )
		  goto 2
		end if
	      end if
	    else
	      call message( -bolt )
	    end if
	  end if
	goto 1
2	continue
	return
	end

********

	subroutine movemonster( maze, nr, nc, p, nm, living )
	implicit integer (a-z)
	integer maze(nc,nr), p(6,0:nm)
	logical living

	parameter open=0, wall=1, hero=2, monster=3, dead=4, bolt=5, munch=6

	do i = 1, nm
	  r = p(1,i)
	  c = p(2,i)
	  if (r.gt.0.and.c.gt.0) then
	    call findmove( maze, nr, nc, r, c, p(1,0), p(2,0), newr, newc )
	    if (newr.gt.0.and.newc.gt.0) then
	      call putit( maze, nr, nc, r, c, open )
	      if (maze(newc,newr).eq.hero) then
		call message( munch )
		call chowdown( maze, nr, nc, newr, newc )
		living = .false.
	      end if
	      call putit( maze, nr, nc, newr, newc, monster )
	      p(1,i) = newr
	      p(2,i) = newc
	    end if
	  end if
	end do

	return
	end

********

	subroutine findmove( maze, nr, nc, r, c, herow, hecol, newr, newc )
	implicit integer (a-z)
	integer maze(nc,nr)

	parameter north=0, east=1, south=2, west=3, compass=4
	parameter open=0, wall=1, hero=2, monster=3, dead=4, bolt=5, munch=6
	integer deltar(north:west) /-1,0,1,0/
	integer deltac(north:west) /0,1,0,-1/
	integer d(4)

	dr = herow - r
	dc = hecol - c
	if (abs(dr).gt.abs(dc)) then
	  if (dr.gt.0) then
	    d(1) = south
	  else
	    d(1) = north
	  end if
	  if (dc.gt.0) then
	    d(2) = east
	  else
	    d(2) = west
	  end if
	else ! prefer to change column
	  if (dc.gt.0) then
	    d(1) = east
	  else
	    d(1) = west
	  end if
	  if (dr.gt.0) then
	    d(2) = south
	  else
	    d(2) = north
	  end if
	end if
	d(3) = mod( d(2)+compass/2, compass )
	d(4) = mod( d(1)+compass/2, compass )
	do i = 1, 4
	  newr = r + deltar( d(i) )
	  newc = c + deltac( d(i) )
	  if (maze(newc,newr).eq.hero) goto 1111
	  if (maze(newc,newr).eq.open) goto 1111
	end do
	newr = 0
	newc = 0
1111	continue
	return
	end

********

	subroutine movebolts( maze, nr, nc, p, nm, living )
	implicit integer (a-z)
	integer maze(nc,nr), p(6,0:nm)
	logical living

	parameter open=0, wall=1, hero=2, monster=3, dead=4, bolt=5, munch=6
	parameter two_bolts=8

	do i = 0, nm
	  if (p(5,i).ne.0.or.p(6,i).ne.0) then
	    r = p(3,i)
	    c = p(4,i)
	    if (maze(c,r).eq.monster.or.maze(c,r).eq.hero) goto 1111
	    count = 0
	    do j = 0, nm
	      if (p(3,j).eq.r.and.p(4,j).eq.c) count = count + 1
	    end do
	    count = count - 1		! don't count ourself, we're leaving.
	    if (count.le.0) call putit( maze, nr, nc, r, c, open )
	    if (count.eq.1) call putit( maze, nr, nc, r, c, bolt )
	    if (count.ge.2) call putit( maze, nr, nc, r, c, two_bolts )
1111	    continue
	    r = r + p(5,i)
	    c = c + p(6,i)
	    if (maze(c,r).eq.wall) then
	      call putit( maze, nr, nc, r, c, wall )
	      call deletebolt( p, nm, i )
	    else if (maze(c,r).eq.monster) then
	      call delay(1200)
	      call putit( maze, nr, nc, r, c, open )
	      do j = 1, nm
		if (p(1,j).eq.r.and.p(2,j).eq.c) then
		  call deletemonster( p, nm, j )
		  goto 2222
	        end if
	      end do
2222	      continue
	      call deletebolt( p, nm, i )
	    else if (maze(c,r).eq.hero) then
	      call putit( maze, nr, nc, r, c, dead )
	      living = .false.
	      call deletebolt( p, nm, i )
	    else
	      if (maze(c,r).eq.bolt) then
	        call putit( maze, nr, nc, r, c, two_bolts )
	      else
		call putit( maze, nr, nc, r, c, bolt )
	      end if
	      p(3,i) = r
	      p(4,i) = c
	    end if
	  end if
	end do
	return
	end

********

	subroutine deletebolt( p, nm, n )
	implicit integer (a-z)
	integer p(6,0:nm)
	if (n.eq.0) call hurl_insult( -1 )
	call initbolt( p(1,n), 0,0,0,0 )
	return
	end

********

	subroutine deletemonster( p, nm, n )
	implicit integer (a-z)
	integer p(6,0:nm)
	  p(1,n) = 0
	  p(2,n) = 0
	return
	end

********

	subroutine compress( p, nm )
	implicit integer (a-z)
	integer p(6,0:nm)
	i1 = 1
	i2 = nm
	do while (i1.le.i2)
	  if      ( (p(1,i2)*p(2,i2).eq.0) .and. (p(5,i2)+p(6,i2).eq.0) ) then
	    i2 = i2 - 1
	  else if ( (p(1,i1)*p(2,i1).eq.0) .and. (p(5,i1)+p(6,i1).eq.0) ) then
	    do i = 1, 6
	      p(i,i1) = p(i,i2)
	    end do
	    i2 = i2 - 1
	  else
	    i1 = i1 + 1
	  end if
	end do
	nm = i2
	return
	end

********

	subroutine initbolt( pi, r, c, dr, dc )
	implicit integer (a-z)
	integer pi(6)
	pi(3) = r
	pi(4) = c
	pi(5) = dr
	pi(6) = dc
	return
	end

********

	subroutine firebolts( maze, nr, nc, p, nm )
	implicit integer (a-z)
	integer maze(nc,nr), p(6,0:nm)

	herow = p(1,0)
	hecol = p(2,0)
	do i = 1, nm
	  if (p(1,i).gt.0.and.p(2,i).gt.0) then
	    if (p(5,i).eq.0.and.p(6,i).eq.0) then
	      r = p(1,i)
	      c = p(2,i)
	      dr = herow - r
	      dc = hecol - c
	      if (abs(dr).gt.2.and.abs(dc).le.1) then
		call checkshot( maze, nr, nc, r, c, herow, c, bdr, bdc )
	      else if (abs(dc).gt.2.and.abs(dr).le.1) then
		call checkshot( maze, nr, nc, r, c, r, hecol, bdr, bdc )
	      else
		bdr = 0
		bdc = 0
	      end if
	      if (bdr.ne.0.or.bdc.ne.0) call initbolt( p(1,i), r, c, bdr, bdc )
	    end if
	  end if
	end do
	return
	end

********

	subroutine checkshot( maze, nr, nc, r1, c1, r2, c2, bdr, bdc )
	implicit integer (a-z)
	integer maze(nc,nr)

	parameter open=0, wall=1, hero=2, monster=3, dead=4, bolt=5, munch=6

	dr = r2 - r1
	dc = c2 - c1
	bdr = 0
	bdc = 0
	if (dr.ne.0) bdr = dr / abs(dr)
	if (dc.ne.0) bdc = dc / abs(dc)
	m = max( abs(dr), abs(dc) )
	do i = 1, m
	  r3 = r1 + i * bdr
	  c3 = c1 + i * bdc
	  if (maze(c3,r3).eq.wall.or.maze(c3,r3).eq.monster) then
	    bdr = 0
	    bdc = 0
	    goto 8888
	  end if
	end do
8888	continue
	return
	end
