	SUBROUTINE TERMINAL_IO
	IMPLICIT NONE
		! externals.
	EXTERNAL	IO$_READVBLK, IO$_WRITEVBLK, IO$_READPROMPT
	EXTERNAL	IO$M_NOFILTR, IO$M_TRMNOECHO, IO$M_NOECHO, IO$M_TIMED
	EXTERNAL	SS$_TIMEOUT, SS$_NORMAL
	INTEGER*4	SYS$QIOW, SYS$ASSIGN, OTS$CVT_L_TI
		! internals.
	PARAMETER	ESCAPE=CHAR(27), NULL=CHAR(0)
	PARAMETER	ORDZERO=ICHAR('0')
	PARAMETER	WAITSEC=1	! wait for completion of escape seqs.
	INTEGER*2	IOSB(4), CHAN
	INTEGER*4	FUN, STAT
	CHARACTER*2	BUF
		!
	INTEGER*4 ROW, COL
	INTEGER*4 NUMBER
	CHARACTER*(*) STRING
		!
	SAVE CHAN
		!
		! statement function to do cursor positioning
		!
	CHARACTER*8 POSITIONING
	POSITIONING(ROW,COL) = ESCAPE	// '['
	1				// CHAR(MOD(ROW/10,10)+ORDZERO)
	1				// CHAR(MOD(ROW,10)+ORDZERO)
	1				// ';'
	1				// CHAR(MOD(COL/10,10)+ORDZERO)
	1				// CHAR(MOD(COL,10)+ORDZERO)
	1				// 'H'
		!
	ENTRY PUT_STRING( ROW, COL, STRING )

	STAT = %LOC( SS$_NORMAL )
	IF ( CHAN .LE. 0 ) STAT = SYS$ASSIGN( 'TT', CHAN, , )
	IF (STAT) THEN
	  STAT = SYS$QIOW(,%VAL(CHAN),IO$_WRITEVBLK,,,,
	1			%REF(POSITIONING(ROW,COL)//STRING),
	1			%VAL(8+LEN(STRING)),,,,)
	END IF

	IF (.NOT.STAT) CALL LIB$STOP( %VAL(STAT) )
	RETURN

	ENTRY GET_KEY( ROW, COL, NUMBER )

	FUN = (		%LOC(IO$_READPROMPT)
	1	.OR.	%LOC(IO$M_TRMNOECHO)
	1	.OR.	%LOC(IO$M_NOECHO)
	1	.OR.	%LOC(IO$M_NOFILTR)	)
				! 
	STAT = %LOC( SS$_NORMAL )
	IF ( CHAN .LE. 0 ) STAT = SYS$ASSIGN( 'TT', CHAN, , )
	IF ( STAT ) THEN
	  STAT = SYS$QIOW( , %VAL(CHAN), %VAL(FUN), %REF(IOSB), , ,
	1		%REF(BUF), %VAL(1), , ,
	2		%REF(POSITIONING(ROW,COL)), %VAL(8) )
				!
	  IF (STAT) THEN	!! first get ok.
	    NUMBER = ICHAR(BUF)	! return terminator.
	    IF (IOSB(1).EQ.%LOC(SS$_TIMEOUT)) THEN	! timed out.
	      STAT = %LOC(SS$_NORMAL)			! ok to time out.
	      NUMBER = 0				! return term = 0.
	    ELSE IF (NUMBER.EQ.ICHAR(ESCAPE)) THEN	!! more in escape seq?
				! get two remaining chars in the escape seq.
				! wait one sec for them to come down the wire.
	      FUN = FUN .AND. (.NOT.%LOC(IO$_READPROMPT))
	1		.OR. %LOC(IO$_READVBLK)
	1		.OR. %LOC(IO$M_TIMED)
	      STAT = SYS$QIOW(,%VAL(CHAN),%VAL(FUN),%REF(IOSB),,,
	1		%REF(BUF),%VAL(2),%VAL(WAITSEC),,,)
				!
	      IF (STAT) STAT = IOSB(1)  ! status of i/o.
	      IF (STAT.EQ.%LOC(SS$_TIMEOUT)) THEN	! incomplete esc seq.
	        STAT = %LOC(SS$_NORMAL)			! that's ok.
	      ELSE					! complete escape seq.
	        NUMBER = 128 + ICHAR(BUF(2:2))
	      ENDIF					! complete escape seq?
	    ENDIF				!! more in escape seq?
	  END IF		!! first get ok.
	END IF

	IF (.NOT.STAT) CALL LIB$STOP( %VAL(STAT) )
	RETURN

	END
