c
c	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c	+	                                                   +
c	+	Q D I S P L A Y         VAX/VMS  3.20              +
c	+	Display VAX/VMS Batch/Device queues and            +
c	+	estimated printing times.                          +
c	+	                                                   +
c	+	30 November 1982	Original release           +
c	+	13 May      1983        Revision 1.10              +
c	+	                                                   +
c	+	John Chong                                         +
c	+	Harris / Farinon Division                          +
c	+	1691 Bayport Avenue                                +
c	+	San Carlos, CA   94070                             +
c	+	(415) 594-3582                                     +
c	+	                                                   +
c	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c
c
	PROGRAM QDisplay
	BYTE mem_(1048576)
	BYTE p2(16), job_state, user_name(13), file_name(20)
	BYTE qname_len, num_queues, dev_queues, copies
	CHARACTER gsdnam*9, curr_time*8, qname*16
	CHARACTER qnames(31)*16, dev_q_names(31)*16
	CHARACTER command_line*128
	INTEGER*2 smq_len, smq_index, q_index, d_index, cps
	INTEGER*2 job_seq, block_size, speed_cps(31)
	INTEGER*4 mem_start, mem_size, mem_addr(2), map_addr(2) 
	INTEGER*4 smq_start, sqh_start, sys$mgblsc, sec$k_matall
	INTEGER*4 file_size, f_siz_total, last_job_seq
	INTEGER*4 ret_stat, lib$get_foreign, sec$m_sysgbl
	REAL*8 DFLOAT, ABS, print_time(31)
	COMMON /mem_blk/ mem_start, mem_size, mem_
	COMMON /com_blk/ f_siz_total, job_seq, p2, job_state,
     1	  file_size, copies, user_name, file_name, last_job_seq
	EQUIVALENCE (p2, qname)
	EXTERNAL sys$mgblsc, lib$get_foreign
	EXTERNAL sec$m_sysgbl, sec$k_matall
	DATA gsdnam /'JBCSYSQUE'/
c
c   ================================================================
c
c   C O N F I G U R A T I O N    N O T E S
c
c   The following data statements are used to identify the available
c   queues  on the system and to specify the output (print) speed of
c   the associated  devices.  The  "Minutes of output" estimates are
c   determined using these speed specifications.   If QDisplay finds
c   a queue on the system that  it cannot identify, it will indicate
c   the total "Blocks  to output" instead of minutes.
c
c   QDisplay, as distributed, defines three queues:   LPA0, TTG4 and
c   TTD7.  Their print speeds are 120, 030 and 030 CPS respectively.
c   Edit the DATA statements  below to  match the  available devices
c   on your installation and recompile/relink using QDBUILD.COM.
c
c   ----------------------------------------------------------------
c
c   1)  Specify:
c		o  The number of output (print) queues being defined.
c
	DATA dev_queues /3/
c
c   2)  Specify for each Device Queue:
c		o  Queue name;
c		o  Queued device's output (print) speed in CPS.
c 
	DATA dev_q_names(1), speed_cps(1) /'LPA0', 120/
	DATA dev_q_names(2), speed_cps(2) /'TTD7', 030/
	DATA dev_q_names(3), speed_cps(3) /'TTG4', 030/
c
c   ================================================================
c
c
c   Symbol definitions.
c
	smq_start = 288
	smq_len = 84
	sqh_start = 0
	block_size = 512
	last_job_seq = -1
c
c   Map to the Job Control System queue.
c
	mem_addr(1) = %LOC (mem_(512))
	mem_addr(2) = %LOC (mem_(1048576))
	ret_stat = sys$mgblsc (mem_addr, map_addr, %VAL (0),
     1	  sec$m_sysgbl, gsdnam, sec$k_matall,)
	mem_start = map_addr(1) - %LOC (mem_(1)) + 1
	mem_size = map_addr(2) - map_addr(1) + 1
c
c   Get current time.
c
	CALL TIME (curr_time)
c
c   Open I/O channel to SYS$OUTPUT.
c
	OPEN (UNIT = 6, CARRIAGECONTROL = 'list', STATUS = 'unknown')
c
c   Get command line.
c
	ret_stat = lib$get_foreign (command_line,,,,)
	IF ((ret_stat .AND. 1) .AND.
     1	  (command_line(1:2) .EQ. '/D')) THEN
	    CALL mem_dump
	    CLOSE (UNIT = 6)
	    CALL EXIT
	    END IF
c
c   Output first line (header).
c
	WRITE (6, 100) curr_time
	WRITE (6, 110)
c
c   Main QDISPLAY loop.  
c
	num_queues = mem_(mem_start + sqh_start + 5)
	DO 200 smq_index = 1, num_queues, 1
	    f_siz_total = 0
	    CALL process_smq (smq_start + (smq_index - 1) * smq_len,
     1	      qname_len)
	    qnames(smq_index) = qname(1:qname_len)
c
c   Determine device speed on current queue.
c
	    cps = 0
	    DO 220 d_index = 1, dev_queues + 1, 1
		IF (qnames(smq_index) .EQ. dev_q_names(d_index)) THEN
		    cps = speed_cps(d_index)
		    END IF
220		CONTINUE
c
c   Calculate estimated output (print) times.
c
	    IF ((cps .NE. 0) .AND. (f_siz_total .NE. 0)) THEN
		print_time(smq_index) = DFLOAT (f_siz_total) *
     1		  DFLOAT (block_size) / DFLOAT (cps) / 60.0
	    ELSE
		print_time(smq_index) = -DFLOAT (f_siz_total)
		END IF
200	    CONTINUE
c
c   Write estimated print times for each queued device.
c
	WRITE (6, 110)
	DO 210 q_index = 1, num_queues, 1
	    IF (print_time(q_index) .GT. 0.0) THEN
		WRITE (6, 120) print_time(q_index), qnames(q_index)
	    ELSE IF (print_time(q_index) .LT. 0.0) THEN
		print_time(q_index) = ABS (print_time(q_index))
		WRITE (6, 130) print_time(q_index), qnames(q_index)
		END IF
210	    CONTINUE
c
	CLOSE (UNIT = 6)
	CALL EXIT
c
c
c
100	FORMAT (1X, T1, 'Entry', T8, 'Queue_name', T26, 'State'
     1	  T33, 'Blks', T40, 'Copy', T46, 'User_name',
     2	  T61, 'File_name', T72, 8A)
110	FORMAT (1X)
120	FORMAT (1X, 10X, F10.2, ' Minutes of output on ', A15)
130	FORMAT (1X, 10X, F10.2, ' Blocks  of output on ', A15)
	END
c
c   Process SMQ structure.
c
	SUBROUTINE process_smq (smq_index, qname_len)
	BYTE mem_(1048576)
	BYTE qname(16), job_state, user_name(13), file_name(20)
	BYTE qname_len, space, copies
	INTEGER*2 sqh__timque, smq__name, qnam_index, job_seq
	INTEGER*2 smq__current, smq__holdlst, sqh__curque
	INTEGER*4 current_list, pend_list, hold_list, time_list
	INTEGER*4 smq_index, f_siz_total, last_job_seq
	INTEGER*4 mem_start, mem_size
	COMMON /mem_blk/ mem_start, mem_size, mem_
	COMMON /com_blk/ f_siz_total, job_seq, qname, job_state,
     1	  file_size, copies, user_name, file_name, last_job_seq
c
c   Symbol definitions.
c
	smq__current = 0
	smq__holdlst = 4
	smq__name = 16
	sqh__timque = 24
	sqh__curque = 64
	space = 32
c
c   Get the name of the current queue.
c
	qname_len = mem_(mem_start + smq_index + smq__name)
	DO 1000 qnam_index = 1, 16, 1
	    IF (qnam_index .LE. qname_len) THEN
		qname(qnam_index) = mem_(mem_start + smq_index +
     1		  smq__name + qnam_index)
	    ELSE
		qname(qnam_index) = space
		END IF
1000	    CONTINUE
c
c   Get pointers to queued lists for each state.
c
	current_list = i4 (mem_(mem_start + smq_index + smq__current))
	pend_list = i4 (mem_(mem_start + sqh__curque))
	hold_list = i4 (mem_(mem_start + smq_index + smq__holdlst))
	time_list = i4 (mem_(mem_start + sqh__timque))
c
c   Process the list for each state.
c
	job_state = 0
	CALL process_sjh (current_list, smq_index)
	job_state = 1
	CALL process_sjh (pend_list, smq_index)
	job_state = 2
	CALL process_sjh (hold_list, smq_index)
	job_state = 3
	CALL process_sjh (time_list, smq_index)
	RETURN
	END
c
c   Process SJH structure
c
	SUBROUTINE process_sjh (job_list, smq_qindex)
	BYTE mem_(1048576)
	BYTE qname(16), job_state, user_name(13), file_name(20)
	BYTE space, copies
	INTEGER*2 sjh__jobseq, sjh__usernam, sjh__nextjob
	INTEGER*2 sjh__reclink, sjh__qindex, job_seq, i2, user_index
	INTEGER*4 sjh_index, job_list, sqr_list, sjh_last, i4
	INTEGER*4 smq_qindex, sjh_qindex, f_siz_total
	INTEGER*4 last_job_seq, mem_start, mem_size
	COMMON /mem_blk/ mem_start, mem_size, mem_
	COMMON /com_blk/ f_siz_total, job_seq, qname, job_state,
     1	  file_size, copies, user_name, file_name, last_job_seq
c
c   Symbol definitions.
c
	sjh__last = 0
	sjh__relink = 0
	sjh__jobseq = 4
	sjh__qindex = 6
	sjh__nextjob = 8
	sjh__usernam = 24
	space = 32
C
	sjh_index = job_list
2000	CONTINUE
	IF (sjh_index .EQ. sjh_last) GOTO 2020
	sjh_qindex = i2 (mem_(mem_start + sjh_index + sjh__qindex))
	IF (sjh_qindex .NE. smq_qindex) GOTO 2030
	DO 2010 user_index = 1, 12, 1
	    user_name(user_index) = mem_(mem_start + sjh_index +
     1	      sjh__usernam + user_index - 1)
2010	    CONTINUE
	user_name(13) = space
	job_seq = i2 (mem_(mem_start + sjh_index + sjh__jobseq))
	sqr_list = i4 (mem_(mem_start + sjh_index + sjh__reclink))
	CALL process_sqr (sqr_list)
2030	CONTINUE
	sjh_index = i4 (mem_(mem_start + sjh_index + sjh__nextjob))
	GOTO 2000
2020	CONTINUE
	RETURN
	END
c
c   Process SQR structure.
c
	SUBROUTINE process_sqr (sqr_list)
	BYTE mem_(1048576)
	BYTE qname(16), job_state, user_name(13), file_name(20)
	BYTE file_name_len, copies, space
	INTEGER*2 file_index, sqr__reclink, sqr__filenam, job_seq
	INTEGER*2 sqr__filesiz, sqr__copycnt
	INTEGER*4 sqr_index, sqr_last, file_size, file_size_n
	INTEGER*4 sqr_list, f_siz_total, last_job_seq
	INTEGER*4 mem_start, mem_size
	COMMON /mem_blk/ mem_start, mem_size, mem_
	COMMON /com_blk/ f_siz_total, job_seq, qname, job_state,
     1	  copies, file_size, user_name, file_name, last_job_seq
c
c   Symbol definitions.
c
	sqr__last = 0
	sqr__reclink = 0
	sqr__filnam = 40
	sqr__copycnt = 61
	sqr__filesiz = 64
	space = 32
c
	sqr_index = sqr_list
3000	CONTINUE
	IF (sqr_index .EQ. sqr_last) GOTO 3020
	file_name_len = mem_(mem_start + sqr_index + sqr__filnam)
	DO 3010 file_index = 1, 20, 1
	    IF (file_index .LE. file_name_len) THEN
		file_name(file_index) = mem_(mem_start + sqr_index +
     1		  sqr__filnam + file_index)
	    ELSE
		file_name(file_index) = space
		END IF
3010	    CONTINUE
	copies = mem_(mem_start + sqr_index + sqr__copycnt)
	file_size_n = i4 (mem_(mem_start + sqr_index + sqr__filesiz))
	IF (copies .GT. 0) THEN
	    file_size = file_size_n / copies
	ELSE
	    file_size = file_size_n
	    END IF
	IF ((job_state .EQ. 0) .OR. (job_state .EQ. 1))
     1	  f_siz_total = f_siz_total + file_size_n
	CALL outline
	sqr_index = i4 (mem_(mem_start + sqr_index + sqr__reclink))
	GOTO 3000
3020	CONTINUE
	RETURN
	END
c
c   Output complete job status line to SYS$OUTPUT.
c
	SUBROUTINE outline
	BYTE p2(16), job_state, copies, p5(13), p6(20)
	CHARACTER qname*16, user_name*13, file_name*20
	CHARACTER j_state*6
	INTEGER*2 job_seq
	INTEGER*4 file_size, mem_start, f_siz_total, last_job_seq
	COMMON /com_blk/ f_siz_total, job_seq, p2, job_state,
     1	  copies, file_size, p5, p6, last_job_seq
	EQUIVALENCE (p2, qname), (p5, user_name), (p6, file_name)
c
c
c
	j_state = ' --- '
	IF (job_state .EQ. 3) j_state = 'Time '
	IF (job_state .EQ. 2) j_state = 'Hold '
	IF (job_state .EQ. 1) j_state = 'Pend '
	IF (job_state .EQ. 0) THEN
	    j_state = 'Curr '
	    job_state = 1
	    END IF
	IF (job_seq .NE. last_job_seq) THEN
	    WRITE (6, 6000) job_seq, qname, j_state, file_size,
     1	      copies, user_name, file_name
	ELSE
	    WRITE (6, 6001) j_state, file_size, copies, file_name
	    END IF
	last_job_seq = job_seq
	RETURN
6000	FORMAT (1X, T1, I4.4, T8, A15, T26, A5, T33, I4.4,
     1	  T40, I3.3, T46, A12, T61, A19)
6001	FORMAT (1X, T26, A5, T33, I4.4, T40, I3.3, T61, A19)
	END
c
c   Dump contents of JBCSYSQUE global section.
c
	subroutine MEM_DUMP
	BYTE mem_(1048576), output_hex(16), output_mem(16)
	BYTE pointer_1, pointer_2, mem_i, dot, output_len
	CHARACTER output_asc*16
	INTEGER*4 mem_start, mem_size
	INTEGER*4 address, index_1, index_2
	LOGICAL*1 zero_current, zero_last, zero_suppress
	COMMON /mem_blk/ mem_start, mem_size, mem_
	EQUIVALENCE (output_hex, output_asc)
c
c   Define symbols
c
	dot = 46
	output_len = 16
c
	WRITE (6, 7094)
	WRITE (6, 7092)
	WRITE (6, 7093)
	WRITE (6, 7094)
	zero_last = .FALSE.
	DO 7000 index_1 = mem_start, mem_start + mem_size - 1, output_len
	    zero_current = .TRUE.
	    address = index_1 - mem_start
	    DO 7010 index_2 = index_1, index_1 + output_len - 1, 1
		pointer_2 = index_2 - index_1 + 1
		pointer_1 = output_len - pointer_2 + 1
		mem_i = mem_(index_2)
		output_mem(pointer_1) = mem_i
		IF (mem_i .GE. 32 .AND. mem_i .LE. 126) THEN
		    output_hex(pointer_2) = mem_i
		ELSE
		    output_hex(pointer_2) = dot
		    END IF
		IF (mem_i .NE. 0) zero_current = .FALSE.
7010		CONTINUE
	    IF (.NOT. (zero_current .AND. zero_last)) THEN
		WRITE (6, 7090)
     1		  address, address, output_mem, output_asc
		zero_suppress = .FALSE.
	    ELSE
		IF (.NOT. zero_suppress) WRITE (6, 7091)
		zero_suppress = .TRUE.
		END IF
	    zero_last = zero_current
7000	    CONTINUE
	IF (zero_suppress) THEN
	    WRITE (6, 7090)
     1	      address, address, output_mem, output_asc
	    END IF
	WRITE (6, 7094)
	RETURN
7090	FORMAT (1X, Z8.8, 1X, I10.10, 2X, 4(1X, 4Z2.2), 3X, A16)
7091	FORMAT (1X, 25X, '****  Zeroes Suppressed  ****')
7092	FORMAT (1X, 'Addr #16', 1X, 'Addr #10  ',
     1	  3X, ' F E D C', 1X, ' B A 9 8', 1X, ' 7 6 5 4',
     2	  1X, ' 3 2 1 0', 3X, 'ASCII')
7093	FORMAT (1X, '--------', 1X, '----------',
     1	  3X, '--------', '-', '--------', '-', '--------',
     2	  '-', '--------', 3X, '----------------')
7094	FORMAT (1X)
	END
c
c   Convert two consecutive bytes to integer*2 (word).
c
	INTEGER*2 FUNCTION i2 (i2t)
	INTEGER*2 i2t
	i2 = i2t
	RETURN
	END
c
c   Convert four consecutive bytes to integer*4 (longword).
c
	INTEGER*4 FUNCTION i4 (i4t)
	INTEGER*4 i4t
	i4 = i4t
	RETURN
	END
c
c   End of the world.
c
