$ !
$ ! Command procedure to start up the remote terminal emulator
$ ! with all the proper attributes set.
$ !
$ ! Written by Kevin Carosso, @ Hughes S&CG PWB/ENG, January 20, 1983
$ !
$ ! First get the terminal line we wanna go out on.
$ !
$	on control_Y then goto done
$	on warning then goto Done
$	set process/noresource_wait
$ !
$	LINE = p1
$	if LINE .nes. "" then goto Gotline
$ Getline:
$	inquire LINE "Terminal line"
$	if LINE .eqs. "" then goto Getline
$ !
$ ! Try to grab that line.
$ !
$ Gotline:
$	allocate 'LINE'
$	if .not. $STATUS then exit
$ !
$ ! Set up the proper characteristics.
$ !
$	SPEED = p2
$	if SPEED .nes. "" then goto Gotspeed
$ Getspeed:
$	inquire SPEED "Remote line speed"
$	if SPEED .eqs. "" then goto Getspeed
$ Gotspeed:
$ !
$	ECHO = p3
$	if ECHO .nes. "" then goto Gotecho
$ Getecho:
$	inquire ECHO "Local or Remote echo (L or R)"
$	if ECHO .eqs. "" then goto getecho
$ Gotecho:
$	if ECHO .eqs. "L" then goto Local
$		ECHO = "NOECHO"
$		goto Setup_terminal
$ !
$ Local:
$	ECHO = "ECHO"
$ !
$ ! Set the terminal line properly
$ !
$ Setup_terminal:
$	set terminal/nottsync/'ECHO
$ !
$ ! Now set up the outgoing terminal line properly.
$ !
$	set terminal/noecho/nointeractive/hostsync/fulldup-
	/type_ahead/ttsync/speed='SPEED' 'LINE'
$ !
$ ! Now invoke the terminal emulator.
$ !
$	define/user_mode TT$LUN 'LINE'
$	define/user_mode SYS$INPUT SYS$COMMAND
$	run PRIV:TERM.EXE
$ !
$ ! Common exit handler.
$ !
$ Done:
$	set noon
$	deallocate 'LINE'
$	set process/resource_wait
$	set ter/echo/ttsync
$	exit
