[inherit ('SYS$LIBRARY:STARLET.PEN')] module IOPmod (input, output);

const
  bufflen = 256;
  reqid = 47;
  infunc  = IO$_READVBLK + IO$M_NOECHO + IO$M_TRMNOECHO + IO$M_NOFILTR;
  outfunc = IO$_WRITEVBLK + IO$M_NOFORMAT;

var
  inchannel, outchannel : [static, volatile, word] -32768..32767;
  bitmap  : [static] array [1..4] of integer := (-1, -1, -1, -1);
  inpterm : [static] array [1..2] of integer := (%x10000000, 0);
  inass, outass : [static] integer := 0;
  wait_time : [static, quad, unsafe] record
		L0 : unsigned;
		L1 : unsigned;
	      end := (%xFFF0BDC0, %xFFFFFFFF);
  outbuff : [static, volatile] record
	      length : integer;
	      chars : packed array [1..bufflen] of char;
	    end := (0, (bufflen of ' '));

[asynchronous, unbound] procedure write_buffer;

var
  stat : integer;

begin (* write_buffer *)
  stat := $CANTIM (reqid,);		(* turn off any timer request AST's *)
  if not odd (stat) then $EXIT (stat);
  with outbuff do
    if length <> 0 then begin
      stat := $QIOW ( , outchannel, outfunc, , , , chars, length, , , , );
      if not odd (stat) then $EXIT (stat);
      length := 0;
    end;
end; (* write_buffer *)

[global, asynchronous] procedure exitprogram (status : integer := SS$_NORMAL);

begin (* exitprogram *)
  write_buffer;
  $EXIT (status);
end; (* exitprogram *)

[global] function tinput : char;

var
  inchar : char;
  stat : integer;

begin (* tinput *)
  if inass = 0 then begin		(* need to assign the channel *)
    inpterm[2] := iaddress (bitmap);
    if odd ($ASSIGN ('SYS$INPUT', inchannel, , )) then inass := 1 else
      inass := -1;
  end;
  if inass < 0 then
    if eof (input) then inchar := chr (26) else
      if eoln (input) then begin
	readln; inchar := chr (13);
      end else read (inchar)
  else begin
    write_buffer;
    stat := $QIOW ( , inchannel, infunc, , , , inchar, 1, , %REF (inpterm), ,);
    if not odd (stat) then exitprogram (stat);
  end;
  tinput := inchar;
end; (* tinput *)

[global] procedure toutpt (outchar : char);

var
  stat : integer;

begin (* toutpt *)
  if outass = 0 then			(* need to assign the channel *)
    if odd ($ASSIGN ('SYS$OUTPUT', outchannel, , )) then outass := 1 else
      outass := -1;
  if outass < 0 then begin
    if outchar = chr (13) then writeln else
      if outchar <> chr (10) then write (outchar);
  end else with outbuff do begin
    stat := $CANTIM (reqid,);		(* turn off any timer request AST's *)
    if not odd (stat) then exitprogram (stat);
    length := succ (length);
    chars[length] := outchar;
    if (length = bufflen) or (outchar = chr (13)) then write_buffer
    else begin
      stat := $SETIMR ( , wait_time, write_buffer, reqid);
      if not odd (stat) then exitprogram (stat);
    end;
  end;
end; (* toutpt *)

end. (* module IOPmod *)
