c
c  TERM.FOR
c
c	This is a program to emulate a terminal allowing a user
c	to dial up another computer and either pass or recieve 
c	ascii files.  The character variable term should be assigned
c	to the terminal port where the user has a data phone to
c	dial out on.  The <ctrl/a> key puts the program into command
c	mode where he can enter the following commands:
c
c	HELP
c	SEND <filename>     File to send default is send.dat
c	RECV <filename>     File to recieve data default is recv.dat
c	CLOSE               Close out the recieve file
c       EXIT                Exit terminal emulator
c
c	The terminal should be in full duplex mode
c
c	written by R. E. Burroughs            OCT 15 1981
c       This version modified by Kevin Carosso,
c       @ Hughes S&CG PWB/ENG, January 21, 1983
c
c
c
c
	implicit integer*4 (a-z)
	integer*2 ttlun,termlun,ttstat(4),termstat(4)
	character tt*2/'TT'/,term*6/'TT$LUN'/,command_line*80
	character*4 send/'SEND'/,recv/'RECV'/,clo/'CLOS'/,exit/'EXIT'/
	character*4 help/'HELP'/
	character*(60) filename
	dimension termchr(10),termdsc(2)
	byte ttbuf(80),termbuf(80),buffer(132),p4b(4),dskbuf(256)
	logical rcv,error,local,echo

	common /lun/ ttlun,termlun,ttbuf,termbuf,rcv,dskbuf,olen

	external IO$_TTYREADALL, IO$M_REFRESH, TT$M_NOECHO
	external IO$_WRITEVBLK, IO$_READVBLK, IO$_SETMODE
	equivalence (p4b(1),p4)
c
	termdsc(1)=40
	termdsc(2)=%LOC(termchr(1))

c
c	put up a greeting to let him know the program is running
c
c

	type 1
1	format(' Terminal Emulation Routine - Version 1.2',/)

	rcv = .false.			!not in receive mode
c
c
c	now let's assign logical unit numbers to his terminal and the
c	one the modem is on
c

	status=SYS$ASSIGN(tt,ttlun,,)		! his terminal
	if(.not. status) call LIB$STOP(%VAL(status))
	status=SYS$ASSIGN(term,termlun,,)	! the one for the modem
	if(.not. status) call LIB$STOP(%VAL(status))

	status=SYS$GETCHN(%VAL(ttlun),blen,termdsc,,)!find out if his terminal
	if(.not. status) call LIB$STOP(%VAL(status))!is in local or remote echo

	tnoecho = %LOC(TT$M_NOECHO)
	l = iand(tnoecho,termchr(3))
	if( l .eq. 0 )then
		echo = .true.
	else
		echo = .false.
	end if

c
c	clear all of the event flags we are going to use
c

	status=SYS$CLREF(%VAL(5))
	if(.not. status) call LIB$STOP(%VAL(status))
	status=SYS$CLREF(%VAL(6))
	if(.not. status) call LIB$STOP(%VAL(status))
	status=SYS$CLREF(%VAL(7))
	if(.not. status) call LIB$STOP(%VAL(status))


c
c	set up read function to pass all and refresh
c

	funcr=%LOC(IO$_TTYREADALL).or.%LOC(IO$M_REFRESH)

c
c	now issue an async read to his terminal and the one
c	for the modem.  AST's will take care of the read.

	Call Localast

	Call Remoteast

c
c	set up mask for flag  7 and wait for it
c

100	mask = '200'O

	status=SYS$WFLOR(%VAL(1),%VAL(mask))
	if(.not. status) call LIB$STOP(%VAL(status))
c
c	Got one. Read all of the flags in cluster 1
c

	status=SYS$READEF(%VAL(1),%REF(event_flags))
	if(.not. status) call LIB$STOP(%VAL(status))

	cmnd=0
c
c	Find out which flags are set
c

	cmnd=jiand(event_flags,'200'O)		! flag 7
	


	if(cmnd .ne. 0) then

c	<cntrl/a> key struck.   Get command from user

		status=SYS$CLREF(%VAL(7))

c
c    set terminal to echo if not already
c
	if( .not. echo ) then
	   termchr(3) = iand ( termchr(3),.not. tnoecho)
	   status = SYS$QIOW(%VAL(11),%VAL(ttlun),IO$_SETMODE,
	1,,,termchr(2),%VAL(0),,,,,)
	   if( .not. status) call LIB$STOP(%VAL(status))
	end if

c	zero command line

		command_line(1:)=char(0)
		type 200
200		format(/,1h$,'TERM> ')
		accept 210, command_line
210		format(a)

c
c    set terminal to noecho if it is supposed to be there
c
	if( .not. echo ) then
	   termchr(3) = ior ( termchr(3), tnoecho)
	   status = SYS$QIOW(%VAL(11),%VAL(ttlun),IO$_SETMODE,
	1,,,termchr(2),%VAL(0),,,,,)
	   if( .not. status) call LIB$STOP(%VAL(status))
	end if
c
c	convert to upper case letters
c
	status = STR$UPCASE (command_line, command_line)
	if (.not. status) call LIB$STOP(%VAL(status))
c
c     See if it is an EXIT command
c
	Loc = index(command_line(1:),exit(1:4))
	If(Loc .ne. 0) stop ' '
c
c	see if it is a send command
c
	loc=index(command_line(1:),send(1:4))
	if(loc .ne. 0) then
		local = .true.
		type 212
212		format(/)
c
c	get filename
c
		call getfil(command_line,filename,error,local)
		if( error ) goto 250

		p4b(1)='2B'X
		p4b(2)=0
		p4b(3)=0
		p4b(4)=0

c	open file and read from it

		open(unit=2,file=filename,status='old',readonly)
220		read(2,230,end=240)n,(buffer(ii),ii=1,n)
230		format(q,132a1)

c	send to modem

	status=SYS$QIOW(%VAL(2),%VAL(termlun),IO$_WRITEVBLK,
	1,,,%REF(buffer),%VAL(n),,%VAL(p4),,)
	if(.not. status) call LIB$STOP(%VAL(status))

c	and write it to screen for him to see

	if(  echo ) then
		type 111,(buffer(jj),jj=1,n)
111		format(1h ,80a1)
	end if

		goto 220	! go get another one

240		close(unit=2)		!all done close out file
		type 241
241		format(' [ End of file ]',/)
		goto 250
	end if

c	see if it was a receive command

	loc=index(command_line(1:),recv(1:4))
	if(loc .ne. 0) then
		type 212

		if(rcv) close(unit=1) !file alread open close it

		local = .false.
		call getfil(command_line,filename,error,local)
		if( error ) goto 250

c	open up receive file

		open(unit=1,file=filename,status='new'
	1            ,carriagecontrol='list')
	
		rcv = .true.
		olen=0		!set output length to 0

		goto 250

	end if


c	see if it was a close command

	loc=index(command_line(1:),clo(1:4))
	if(loc .ne. 0) then
		type 212

		close(unit=1)	!close read file
	
		rcv = .false.
		olen=0
		type 245
245		format(' { Input file closed }',/)

		goto 250

	end if

c	see if it was a HELP command

	loc=index(command_line(1:),help(1:4))
	if(loc .ne. 0) then
		type 212
		type 246
246		format (' The following commands may be specified:',/,/,
     *			'     HELP           - Print this message.',/,
     *			'     SEND filename  - Send the specified file.',/,
     *			'     RECV filename  - Recieve the specified file.',/,
     *			'     CLOSE          - Close up received file.',/,
     *			'     EXIT           - Exit the program.',/)

		goto 250

	end if


		type *,' Unknown Command  '
		type 212

250		Call localast

		goto 100
	end if
	
c	error

	type *,'unknown event flag'

	end
c
c
c
c

	subroutine ttast(ttstat)
c
c	This is an AST routine to handle output to the modem
c	when the user enters a character
c
	implicit integer*4 (a-z)
	integer*2 ttlun,termlun,ttstat(4)
	byte ttbuf(80),termbuf(80),dskbuf(256)
	logical rcv
	common /lun/ ttlun,termlun,ttbuf,termbuf,rcv,dskbuf,olen

	external IO$_WRITEVBLK, IO$M_NOFORMAT, IO$M_REFRESH

c	set up a write pass all

	func=%LOC(IO$_WRITEVBLK).or.%LOC(IO$M_NOFORMAT).or.
	1%LOC(IO$M_REFRESH)


c	see if he pressed a cntrl/a. If so go get command

	if(ttbuf(1) .eq. 1 ) then
		status=SYS$SETEF(%VAL(7))
		if(.not. status) call LIB$STOP(%VAL(status))
		return
	end if


	p4=0

c	Ok , now write character to modem

	status=SYS$QIO(%VAL(3),%VAL(termlun),%VAL(func),
	1,,,%REF(ttbuf),%VAL(1),,%VAL(p4),,)
	if(.not. status) call LIB$STOP(%VAL(status))


10	ttbuf(1)=0
c   issue a new read request

	Call Localast
	

	return
	end
c
c
c
c

	subroutine outchar (char)
c
c	This is a routine to output a character to the user's terminal
c	when the modem sends a character.  It takes care of writing into
c	a file if we are receiving.  INDEX is the index of the
c	character in the TERMBUF buffer.
c
	implicit integer*4 (a-z)
	integer*2 ttlun,termlun,ttstat(4),termstat(4)
	byte ttbuf(80),termbuf(80),dskbuf(256),char
	logical rcv
	common /lun/ ttlun,termlun,ttbuf,termbuf,rcv,dskbuf,olen
C
C  Replaced the QIO here with my own version of TOUTPT.  This
C  seems to cut system overhead on the interrupt stack by about
C  50%.  Also cut time in kernel mode by about 20%.
C
C If you don't have "toutpt", then replace with a simple 1 character,
C unformatted QIO to the output device (terminal).  If you want to write
C a "toutpt" then be aware that it is a simple buffered output routine
C that stores characters in an output buffer and then writes them all out
C with a single QIO when either: the buffer is full, an input request via
C "tinput" is called, or when 1/10th of a second elapses between
C "toutpt" calls.

	call toutpt (char)

	if ( rcv ) then	! We are in receive mode

	if(char .ne. 13 ) Then			!use <cr> as record delimiter
	    if(char .ne. 10) Then		!Don't write out linefeeds
		olen=olen+1
		dskbuf(olen)=char		! add data to output buffer
	    End If
	Else

	    write(1,6)(dskbuf(i),i=1,olen)
6	    format(256a1)
	    olen=0
	End If
	End If

	return
	end
c
c
c

	subroutine termast(index)
c
c	This is an AST routine to handle output to the user terminal
c	when the modem sends a character.  INDEX is the index of the
c	character in the TERMBUF buffer.
c
	implicit integer*4 (a-z)
	integer*2 ttlun,termlun,ttstat(4),termstat(4)
	byte ttbuf(80),termbuf(80),dskbuf(256)
	logical rcv
	common /lun/ ttlun,termlun,ttbuf,termbuf,rcv,dskbuf,olen

c	
c	write character from modem to user terminal or receive file.
c
	call outchar (termbuf(index))
	termbuf(index)=0

c   issue new read request if we are AST level.

	Call Remoteast

	return
	end
c
c
c

	subroutine getfil(command,filename,error,local)
c
c	This routine is used to get a file name from command
c	and return it in filename after checking it for validity
c

	implicit integer (A-Z)
	character*(*) command
	character*(60) filename
	character*1 spc/' '/
	logical error,local,found
c
	error = .false.
	found = .false.
c
	do i=1,60
		filename(i:i)=char(0)
	end do

	loc = index(command(1:),spc(1:1))
	if(loc .eq. 0) then
		type 10
10		format(/,' Command line error')
		error = .true.
		return
	end if
c
	do i=loc,80	!find first character in filename
		indx = i
		if(ichar(command(i:i)) .gt. 32)go to 100
	end do
c
c	use default names
c
	if(local)filename='send.dat'
	if(.not. local)filename='recv.dat'
	goto 200
c
c
100	loc=0   ! load file name into filename
110	if(ichar(command(indx:indx)) .le. 32)goto 200
	loc = loc + 1
	filename(loc:loc) = command(indx:indx)
	indx = indx + 1
	goto 110
c
c	see if it is valid and check to see if it exists
c
200	inquire(file=filename,err=300,exist=found)
	goto 400

300		error = .true.
		type 350
350		format(/,' File specification error')
		return
c
c
400	if( local .and. found ) return  ! found one to send
	if( local .and. (.not. found))then
		type 450
450		format(/,' File not found') !didn't find one to send
		error = .true.
		return
	end if
c
	return
	end	
c
c
c

	Subroutine Remoteast
c
c
	implicit integer*4 (a-z)
	integer*2 ttlun,termlun,ttstat(4),termstat(4)
	byte ttbuf(80),termbuf(80),buffer(132),dskbuf(256)
	integer*4 termask(2)
	logical rcv,error,local

	common /lun/ ttlun,termlun,ttbuf,termbuf,rcv,dskbuf,olen

	data termask /0, 0/

	external IO$_TTYREADALL, IO$M_REFRESH, termast, ttast
	external IO$_WRITEVBLK, IO$_READVBLK, IO$M_TIMED
	external SS$_NORMAL, SS$_TIMEOUT
c
c  Set up read function to pass all and refresh
c
      funcr = %LOC (IO$_TTYREADALL) .or. %LOC (IO$M_TIMED)
C
C  First we'll try reading a bufferful of characters from the
C  remote line.   This way, high baud rates will work without
C  an excessive amount of kernel thrashing.
C
10    status = SYS$QIOW (, %VAL(termlun), %VAL(funcr),
     *                   %REF(termstat),,, %REF(termbuf), %VAL(80),
     *                   %VAL(0), %REF(termask),,)
      if (.not. status) call LIB$STOP (%VAL(status))
C
C  If we got anything from the type ahead buffer, use TERMAST to output
C  each character and then try again.  If we didn't get anything, then
C  go set up an AST to see anything coming in the future.
C
      if ((.not. termstat(1)) .and.
     *    (termstat(1) .ne. %LOC (SS$_TIMEOUT)))
     *  call LIB$STOP (%VAL (termstat(1)))

      if (termstat(2) .ne. 0) then
        do i = 1, termstat(2)
          call outchar (termbuf(i))
        end do
      end if
c
c  Set up read function to pass all and refresh, with no time limits.
c
      funcr=%LOC(IO$_TTYREADALL)
c
c  Now issue an async read to the modem.
c  AST's will take care of the read.

      status = SYS$QIO (%VAL(2),%VAL(termlun),%VAL(funcr),
     *                  %REF(termstat),termast,%REF(1),
     *                  %REF(termbuf),%VAL(1),,,,)
      if(.not. status) call LIB$STOP(%VAL(status))

      Return
      End
c
c
c

	Subroutine Localast
c
c
	implicit integer*4 (a-z)
	integer*2 ttlun,termlun,ttstat(4),termstat(4)
	byte ttbuf(80),termbuf(80),buffer(132),p4b(4),dskbuf(256)
	logical rcv,error,local

	common /lun/ ttlun,termlun,ttbuf,termbuf,rcv,dskbuf,olen

	external IO$_TTYREADALL, IO$M_REFRESH, termast,ttast
	external IO$_WRITEVBLK, IO$_READVBLK
	equivalence (p4b(1),p4)

c
c	set up read function to pass all and refresh
c

	funcr=%LOC(IO$_TTYREADALL)

c
c	Now issue an async read to his terminal 
c	AST's will take care of the read.
c
	status=SYS$QIO(%VAL(1),%VAL(ttlun),%VAL(funcr),
	1%REF(ttstat),ttast,ttstat,%REF(ttbuf),%VAL(1),,,,)
	if(.not. status) call LIB$STOP(%VAL(status))



	Return
	End
