{
  This is a simple program to replace the DECnet MAIL network
  object to allow routing of non-VMS mail messages into and
  out of the system.
}
program RmtMail (network, output);

type
  string = varying [256] of char;

var
  network : text;
  sender, addressee, message_line : string;
  done : boolean;
  success : [readonly] packed array [1..4] of char := (chr(1), 3 of chr(0));
  i, valid_addr_count : integer;

begin
  open (File_variable := network,
	File_name := 'SYS$NET',
	History := OLD);

{  First read the sender's name. }

  reset (network);
  readln (network, sender);
  writeln ('Sender: ', sender);

{  Now read the addressee list.  It is terminated by a null byte. }

  done := false;
  valid_addr_count := 0;
  repeat
    reset (network);
    readln (network, addressee);
    if length (addressee) = 1 then
      done := ord (addressee[1]) = 0;
    if not done then
    begin
      writeln ('Addressee: ', addressee);
      rewrite (network);
      writeln (network, success);
      valid_addr_count := valid_addr_count + 1;
    end;
  until done;

{  Now read the "To:" and "Subject:" lines. }

  reset (network);
  readln (network, message_line);
  writeln (message_line);
  readln (network, message_line);
  writeln (message_line);

{  Now read the message body. }

  done := false;
  repeat
    readln (network, message_line);
    if length (message_line) = 1 then
      done := ord (message_line[1]) = 0;
    if not done then
      writeln (message_line);
  until done;

{  Indicate that we got message ok. }

  rewrite (network);
  for i := 1 to valid_addr_count do
    writeln (network, success);
  close (network);
end.
