{
  TAIL prints out the last N lines of it's input file.  This was originally
  written by Lisa Penninger, but modified a bit by Kevin Carosso.
}

program tail (sysoutput, datafile);

type
    string = varying [256] of char;
    linebuf = record
		line : string;
		next : ^linebuf; 
               end;

var
    stat : integer;
    i,n,count : integer;
    buf,start : ^linebuf;
    lines_str, file_str : string;
    sysoutput, datafile : text;

procedure LIB$STOP (stat : integer); extern;

function CLI$GET_VALUE (name : [class_s] packed array [l1..u1:integer] of char;
			var value : varying [ml2] of char
		       ) : integer; extern;

begin
    stat := CLI$GET_VALUE ('P1', file_str);
    if not odd (stat) then LIB$STOP (stat);
    stat := CLI$GET_VALUE ('LINES', lines_str);
    if not odd (stat) then LIB$STOP (stat);
    readv (lines_str, n);

    open (FILE_VARIABLE := datafile,
	  FILE_NAME := file_str,
	  HISTORY := READONLY,
	  ORGANIZATION := SEQUENTIAL,
	  RECORD_LENGTH := 512,
	  SHARING := READWRITE);

    reset (datafile);

    open (FILE_VARIABLE := sysoutput,
	  FILE_NAME := 'SYS$OUTPUT',
	  ORGANIZATION := SEQUENTIAL,
	  RECORD_LENGTH := 512);

    rewrite (sysoutput);

{ Build a circular linked list for N lines. }

    new (start);
    buf := start;
    for i := 2 to n do begin
        new (buf^.next);
	buf := buf^.next;
    end;
    buf^.next := start;
    start := buf;

{ Fill the circular list.  When done it will contain last N lines. }

    count := 0;
    while not eof (datafile) do begin
        count := count + 1;
        readln (datafile, buf^.line);
        buf := buf^.next;
    end;

{ Print out the list. }

    if count < n then begin
        buf := start;
	n := count;
    end;

    for i := 1 to n do begin
        writeln (sysoutput, buf^.line);
        buf := buf^.next;
    end;
end.	    
