$!			INCBACKUP.COM
$!	This command procedure will perform an incremental backup
$!	of a disk from the date of the last backup to the current time.  
$!	It will log the following information for later use;
$!
$!		a) The Operators name
$!		b) The Disk name and device
$!		c) The Tape Number and Tape name
$!		d) The Container file name
$!		e) The date(s) spanned by the backup
$!		f) The last date/time backuped to
$!		g) The # of tape errors if any.
$!
$	Verify_at_Start = 'F$VERIFY(0)'			!
$	Notified="F"
$	ON ERROR THEN GOTO The_End			!
$	ON CONTROL_Y THEN GOTO Catch_Abort		! Trap aborts
$	Users="ALL"
$!	Users="TERM=TT:"
$	Old_Disk:="''F$LOGICAL("SYS$DISK")'"		! Get starting disk
$	Old_UIC:="''F$USER()'"				! Get old UIC
$	Old_Directory:="''F$DIRECTORY()'"		!
$	SET UIC [300,300]
$	SET DEFAULT SYS$SYSDEVICE:[OPERATOR]
$	PAGE						!
$	TYPE SYS$INPUT					!
			INCBACKUP.COM
			     V2.3

	Remember -- the disk must be mounted for the backup to work!!

$	SET CONTROL_Y					!
$!
$	Tmp:='Last_Name'				!
$	Last_Name:='Tmp'				!
$	If Last_Name .EQS. "" THEN -			!
		INQUIRE Last_Name "What is your last name"
$Get_Device:						!
$	INQUIRE Disk "Which device do you wish to backup"! Find which disk
$	IF Disk .EQS. "" THEN GOTO  Get_Device	! Insist we have the
$	IF Disk .EQS. "DRA0:" THEN GOTO Got_Device	!  specified drive
$	IF Disk .EQS. "DRA1:" THEN GOTO Got_Device	!
$	IF Disk .EQS. "DMA1:" THEN GOTO Got_Device	!
$	IF Disk .EQS. "DUA0:" THEN GOTO Got_Device	!
$	WRITE SYS$OUTPUT ""				!
$	WRITE SYS$OUTPUT "INCBACKUP -- Invalid device name.  Valid names are:"
$	WRITE SYS$OUTPUT "                  DRA0:, DRA1:, DMA1:, DUA0:"
$	GOTO Get_Device					!
$Got_Device: 						! 
$	Vol_name:='F$GETDVI(Disk,"VOLNAM")'	! Get current vol name
$	Allocated:='F$GETDVI(Disk,"ALL")'	! Is disk allocated
$	IF .NOT. Allocated THEN GOTO Check_Mount! If not, is it mounted
$!
$	WRITE SYS$OUTPUT " "			! Bad, bad, disk is allocated
$	WRITE SYS$OUTPUT -			! Tell operator the bad news
"	''Disk' is currently privately allocated to another process.
$	WRITE SYS$OUTPUT -			! Print out owner so can
"	Please, contact the user and find out why ''Vol_Name' is not available"
$	WRITE SYS$OUTPUT " "			!
$	SHOW DEV 'Disk'/FULL			! get owner from listing
$	TYPE SYS$INPUT				!

	Procedure terminated.  Try again when disk deallocated.
$	GOTO The_End				!
$Check_Mount:					! Now check if disk mounted
$	Mounted:='F$GETDVI(Disk,"MNT")'		! It had better be
$	IF Mounted THEN GOTO Allocate_tape	! It is, see if tape avail
$!
$	WRITE SYS$OUTPUT " "			! Ugh, disk not mounted
$	WRITE SYS$OUTPUT "INCBACKUP -- ''Disk' is not mounted"
$	WRITE SYS$OUTPUT "             Mount the disk and restart backup"
$	WRITE SYS$OUTPUT "             Exiting!!"	!
$	IF Verify_at_Start THEN SET VERIFY		!
$	GOTO The_End				!

$Allocate_Tape:					! See if tape is ready
$	Allocated:='F$GETDVI("MSA0:","ALL")'	! Is it allocated
$	IF Allocated THEN GOTO Tape_Allocated	! If yes, fatal error
$	ALL MSA0:				! Gotcha, your all mine
$	TYPE SYS$INPUT				! Remind operator

	Warnings at 1 minute intervals for up to 5 minutes will be broadcast 
$	WRITE SYS$OUTPUT -			!
"to all users to close all files and get off ''Disk'."
$	WRITE SYS$OUTPUT " "			!
$!
$!
$	Count=0					! Init counter
$	Message1:=-				! Set up messages for 
"''Disk' must go down for backup."		! sending to users
$	Message2:=-				! 
"Immediately close all files on ''Disk'. Open files can not be backed up."
$	Message="''F$FAO("''Message1'!/''Message2'")'"! Stick in <CR>
$	REPLY/'Users'/BELL "''Message'"		!
$	Notified="T"
$	Transaction_count:='F$GETDVI(Disk,"TRANSCNT")'	! Only repeat if open
$	IF Transaction_count .LE. 2 THEN GOTO Do_Backup	! files on volume
$Request:					!
$	WAIT 'Interval'				! Message interval
$	IF Count .GE. 4  THEN GOTO Do_Backup	! Warn users only 5 times
$	REPLY/'Users'/BELL  "''Message'"	!
$	Count=Count+1				! We can count
$	Transaction_count:='F$GETDVI(Disk,"TRANSCNT")'	! Only repeat if open
$	IF Transaction_count .GT. 2 THEN GOTO Request	! files on volume
$Do_Backup:					! All ready for backup
$	Message1:=-				!
"''Disk' is being backed up. Any open files will not be backed up."
$	Message2:=-				!
"You will be notified when the backup is completed and the disk may be used."
$	Message3:="Please do not use ''Disk' until then."
$	Message:="''F$FAO("''Message1'!/''Message2'!/''Message3'!/")'"!
$	REPLY/'Users'/BELL "''Message'"		!
$	Length='F$LENGTH(Vol_Name)		! How long is name
$	Tmp:='Vol_Name'				! Assume disk name
$	IF Length.GT.9 THEN Tmp[0,9]:=Vol_Name	! Truncate to 9 char
$	Disk_Name=tmp				!
$!
$	Today[0,11]:="''F$TIME()'"			! Get today's date
$	Month:="''F$EXTRACT(3,3,Today)'"		! Get month
$	Year:="''F$EXTRACT(7,4,Today)'"			! Get year
$	Day:="''F$EXTRACT(0,2,Today)'"			! Get day
$	Test:="''F$EXTRACT(0,1,Today)'"			! Check for blank
$	IF Test .EQS. " " THEN Day[0,1]:="0"		!  If so, make a 0
$	IF Test .EQS. " " THEN Today[0,1]:="0"		!  If so, make a 0
$!
$Get_Tape_Name:						!
$	System:='F$LOGICAL("SYS$SYSUSER1")'		! RA81 disk 
$	IF System .NES. Disk THEN GOTO Get_Tape_Name_2!
$	This_Day='Day'					! Make a number
$	Week=This_Day/7+1				! Find week in month
$	Tape_Name:=WK'Week'BKP				! The tape to mount
$	WRITE SYS$OUTPUT ""
$	WRITE SYS$OUTPUT -
"If the backup is the weekly RA81 backup, use the tape named ''Tape_Name'"! 
$	WRITE SYS$OUTPUT ""
$Get_Tape_Name_2:
$	INQUIRE Tape_Name "What is the backup tape name"!
$	IF Tape_Name .EQS."" THEN GOTO Get_Tape_Name_2	!
$	Length='F$LENGTH(Tape_Name)'			! Is name Valid?
$	Tape[0,6]:=" "					! Force 6 spaces
$	Tape[0,'Length']:='Tape_Name'			!
$	IF Length .LE. 6 THEN GOTO Get_Tape_Number	!
$	WRITE SYS$OUTPUT " "				!
$	WRITE SYS$OUTPUT "INCBACKUP -- Tape names must be <= 6 characters"
$	GOTO Get_Tape_Name				!
$Get_Tape_Number:					!
$	INQUIRE Tape_Number "What is the backup tape number"
$	IF Tape_Number .eqs. "" THEN GOTO Get_Tape_Number!
$	Length='F$LENGTH(Tape_Number)'			!
$	IF Length .GT. 4 THEN GOTO Get_Tape_Number	!
$	Tap_Nbr[0,4]:=" "				! Blank fill
$	Tap_Nbr[0,'Length']:='Tape_Number'		!
$Ask_New_Tape:						!
$	INQUIRE New_Tape -				!
	"Initialize a new tape or append to existing backup sets (I/A)"
$	IF New_Tape .NES. "I"	.AND. -			! If neither init
	   New_Tape .NES. "A"	THEN GOTO Ask_New_Tape	!
$	IF New_Tape .EQS. "A"   THEN GOTO Append_It	!
$	WRITE SYS$OUTPUT " "				!
$	WRITE SYS$OUTPUT -				!
	"Initializing the tape will wipe out all old backups on the tape"
$	INQUIRE Are_You_Sure "Are you sure you want to do this [Y/N]"
$	IF .NOT. Are_You_Sure THEN GOTO Ask_New_Tape	!
$	Rewind:=/REWIND					!
$	Label:="/LABEL=''Tape_Name'"			! Lable a new tape
$	New:="Y"					!
$	GOTO Get_Last_Backup				! Get date of last bkp
$Append_It: Rewind:=/NOREWIND				! Force Append
$	Label:=""					! No label on append
$	New:="N"					!
$Get_Last_Backup:					!
$	Disk$Name:='Disk_Name'				!
$	Name_Length='F$LENGTH(Disk$NAME)'		! See if a _ is pres
$	Position='F$LOCATE("_",Disk$Name)		!
$	IF Position .EQ. Name_Length THEN GOTO Name_OK	! If EQ, no _ found
$	Disk$Name['Position',1]:="X"			! Make _ into an X
$Name_OK:						!
$	Start_Date:=01-JAN-1980				! Defaults to long ago
$	Versn="00"					! Assume 0 version #
$	TESTFILE SYS$SYSDEVICE:[OPERATOR.BACKUP]'Disk$Name'.BAK ! Prev bkp done?
$	IF $STATUS .NE.1 THEN GOTO Get_Time		! No, prompt for time
$	SET NOCONTROL_Y					! No aborts for now
	OPEN/READ INFILE -				!
	SYS$SYSDEVICE:[OPERATOR.BACKUP]'Disk$Name'.BAK 	! Yes, find last time
$Loop:							!
$	READ/END_OF_FILE=End_Loop INFILE RECORD		! Read file up to end
$	GOTO Loop					! 
$End_Loop: CLOSE INFILE					! Extract time of last
$	ON CONTROL_Y THEN GOTO Catch_Abort		!
$	SET CONTROL_Y					! Allow them now
$	Start_Date:='F$EXTRACT(14,11,RECORD)'		!  backup done on disk
$	Version_number_loc='F$LOCATE(".B",RECORD)'	! Find start of versn
$	Start_loc=Version_number_loc+2			!
$	Oldversn=F$EXTRACT(Start_Loc,2,RECORD)		!
$	IF Oldversn .EQS. "99" THEN Oldversn="1"	!
$	TMP=F$INTEGER(1+'OLDVERSN')			!
$	Versn='TMP'					!
$	IF TMP.LT.10 THEN VERSN ="0"+F$STRING(TMP)	!
$	WRITE SYS$OUTPUT -				!
	"''Disk_Name' was last incrementally backed up on ''Start_Date'"!
$Get_Time:						!
$	INQUIRE From "Backup files starting from (<CR> => ''Start_Date')"
$	IF From .EQS. "" THEN From:='Start_Date'	! <CR> => default
$	Length='F$LENGTH(From)				! Get string length
$	IF Length .NE. 11 THEN -			! Insure proper date
	WRITE SYS$OUTPUT "INCBACKUP -- Invalid time string" ! Warn and
$	IF Length .NE. 11 THEN GOTO Get_Time		! reprompt if bad
$	Backup_Name:='Month''Day''Year'".B"'Versn'	!
$!
$Mount_Tape:						!
$	ON CONTROL_Y  THEN GOTO Mount_Abort		! Trap aborts
$	SET CONTROL_Y					! Allow aborts
$	WRITE SYS$OUTPUT " "				!
$	WRITE SYS$OUTPUT "Place a mag-tape on MSA0"	!
$	WRITE SYS$OUTPUT "The tape will be initialized with the name ''Tape_Name'"
$	WRITE SYS$OUTPUT ""
$	INQUIRE READY "Are you ready to continue [Y -> yes, ^Y to abort]"
$	IF .NOT. Ready THEN GOTO Mount_Tape
$	IF Are_You_Sure THEN INITIALIZE MSA0:/OVER=(ACC,EXP) 'Tape_Name'
$	IF $STATUS .NE. 1 THEN GOTO Mount_Tape		!
$	MOUNT MSA0: /FOREIGN				!
$	IF $STATUS .NE. 1 THEN GOTO Mount_Tape		!
$	Error_at_Start='F$GETDVI("_MSA0","ERRCNT")'! Error count at start
$	ON ERROR THEN GOTO Tape_Error			! Catch tape errors
$	WRITE SYS$OUTPUT "Starting backup"		! 
$	SHOW TIME					!
$	BACKUP/FAST/VERIFY -				!
'Disk'[*...]/SINCE:'From' MSA0:'Backup_Name''Rewind''Label'	!
$	ON ERROR THEN GOTO The_End			!
$	SET CONTROL_Y					! Allow aborts now
$	Error_at_End='F$GETDVI("_MSA0","ERRCNT")'	! Error count at start
$	Err= Error_at_End - Error_at_Start		! Calc the dif
$	Error[0,5]:='Err'				! Make a string
$	IF Err .ne. 0 THEN WRITE SYS$OUTPUT -		!
	"WARNING -- ''Err' Tape errors were encountered during the backup"
$	SET NOCONTROL_Y					! Don't allow aborts
$!
$	TESTFILE SYS$SYSDEVICE:[OPERATOR.BACKUP]'Disk$Name'.BAK ! Logfile exist?
$	IF $STATUS .EQ. 1	THEN GOTO Add_Rec	! 
$!
$! File does not yet exist, create it
$	OPEN/WRITE OUTFILE -				!
	SYS$SYSDEVICE:[OPERATOR.BACKUP]'Disk$Name'.BAK	!
$	WRITE OUTFILE -					!
"   From           To       Tape    #   Init  Set_Name     Error    Operator"
$	WRITE OUTFILE -
"''From'   ''Today'  ''Tape'  ''Tap_Nbr' ",-		!
"''New'   ''Backup_Name'   ''Error'  ''Last_Name'"	!
$	CLOSE OUTFILE					!
$	ASSIGN/USER NL: SYS$OUTPUT			!
$	ASSIGN/USER NL: EDTINI				!
$	Edit/EDT SYS$SYSDEVICE:[OPERATOR.BACKUP]'Disk$Name'.BAK! Fix carriage control
EXIT
$	PURGE SYS$SYSDEVICE:[OPERATOR.BACKUP]'Disk$Name'.BAK! 
$	PRINT SYS$SYSDEVICE:[OPERATOR.BACKUP]'Disk$Name'.BAK! Print list
$	GOTO Finish_Up					!
$Add_Rec:						!
$	OPEN/WRITE OUTFILE -				!
	'Disk$Name'.XXX					! A temp file
$	WRITE OUTFILE -					!
"''From'   ''Today'  ''Tape'  ''Tap_Nbr' ",-		!
"''New'   ''Backup_Name'   ''Error'  ''Last_Name'"	!
$	CLOSE OUTFILE					!
$	ASSIGN/USER NL: EDTINI				!
$	ASSIGN/USER NL: SYS$OUTPUT			!
$	EDIT/EDT 'Disk$Name'.XXX 			! Fix carriage control
EXIT
$	APPEND 'Disk$Name'.XXX -			!
	SYS$SYSDEVICE:[OPERATOR.BACKUP]'Disk$Name'.BAK	! Tack on record
$	DELETE 'Disk$Name'.XXX;*			!
$	PRINT/NOIDENT SYS$SYSDEVICE:[OPERATOR.BACKUP]'Disk$Name'.BAK ! Print list
$Finish_Up:						!
$	SHOW TIME					!
$	set noon
$	DISMOUNT MSA0:/UNLOAD				!
$	TYPE SYS$INPUT					!

INCBACKUP -- The disk backup is now complete.  Please remember to;
             a) Affix a date sticker to the tape reel.
             b) Physically dismount the tape and return it
                to it's cabinet.

$The_End:						!
$	IF .NOT. Notified THEN GOTO The_End_1
$	TYPE SYS$INPUT
	Users have been told that the disk is being backed up.  If they
	are to use the disk again, they should be told it is ready.

$	Inquire OK "Is disk ''Disk' now available for general use [Y/N]"
$	IF OK THEN REPLY/'Users'/BELL -
"Disk ''Disk' is now available for use."
$The_End_1:
$	SET MESSAGE/NOTEXT/NOIDENT/NOFACILITY/NOSEVERITY
$	DEALLOCATE MSA0:
$	SET MESSAGE/TEXT/IDENT/FACILITY/SEVERITY
$	SET UIC 'Old_UIC'
$	SET DEFAULT 'Old_Disk''Old_Directory'
$	SET CONTROL_Y					! Allow aborts
$	IF Verify_at_Start THEN SET VERIFY		!
$	EXIT						! all done
$!
$Tape_Error:
$	SHOW TIME					!
$	DISMOUNT MSA0:/UNLOAD				!
$	TYPE SYS$INPUT					!

INCBACKUP -- A tape error occurred which probably means the backup
             tape is now useless.  Get HELP!!!

$	SET CONTROL_Y					!
$	GOTO The_End
$!
$Catch_abort:						!
$	TYPE SYS$INPUT

	INCBACKUP has been aborted with a ^Y.  Cleaning up...

$	GOTO The_End					!
$Mount_Abort:
$	TYPE SYS$INPUT

	The tape mount has been aborted.  

$	GOTO The_end
$Tape_Allocated:
$	TYPE SYS$INPUT

	The tape drive is already allocated to another user.

$	SHOW DEV MSA0:/FULL
$	GOTO The_End
$!
$!  File Name:	INCBACKUP.COM
$!  Author:	James G. Downward
$!  Date:	05-Feb-1982
$!  Function:	Provide for an automatic backup procedure which
$!		keeps a log of backup as they are done.
$!
$! Required files:	[SYSMGR.CMDFIL]PAGE.COM      - Erase Screen or FF
$!
$!  Modified:
$!		17-AUG-1983	Update for DUA0:
$!		09-Sep-1983	Check for devices being properly mounted
$!				clean up process to use V3.0 features.
$!				Allow multiple backup sets on same day.
$!
