$!			JNLBACKUP.COM
$!	This command procedure will perform an incremental backup
$!	of a collection of files as specified by the user.  It will
$!	create a journal file of the process,SYS$LOGIN:JNLBACKUP.BJL,
$!	and keep a running log in SYS$LOGIN:JNLBACKUP.LOG of your 
$!	backup dates and backup set times.  It will insure that all 
$!	backup set names on a given tape are unique.
$!
$	Verify_at_Start = 'F$VERIFY(0)'			!
$	Old_Default:="SYS$DISK:''F$DIRECTORY()'"	!
$	ON ERROR THEN GOTO The_End			!
$	ON CONTROL_Y THEN GOTO Catch_Abort		! Trap aborts
$	PAGE
$	TYPE SYS$INPUT					!
			JNLBACKUP.COM
			     V3.1

$	ON CONTROL_Y THEN GOTO Catch_Abort		!
$	SET CONTROL_Y					!
$!
$Get_Device:						!
$	INQUIRE Device "Which disk do you wish to backup"! Find which disk
$	IF Device .EQS. "" THEN GOTO  Get_Device	! Insist we have the
$	Colon_loc='F$LOCATE(":",Device)'		! A colon in name?
$	IF Colon_loc .EQ. 'F$LENGTH(Device)' THEN Device:="''Device:"
$	TMP:= 'F$GETDVI(Device,"EXISTS")'		! See if it exists
$	IF .NOT. TMP THEN GOTO No_Such_Device		!
$	TMP1:='F$GETDVI(Device,"DEVCLASS")'		! and can have files
$	IF TMP1 .EQS. "1" THEN GOTO Got_Device		!
$	WRITE SYS$OUTPUT ""				! In case not a
$	WRITE SYS$OUTPUT -				!
"JNLBACKUP -- ''Device' is not a disk"
$	WRITE SYS$OUTPUT "" 				!
$	GOTO Get_Device					!
$No_Such_Device:
$	WRITE SYS$OUTPUT ""				!
$	WRITE SYS$OUTPUT "JNLBACKUP -- Invalid device name: ''Device'"
$	WRITE SYS$OUTPUT "             Valid names are: DRA0:, DRA1:, DMA1:"
$	WRITE SYS$OUTPUT "             SYS$SYSROOT:, and SYS$SYSDEVICE:"
$	WRITE SYS$OUTPUT "" 				!
$	GOTO Get_Device					!
$Got_Device: 						! No aborts now
$	ON CONTROL_Y THEN GOTO Catch_Abort		!
$	SET CONTROL_Y					! Allow aborts now
$	TMP:='F$GETDVI(Device,"MNT")' 			! See if disk is
$	IF TMP THEN GOTO Is_Mounted 			!   mounted?
$	WRITE SYS$OUTPUT " "				!
$	WRITE SYS$OUTPUT "JNLBACKUP -- ''Device' is not mounted"
$	WRITE SYS$OUTPUT "             Mount the disk and restart backup"
$	WRITE SYS$OUTPUT "             Exiting!!"	!
$	IF Verify_at_Start THEN SET VERIFY		!
$	EXIT						!
$Is_Mounted:						!
$	INQUIRE Directory "What is directory name"
$	Disk_Name:='F$GETDVI(Device,"VOLNAM")'		! Get disk name
$	Today[0,11]:="''F$TIME()'"			! Get today's date
$	Month:="''F$EXTRACT(3,3,Today)'"		! Get month
$	 Year:="''F$EXTRACT(7,4,Today)'"		! Get year
$	  Day:="''F$EXTRACT(0,2,Today)'"		! Get day
$	 Test:="''F$EXTRACT(0,1,Today)'"		! Check for blank
$	IF Test .EQS. " " THEN Day[0,1]:="0"		!  If so, make a 0
$	IF Test .EQS. " " THEN Today[0,1]:="0"		!  If so, make a 0
$!
$Get_Tape_Name:						!
$	INQUIRE Tape_Name "What is the backup tape name"!
$	IF Tape_Name .EQS."" THEN GOTO Get_Tape_Name	!
$	Length='F$LENGTH(Tape_Name)'			! Is name Valid?
$	Tape[0,6]:=" "					! Force 6 spaces
$	Tape[0,'Length']:='Tape_Name'			!
$	IF Length .LE. 6 THEN GOTO Get_Tape_Number	!
$	WRITE SYS$OUTPUT " "				!
$	WRITE SYS$OUTPUT "JNLBACKUP -- Tape names must be <= 6 characters"
$	GOTO Get_Tape_Name				!
$Get_Tape_Number:					!
$	INQUIRE Tape_Number "What is the backup tape number"
$	IF Tape_Number .eqs. "" THEN GOTO Get_Tape_Number!
$	Length='F$LENGTH(Tape_Number)'			!
$	Tap_Nbr[0,3]:=" "				! Blank fill
$	Tap_Nbr[0,'Length']:='Tape_Number'		!
$Ask_New_Tape:						!
$	INQUIRE New_Tape -				!
	"Initialize a new tape or append to existing backup sets (I/A)"
$	IF New_Tape .NES. "I"	.AND. -			! If neither init
	   New_Tape .NES. "A"	THEN GOTO Ask_New_Tape	!
$	IF New_Tape .EQS. "A"   THEN GOTO Append_It	!
$	WRITE SYS$OUTPUT " "				!
$	WRITE SYS$OUTPUT -				!
	"Initializing the tape will wipe out all old backups on the tape"
$	INQUIRE Are_You_Sure "Are you sure you want to do this [Y/N]"
$	IF .NOT. Are_You_Sure THEN GOTO Ask_New_Tape	!
$	Rewind:=/REWIND					!
$	Label:="/LABEL=''Tape_Name'"			! Lable a new tape
$	New:="Y"					!
$	GOTO Get_Last_Backup				! Get date of last bkp
$Append_It: Rewind:=/NOREWIND				! Force Append
$	Label:=""					! No label on append
$	New:="N"					!
$Get_Last_Backup:					!
$	Disk$Name:='Disk_Name'				!
$	Name_Length='F$LENGTH(Disk$NAME)'		! See if a _ is pres
$	Position='F$LOCATE("_",Disk$Name)		!
$	IF Position .EQ. Name_Length THEN GOTO Name_OK	! If EQ, no _ found
$	Disk$Name['Position',1]:="X"			! Make _ into an X
$Name_OK:						!
$	Start_Date:=01-JAN-1976				! Defaults to long ago
$	Versn="00"					! Assume 0 version #
$	TESTFILE SYS$LOGIN:JNLBACKUP.LOG 			! Prev bkp done?
$	IF $STATUS .NE.1 THEN GOTO Get_Time		! No, prompt for time
$	SET NOCONTROL_Y					! No aborts for now
$	OPEN/READ INFILE SYS$LOGIN:JNLBACKUP.LOG		!
$Loop:							!
$	READ/END_OF_FILE=End_Loop INFILE RECORD		! Read file up to end
$	GOTO Loop					! 
$End_Loop: CLOSE INFILE					! Extract time of last
$	ON CONTROL_Y THEN GOTO Catch_Abort		!
$	SET CONTROL_Y					! Allow them now
$	Version_number_loc='F$LOCATE(".B",RECORD)'	! Find start of versn
$	Start_loc=Version_number_loc+2			!
$	Oldversn=F$EXTRACT(Start_Loc,2,RECORD)		!
$	IF Oldversn .EQS. "99" THEN Oldversn="1"	!
$	TMP=F$INTEGER(1+'OLDVERSN')			!
$	Versn='TMP'					!
$	IF TMP.LT.10 THEN VERSN ="0"+F$STRING(TMP)	!
$	Start_Date:='F$EXTRACT(14,11,RECORD)'		!  backup done on disk
$	WRITE SYS$OUTPUT -				!
	"JNLBACKUP was last used on ''Start_Date'"	!
$	WRITE SYS$OUTPUT -				!
"Enter 01-Jan-1976 to backup all files regardless of date"
$Get_Time:						!
	INQUIRE From "Backup files starting from (<CR> => ''Start_Date')"
$	IF From .EQS. "" THEN From:='Start_Date'	! <CR> => default
$	Length='F$LENGTH(From)				! Get string length
$	IF Length .NE. 11 THEN -			! Insure proper date
	WRITE SYS$OUTPUT -				! if not
"JNLBACKUP -- Invalid date string. Use dd-MMM-YYYY (01-Jan-1982)" ! Warn and
$	IF Length .NE. 11 THEN GOTO Get_Time		! reprompt if bad
$	Backup_Name:="''Month'''Day'''Year'.B''versn'"	!
$!
$	Select=""					! Assume null
$	INQUIRE Select "File selection string (<CR> -> All files) "
$	IF Select .EQS. "" THEN Select="*.*;*"
$!
$Mount_Tape:						!
$	ON CONTROL_Y  THEN GOTO Catch_Abort		! Trap aborts
$	SET CONTROL_Y					! Allow aborts
$	WRITE SYS$OUTPUT " "				!
$	WRITE SYS$OUTPUT "Place a mag-tape on MSA0"	!
$	INQUIRE READY "Type <return> when ready"	!
$	MOUNT MSA0: /FOREIGN				!
$	IF $STATUS .NE. 1 THEN GOTO Mount_Tape		!
$	ON CONTROL_Y THEN GOTO Finish_Up		!
$	Error_at_Start='F$GETDVI("_MSA0","ERRCNT")'	! Error count at start
$	WRITE SYS$OUTPUT "Starting backup at ''F$TIME()'"! 
$	Sys_Priv=F$PRIVILEGE("SYSPRV")			!
$	Switch:=""					!
$	IF Sys_Priv THEN Switch:="/IGNORE=INTERLOCK/FAST"!
$	SET DEFAULT SYS$LOGIN				! 
$	SET NOON					!
$	ON SEVERE THEN GOTO Tape_Error			! Catch tape errors
$	ON WARNING THEN CONTINUE			!
$	BACKUP/VERIFY'Switch'-			
	/JOURNAL=SYS$LOGIN:JNLBACKUP -			!
	'Device''Directory''Select'-			!
	/SINCE:'From' -					!
	MSA0:'Backup_Name''Rewind''Label'		!
$	ON ERROR THEN GOTO The_End			!
$	SET DEFAULT 'Old_Default'
$	Error_at_End='F$GETDVI("_MSA0","ERRCNT")'	! Error cnt at end
$	Err= Error_at_End - Error_at_Start		! Calc the dif
$	Error[0,5]:='Err'				! Make a string
$	IF Err .ne. 0 THEN WRITE SYS$OUTPUT -		!
"JNLBACKUP -- WARNING -- ''Err' Tape errors were encountered during the backup"
$	SET NOCONTROL_Y					! Don't allow aborts
$!
$	TESTFILE SYS$LOGIN:JNLBACKUP.LOG			! Logfile exist?
$	IF $STATUS .EQ. 1	THEN GOTO Add_Rec	! 
$!
$! File does not yet exist, create it
$	OPEN/WRITE OUTFILE SYS$LOGIN:JNLBACKUP.LOG		!
$	WRITE OUTFILE -					!
"   From           To       Tape    #   Init  Set_Name     Errors   Directory    Files"
$	WRITE OUTFILE -
"''From'   ''Today'  ''Tape'  ''Tap_Nbr'  ",-		!
"''New'   ''Backup_Name'   ''Error'  ''Directory'    ''Select'"!
$	CLOSE OUTFILE					!
$	ASSIGN/USER NL: SYS$OUTPUT			!
$	ASSIGN/USER NL: EDTINI				!
$	EDIT SYS$LOGIN:JNLBACKUP.LOG			!Fix carriage control
EXIT
$	PURGE SYS$LOGIN:JNLBACKUP.LOG			!
$	PRINT SYS$LOGIN:JNLBACKUP.LOG/NOIDENT		! Print list
$	GOTO Finish_Up					!
$Add_Rec:						!
$	OPEN/WRITE OUTFILE -				!
	'Disk$Name'.XXX					! A temp file
$	WRITE OUTFILE -					!
"''From'   ''Today'  ''Tape'  ''Tap_Nbr'  ",-		!
"''New'   ''Backup_Name'   ''Error'  ''Directory'    ''Select'"	!
$	CLOSE OUTFILE					!
$	ASSIGN/USER NL: EDTINI				!
$	ASSIGN/USER NL: SYS$OUTPUT			!
$	EDIT 'Disk$Name'.XXX 				! Fix carriage control
EXIT
$	APPEND 'Disk$Name'.XXX SYS$LOGIN:JNLBACKUP.LOG	! Tack on record
$	DELETE 'Disk$Name'.XXX;*			!
$	PRINT SYS$LOGIN:JNLBACKUP.LOG/NOIDENT		! Print list
$Finish_Up:						!
$	WRITE SYS$OUTPUT "Backup finished at ''F$TIME()'"
$	DISMOUNT MSA0:/NOUNLOAD				!
$	TYPE SYS$INPUT					!

JNLBACKUP -- The disk backup is now complete.  Please remember to;
             a) Affix a date sticker to the tape reel.
             b) Physically dismount the tape and store it safely.

$The_End:						!
$	SET DEFAULT 'Old_Default'			!
$	SET CONTROL_Y					! Allow aborts
$	IF Verify_at_Start THEN SET VERIFY		!
$	EXIT						! all done
$!
$Tape_Error:
$	WRITE SYS$OUTPUT "JNLBACKUP -- Tape error abort at ''F$TIME()'"
$	DISMOUNT MSA0:/UNLOAD				!
$	TYPE SYS$INPUT					!

JNLBACKUP -- A tape error occurred which probably means the backup
             tape is now useless.  Get HELP!!!
$	SET CONTROL_Y					!
$	IF Verify_at_Start THEN SET VERIFY		!
$	EXIT
$!
$Catch_abort:						!
$	WRITE SYS$OUTPUT -				!
"^Y - Abort, cleaning up and exiting"			!
$	GOTO The_End					!
$!
$!  File Name:	JNLBACKUP.COM
$!  Author:	James G. Downward
$!  Date:	08-JUL-82
$!  Function:	Provide for an automatic backup procedure which
$!		keeps a log of backup as they are done.
$!
$! Required files:	[SYSMGR.CMDFIL]PAGE.COM      - Erase Screen or FF
$!			[SYSMGR.CMDFIL]TESTFILE.COM  - See if file there
$!
$!  Modified:	27-Oct-1982	JGD	Make more robust. Use F$GETDVI.
$!
