
$!				OPERATOR.COM
$!	   It is desireable to have a variety of operator functions which can
$!	be performed by a variety of people who do not necessarily understand
$!	all the details of the operations being performed.  The operators
$!	account is viewed as essentially a "slave" account which provides a
$!	menue of functions for managing the system which when invoked will
$!	perform exactly the same way each and every time.  More over log 
$!	records will be kept in the operators log as the the function being
$!	done.  Together with the console listing, recovery from a disasterous
$! 	error should be easier.
$!
$	ON CONTROL_Y THEN GOTO All_Done			!
$	TYPE SYS$INPUT
                        OPERATOR.COM
                           V1.7

$!
$	IF TerminaL_Unit .EQS. "OPA0:" THEN -		!
			 GOTO Enter_Name 		! Must use console
$	TYPE SYS$INPUT					! Warn user

OPERATOR -- Warning.  Most operator functions must be run from
	    the console terminal.

$!
$Enter_Name:
$!	SET CONTROL_Y					!
$	INQUIRE/GLOBAL Last_Name "What is your last name"!
$	IF Last_name .EQS. ""  THEN GOTO All_Done	!
$! Verify that the last name is one of the names in the authorization file
$! for using the operator account.
$Check_Name:						!
$	TESTFILE SYS$SYSDEVICE:[OPERATOR]OPERATORS.DAT	! See if list exists
$	IF $STATUS .NE. 1  THEN GOTO No_Operator_File	! Warn of error
$	SET NOCONTROL_Y					! No aborts now
$	OPEN/READ/ERROR=Read_Error INFILE -		!
	SYS$SYSDEVICE:[OPERATOR]OPERATORS.DAT		! See if user is OK
$Check_Loop:						!
$	READ/END_OF_FILE=EOF INFILE Name		!
$	IF Name .NES. Last_name THEN GOTO Check_Loop	! Try another name
$	CLOSE INFILE					! Found user
$	SET TERM/NOECHO
$	INQUIRE Password "Password"
$	SET TERM/ECHO
$	SET MESSAGE/NOTEXT/NOSEVERITY/NOIDENT/NOFACILITY
$	ON ERROR THEN CONTINUE
$	ASSIGN/USER NL: SYS$OUTPUT
$	SPAWN/INPUT=NL:/OUTPUT=NL: -
$TESTFILE STAR"''Last_name' ''Password'"::[000000]OPERATOR.DIR
$	TMP=$STATUS
$	DEASSIGN SYS$OUTPUT
$	SET MESSAGE/TEXT/SEVERITY/IDENT/FACILITY
$	IF TMP THEN GOTO Operator_OK
$	GOTO EOF					! Password not ok
$!
$Operator_OK:
$	SET CONTROL_Y
$	TESTFILE OPERATOR.LOG				! Is logfile there
$	IF $STATUS .NE. 1 THEN CREATE OPERATOR.LOG	! create if missing
$	OPEN/WRITE OUTPUT TMP.LOG			!
$	WRITE OUTPUT "''Last_name' accessed operator account on ''F$TIME()'"
$	CLOSE OUTPUT					!
$	SET MESSAGE/NOSEVERITY/NOFACILITY/NOTEXT/NOIDENT!
$	APPEND TMP.LOG OPERATOR.LOG			!
$	SET MESSAGE/SEVERITY/FACILITY/TEXT/IDENT	!
$	DEL TMP.LOG;*					!
$!
$Menue:
$	SET MESSAGE/NOSEVERITY/NOFACILITY/NOTEXT/NOIDENT! Disable msg on ^O
$	PAGE
$	TYPE SYS$INPUT
		The following operator functions are available

	ACCOUNT		-  Account file additions, listings, mods
	BACKUP		-  Perform an incremental or image backup of a disk.
	COMMAND		-  Submit/log command procedures for execution
	INITIALIZE      -  Initialize a virgin magnetic tape 
	IP6400		-  Load in the DeAnza IP6400 Global Section
	SHUTDOWN	-  Shut down the system
	EXIT		-  Exit/LOGOFF from this procedure.

$	SET MESSAGE/SEVERITY/FACILITY/TEXT/IDENT	! Enable messages
$Menue_1:
$	INQUIRE Function -
"Operator: What operator function would you like to perform"
$	IF Function .EQS. "EXIT"     THEN GOTO All_Done
$	IF Function .EQS. "COMMAND"  THEN GOTO Submit_Command
$	IF Function .EQS. "BACKUP"   THEN GOTO BACKUP
$	IF TerminaL_Unit .EQS. "OPA0:" THEN -		!
			 GOTO Menue_2			! Must use console
$	TYPE SYS$INPUT					! Warn user

OPERATOR -- The operator function requested must be run from the
	    console device, OPA0:.  Please go to the console and try again.  
	    Logging off....

$	LOGOUT
$	EXIT
$Menue_2:
$	IF Function .EQS. "ACCOUNT"    THEN GOTO Account
$	IF Function .EQS. "BACKUP"     THEN GOTO Backup
$	IF Function .EQS. "INITIALIZE" THEN GOTO Init_Tape
$	IF Function .EQS. "IP6400"     THEN GOTO IP6400
$	If Function .EQS. "SHUTDOWN"   THEN GOTO Shut_Down
$	TYPE SYS$INPUT

OPERATOR -- The function you selected is not available, try again

$	GOTO Menue
$Account:
$	@SYS$SYSROOT:[SYSMGR.CMDFIL]OPERACNT.COM
$	GOTO Menue_1
$!
$Backup:						!
$	TYPE SYS$INPUT	

	Three types of disk backup procedures exist:
	 a) FULL disk backup of DRA1:SYSUSER0, DUA0:SYSUSER1 or DMA1:
	 b) Incremental disk backup of any files

$Ask_Backup_Type:
$	ON CONTROL_Y THEN GOTO All_Done			!
$	INQUIRE Bkptyp "Full disk or Incremental backup [F/I]"
$	Tmpx[0,1]:='Bkptyp'				!
$	IF Tmpx .EQS. "F"  THEN GOTO Full_Backup	!
$	IF Tmpx .NES. "I"  THEN GOTO Ask_Backup_Type	!
$	SET PROC/PRIV=(BYPASS)				!
$	@SYS$SYSROOT:[SYSMGR.CMDFIL]INCBACKUP		!
$	SET PROC/PRIV=(NOBYPASS)			!
$	WRITE SYS$OUTPUT " "				!
$	GOTO Menue_1					!
$Full_Backup:						!
$	IF TerminaL_Unit .EQS. "OPA0:" THEN -		!
			 GOTO Full_Backup_2		! Must use console
$	TYPE SYS$INPUT					! Warn user

OPERATOR -- Full disk backups must be done from the operator console
	    device, OPA0:.  Please go to the console and try again.  
	    Logging off....

$	LOGOUT
$	EXIT
$Full_Backup_2:
$	SET PROC/PRIV=(BYPASS)
$	INQUIRE Disk "Disk to backup [DRA1:/DMA1:/DUA0:]"
$	IF Disk .NES. "DMA1:" .AND. Disk .NES. "DRA1:" .AND.-
           Disk .NES. "DUA0:" THEN GOTO Full_Backup_2
$	IF Disk .EQS. "DRA1:" THEN -
	@SYS$SYSROOT:[SYSMGR.CMDFIL]SYSBACKUP DRA1: SYSUSER0 !
$	IF Disk .EQS. "DMA1:" THEN -
	@SYS$SYSROOT:[SYSMGR.CMDFIL]SYSBACKUP DMA1:	!
$	IF Disk .EQS. "DUA0:" THEN -
	@SYS$SYSROOT:[SYSMGR.CMDFIL]SYSBACKUP DUA0: SYSUSER1 !
$	SET PROC/PRIV=(NOBYPASS)			!
$	WRITE SYS$OUTPUT " "				!
$	GOTO Menue_1					!
$!
$Init_Tape:
$	INQUIRE TMP "Place a tape on MSA0: Press RETURN when ready"
$	SET PROCESS/PRIV=VOLPRO
$	ON ERROR THEN GOTO Not_Allocated
$	ALL MSA0:
$	ON ERROR THEN CONTINUE
$	INIT MSA0:/OVERRIDE=(EXPIRATION,ACCESSIBILITY)  TEST
$	SET PROC/PRIV=NOVOLPRO
$	DEALLOCATE MSA0:
$	TYPE SYS$INPUT

	The virgin (factory fresh) tape has now had its first initialization.
	The default name given it was TEST.  At any later time, users
	may again initialize this tape using the name of their choice.

$	GOTO Menue_1
$Not_allocated:
$	TYPE SYS$INPUT
	
	The tape drive could not be allocated.  Find out who
	is using the tape drive and have them deallocate it
	
$	SHOW DEVICE MSA0:/FULL
$	GOTO Menu
$Not_Initialized:
$	TYPE SYS$INPUT

	The tape has not been initialized correctly.  Please
	save the console printout and get help.

$	GOTO Menu
$IP6400:
$	WRITE SYS$OUTPUT "OPERATOR -- Loading the IP6400 Global Section"
$	RUN SYS$SYSTEM:CREIP5				!
$	GOTO Menue_1					! Back for more
$!
$Submit_Command:
$	@SYS$SYSROOT:[SYSMGR.CMDFIL]OPERCMD.COM		! Go get command file
$	WRITE SYS$OUTPUT " "				!
$	GOTO Menue_1					! Back for more
$!
$Shut_Down:						!
$	INQUIRE Are_You_Sure -				!
	"Are you really sure you want to shut the system down [Y/N]"
$	IF .NOT. Are_You_Sure  THEN GOTO Menue_1	!
$	TYPE SYS$INPUT

    Remember to complete the shut down procedure and to later re-boot
the VAX-11/750 console mode switch must be turned from SECURE to LOCAL.
Once you do this, the console is "armed" and ^P will cause an unplanned
HALT.  DO NOT type ^P until the console prompts you to HALT the system
using the console. 

    To reboot type ^P.  When the system types >>>, you should respond
by typing
			 B           ! Boots from DRA0:
			 B DBA0      ! Boots from DRA0:
			 B DBA1      ! Boots from DRA1:

followed with a carriage return.  To boot Standalone Backup from the 
system disk (DRA0:), when the system types >>>, respond by typing

		         B/B0000000	    ! Boot from DRA0:
			 B/B0000000 DBA1    ! Boot from DRA1:

When Standalone Backup boots, to backup a system disk,

		1) Write Protect all disks
		2) Issue the command

		BACKUP/REWIND/IMAGE DRA0: MSA0:SYSTEM.SAV


$!
$	SET CONTROL_Y					! So can abort
$	@SYS$SYSTEM:SHUTDOWN.COM			! Shut down proc
$	SET NOCONTROL_Y					! Back to normal
$	GOTO Menue_1					! In Case was aborted
$	
$!
$All_Done:
$	SET TERM/ECHO					!
$	LOGOUT						!
$	EXIT
$No_Operator_File:					!
$	WRITE SYS$OUTPUT -				!
	"OPERATOR -- No operator authorization file exists, Exiting!"
$	LOGOUT
$EOF:	CLOSE INFILE					!
$	SET CONTROL_Y					!
$	WRITE SYS$OUTPUT " "				!
$	WRITE SYS$OUTPUT -				!
	"OPERATOR -- User not authorized for this operator account"
$	WRITE SYS$OUTPUT -				!
	"            or invalid name typed in"		!
$	GOTO Enter_Name					! Try again
$Read_Error:						!
$	WRITE SYS$OUTPUT -				!
	"OPERATOR -- Error reading OPERATORS.DAT, Exiting!!"
$	LOGOUT						!
$!
$!  File Name:	OPERATOR.COM
$!  Author:	James G. Downward
$!  Date:	15-Feb-82
$!  Function:			Provide for a controled function operator
$!				account which keeps track of who does what.
$!
$!  Modified:  	06-Jul 82 
$!		P. Vavra	Change SYS$SYSDISK to SYS$SYSDEVICE
$!                         	as required for Version 3.0
$!
$!		22-JUL-83	Add support for RA81
$!		J. Downward
$!
