$!		SYSBACKUP.COM
$! This command procedure will allow a full image backup to be
$! done by an operator.
$!
$	Users="ALL"				! Who to broadcast to
$	Interval="00:01:00"			! Delay between messages
$	Disk:='P1'				! Disk (passed from parent)
$	Vol_Name:='P2'				! Volume (passed from parent)
$	Tmp:='Disk''Vol_name'			! See if should prompt
$	Tape_Verify="/VERIFY"			! By default verify tape backup
$	PAGE					! Erase screen or eject page
$	TYPE SYS$INPUT				!
		            SYSBACKUP V1.6

$	Old_Disk:="''F$LOGICAL("SYS$DISK")'"	! Get starting disk
$	Old_UIC:="''F$USER()'"			! Get old UIC
$	Old_Directory:="''F$DIRECTORY()'"	!
$	ON ERROR THEN GOTO No_Privilege		!
$	ON Control_Y THEN GOTO All_Done		! Abort trap
$	SET UIC [300,300]				! Set required UIC
$	SET DEFAULT SYS$SYSDEVICE:[OPERATOR]	!
$	SET NOON				! stop trapping errors for now
$	Tmp:='Last_Name'			! See if passed from parent
$	IF Tmp .EQS. "" THEN -			! If no, grab username from
	Last_Name="''F$GETJPI("","USERNAME")'"	!  the current process
$	Return:="Start"				! where to return to
$	IF Disk .EQS. ""     THEN GOTO Get_Disk	! If disk/vol not input
$	IF Vol_Name .EQS. "" THEN GOTO Get_Disk	!
$Start:						!
$!
$	INQUIRE OK "Do you wish to backup ''Disk'''Vol_Name' [Y/N]"
$	IF .NOT. OK	THEN GOTO All_Done	! Wrong disk give up
$	Allocated:='F$GETDVI(Disk,"ALL")'	! Is disk allocated
$	IF .NOT. Allocated THEN GOTO Check_Mount! If not, is it mounted
$!
$	WRITE SYS$OUTPUT " "			! Bad, bad, disk is allocated
$	WRITE SYS$OUTPUT -			! Tell operator the bad news
"	''Disk' is currently privately allocated to another process.
$	WRITE SYS$OUTPUT -			! Print out owner so can
"	Please, contact the user and find out why ''Vol_Name' is not on	
$	WRITE SYS$OUTPUT -			! maybe do something
"	the system, MOUNTED/SYSTEM, and available for backup."
$	WRITE SYS$OUTPUT " "			!
$	SHOW DEV 'Disk'/FULL			! get owner from listing
$	TYPE SYS$INPUT				!

	Procedure terminated.  Try again when disk deallocated.
$	GOTO All_Done				!
$Check_Mount:					! Now check if disk mounted
$	IF "''Disk'" .EQS. "DUA0:" THEN Tape_Verify=""! Do not verify RA81
$	Mounted:='F$GETDVI(Disk,"MNT")'		! It had better be
$	IF Mounted THEN GOTO Check_Name		! It is, see if name ok
$!
$	WRITE SYS$OUTPUT " "			! Ugh, disk not mounted
$	WRITE SYS$OUTPUT -			! Tell bad news
"	''Disk' is not currently mounted.  Please find out why.
$	WRITE SYS$OUTPUT -			! 
"	Procedure terminated..."		!
$	GOTO All_Done				!
$Check_Name:					!
$	Disk_name:='F$GETDVI(Disk,"VOLNAM")'	! Now is it the right disk?
$	IF Disk_Name .EQS. Vol_Name	THEN -	! If it is,
		GOTO Tape_Ready			!    see if tape ready
$!
$	WRITE SYS$OUTPUT " "			! Ugh, not the right disk
$	WRITE SYS$OUTPUT -			! Tell the operator
"	Warning, ''Disk' contains ''Disk_Name' not ''Vol_Name'.
$	WRITE SYS$OUTPUT -			! the bad news
"	Please find out why.  Try again when ''Vol_Name' is on the system."
$	WRITE SYS$OUTPUT -			! and give up with a whimper
"	Procedure terminated..."		!
$	GOTO All_Done				!
$Tape_Ready:					! See if tape is ready
$	Allocated:='F$GETDVI("MSA0:","ALL")'	! Is it allocated
$	IF Allocated THEN GOTO Tape_Allocated	! If yes, fatal error
$	ALL MSA0:				! Gotcha, your all mine
$	PAGE					! Clean screen
$	TYPE SYS$INPUT				! Remind operator

	Warnings at 1 minute intervals for up to 5 minutes will be broadcast 
$	WRITE SYS$OUTPUT -			!
"to all users to close all files and get off ''Disk'.  During this time"
$	WRITE SYS$OUTPUT " "			!
$	WRITE SYS$OUTPUT -			!
"	1)  Find the oldest tape set for ''Disk'''Vol_Name' backups."
$	TYPE SYS$INPUT				!
	2)  Physically mount the first tape of the set on MSA0:
	3)  Prepare new date stickers

$!
$!
$	Count=0					! Init counter
$	Message1:=-				! Set up messages for 
"''Disk' must go down for backup."		! sending to users
$	Message2:=-				! 
"Immediately close all files on ''Disk'. Open files can not be backed up."
$	Message="''F$FAO("''Message1'!/''Message2'")'"! Stick in <CR>
$	REPLY/'Users'/BELL "''Message'"		!
$	Transaction_count:='F$GETDVI(Disk,"TRANSCNT")'	! Only repeat if open
$	IF Transaction_count .LE. 2 THEN GOTO Do_Backup	! files on volume
$Request:					!
$	WAIT 'Interval'				! Message interval
$	IF Count .GE. 4  THEN GOTO Do_Backup	! Warn users only 5 times
$	REPLY/'Users'/BELL  "''Message'"	!
$	Count=Count+1				! We can count
$	Transaction_count:='F$GETDVI(Disk,"TRANSCNT")'	! Only repeat if open
$	IF Transaction_count .GT. 2 THEN GOTO Request	! files on volume
$Do_Backup:					! All ready for backup
$	Message1:=-				!
"''Disk' is being backed up. Any open files will not be backed up."
$	Message2:=-				!
"You will be notified when the backup is completed and the disk may be used."
$	Message3:="Please do not use ''Disk' until then."
$	Message:="''F$FAO("''Message1'!/''Message2'!/''Message3'!/")'"!
$	REPLY/'Users'/BELL "''Message'"		!
$	Length='F$LENGTH(Vol_Name)		! How long is name
$	Tmp:='Vol_Name'				! Assume disk name
$	IF Length.GT.9 THEN Tmp[0,9]:=Vol_Name	! Truncate to 9 char
$Mount_Tape:					!
$	ON CONTROL_Y  THEN GOTO Mount_Abort	! Trap aborts
$	SET CONTROL_Y				! Allow aborts
$	Today[0,17]:='F$TIME()'			! Date and time
$	INQUIRE X "What is the backup set number"! Good idea to get this
$	Tap_Nbr[0,4]:="''X'"			! Format to 4 spaces
$	WRITE SYS$OUTPUT " "			!
$	WRITE SYS$OUTPUT "Place a mag-tape on MSA0"!
$	WRITE SYS$OUTPUT "The tape will be initialize with the name BACKUP"
$	INQUIRE READY "Type <return> when ready, ^Y to abort."	!
$	INITIALIZE MSA0:/OVER=(ACC,EXP) BACKUP
$	MOUNT MSA0:/FOREIGN			! Try mounting tape
$	IF $STATUS .NE. 1 THEN GOTO Mount_Tape	!
$	ON CONTROL_Y THEN GOTO Backup_Abort	!
$	Error_at_Start='F$GETDVI("_MSA0","ERRCNT")'! Error count at start
$	WRITE SYS$OUTPUT "Starting backup at ''F$TIME()'"! 
$	ON SEVERE THEN GOTO Tape_Severe_Error	! Don't stop on tape errs
$	ON WARNING THEN GOTO Tape_Warning_Error	!
$! Make an image mode backup
$	SET PROC/PRIV=SYSPRV			! Required for /IGNORE=
$	BACKUP/REWIND'Tape_Verify'/IMAGE/IGNORE=INTERLOCK 'Disk' MSA0:'Tmp'.SAV
$OK:	Backup_Status=1				! show OK
$	GOTO OK2				! Process 
$Tape_Severe_Error:
$	BACKUP_STATUS=$STATUS
$	Err_msg:="''F$MESSAGE(BACKUP_STATUS)'"
$	WRITE SYS$OUTPUT - 
"SYSBACKUP -- BACKUP exit status message ''Err_msg'"
$	WRITE SYS$OUTPUT " "
$	TYPE SYS$INPUT

	   WARNING    WARNING    WARNING    WARNING

	A severe error occured during backup.  The tape may
	not contain a valid backup set.  This may have been
	caused by users modifying files on the disk being 
	backed up.  If files were being modified on the disk
	while backup was progressing, file verification will
	fail during the verification pass, and a severe error
	will result.  This error can probably be safely ignored.
	
	If, however, the error is caused by fatal tape read/write 
	errors, hard disk errors, etc., the backup set is invalid
	and the backup procedure should be done on a new tape.
 
	Based on the error message from BACKUP,  please correct 
	the problem, save copies of the printout and get help
	if unsure what to do.

$	GOTO OK2
$Tape_Warning_Error:
$	BACKUP_STATUS=$STATUS
$	Err_msg:="''F$MESSAGE(BACKUP_STATUS)'"
$	WRITE SYS$OUTPUT - 
"SYSBACKUP -- BACKUP error message: ''Err_msg'"
$	WRITE SYS$OUTPUT " "
$	TYPE SYS$INPUT

	               C A U T I O N

	A warning error occured during backup.  The backup tape
	is probably valid but you should check the error message
	to verify the cause.  If any recoverable tape errors
	or if the disk was modified during backup, an error 
	may get flagged.  This generally means that most or all
	of the files are backed up correctly.

	Based on the error message from BACKUP, decide whether
	on not the tape set is valid and if invalid, repeat the
	backup.  In any event, save this print out with the
	printed backup set index and store it in the safe folder.

$	GOTO OK2
$OK2:
$	SET PROC/PRIV=NOSYSPRV			!
$	SET NOCONTROL_Y				!
$	ON ERROR THEN GOTO All_Done		!
$	Error_at_End='F$GETDVI("_MSA0","ERRCNT")'! Error cnt at end
$	Err= Error_at_End - Error_at_Start	! Calc the dif
$	Error[0,5]:='Err'			! Make a string
$	IF Err .ne. 0 THEN WRITE SYS$OUTPUT -	!
"SYSBACKUP -- WARNING -- ''Err' Tape errors were encountered during the backup"
$!
$	TESTFILE SYS$LOGIN:'Tmp'.LOG		! Logfile exist?
$	IF $STATUS .EQ. 1	THEN GOTO Add_Rec! 
$!
$! File does not yet exist, create it		!
$	CREATE SYS$LOGIN:'Tmp'.LOG		!
$	OPEN/WRITE OUTFILE SYS$LOGIN:TMP.LOG	!
$	WRITE OUTFILE -				!
"                 Backup History of ''Vol_Name'"!
$	WRITE OUTFILE " "			!
$	WRITE OUTFILE -				!
"SET #           Date         Disk      Name      Errors    Operator      Exit Status"
$	GOTO Add_Rec_2
$Add_Rec:					!
$	OPEN/WRITE OUTFILE SYS$LOGIN:TMP.LOG	!
$Add_Rec_2:					!
$	WRITE OUTFILE -				!
"   ''Tap_Nbr'   ''Today'  ''Disk'   ''Vol_Name'      ''Error'   ''Last_Name'   ''Backup_Status'"
$	CLOSE OUTFILE				!
$	ON ERROR THEN CONTINUE			!
$	SET MESSAGE/NOIDENT/NOFACILITY/NOTEXT/NOSEVERITY
$	APPEND TMP.LOG 'Tmp'.LOG		!
$	DELETE TMP.LOG;*			!
$	SET MESSAGE/IDENT/FACILITY/TEXT/SEVERITY!
$	PRINT SYS$LOGIN:'Tmp'.LOG/NOIDENT	! Print list
$Finish_Up:					!
$	WRITE SYS$OUTPUT "Backup finished at ''F$TIME()'"
$	DISMOUNT MSA0:				!
$	TYPE SYS$INPUT				!

SYSBACKUP -- The disk backup is now complete.  Please remember to;
	     a) Affix a date sticker to the tape reel.
	     b) Physically dismount the tape and place it
		in the safe.
	     c) Remove the printout of the log file and
		place it in the backup file folder in the safe.

$	REPLY/'Users'/BELL -			!
"Backup of ''Disk' is complete. It is ready for use."	!
$	GOTO All_Done
$Tape_Allocated:
$	TYPE SYS$INPUT				!

	The tape drive is allocated to another user.  This
	presents an insurmountable hurdle to the backup.
	Go find out who has left the tape drive allocated,
	and get them to deallocate it and try again.  From the
	following full device listing you should be able to
	figure out who has allocated the tape drive.

$	SHOW DEVICE MSA0:/FULL			!
$	TYPE SYS$INPUT				!

	We will exit now and let you solve the tape allocation
	problem.

$	GOTO All_Done				!
$Will_Not_Mount:				!
$	TYPE SYS$INPUT				!

	The tape failed to mount correctly.  If the problem
	is correctable (tape not loaded, etc.), fix the
	problem and try again.  Otherwise, save the print out
	and get help from a systems programmer.

$	INQUIRE Again "Try again [Y/N]"		!
$	IF Again THEN GOTO Mount_Tape		!
$	REPLY/'Users'/BELL -			!
"Backup of ''Disk' is complete. It is ready for use."	!
$	GOTO All_Done				!
$!
$Get_Disk:
$	IF Disk .EQS. "" THEN -
	INQUIRE Disk "Which disk do you wish to backup"! Find which disk
$	IF Disk .EQS. "" THEN GOTO  Get_Disk	! Insist we have the
$	Colon_loc='F$LOCATE(":",Disk)'		! A colon in name?
$	IF Colon_loc .EQ. 'F$LENGTH(Disk)' THEN Disk:="''Disk:"
$	TMP:= 'F$GETDVI(Disk,"EXISTS")'		! See if it exists
$	IF .NOT. TMP THEN GOTO No_Such_Device	!
$	TMP1:='F$GETDVI(Disk,"DEVCLASS")'	! and can have files
$	IF TMP1 .EQS. "1" THEN GOTO Get_Volume	!
$	WRITE SYS$OUTPUT ""			! In case not a
$	WRITE SYS$OUTPUT -			!
"SYSBACKUP -- ''Disk' is not a disk"		!
$	WRITE SYS$OUTPUT "" 			!
$	GOTO Get_Disk				!
$No_Such_Device:				!
$	WRITE SYS$OUTPUT ""			!
$	WRITE SYS$OUTPUT "SYSBACKUP -- Invalid disk name: ''Disk'"
$	WRITE SYS$OUTPUT "             Valid names are: DRA0:, DRA1:, DMA1:"
$	WRITE SYS$OUTPUT "" 			!
$	GOTO Get_Disk				!
$Get_Volume:					!
$	Vol_name:='F$GETDVI(Disk,"VOLNAM")'	! Get current vol name
$	GOTO 'Return'				!
$Mount_Abort:
$	TYPE SYS$INPUT

	The tape mount has been aborted.  If you want to try
	the backup procedure again, users should not now be notified
	that the disk is available.

$	Inquire OK "Is disk ''Disk' now available for general use [Y/N]"
$	IF OK THEN REPLY/'Users'/BELL -
"Disk ''Disk' is now available for use."
$	GOTO All_Done
$Backup_Abort:
$	SET PROC/PRIV=NOSYSPRV
$	TYPE SYS$INPUT

	The backup has been aborted and the data on the tape is not
	valid.  If you do not retry the procedure and succeed in 
	placing a valid backup set on the tape, Please affix a large
	label to the tape stating that the tape does not contain a
	valid backup tape.

	If you want to try the backup procedure again, users should not
	now be notified that the disk is available.

$	Inquire OK "Is disk ''Disk' now available for general use [Y/N]"
$	IF OK THEN REPLY/'Users'/BELL -
"Disk ''Disk' is now available for use."
$	GOTO All_Done
$No_Privilege:
$	TYPE SYS$INPUT

	You do not have the required privilege to use this procedure from
	this account.  It is designed to be run from the OPERATOR account
	or from and account which can access UIC = [1,7].

	Procedure terminated...
$	EXIT
$All_Done:
$	SET MESSAGE/NOTEXT/NOIDENT/NOFACILITY/NOSEVERITY
$	DEALLOCATE MSA0:
$	SET MESSAGE/TEXT/IDENT/FACILITY/SEVERITY
$	SET UIC 'Old_UIC'
$	SET DEFAULT 'Old_Disk''Old_Directory'
$	SET CONTROL_Y
$	EXIT
$!
$!  File Name:	SYSBACKUP.COM
$!  Author:	James G. Downward
$!  Date:	20-Dec-1982
$!  Function:	Provide a common procedure for /Image backups of system disks.
$!		Creates logfiles of backups for each volume on [OPERATOR].
$!		Designed to be invoked from the operator procedure.  This 
$!		command procedure only can be run successfully from suitably
$!		privileged accounts.  No check is made on privilege since
$!		the only way this can be run is from captive operators 
$!		account or system manager (others could try but it wouldn't
$!		work - or hurt anything).
$!
$!  Modified:	V1.4	
$!		James G. Downward	Return to correct disk device when 
$!					done.  Allow only disk to be specified.
$!					Initialize tape each time in case have
$!					a new tape.
$!
$!		V1.5			Modified to reflect /REWIND default 
$!		James G. Downward	change in BACKUP
$!
$!		V1.6			By default, do not verify backup when
$!		James G. Downward	the disk is an RA81.
