C
C
C
C 
C 
C 
C
C
C
C
C
C   ++++++++++++++++++++++++++++++++++++++++++++++++++
C   +                                                +
C   +            CALC    VERSION  X01-07             +
C   +                                                +
C   +  PETER BAUM  1-SEP-77                          +
C   +  DIGITAL EQUIPMENT CORPORATION                 +
C   +  146 MAIN STREET                               +
C   +  MAYNARD, MASSACHUSETTS  01754                 +
C   +                                                +
C   ++++++++++++++++++++++++++++++++++++++++++++++++++
C
C  This is a modified version of VAX CALC as placed in the DECUS
C  Library.
C
C
C
C *******************************************************
C *******************************************************
C ***                                                 ***
C ***               CALC   MAINLINE                   ***
C ***                                                 ***
C *******************************************************
C *******************************************************
C
C
C This program evaluates arithmetic expressions input to it
C and allows variables to be assigned values. It features
C multiple precision arithmetic in Base 10, Octal, and
C Hexadecimal. See CALC.MEM for a complete description in 
C the form of A Users guide. Type ? <keyword> or HELP <keyword>
C to obtain HELP on the use of CALC.
C
C
C
C    CALC CALLS
C
C  ASSIGN    OPENS A FILE AND ASSIGNS IT TO A LOGICAL I/O UNIT.
C  CLOSE     CLOSES A FILE ASSOCIATED WITH A LOGICAL I/O UNIT.
C  CMND      DETERMINES WHAT CALC COMMAND IS REQUIRED.
C  ERRCX     CHECKS THE EXPRESSION IN AN INPUT LINE FOR SYNTAX ERRORS.
C  ERRMSG    PRINTS OUT ERROR MESSAGES.
C  EXIT      RETURNS TO OPERATING SYSTEM.
C  GETMCR    GETS THE COMMAND LINE USED TO INVOKE CALC. IF AN ARGUMENT
C            IS PRESENT, CALC EXITS AFTER THAT ONE COMMAND IS EXECUTED.
C  INPOST    CONVERTS AN INFIX EXPRESSION TO POSTFIX FORM.
C  LIST      LISTS THE LEGAL CALC COMMANDS.
C  POSTVL    CONVERTS AN EXPRESSION IN POSTFIX NOTATION ON STACK 1 TO
C            A VALUE.
C  SLEND     FINDS THE LAST NON-BLANK IN LINE(80).
C  VAROUT    PRINTS OUT THE VALUE OF A VARIABLE.
C  ZNEG      DETERMINES IF A VARIABLE IS POSITIVE IN VALUE
C
C
C
C
C
C
C
C   VARIABLE      USE
C
C  BASED        DEFAULT BASE WHEN CONSTANTS ARE ENTERED.
C  BLANK        ' '
C  DIGITS(16,3) HOLDS DECIMAL, OCTAL, AND HEXADECIMAL DIGITS. THE
C               SECOND SUBSCRIPT IS
C                     1 FOR DECIMAL
C                     2 FOR OCTAL
C                     3 FOR HEXADECIMAL
C  I,J          HOLD TEMPORARY VALUES.
C  ITCNTV(6)    INDEXED BY LEVEL. 0 INDICATES THAT NO ITERATION ON THE
C               INDIRECT COMMAND FILE IS TO TAKE PLACE. IF POSITIVE, IT
C               HOLDS THE INDEX INTO VBLS AND REPRESENTS THE VARIABLE
C               USED TO CONTROL ITERATION.
C  LEND         POINTS TO LAST NON-BLANK CHARACTER IN LINE(80)
C  LEVEL        HOLDS THE LOGICAL I/O UNIT WHERE THE NEXT CALC COMMAND
C               LINES COME FROM.
C  LINE(80)     COMMAND INPUT LINE.
C  NONBLK       POINTS TO LAST NON-BLANK FOUND IN LINE(80).
C  ONCE         HOLDS 1 IF ONLY ONE COMMAND LINE IS TO BE EXECUTED,
C               0 OTHERWISE.
C  STAR         '*'
C  VIEWSW           VIEW SWITCH
C                    0 = OUTPUT ERROR MESSAGES
C                    1 = OUTPUT ERROR MESSAGES AND FILE COMMAND LINES
C                    2 = OUTPUT ERROR MESSAGES AND VALUE OF EXPRESSIONS
C                        EVALUATED.
C                    3 = OUTPUT EVERYTHING
C  WHAT         '?' SIGNIFIES THAT A LIST OF POSSIBLE COMMANDS
C               SHOULD BE OUTPUT.
C
C
C	MODIFIED	REASON
C
C	18-MAY-1981	DELETED LINE THAT CAUSED DEFAULT BASE TO BE RESET
C			WHEN AN ERROR OCCURS (PB)
C
C	18-MAY-1981	ADDED CODE AT LINES 106 TO 108 TO CONVERT FROM LOWER
C			TO UPPER CASE  (PB)
C
C	18-Nov-1982	Added VAX HELP
C
C
	INTEGER*2 LEVEL,NONBLK,LEND
	INTEGER*2 RETCD,VIEWSW,BASED
	INTEGER*2 ONCE
	INTEGER*2 ZNEG,ITCNTV(6)
C
	LOGICAL*1  LINE(80),WHAT,STAR,QUOTE
	LOGICAL*1 ALPHA(27),COMMA,BLANK,RPAR,LPAR,EQ
	LOGICAL*1 DIGITS(16,3)
C
	COMMON  LEVEL,LINE,NONBLK,LEND,VIEWSW,BASED
	COMMON  /CONS/ALPHA,COMMA,BLANK,RPAR,LPAR,EQ
	COMMON /DIGV/ DIGITS
	COMMON/ITERA/ITCNTV
C
	DATA  WHAT/'?'/, STAR/'*'/, QUOTE/''''/
	DATA ONCE/0/
C
C
C
C LOGICAL I/O UNIT 1 IS ASSIGNED TO THE INVOKING TERMINAL
C IF YOU DON'T WANT TO RISK THE BUILDER TASK BUILDING (LINKING)
C THE MODULES PROPERLY, PUT IN A
	CALL ASSIGN (1,'TT:')
C THE ADVANTAGE OF NOT DOING THIS IS THAT YOU CAN CREATE AN OUTPUT
C TEST FILE TO DISK TO HELP VERIFY CORRECTNESS AFTER A CHANGE TO THE
C SOURCE HAS BEEN MADE.
C
C
C
C GET MCR COMMAND LINE (RSX11-M CALL)
	CALL GETMCR(LINE,LEND)
	IF(LEND)20,20,5
5	CONTINUE
	DO 6 NONBLK=1,7
	IF(LINE(NONBLK).EQ.BLANK)GO TO 7
	IF(LINE(NONBLK).EQ.13)GO TO 20
6	CONTINUE
	STOP 6
7	NONBLK=NONBLK+1
	ONCE=1
	GO TO 106
C
C  ERROR RESET
10	IF(LEVEL.EQ.1) GO TO 12
	CALL CLOSE(LEVEL)
	LEVEL=LEVEL-1
	GO TO 10
12	CONTINUE
	VIEWSW=3
C
C
C  GET NEXT INPUT LINE
20	IF(ONCE.EQ.1.AND.LEVEL.EQ.1) CALL EXIT
	IF(LEVEL.EQ.1)WRITE(1,22)
22	FORMAT(' CALC>',$)
C
C
	READ (LEVEL,24,END=900,ERR=1000) LINE
24	FORMAT (80A1)
C
C
C
C FIND LAST NONBLANK, SAVE POSITION WITH VARIABLE 'LEND'
	CALL SLEND(RETCD)
	GO TO(30,20),RETCD
	STOP 30
30	CONTINUE
C
C
C
C SHOW WHAT WAS READ FROM FILE
	IF(LEVEL.NE.1.AND.(VIEWSW.EQ.1.OR.VIEWSW.EQ.3))
     1 WRITE(1,40)LEVEL,(LINE(I),I=1,LEND)
40	FORMAT (' CALC<',I1,'>',80A1)
103	CONTINUE
C
C  IDENTIFY FIRST NON-BLANK
	DO 104 NONBLK=1,LEND
	IF (LINE(NONBLK).NE.BLANK) GOTO 106
104	CONTINUE
	STOP 104
C
C CONVERT LOWER CASE TO UPPER CASE
106	DO 108 I=NONBLK,LEND
	J=LINE(I)
	IF (I.EQ.NONBLK) GOTO 107
	IF (LINE(I-1).EQ.QUOTE) GOTO 108
107	IF(J.GE.97.AND.J.LE.122) LINE(I)=J-32
108	CONTINUE
C
C  See if the user is requesting HELP

C
C ... See if the user is asking for HELP (they often do)
C
	Len=Lend-Nonblk+1
	IF((Line(Nonblk)  .EQ.'H'	.AND. 
     -      Line(Nonblk+1).EQ.'E'	.AND.
     -	    Line(Nonblk+2).EQ.'L'	.AND.
     -      Line(NonblK+3).EQ.'P')	.OR.
     -      Line(Nonblk).EQ.WHAT)	THEN

	    IF(Line(Nonblk).EQ.WHAT)
     -		CALL HELP(LINE(Nonblk+2),Len-2)! Process help command
	    IF(Line(Nonblk).NE.WHAT)
     -		CALL HELP(LINE(Nonblk+5),Len-5)!
	    GOTO 20				! Get another command
	END IF					!
c	IF (LINE(NONBLK).NE.WHAT) GOTO 110
c	CALL LIST
c	GOTO 20
C
C  SEE IF IT IS A COMMAND
110	IF (LINE(NONBLK).NE.STAR) GOTO 120
	CALL CMND (RETCD)
	GOTO (20,115,10), RETCD
	STOP 110
C
C
C A READ COMMAND WAS EXECUTED SO LINE HOLDS THE NEW COMMAND LINE.
115	CALL SLEND(RETCD)
	GO TO (103,20),RETCD
	STOP 115
C
C  SEE IF ONLY ONE ALPHA CHARACTER
120	J=NONBLK+1
	IF (LEND.NE.NONBLK) GOTO 130
	DO 124 I=1,27
	IF (LINE (NONBLK).EQ.ALPHA(I)) GOTO 126
124	CONTINUE
C
C ALLOW FOR A SINGLE DIGIT TO BE ASSIGNED TO %
	DO 125 I=1,10
	IF(LINE(NONBLK).EQ.DIGITS(I,1))GO TO 130
125	CONTINUE
C
C
C ALLOW FOR ENTERING THE ASCII BLANK
	IF(LINE(NONBLK).EQ.QUOTE)GO TO 130
	I=1
	GOTO 1001
C
C  OUTPUT VALUE OF SINGLE VARIABLE
126	CALL VAROUT(I)
	GOTO 20
C
C
C CHECK INPUT FOR SYNTAX ERRORS
130	CALL ERRCX (RETCD)
	GOTO (140,10),RETCD
	STOP 130
C
C  CHANGE FROM INFIX TO POSTFIX NOTATION
140	CALL INPOST (RETCD)
	GOTO (150,10), RETCD
C
C
C EVALUATE EXPRESSION
150	CONTINUE
	CALL POSTVL(RETCD)
	GOTO(20,10),RETCD
	STOP 150
C
C
C  EXIT
900	IF (LEVEL.EQ.1) CALL EXIT
	IF(ITCNTV(LEVEL).EQ.0)GOTO 910
	IF(ZNEG(ITCNTV(LEVEL)).EQ.1)GO TO 910
C
C VALUE OF ITERATION VARIABLE IS POSITIVE SO REWIND FILE
C AND EXECUTE AGAIN.
	REWIND LEVEL
	GO TO 20
C
C
C EXIT FROM THIS LEVEL BY CLOSING THE FILE AND DECREASING VALUE
C OF LEVEL BY ONE.
910	CALL CLOSE(LEVEL)
	LEVEL=LEVEL-1
	GOTO 20
C
C
C
C *** ERROR PROCESSING ***
1000	I=27
1001	CALL ERRMSG(I)
	GO TO 10
	END




	SUBROUTINE HELP(String,Length)
C
C	This subroutine will parse the HELP command and convert
C	it into a form suitable for using VAX HELP.  The program will
C	look up HELP information in SYS$SYSDEVICE:[SYSUTL]SYSUTL.HLB
C	and display it.


	IMPLICIT	INTEGER*4 (A - Z)
	LOGICAL*1	String(1),Length
	INTEGER*2	INDEX,I,J
	INTEGER*4	KEY_LEN(9),
	1		LBR$C_READ /1/
	CHARACTER*80	Cstring
	CHARACTER*32	KEY(9)

C ... Initialize all key lengths to zero and key fields to blank
C
	DO I=2,9					!
	    KEY_LEN(I)=0				! Zero length
	    KEY(I)= ' '					! Fill with blanks
	END DO						!

C	Convert the LOGICAL*1 data to character data	!
	WRITE(Cstring,5)(String(i),i=1,length)		! Cnvt to str
5	FORMAT(80A1)					!



C	Initialize the librarian			
	STATUS = LBR$INI_CONTROL (LIB_INDEX, LBR$C_READ)!
	IF (.NOT. STATUS) CALL LIB$STOP (%VAL(STATUS))	! Abort on err


C	Open HELP library
	STATUS = LBR$OPEN (LIB_INDEX,			! Open library
     -		'SYS$SYSDEVICE:[SYSUTL]SYSUTL.HLB')!  for HELP 
	IF(.NOT. STATUS)    THEN			! If fail print msg
	   TYPE *,'LIPS -- Error opening SYS$SYSDEVICE:[SYSUTL]SYSUTL.HLB'!
	   TYPE *,'        Report this problem AT ONCE!!'
	   RETURN					!   and return
	END IF						!

C
C ... Parse HELP input line to find all possible keys
C
	IF(Length.EQ.0)		       GOTO 1000! No keywords, 
	Jpos=1					! Start with first char
	DO J=1,80
	  IF(Cstring(J:J) .EQ. ' ')Jpos = Jpos+1! Find 1st non space and use
	  IF(Cstring(J:J) .NE. ' ') GOTO 50	!  it as start of search
	END do
	GOTO 1000				! No keywords

50	DO 100, Ikey=2,9			! Parse up to 8 keys
	  Jspace = INDEX(Cstring(Jpos:Length),' ')! Find first space or end
	  IF(Jspace.EQ.0)	       THEN	! If space not found (EOL)
c	     Imax=Length-Jpos+1			! as copied from LIPS
	     Imax=Length-Jpos+1			! Max string length
	     KEY(Ikey)(1:Imax)=Cstring(Jpos:Length)!
	     KEY_LEN(Ikey)=Imax
c	     write(*,200)Ikey,key_LEN(Ikey),KEY(Ikey)!******
c200	     format(' ',i2,2x,i2,2x,a)		     !******
	     GOTO 1000				! Go process HELP
	  END IF				!
	  Jspace=Jspace+Jpos			! Position at space
C	  Imax=Jspace-1				! as copied from LIpS
	  Imax=Jspace				! Gets all the keyword
	  KEY(Ikey)(1:Imax)=Cstring(Jpos:Jspace-1)! Fill help keys
	  Jpos=Jspace				!
	  KEY_LEN(Ikey)=Imax			!
C	write(*,200)Ikey,key_LEN(Ikey),KEY(Ikey)
	IF(Jpos.EQ.Length)	       GOTO 1000! All done
100	CONTINUE				!


1000	KEY(1)='CALC'
	KEY_LEN(1)=4
	STATUS = LBR$GET_HELP (LIB_INDEX,,,,
     -			       KEY(1) (1:KEY_LEN(1)),
     -			       KEY(2) (1:KEY_LEN(2)),
     -			       KEY(3) (1:KEY_LEN(3)),
     -			       KEY(4) (1:KEY_LEN(4)),
     -			       KEY(5) (1:KEY_LEN(5)),
     -			       KEY(6) (1:KEY_LEN(6)),
     -			       KEY(7) (1:KEY_LEN(7)),
     -			       KEY(8) (1:KEY_LEN(8)),
     -			       KEY(9) (1:KEY_LEN(9)))
	IF (.NOT. STATUS) 		THEN	!
	   TYPE *,'LIPS -- Call to LIBR$GET_HELP failed'
	   TYPE *,'        Report this problem AT ONCE!!'
	   CALL LIB$SIGNAL (%VAL(STATUS))
	END IF

C	Close the library
	STATUS = LBR$CLOSE (LIB_INDEX)		!
	IF (.NOT. STATUS) 		THEN	!
	   TYPE *,'LIPS -- Can not close SYS$SYSDEVICE:[SYSUTL]SYSUTL.HLB'
	   TYPE *,'        Report this problem AT ONCE!!'
	   CALL LIB$STOP (%VAL(STATUS))		! Die if fails
	END IF
	RETURN					! Back home to mama
	END
