C+
C These subroutines are a start at making it easier to migrate between
C RSX and VAX.  Often RSX programs call on executive services which
C are inappropriate or not otherwise applicable to our VAX.  To
C allow for this to hapen, one easy way is to create either dummy VAX
C routines to bypass those differences, or to map the calls into appropriate
C VAX routines
C
C-
C***********************DUMMY********ROUTINES***********************
	OPTIONS /NOI4
 	SUBROUTINE RECEIV(IDMY1,IDMY2,IDMY3,IDS)
	IDS=-1				! Show recieve data failed
	RETURN				!
	END
	
	OPTIONS /NOI4
	SUBROUTINE SEND(TASK,IBUF,IEFN,IDS) 
	DIMENSION IBUF(13) 
	RETURN 	
	END

	OPTIONS/NOI4
	SUBROUTINE REQUES(TASK,IOPT,IDS)
	RETURN
	END
C*******************************************************************



C 
C ---------------------------------------------------------------------
C

	OPTIONS /NOI4
	SUBROUTINE WAIT(Itime_magnitude, Itime_unit, Ids)
C+
C -- Dummy up the RSX11M   CALL WAIT subroutine
C
C	CALL WAIT (Itime_magnitude,Itime_unit [,Ids])
C	
C	where	Itime_magnitude  = I*2 interval
C		Itime_unit	 = 0 -> tics (force to 100 tics/sec)
C				   1 -> Milliseconds
C				   2 -> Seconds
C				   3 -> Minutes
C				   4 -> Hours
C
C		Ids		 = 1 -> Success
C				 = -93 -> Invalid time parameter (IE.ITI)
C
C	VMS uses event flags much, much differently than RSX does.
C	EFN=0 must not be used since VMS uses it for a default with certain
C	calls (SETIMR, QIO, etc) which can be confusing. VMS allows one
C	to dynamically grab a free EFN number (32-63 working from the top)
C	and this routine (LIB$GET_EF) is used.  However, one must be
C	very, very sure to let go of each EFN so grabbed.  The documentation
C	on SYS$SETIMR does not say so, but it must clear the EFN if it is
C	set.   Since this subroutine is compiled /NOI4, direct arguments
C	to the quadword subroutines must be variables if they are to
C	work reliably, ie one can not pass a zero by placing a 0 as 
C	an argument.  Instead one must create a quadword which is zero
C
C	VMS keeps its internal timer in 100 nsec units.  To initiate a 
C	wait, a quadword containing the negative number of units to
C	wait is passed in the VMS service call SYS$SETIMR.  This routine
C	requires the quadword math routines in QUADMATH.MAR.
C
C	Written by:	James G. Downward		25-Apr-82
C			KMS Fusion, Inc
C			P.O. Box 1567
C			Ann Arbor, Mich. 48104
C
C	Modified:	James G. Downward		24-May-82
C							Fixed use of EFN's
C							and Quadword subtract
C-

	INTEGER*2 Itime_magnitude,Itime_unit,Istatus
	INTEGER*2 Ihundredths,Iseconds,Iminutes,Ihours
	INTEGER*4 Iconstant_Quad(2),Ivalue_Quad(2)
	INTEGER*4 Itimer(2),IZERO(2)		!
	INTEGER*4 SYS$SETIMR,SYS$WAITFR		!
	INTEGER*4 LIB$GET_EF,LIB$FREE_EF	!
	INTEGER*4 Ists,Iefn			!
	INCLUDE 'SYS$SYSDISK:[SYSLIB]SSDEF.FOR/NOLIST'	!
	PARAMETER IE_ITI=-93			! Invalid time parameters
	DATA IZERO(1) /0/, IZERO(2) /0/		!

	CALL ARGCNT(Number_of_Arguments)	! See if IDS is present
	Istatus=IE_ITI				! Assume will fail
	IF (Itime_unit.LT.0	.OR.		! See if valid time unit
     -	    Itime_unit.GT.4)		GOTO 100!  If not,exit with bad status
C
C -- Convert the input time into 100 nsec units
C
C -- First to Milliseconds
C
	IF     (Itime_unit.EQ.0)	THEN	! If tics (100 tics/sec)
	   Iconstant_quad(1) = 10		!   convert to milliseconds
	ELSE IF(Itime_unit.EQ.1)	THEN	! If Milliseconds
	   Iconstant_quad(1) = 1		!   convert to milliseconds
	ELSE IF(Itime_unit.EQ.2)	THEN	! If seconds
	   Iconstant_quad(1) = 1000		!   convert to miliseconds
	ELSE IF(Itime_unit.EQ.3)	THEN	! If minutes
	   Iconstant_quad(1) = 60000		!   convert to miliseconds
	ELSE IF(Itime_unit.EQ.4)	THEN	! If Hours
	   Iconstant_quad(1) = 1440000		!   convert to miliseconds
	END IF					!
	Iconstant_quad(2)=0			! Be sure is always zero
	Ivalue_Quad(1) = Itime_magnitude	! Set magnitude in quadword
	Ivalue_Quad(2) = 0			! Be sure is always zero
C
C -- Now convert into internal VMS format
C
	CALL EMUL(Iconstant_quad,Ivalue_Quad,Ivalue_quad) ! cnvt to msec
	Iconstant_Quad(1)=10000			! To convert to 100 nsec tics
	Iconstant_quad(2)= 0			! Be sure is zero
	CALL EMUL(Iconstant_Quad,Ivalue_Quad,Itimer(1)) ! multiply
	CALL SUBQUAD(IZERO(1),Itimer(1),Itimer(1))! Make negative
C
C -- Get (or at least try) a free Efn
	Ists=LIB$GET_EF(Iefn)			! Get a free event flag
 	IF(Ists.NE.SS$_NORMAL)		THEN	! If it fails try and
	   WRITE(5,80)Ists			!  output a warning
80	   FORMAT(' VAXSUB(WAIT) -- LIB$GET_EF failed. Ists = ',z8)
	   CALL LIB$FREE_EF(IEFN)		!  try freeing the efn
	   RETURN				!  and give up
	END IF					!


	Ists=SYS$SETIMR(%VAL(IEFN),Itimer(1),,) ! Go set the timer
	IF(Ists.NE.SS$_NORMAL)		THEN	! If all is not OK warn the
	   WRITE(5,95)Ists			!  poor user
95	   FORMAT(' VAXSUB(WAIT) -- SYS$SETIMR failed. Ists = ',z8)
	   CALL LIB$FREE_EF(IEFN)		!  try and free the efn
	   RETURN				!  and exit
	END IF					!


	Ists=SYS$WAITFR(%VAL(IEFN))		! Wait until flag set
	IF(Ists.EQ.SS$_NORMAL)	Istatus=Ists	! If $NORMAL return RSX IS.SUC

	Ists=LIB$FREE_EF(IEFN)			! Release the event flag
100	IF (Number_of_Arguments .EQ. 3)  Ids = Istatus	! Xfer status of wait
	RETURN
	END



C
C -------------------------------------------------------------------
C

	OPTIONS /NOI4
	SUBROUTINE GETMCR (Lbuf,Ids)
C
C -- Dummy up the call to GETMCR
C
C	CALL GETMCR (LBUF [,IDS])
C
C	Where LBUF is an 80 byte array to receive command line
C	      IDS is the directive status
C	             +n Number of bytes transfered (less terminator)
C			but a <CR> is at the end of the buffer
C	            -80 If no command line present (corresponds to
C			RSX IE.AST
C
C
C	26-Aug-1983	J. Downward	Fixed bug if IDS not present
C-
	CHARACTER*84 Command
	LOGICAL*1 LBUF(80)
	CHARACTER*1 Carriage_Return
	INTEGER*2 Ids
	INTEGER*4 Iaddr(1)
	INTEGER*4 Istatus
	INTEGER*4 Outlength
	INTEGER*4 LIB$GET_FOREIGN
	EXTERNAL LIB$GET_FOREIGN
	DATA Carriage_Return /"15/		! Set Carriage Return
	DATA IE_AST /-80/			! Error if no command line
	CALL ARGCNT(Narg)			! Find out if IDS present
						!    if not 1 arg only
	Command=' '				! Blank fill
	Length=IE_AST				! Assume no command
	ISTATUS=LIB$GET_FOREIGN(Command(5:),,Outlength)
	IF(Outlength.EQ.0)		GOTO 10	! No Command line, show it
	Command(1:4)='VAX '			! Set in prefix	   
	Length=Outlength+4			! The true length (incl <CR>)
	IF(Length.GT.79)	Length=79	! Never can be longer
	Last=Length+1				! Make <CR> last char in buf
	Command(Last:Last)=Carriage_Return	! Tack on a CR at buffer end
c10	IF(IADDR(1).NE.0) IDS=Length		! Set in correct length or
10	IF(Narg.GT.1) IDS=Length		! Set in correct length or
						!   IE_AST error code
	DO 20,I=1,Length+1			! The final transfer
20	LBUF(I)=ICHAR(Command(I:I))		!
	RETURN
	END

C ----------------------------------------------------------------------
C
C+
	OPTIONS /CHECK=NOOVERFLOW/NOI4
C
	SUBROUTINE GETTSK(IBUF,IDS)
C
C	This subroutine will emulate the RSX11M CALL GETTSK executive
C	service call.
C	
C		CALL GETTSK (IBUF[, Ids])
C
C	Where:
C		IBUF - A 16 word integer array to receive the task
C		       parameters.
C		Ids  - Optional directive status
C
C	IBUF	Word  0 -- Issuing task's name in RAD50 (first half)
C		Word  1 -- Issuing task's name in RAD50 (second half)
C		Word  2 -- Partition name in RAD50 (first half)
C			   Always GEN on VMS.
C		Word  3 -- Partition name in RAD50 (second half)
C			   Always blank on VMS
C		Word  4 -- Undefined
C		Word  5 -- Undefined
C		Word  6 -- Run priority
C		Word  7 -- User identification code (UIC) of issuing task
C		Word 10 -- Number of logical I/O units (LUNS)
C		Word 11 -- Undefined
C		Word 12 -- Undefined
C		Word 13 -- Address of task SST vector table
C			   UNDEFINED in VMS
C		Word 14 -- Size of task SST vector table
C			   = 0  in VMS
C		Word 15 -- Size (in bytes) either of task's address windo 0
C			   in mapped systems or task's partition size in
C			   unmapped systems. (always 64kbytes)
C		Word 16 -- System on which system is runnint => 5 for VMS
C		Word 17 -- Protection UIC,  Same as Word 7
C
C Written by:
C		James G. Downward
C		KMS Fusion, Inc
C		P.O. Box 1567
C		Ann Arbor, Mich 48106
C		(313)-769-8500
C		11-June-1982
C
C Modified by:   James G. Downward
C		 JGD01			Make task size 32k words work
C					after Fortran compiler change
C					got too smart in converting I*4
C					to I*2.
C
C  *********************************************************************
C  ***   NOTE:	This subroutine MUST be compiled /CHECK=NOOVERFLOW   ***
C  *********************************************************************
C-
C	INCLUDE 'SYS$SYSDISK:[SYSLIB]JPIDEF.FOR/NOLIST'
	PARAMETER Max_task_size="100000		! A 32kw (2*32*1024 bytes)JGD01
	PARAMETER JPI$_PRCNAM     = '31C'X	! Code to get process name
	PARAMETER JPI$_PRI        = '302'X	! code to get process priority
	PARAMETER JPI$_UIC        = '304'X	! Code to get process UIC

	CHARACTER*8	CProcess_name		!
	LOGICAL*1	LUIC(1:2)		! Task UIC (group,member)
	INTEGER*2	IUIC,Narg		! Task UIC
	INTEGER*2	IBUF(0:15)		! Buffer to fill for GETTSK
	INTEGER*2 	IDS,IXFER(2)		!
	INTEGER*2	JPI_LIST(8) 	/4,JPI$_PRI,6*0/
	INTEGER*4	SYS$GETJPI,ISTATUS	!
	INTEGER*4	JPI_DATA,JPI_DATA_ADR	! 
	REAL*8		PAR			! Partition name
	REAL*8		Rprocess_name		! For Rad50 conversion
	EQUIVALENCE	(IUIC,LUIC(1))		! To ease insertion of ggg,mmm
	EQUIVALENCE	(JPI_DATA,IXFER(1))	!   with handy equivalence
	EQUIVALENCE	(JPI_LIST(3),JPI_DATA_ADR)
	DATA	PAR	/'GEN   '/

	CALL ARGCNT(Narg)			! Is IDS present

	CALL IRAD50(6,PAR,IBUF(2))		! Set partition name (GEN)
	IBUF(4)=0				! Undefined on RSX
	IBUF(5)=0				! Undefiend on RSX
	IBUF(9)=0				! Undefined on RSX
	IBUF(10)=0				! Undefined on RSX
	IBUF(11)=0				! Address of Vector tbl =0
	IBUF(12)=0				! Size of SST vector tbl=0
	IBUF(13)=Max_task_size			! Size in bytes of task
	IBUF(14)=5				! Operating system =VMS

	JPI_DATA_ADR=%LOC(JPI_DATA)		! Get buffer address for JPI$
	JPI_LIST(2)=JPI$_PRI			! First get process priority
	ISTATUS=SYS$GETJPI(%VAL(1),,,JPI_LIST,,,)! Get process priority
	IBUF(6)=JPI_DATA			! Transfer it

	JPI_LIST(2)=JPI$_UIC			! UIC process runs under
	ISTATUS=SYS$GETJPI(%VAL(1),,,JPI_LIST,,,)! Get the UIC
	LUIC(1)=IXFER(1)			! Must compile with /NOOVR
	LUIC(2)=IXFER(2)			! Unpack the longword UIC
	IBUF(7)=IUIC				!  format and repack to 1 word
	IBUF(15)=IBUF(7)			! Protection UIC

	JPI_LIST(1)=8				! Get 6 bytes of data
	JPI_LIST(2)=JPI$_PRCNAM			! Code to get our process name
	JPI_DATA_ADR=%LOC(Cprocess_name)	! Process name ret as string
	ISTATUS=SYS$GETJPI(%VAL(1),,,JPI_LIST,,,)! Get the UIC
	READ(Cprocess_name,10)Rprocess_name	!
10	FORMAT(A8)				!
	CALL IRAD50(6,Rprocess_name,IBUF(0))	! Set process name(1st 6 char)


	IF(Narg.GT.1)		IDS=1		! Show success
	RETURN
	END

C ----------------------------------------------------------------------
C
C+
C	EXST
C
C	Simulate the RSX11M Exit With Status
C
C	CALL EXST(Iexit_status)
C
C	Where 	Istatus = I*2  status value
C
C	The behavior is not quite identical with that of RSX since
C	the VAX exit status is stored in a symbol $STATUS which is 
C	an I*4 word.  To suppress error messages bit 28 is set in the
C	status longword.  Hence, only the low order 16 bits should be
C	tested of $STATUS if exact conformance with RSX calls are to
C	be maintained.  This is OK since exit status on RSX is only
C	a 16 bit integer.
C
C	Writen by:	James G. Downward
C			KMS Fusion, Inc.
C			P.O. Box 1567
C			Ann Arbor, Mich. 48106
C			(313)-769-8500
C			22-Oct-1982
C	Modified:
C-
	OPTIONS /NOI4
	SUBROUTINE EXST(Iexit_status)
	INTEGER*4 Ihighbits				!
	INTEGER*4 Istatus,Ists				!
	INTEGER*4 SYS$EXIT
C ...
C ... Documentation for condition passing states that for signaling
C ... exit status without sending a message, one should set bit 28
C ... in the I*4 condition value as follows
C ...
C ...		Bit 28  '2000000000'O   Suppress error message
C ...
C
	PARAMETER (Ihighbits='2000000000'O)		! The bit to set
	Ists=Ihighbits+Iexit_status			! Set high bits
	Istatus=SYS$EXIT(%VAL(Ists))			! Exit with status
	RETURN
	END
C
C----------------------------------------------------------------------
C

C+
C	SPAWN
C
C	This subroutine emulates the RSX SPAWN executive subroutine with
C	a number of important restrictions which are necessitated by the
C	nature of the VMS environment.
C
C	     1.  Only SPAWNS to DCL are supported.  These occur regardless
C		 of Rtask.  However, warnings are printed to SYS$OUTPUT
C		 if Rtask is not one of MCR..., CLI..., or ...DCL.
C
C	     2.  The group and member codes parameters are not supported.
C
C	     3.  The AST address and parameter are not supported.
C		 Conceivably they could be, but this would require the
C		 mainline code pass the address and parameter as I*4
C		 words whereas on RSX they are I*2 words.  The choice
C		 was to not support a feature which would not produce
C		 back migratable code.
C
C	     4.  The Unit and Device name for the TI: of the command
C		 are not supported because they can't fully be supported
C		 in the general case as RSX does.  In RSX, it means
C		 'this is the terminal the command comes from' and hence
C		 one can use the spawn command to log on and off of
C		 terminals remotely.  Under VMS, terminals can not
C		 normally be allocated except by a privileged user
C		 so any code using the remote terminal feature would
C		 have to be run by a privileged user or be installed
C		 with privilege.  These ramifications are too much of
C		 a bother to worry about now, so we are not going
C		 to implement SPAWNing to terminals other than the
C		 process's initial TI:
C
C	      5. The exit status block must be specified in the mainline
C		 code as I*4 or else one stands a chance of crashing
C		 the program or corrupting other data.  Since exit
C		 status is returned asychronously, the subroutine can not
C		 match up the difference between I*4 and I*2 requirements
C		 within its boundaries.  Rather, after the spawn is 
C		 done, the exit status block will get set.  It is up
C		 to the mainline code to either wait for the event
C		 flag to be set, or to execute additional code
C		 and periodically check the event flag to see when the
C		 command has completed.
C
C		 Note, that the behavior with no event flag specified is
C		 very different from that of RSX.  While VMS will wait for 
C		 SPAWN to complete, RSX will start off the spawn is
C		 parallel and never worry about syncronization (if no
C		 ast or other mechanism is provided)
C
C	      6. The command line must be passed either as a logical 
C		 array or as a packed integer array.  Under RSX it
C		 was possible to get away with passing the command line
C		 as a string litteral.  This can not work under VMS.
C		 The subroutine has no way of knowing if the calling
C		 program had a logical, and integer, or a character
C		 array at the call site.  Since character data is 
C		 passed differently than integer data, the subroutine
C		 will get data in a different format than it expects
C		 if an attempt was made to pass the data as a literal
C		 string.
C		 
C	
C	CALL SPAWN (Rtask, Iugc,  Iumc,  Iefn, Iast, Iesb, Iparm,
C			  Icmlin, Icmlen, Iunit, Idnam, Ids)
C
C  Where:
C
C	Rtask  -- Name of task to spawn to. Ignored. Command line goes
C		  to VMS DCL. Warning issued if Rtask not one of 
C		  MCR..., CLI..., or ...DCL.
C	Iugc   -- UIC group code.  Ignored, Warning given
C	Iumc   -- UIC member code. Ignored, Warning given
C	Iefn   -- Event flag to be cleared on call and
C		  set on completion of spawn.
C	Iast   -- Ast routine to call when spawn completes. Ignored and
C		  warning message given.
C	Iparm  -- Name of word to recieve the status block when
C		  AST occurs.  Ignored, and warning message given.
C	Iesb   -- Exits status block (1 word)
C	Icmlin -- Name of command line to queue
C	Icmlen -- Length of command line
C	Iunit  -- Unit number for TI:. Ignored. Warning message given
C	Idnam  -- Device name.  Ignored, warning message given
C	Ids    -- Directive status
C
C	Note:  Iesb MUST be at least an I*4 integer.  RSX11M states that
C	       the Exit Status block should be 8 words deep.  However,
C	       directives generally worked with a 1 word block.  This 
C	       routine requires IESB to be I*4 to correctly return
C	       status from VMS.  The Status returned will be VMS Status
C	       which generally bears little semblance to the RSX variety.
C
C	Written by:	James G. Downward	Version V1.0
C			KMS Fusion, Inc.
C			PO Box 1567
C			Ann Arbor, Mich 48106
C			(313)-769-8500
C			26-Oct-1982
C	Moddified by:
C
C	IDENT	/V01.0/
C-
	OPTIONS /NOI4
	SUBROUTINE SPAWN(Rtask,Iugc,Iumc,Iefn,Iast,Iesb,Iparm,
     -			 Icmlin,Icmlen,Iunit,Idnam,Ids)	

	CHARACTER*80	Cspawn_line		! For unpacking command line
	LOGICAL*1	Lnull /0/		!
	LOGICAL*1	Icmlin(1)		! Dummy dimension
	LOGICAL*1	Ievent_Flag		! 	
	INTEGER*4	Istatus,Iesb		! Iesb must be I*4
	INTEGER*4	LIB$SPAWN,SYS$CLREF	! System service calls
	INTEGER*4	Iflags			! If Iflags=1, to not wait
	DATA		Test_Task1 /6RMCR.../	! Only allow spawns to MCR
	DATA		Test_Task2 /6R...DCL/	!   DCL 
	DATA		Test_Task3 /6RCLI.../	!   or  CLI...
	INCLUDE		'($SSDEF)'		! Error code definitions

	PARAMETER IE_SUC=1			! Success
	PARAMETER IE_INS=-2			! Task not installed
	PARAMETER IE_ACT=-7			! Task already active
	PARAMETER IE_ADP=-98			! Priviliege violation

	IF(Icmlen.GT.79)  Icmlen=79		! RSX only takes 79 characters
	DO I=1,Icmlen				!  so that's all we will allow
	   Cspawn_line(I:I)=CHAR(Icmlin(I))	!  although VMS can handle up
	END DO					!  to 255 characters
	DO I=Icmlen+1,79			! Clean out old garbage
	  Cspawn_line(I:I)=CHAR(Lnull)		! Fill up with nulls
	END DO					! to clean
C
C ... See which arguments are present
C
	Iarg1 = Iaddr(Rtask)			! If 0, Rtask not present
	Iarg2 = Iaddr(Iugc)			! If 0, Iugc  not present
	Iarg3 = Iaddr(Iumc)			! If 0, Iumc  not presetn
	Iarg4 = Iaddr(Iefn)			! If 0, Iefn  not present
	Iarg5 = Iaddr(Iast)			! If 0, Iast  not present
	Iarg6 = Iaddr(Iesb)			! If 0, Iesb  not present
	Iarg7 = Iaddr(Iparm)			! If 0, Iparm not present
	Iarg10= Iaddr(Iunit)			! If 0, Iunit not present
	Iarg11= Iaddr(Idnam)			! If 0, Idnam not present
	Iarg12= Iaddr(Ids)			! If 0, Ids   not present
C
C ... Some subroutine arguments we have no way of correctly handling
C     under our current VMS context.  For this reason, if these
C     arguments are present, we are going to issue a warning message
C     and then ignore them
C
	IF(Iarg1.EQ.0) 		THEN		!
	  TYPE *,'SPAWN_RSX -- For compatability you must specify a CLI'
	ELSE
	  IF(Rtask.NE.Test_Task1	.AND.	!
     -	     Rtask.NE.Test_Task2	.AND.	!
     -	     Rtask.NE.Test_Task3)	
     -    TYPE *,'SPAWN_RSX -- Only SPAWNS to a CLI are allowed'
	END IF
	IF(Iarg2.NE.0) TYPE *,'SPAWN_RSX -- Group Code not supported'
	IF(Iarg3.NE.0) TYPE *,'SPAWN_RSX -- Member Code not supported'
	IF(Iarg5.NE.0) TYPE *,'SPAWN_RSX -- AST address not supported'
	IF(Iarg7.NE.0) TYPE *,'SPAWN_RSX -- AST parameters not supported'
	IF(Iarg10.NE.0)TYPE *,'SPAWN_RSX -- Device unit not supported'
	IF(Iarg11.NE.0)TYPE *,'SPAWN_RSX -- Device name not supported'
C
C ... The VMS SPAWN facility will create a subprocess and send a
C     command to it.  By default it will wait unitl the command is done.
C     However, if Iflags=1, the subprocess will start to execute in
C     parallel with the main process.  If the user specifies an event
C     flag,(as he/she should) the NOWAIT bit gets set, and SPAWN
C     returns control to the mainline program to wait for the event flag
C     to signal the completion of the command.  If no event flag is 
C     specified, VMS forces the SPAWN to complete before continuing
C     with the mainline. 
C
	IF(Iarg4.EQ.0)		THEN		! If event flag not spec
	    IF(Iarg6.GT.0)	THEN		! If Iesb is specified
	         Istatus=LIB$SPAWN(Cspawn_Line,,,,,,Iesb)! we will ret value
	    ELSE				! If not specified forget
                 Istatus=LIB$SPAWN(Cspawn_Line,,,,,,)! Iesb even exists
	    END IF				! 
	ELSE					! Else if event flag specif
	    Iflags=1				!   Force No Wait
	    IF(Iefn.EQ.0)	THEN		!   If event Flag =0
	      TYPE *,'SPAWN_RSX -- Event Flag 0 is illegal'
	      Istatus=-1			!   show failure
	      GOTO 100				!   See if can show same
	    END IF				!   
	    Ievent_Flag=Iefn			!   Show which event flag
	    CALL SYS$CLREF(%VAL(Iefn))		!   But if present, clear it
	    IF(Iarg6.GT.0)	THEN		!   If exit status specified
		Istatus=LIB$SPAWN(Cspawn_Line,,,Iflags,,,! Wait and pass it
     -		                  Iesb,Ievent_Flag)! to Iesb
	    ELSE				!    Else just start spawn
		Istatus=LIB$SPAWN(Cspawn_Line,,,Iflags,,,! in parallel and
     -		                  ,Ievent_Flag)	!    set efn when done
	    END IF				!
	END IF					!

	IF (Iarg12.GT.0)	THEN		! If IDS is present
100	IDS=Istatus				! Always return something
	  IF(Istatus.EQ.SS$_ACCVIO)  Ids=IE_ADP	! Can not access variables
	  IF(Istatus.EQ.SS$_DUPLNAM) Ids=IE_ACT	! already active
	  IF(Istatus.EQ.SS$_NOCLI)   Ids=IE_INS	! No CLI or no target task
	  IF(Istatus.EQ.SS$_NORMAL)  Ids=IE_SUC	! Success
	END IF

	RETURN					!
	END
