C
C------------------------------------------------------------------------
C
	SUBROUTINE ABORT(Task_Name,Idirective_Status)
C+
C  Emulate the RSX11M CALL ABORT for the VAX.  
C
C		CALL ABORT(Task_Name,Istatus)
C	
C	where	Task_Name   Real*2	Task name (Rad-50)
C		Istatus	    I*2		Directive status
C-



	Character*6	Process_Name		!
	Logical*1	Ltask(6)
	Integer*2	Idirective_status	!
	Integer*2	Number_of_Arguments	!
	Integer*4	SYS$FORCEX,Istatus	!
	Real*4		Task_Name		!
	INCLUDE		'SYS$LIBRARY:SSDEF.FOR'

	PARAMETER IS_SUC=1			! Success
	PARAMETER IE_INS=-2			! Task not installed
	PARAMETER IE_ACT=-7			! Task not active
	PARAMETER IE_PRI=-16			! Privilege violation
	PARAMETER IE_IPR=-95			! Invalid priority
	PARAMETER IE_ADP=-98			! Part of DPB not accessable
	

	CALL ARGCNT(Number_of_Arguments)	! Find out if status present
	CALL R50ASC(6,Task_Name,Ltask)		! Convert to ASCII
	DO I=1,6				!
	  Process_Name(I:I)=CHAR(Ltask(I))	! Convert to a string
	END DO					!
	Istatus=SYS$FORCEX(,Process_Name,)	! Force process to exit
	IF(Number_of_Arguments.GT.1)	THEN	!
	    IF(Istatus.EQ.SS$_NORMAL) Idirective_Status=IS_SUC
	    IF(Istatus.EQ.SS$_ACCVIO) Idirective_Status=IE_ADP
	    IF(Istatus.EQ.SS$_NONEXPR)Idirective_Status=IE_ACT
	    IF(Istatus.EQ.SS$_NOPRIV) Idirective_Status=IE_PRI
	    IF(Istatus.EQ.SS$_INSFMEM)Idirective_Status=IE_ADP
	END IF
	RETURN
	END

C
C-------------------------------------------------------------------------
C
	SUBROUTINE ALTPRI(Task_Name,Ipriority,Idirective_Status)
C+
C	Emulate the RSX11M CALL ALTPRI directive
C
C	CALL ALTPRI ([Task_Name], [Ipriority] [,Idirective_Status])
C
C	The priority (RSX 0-250, will be scalled to the VMS priority
C	range 1-16 such that the default RSX priority of 50 will
C	be the default VMS priority of 5.
C+
	

	Character*6	Process_Name		!
	Logical*1	Ltask(6)		!
	Integer*2	Idirective_status	!
	Integer*2	Number_of_Arguments	!

	Integer*2	Ipriority		!
	Integer*4	Iarg1,Iarg2,Iarg3	!
	Integer*4	SYS$SETPRI,Istatus	!
	Real*4		Task_Name		!
	INCLUDE		'SYS$LIBRARY:SSDEF.FOR'
	
	PARAMETER IS_SUC=1			! Success
	PARAMETER IE_INS=-2			! Task not installed
	PARAMETER IE_ACT=-7			! Task not active
	PARAMETER IE_PRI=-16			! Privilege violation
	PARAMETER IE_IPR=-95			! Invalid priority
	PARAMETER IE_ADP=-98			! Part of DPB not accessable


	CALL ARGCNT(Number_of_Arguments)	! Find out if status present
	Iarg1=IADDR(Task_Name)			! If =0, argument is missing
	Iarg2=IADDR(Ipriority)			!
	Iarg3=IADDR(Istatus)			!
	CALL R50ASC(6,Task_Name,Ltask)		! Convert to ASCII
	DO I=1,6				!
	  Process_Name(I:I)=CHAR(Ltask(I))	! Convert to a string
	END DO					!

	IF(Iarg2.EQ.0)		THEN		! If no priority passed
	    Iset_Priority=5			! Use default VMS priority
	  ELSE					!  Else scale (0-255) RSX pri
	    Iset_Priority=(Ipriority/16)+1	!   to 0-16 VMS priority
	END IF					!
	IF(Iarg1.EQ.0) Istatus=SYS$SETPRI(,,Ipriority,)
	IF(Iarg1.GT.0) Istatus=SYS$SETPRI(,Process_Name,Ipriority,)
	IF(Iarg3.GT.0)		THEN		! If Idirective_status present
	  Idirective_Status=IS_SUC		! Assume all okay
	  IF(Istatus.EQ.SS$_ACCVIO)  Idirective_Status=IE_ADP
	  IF(Istatus.EQ.SS$_NONEXPR) Idirective_Status=IE_ACT
	  IF(Istatus.EQ.SS$_NOPRIV)  Idirective_Status=IE_PRI
	END IF					!
	RETURN					!
	END

C
C----------------------------------------------------------------------------
C

	SUBROUTINE ASNLUN(Lun, Idevice, Iunit, Idirective_Status)
C+
C	Emulate the RSX CALL ASNLUN on VMS
C
C	CALL ASNLUN (Lun, Idevice, Iunit [,Ids])
C
C	where 	Lun	I*2	Logical unit number
C		Idevice I*2	Device name (format 1A2)
C		Iunit	I*2	Device unit #
C		Ids	I*2	Directive status (optional)
C
C	There is a MAJOR difference in whay this routine works on
C	the VAX and on RSX.  On RSX, the Lun you supply (for QIO's, etc)
C	is the one you get.  On VMS, you call ASNLUN to return the 
C	Channel Number for use in QIO's.  For this reason, Lun, MUST
C	be a variable.  Whatever value it has to start with, will be
C	modified to reflect the VMS channel number assigned to I/O for
C	that device.
C-

	CHARACTER*5	Device_Name		!
	Integer*2	Idirective_status	!
	Integer*2	Number_of_Arguments	!
	Integer*2	Idevice, Iunit		!
	Integer*2	Ipriority		!
	Integer*4	Iarg4			! argument present flag
	Integer*4	SYS$ASSIGN,Istatus	!
	Real*4		Task_Name		!

	INCLUDE		'SYS$LIBRARY:SSDEF.FOR'

	PARAMETER IS_SUC=1			! Success
	PARAMETER IE_LNL=-90			! Lun locked in use
	PARAMETER IE_IDU=-92			! Invalid device or unit
	PARAMETER IE_ILU=-96			! Invalid logical unit #
	PARAMETER IE_ADP=-98			! Part of DPB not accessable

	Iarg4=IADDR(Idirective_Status)		! Is Status word present?
	WRITE(Device_Name,10)Idevice,Iunit	! Encode the device name
10	FORMAT(1A2,I2.2,':')			!  and # as a char. string
	Istatus=SYS$ASSIGN(Device_Name,Lun,,)	! Get an Channel assigned
	IF(Iarg4.GT.0)			THEN	! If Idirective_status present
	  IF(Istatus.EQ.SS$_NORMAL)	THEN	!
	      Idirective_Status=IS_SUC		! All is OK
	  ELSE					! Else error
	      Idirective_Status=IE_IDU		! Assume invalid device/unit
	      IF(Istatus.EQ.SS$_DEVALLOC)  Idirective_Status=IE_LNL
	      IF(Istatus.EQ.SS$_NOIOCHAN)  Idirective_Status=IE_LNL
	      IF(Istatus.EQ.SS$_INSFMEM)   Idirective_Status=IE_ADP
	  END IF				!
	END IF					!
	RETURN	
	END

C
C-------------------------------------------------------------------------
C

	SUBROUTINE CLREF(Ievent_flag,Idirective_status)
C+
C	Emulate the RSX call to clear an event flag
C
C		CALL CLREF(Iefn [,Ids])
C
C	Where  	Iefn	I*2	Event flag number (0 - 64 or 96)
C		Ids	I*2	Directive status
C
C-

	Integer*2	Idirective_status	!
	Integer*2	Ievent_flag		!
	Integer*4	Iarg2			! argument present flag
	Integer*4	SYS$CLREF,Istatus	!

	INCLUDE		'SYS$LIBRARY:SSDEF.FOR'

	PARAMETER IS_CLR=0			! Event flag was clear
	PARAMETER IS_SET=2			! Event flag was set
	PARAMETER IE_IEF=-97			! Illegal event flag #
	PARAMETER IE_ADP=-98			! Part of DPB not accessable

	Iarg2=IADDR(Idirective_Status)		! Is Status word present?
	Istatus=SYS$CLREF(%VAL(Ievent_Flag))	! Clear the flag
	write(*,10)Istatus
10	format(' Status =',z10)
	IF(Iarg2.GT.0)			THEN	! If status word present
	   IF(Istatus.EQ.SS$_WASCLR) Idirective_status=IS_CLR
	   IF(Istatus.EQ.SS$_WASSET) Idirective_status=IS_SET
	   IF(Istatus.EQ.SS$_ILLEFC) Idirective_status=IE_IEF
	   IF(Istatus.EQ.SS$_UNASEFC)Idirective_status=IE+ADP
	END IF					!
	RETURN
	END

C
C------------------------------------------------------------------------
C
	SUBROUTINE SETEF(Ievent_flag,Idirective_status)
C+
C	Emulate the RSX call to set an event flag
C
C		CALL SETEF(Iefn [,Ids])
C
C	Where  	Iefn	I*2	Event flag number (0 - 64 or 96)
C		Ids	I*2	Directive status
C
C-

	Integer*2	Idirective_status	!
	Integer*2	Ievent_flag		!
	Integer*4	Iarg2			! argument present flag
	Integer*4	SYS$SETEF,Istatus	!

	INCLUDE		'SYS$LIBRARY:SSDEF.FOR'

	PARAMETER IS_CLR=0			! Event flag was clear
	PARAMETER IS_SET=2			! Event flag was already set
	PARAMETER IE_IEF=-97			! Illegal event flag #
	PARAMETER IE_ADP=-98			! Part of DPB not accessable

	Iarg2=IADDR(Idirective_Status)		! Is Status word present?
	Istatus=SYS$SETEF(%VAL(Ievent_Flag))	! Clear the flag
	write(*,10)Istatus
10	format(' Status =',z10)
	IF(Iarg2.GT.0)			THEN	! If status word present
	   IF(Istatus.EQ.SS$_WASCLR) Idirective_status=IS_CLR
	   IF(Istatus.EQ.SS$_WASSET) Idirective_status=IS_SET
	   IF(Istatus.EQ.SS$_ILLEFC) Idirective_status=IE_IEF
	   IF(Istatus.EQ.SS$_UNASEFC)Idirective_status=IE+ADP
	END IF					!
	RETURN
	END

C
C-----------------------------------------------------------------------------
C


	SUBROUTINE MARK(Ievent_flag,Itime_magnitude, Itime_unit, Ids)
C+
C -- Dummy up the RSX11M   CALL MARK subroutine
C
C	CALL MARK(Ievent_flag,Itime_magnitude,Itime_unit [,Ids])
C	
C	where	Ievent_flag	 = I*2  Event flag to use
c		Itime_magnitude  = I*2  interval
C		Itime_unit	 = 0 -> tics (force to 100 tics/sec)
C				   1 -> tics (force to 100 tics/sec)
C				   2 -> Seconds
C				   3 -> Minutes
C				   4 -> Hours
C
C		Ids		 = 1 -> Success
C				 = -93 -> Invalid time parameter (IE.ITI)
C
C	VMS uses event flags much, much differently than RSX does.  EFN=0
C	should not be used since VMS calls will user it by default (SETIMR,
C	QIO, etc).  The documentation on SYS$SETIMR does not say so, but it
C	must clear the EFN if it is set.  Since this subroutine is compiled
C	/NOI4, direct arguments to the quadword subroutines must be variables
C	if they are to work reliably, ie one can not pas a zero by placing
C	a (0, as an argument.  Instead one must create a quadword which is
C	zero.
C
C	VMS keeps its internal timer in 100 nsec units.  To initiate a 
C	wait, a quadword containing the negative number of units to
C	wait is passed in the VMS service call SYS$SETIMR.  This routine
C	requires the quadword math routines in QUADMATH.MAR.
C
C	Written by:	James G. Downward		10-Sept-82
C			KMS Fusion, Inc
C			P.O. Box 1567
C			Ann Arbor, Mich. 48104
C
C-

	INTEGER*2 Itime_magnitude,Itime_unit,Istatus
	INTEGER*2 Ihundredths,Iseconds,Iminutes,Ihours
	INTEGER*4 Iconstant_Quad(2),Ivalue_Quad(2)
	INTEGER*4 Itimer(2),IZERO(2)		!
	INTEGER*4 SYS$SETIMR,SYS$WAITFR		!
	INTEGER*4 LIB$GET_EF,LIB$FREE_EF	!
	INTEGER*4 Ists,Iefn			!
	INCLUDE 'SYS$SYSDISK:[SYSLIB]SSDEF.FOR/NOLIST'	!
	
	PARAMETER IS_SUC=0
	PARAMETER IE_UPN=-1			! Insufficient dyn mem
	PARAMETER IE_ITI=-93			! Invalid time parameters
	PARAMETER IE_IEF=-97			! Invalid event flag
	PARAMETER IE_ADP=-98			! Invalid DPB

	DATA IZERO(1) /0/, IZERO(2) /0/		!

	CALL ARGCNT(Number_of_Arguments)	! See if IDS is present
	Istatus=IE_ITI				! Assume will fail
	IF (Itime_unit.LT.0	.OR.		! See if valid time unit
     -	    Itime_unit.GT.4)		GOTO 100!  If not,exit with bad status
C
C -- Convert the input time into 100 nsec units
C
C -- First to Milliseconds
C
	IF     (Itime_unit.EQ.0)	THEN	! If tics (100 tics/sec)
	   Iconstant_quad(1) = 10		!   convert to milliseconds
	ELSE IF(Itime_unit.EQ.1)	THEN	! A '1' is also tics
	   Iconstant_quad(1) = 10		!   convert to milliseconds
	ELSE IF(Itime_unit.EQ.2)	THEN	! If seconds
	   Iconstant_quad(1) = 1000		!   convert to miliseconds
	ELSE IF(Itime_unit.EQ.3)	THEN	! If minutes
	   Iconstant_quad(1) = 60000		!   convert to miliseconds
	ELSE IF(Itime_unit.EQ.4)	THEN	! If Hours
	   Iconstant_quad(1) = 1440000		!   convert to miliseconds
	END IF					!
	Iconstant_quad(2)=0			! Be sure is always zero
	Ivalue_Quad(1) = Itime_magnitude	! Set magnitude in quadword
	Ivalue_Quad(2) = 0			! Be sure is always zero
C
C -- Now convert into internal VMS format
C
	CALL EMUL(Iconstant_quad,Ivalue_Quad,Ivalue_quad) ! cnvt to msec
	Iconstant_Quad(1)=10000			! To convert to 100 nsec tics
	Iconstant_quad(2)= 0			! Be sure is zero
	CALL EMUL(Iconstant_Quad,Ivalue_Quad,Itimer(1)) ! multiply
	CALL SUBQUAD(IZERO(1),Itimer(1),Itimer(1))! Make negative

	Iefn=Ievent_Flag			!
	Istatus=SYS$CLREF(%VAL(Iefn))		! Besure event flag clear
	IF(Istatus.EQ.SS$_UNASEFC	.or.	! If not associated with EFN
     -	   Istatus.EQ.SS$_ILLEFC)	 THEN	! or if illegal event flag
	     IF(Number_of_arguments.EQ.4)THEN	!
	       Idirective_Status=IE_IEF		!
	     END IF				!
	   RETURN				!
	END IF					!
	   					!

	Ists=SYS$SETIMR(%VAL(Iefn),Itimer(1),,) ! Go set the timer
	IF(Number_Of_Arguments.EQ.4)	THEN	!
	    Idirective_status=SS$_NORMAL	! Assume the best
	    IF(Ists.EQ.SS$_ACCVIO) Idirective_status=IE_ITI
	    IF(Ists.EQ.SS$_EXQUOTA)Idirective_status=IE_UPN
	    IF(Ists.EQ.SS$_ILLEFC) Idirective_status=IE_IEF
	    IF(Ists.EQ.SS$_INSFMEM)Idirective_status=IE_UPN
	    IF(Ists.EQ.SS$_UNASEFC)Idirective_status=IE_IEF
	END IF					!

100	RETURN					!  and exit
	END
