C+
C Check_Time
C		Subroutine to check that the input
C		time to be sure it lies within valid bounds
C
C	CALL Check_Time(Ctime,Ilength,Ierror)
C
C	Where	Ctime	    Character*5	   Time string in format HH:MM
C		Ilength	    I*4		   Length of time string
C	        Ierror	    I*4		   Return error code
C					   =  0  Success
C					   = -1  Bad time value
C
C	This subroutine will accept as valid times of the format
C	1:mm, 01:mm, 10:mm, etc.  Times of the format 10:m however
C	are not valid.  Valid hours range from 0 - 23 and valid
C	minutes range from 0 - 59.
C-
	SUBROUTINE Check_Time(Ctime,Ilength,Ierror)
	CHARACTER*5 Ctime			!
	CHARACTER*2 Cminute			!
	CHARACTER*2 Chour			!

	IF(Ilength.GT.5		.OR.		! If time string too long
     -     Ilength.LT.4)	       GOTO 9000! or too short, error
	IF(Ilength.EQ.4)  Ctime(1:5)='0'//Ctime(1:4)! Stick on leading 0
	Ipos=INDEX(Ctime,':')			! Find seperator
	IF(Ipos.EQ.0)		       GOTO 9000! Must have colon
	Chour=Ctime(1:2)			!
	Cminute =Ctime(4:5)			!
	READ(Chour,10,ERR=9000)Ihour		!
10	FORMAT(I2.2)				!
	READ(Cminute,10,ERR=9000)Iminute	!
	IF(Ihour  .LT.0		.OR.		! Only accept times from
     -     Ihour  .GT.23)	       GOTO 9000! 00:00 to 23:59
	IF(Iminute.LT.0		.OR.		!
     -     Iminute.GT.59)	       GOTO 9000!
	Ierror=0				! show time OK
	RETURN					!
9000	Ierror=-1				!
	RETURN					!
	END					!
