C+
C	Check_Escape
C
C	Various VPW programs start up using alternate keypad mode.  Following
C	a call to Read_String, a call to Check_Escape is made to determine
C	if an Escape key has been hit and if so how to process it.  The
C	current screen window is stored in COMMON /Screen/ must be set up
C	from calling program.
C
C
C	CALL Check_Escape(Ctmp,Nchar,Iterminal,Chelp,
C     -			*nnn,			! ^z/Alt -
C     -			*mmm,			! Backup(up arror) Return
C     -			*ooo,			! Done (7)_return
C     -			*ppp)			! Help/VPW return PF2/PF4
C
C	      Ctmp	CHARACTER*(*)	Input character string to check
C	      Nchar	INTEGER*4	Number of characters
C					>=  0 not escape seq
C					=  -1 ^Z input
C					=  -2 Escape sequence
C	      Iterminal	INTEGER*4	Terminal type
C	      Chelp	CHARACTER*(*)	Help text to display
C	      *nnn      ......		List of alternate return addresses
C
C	Depending on the type of input the routine will automatically branch
C	To the required routine.
C-
C		IDENT	/1/
C
	SUBROUTINE Check_Escape(Ctmp,Nchar,Iterminal,Chelp,
     -			*,			! ^z/Alt -
     -			*,			! Backup(up arror) Return
     -			*,			! Done (7)_return
     -			*)			! KEYPAD/Help/VPW ret PF2/PF4

	CHARACTER*1	Cin_Use_Flag		! If "Y" VPW started us up
	CHARACTER*(*)	Ctmp			!
	CHARACTER*(*)	Chelp			! Help text to display
	CHARACTER*20	Cprogram		! 
	COMMON	/Program/	Cprogram	! Program name
	COMMON	/Screen/	Iline,Itop,Ibot	! Screen window

	IF(Nchar.GT.0)			RETURN		! Not escape seq
	IF(Nchar.EQ.-1)			RETURN 1	! If ^Z input

	IF(Nchar.EQ.-2)				THEN	! if ESC seq
	    IF(Ctmp(1:1).EQ.'P')		THEN	! If KEYPAD key
	      CALL Display_Help('VPW KEYPAD',Iterminal,Iline+1,23)!
	    ELSE IF(Ctmp(1:1).EQ.'Q')		THEN	! If HELP key
	      CALL String_Length(Chelp,I)		!
	      CALL Display_Help(Chelp(1:I),Iterminal,Iline+1,22)!
	    ELSE IF(Ctmp(1:1).EQ.'S')		THEN	!
	      IF(Iterminal.LT.96)  TYPE *,' '		!
	      CALL Command_Screen(Iterminal,Iline+1,24)	! 
	    ELSE IF(Ctmp(1:1).EQ.'M')		THEN	! If ENTER key
	      Nchar=0					! Pretend it is return
	      RETURN					!
	    ELSE IF(Ctmp(1:1).EQ.'A')		THEN	! If up-arrow key
	      IF(Iline.GT.Itop) Iline=Iline-1		! Backup a line
	      RETURN 2					! and try again
	    ELSE IF(Ctmp(1:1).EQ.'p')		THEN	! If MENU key
	      Istatus=LIB$GET_SYMBOL('VPW_In_Use',Cin_use_Flag)! How started?
	      IF(Istatus)			THEN	! If got symbol and if
	        IF(Cin_Use_Flag.EQ.'T')	       CALL EXIT!  If 'T' Exit -> menu
	      END IF					! end if
	      Istatus=LIB$DO_COMMAND('VPWMENU')		! Off to the menu
	      RETURN 					! Never can get here
	    ELSE IF(Ctmp(1:1).EQ.'w')		THEN	! If QUIT key treat
	      RETURN 1					!   like ^Z
	    ELSE IF(Ctmp(1:1).EQ.'m')		THEN	! If DONE key
	      RETURN 3					! Back to calling prog
	    ELSE 					!
	      RETURN					!
	    END IF					!
	    CALL VPW_SCROLL(Iterminal,Itop,Ibot,0)	! reset scroll 
	    CALL SCREEN(' ',Iterminal,Iline,1,1)	! Erase to end of scrn
	    RETURN 4
	END IF						!
	END

