C+
C	Command_Screen
C
C	This subroutine creates a window on the VT100 terminal which
C	acts as a secondary command screen.  Its use is when the PF4 key
C	is hit, to allow the user to interrupt work in progress and
C	send off commands to DCL, later returning to the work in progress.
C
C	CALL Command_Screen(Iterminal,Itop,Ibot)
C	
C	Where
C		Iterminal  Integer*4	Terminal identification code
C		Itop	   Integer*4	Top line of scroll region
C		Ibot	   Integer*4	Bottom line of scroll region
C
C	The command screen sets terminal characteristics to be a funny, non-
C	standard CRT.  The reason for this is that EDT, Phone, Broadcast, and
C	a few other random VMS utilities, ignore the scrolling region 
C	previously set up for the terminal.  Specifically, EDT and phone
C	erase the screen, thus loosing all that was present.  To avoid this
C	problem we set the terminal to be an LA120 with CRT characteristics
C	(for rubout).  EDT now only works in line mode, and phone not at
C	all.  At present this seems to be the only workaround to the problem,
C	and admittedly, it stinks. When the user exits the command screen 
C	(^Z),  the scrolling region and the terminal characteristics will 
C	be restored.
C
C-
	SUBROUTINE Command_Screen(Iterminal,Itop,Ibot)
	EXTERNAL	Idone				! Ast completion routine
	CHARACTER*(*)	Cbold
	CHARACTER*(*)	Cnorm
	CHARACTER*1	Cnull	/0/
	Character*80	Cans
	CHARACTER*80	Cstring
	CHARACTER*48	Cstring2
	INTEGER*4	Ilength
	PARAMETER (Cbold=CHAR(27)//'[1m')
	PARAMETER (Cnorm=CHAR(27)//'[0m')
	PARAMETER (Cstring= '-------------------- VPW Command Screen '//
     -		            '(Type ^Z to EXIT) ----------------------')
	CALL SCREEN(Cstring,Iterminal,Itop,0,1)		! Erase to end of Sc
	IF(Iterminal.LT.96)	TYPE *,' '		!

	CALL VPW_SCROLL(Iterminal,Itop+2,Ibot,3)	! scroll window/smooth
							! set origin mode
5	CALL Screen('VPW>',Iterminal,1,1,0)		! First prompt
							!
20	CALL Read_String(Cans,Nchar)			! Read input
	IF(Nchar.EQ.-1)			      GOTO 100	! ^Z EXIT
	IF(Nchar.LT.1)			      GOTO 5	! Reprompt
							!
	Istatus=lib$spawn('@SYS$VPWFILES:VPWSPAWN '//Cans(1:Nchar),
     -		           ,,,,,,,Idone)		!
	IF(.NOT.Istatus) 				!
     -      TYPE *,'VPW -- SPAWN of @SYS$VPWFILES:VPWSPAWN failed'

100	CALL VPW_Scroll(Iterminal,1,24,0)		! Scroll full screen
	TYPE *,' '					!
	IF(Iterminal.GE.96)			THEN	! If VT100
	   CALL SCREEN(' ',Iterminal,Itop,1,1)		!
	END IF						!
	RETURN						!
	END
C
C+
C  This micro routine's function is to trap the situation of the
C  subprocess exiting and leaving in an unknown state.  Using this
C  routine, whenever our subprocess exits, Idone will get called to
C  reset terminal characteristics.
C
C-
	SUBROUTINE IDONE(IVAL)
	IMPLICIT INTEGER*4	(A-Z)
	Istatus=LIB$SPAWN('$SET TERM/INQUIRE')
	RETURN
	END

