$	PAGE
$	TYPE SYS$INPUT
		Create Control Files for NoteBook

     This procedure will create the prototype text files which are used
to drive the VAX Notebook.  Four files are needed

		a) The menu file
		b) The Prompt file
		c) The display format control
		d) The sort control file
		e) The Help file.

To create these files, you first need supply the name to access this data
base with, and a three letter mnemonic prefix for creating the text files
for insertion into VPW.TLB and VPW.HLB

$Get_Program_Name:
$	INQUIRE Program "Program name"
$	Length='F$LENGTH(Program)'
$	IF Length .EQ. 0 THEN EXIT
$	IF Length .LE. 9 THEN GOTO Get_Prefix
$	TYPE SYS$INPUT

	Program names must be <= 9 characters long. Try again.

$	GOTO Get_Program_Name
$Get_Prefix:
$	INQUIRE Prefix "Three letter Prefix name"
$	Length='F$LENGTH(Prefix)'
$	IF Length .NE. 3 THEN GOTO Get_Prefix
$	TYPE/OUTPUT='Program'.TXT SYS$INPUT
	You may choose:
			[1mA[0mdd     -  Add a new record
			[1mDE[0mlete  -  Delete a record
			[1mDI[0msplay -  Display a record
			[1mM[0modify  -  Modify a record
			[1mE[0mxit    -  Exit
/
A DE DI E M
$	PAGE
$	READ/PROMPT="Program Title: " SYS$COMMAND Title
$	INQUIRE Data_File "Default data file name"
$	N=1
$	WRITE SYS$OUTPUT " "
$Get_Prompt_Loop:
$	TMP'N'=" "
$	READ/PROMPT="Prompt string ''N' (<CR> -> Stop input): " -
	SYS$COMMAND Prompt'N'
$!	INQUIRE Prompt'N' "Prompt string ''N' (<CR> -> Stop input)"
$	Length=F$LENGTH(Prompt'N')
$	IF Length .EQ.0 THEN GOTO No_More_Prompt_Fields
$	TMP'N'=Prompt'N'+"|"
$	INQUIRE Field_Length'N' "Length of input field"
$	Length=F$LENGTH(Field_Length'N')
$	IF Length .EQ.0 THEN GOTO Get_Prompt_Loop
$	INQUIRE Help_Keyword'N' "Help keyword"
$	Length=F$LENGTH(Help_Keyword'N')
$	IF Length .EQ.0	THEN GOTO Get_Prompt_Loop

$Get_Match_Type:
$	TYPE SYS$INPUT
	
	Allowed data type match checking includes

	0	No input field checking
	1	Exit if no input in add mode
	2	Input required in add mode. Reprompt for it
	3	Protected fields may not be modified
	4	Match one of list
	5	Verify input is date string
	6	Range check input

$	INQUIRE Select "Match type (0 - 6)"
$	IF Select .LT. 0 THEN GOTO Get_Match_Type
$	IF Select .GT. 6 THEN GOTO Get_Match_Type
$	IF Select .EQ. 0 THEN Match'N'=0
$	IF Select .EQ. 1 THEN Match'N'=1
$	IF Select .EQ. 2 THEN Match'N'=2
$	IF Select .EQ. 3 THEN Match'N'=4
$	IF Select .EQ. 4 THEN Match'N'=8
$	IF Select .EQ. 5 THEN Match'N'=16
$	IF Select .EQ. 6 THEN Match'N'=32
$	IF Select .EQ. 3 THEN GOTO Protected_field
$	IF Select .Eq. 4 THEN GOTO One_Of_List
$	IF Select .EQ. 5 THEN Field_Length'N'=11
$	IF Select .EQ. 6 THEN GOTO Range_Check
$	GOTO Loop_end
$Loop_end:
$	Tmp'N'=Tmp'N'+F$STRING(Field_Length'N')+"|"+"''Program' "-
	+Help_Keyword'N'+"|"
$	Tmp'N'=Tmp'N'+F$STRING(Match'N')
$	Tmp=Tmp'N'
$	N=N+1
$	WRITE SYS$OUTPUT " "
$	GOTO Get_Prompt_Loop
$One_Of_List:
$	INQUIRE Match_Field "Enter match list"
$	Match'N'=F$STRING(Match'N')+"|"+Match_Field+" "
$	GOTO Loop_End
$Protected_Field:
$	INQUIRE Match_Field "Enter protected field"
$	Field_Length'N'=F$LENGTH(Match_Field)
$	Match'N'=F$STRING(Match'N')+"|"+Match_Field
$	GOTO Loop_End
$Range_Check:
$	INQUIRE Loval "Enter low value"
$	INQUIRE Hival "Enter hi value"
$	Match_Field=F$STRING(Loval)+"/"+F$STRING(Hival)
$	Match'N'=F$STRING(Match'N')+"|"+Match_field
$	GOTO Loop_End
$!	
$No_More_Prompt_Fields:
$	N=N-1
$	IF N .EQ. 0 THEN EXIT
$	OPEN/WRITE OUTPUT 'Prefix'PRMPT.TXT
$	WRITE OUTPUT "''Title'"
$	WRITE OUTPUT "''Data_File'"
$	WRITE OUTPUT "/"
$	J=1
$Loop2:
$	TMP=TMP'J'
$	WRITE OUTPUT "''TMP'"
$	J=J+1
$	IF J.LE.N THEN GOTO Loop2
$	CLOSE OUTPUT
$	OPEN/WRITE OUTPUT 'Prefix'HELP.HLP
$	WRITE OUTPUT "1	''Program'"
$	WRITE OUTPUT "No Help available yet"
$	J=1
$Loop3:
$	tmp=Help_Keyword'J'
$	WRITE OUTPUT "2	''TMP'"
$	WRITE OUTPUT "No Help is available yet"
$	J=J+1
$	IF J.LE.N THEN GOTO Loop3
$	CLOSE OUTPUT
$	OPEN/WRITE OUTPUT 'Prefix'FORMS.TXT
$	WRITE OUTPUT "Basic output form - Please change as appropriate"
$	WRITE OUTPUT "(' ',''N'(A,2X))"
$	J=1
$	tmp=F$STRING(N)
$Loop4:
$	Tmp=tmp+","+F$STRING(J)
$	J=J+1
$	IF J .LE. N THEN GOTO Loop4
$	WRITE OUTPUT "''TMP'
$	CLOSE OUTPUT
$	WRITE SYS$OUTPUT " "
$	TYPE SYS$INPUT

	By default, this file will not be sorted.  If you wish it to
	be sorted you must edit the sort control text file to insert
	the proper sort control parameters.  The file to edit is:

$	WRITE SYS$OUTPUT "                      ''Prefix'SORT.TXT"
$	OPEN/WRITE OUTPUT 'Prefix'SORT.TXT
$	WRITE OUTPUT "0"
$	CLOSE OUTPUT
$	TESTFILE VPW.TLB
$	IF $STATUS .NE. 1 THEN LIBR/CREATE/TEXT VPW.TLB
$	TESTFILE VPW.HLB
$	IF $STATUS .NE. 1 THEN LIBR/CREATE/HELP VPW.HLB
$	LIBR VPW.HLB 'Prefix'HELP.HLP
$	LIBR VPW.TLB 'Program'.TXT/MODULE='Program'
$	LIBR VPW.TLB 'Prefix'PRMPT.TXT/MODULE='Program'_PROMPTS
$	LIBR VPW.TLB 'Prefix'FORMS.TXT/MODULE='Program'_FORMS
$	LIBR VPW.TLB 'Prefix'SORT.TXT/MODULE='Program'_SORT
$
$	
$exit

