	PROGRAM FOLDER_INDEX
C+		Ident /1/
C
C	Provide a program which will provide a formatted index of a 
C	File Folder.  FOLDRINDX is designed to be used as a foreign
C	commmand.  The command line passes both the text library 
C	string, and the title to display if any files are found.
C
C	Foldrindx  Folder_name[|"Title...Title....Title"]
C				__                      _
C	Note that  the |" and the trailing " in the title line
C	are required if a title is present. The title is optional.
C
C	The display is set to 
C
C		Title...Title...Title
C	
C	Document1	Document2	Document3	Document4
C	Document5	Document6	Document7	Document8
C	Document6	Document10	Document11	Document12
C	Document13	Document14	Document15	Document16
C
C Written by:	Version 1.0
C		April 18,1983
C		James G. Downward
C		KMS Fusion, Inc.
C		P.O. Box 1567
C		Ann Arbor, Mich. 48106
C		(#13)-769-8500
C
C-
	IMPLICIT INTEGER*4	(A-Z)
	Logical*1 	Ltitle_Flag	/.False./	! Assume not printed
	Logical*1	Lfound_one	/.False./	! Assume no files found
	CHARACTER*1	Cnull,Cesc,Cans			! A null to test for
	CHARACTER*4	Cbold,Cnorm,Ctmp		!
	CHARACTER*30	Csearch				! File search string
	Character*80	Ctitle				! Title to display
	Character*80	Outline		/' '/		! Output display line
	Character*132	Command_Line			! Input
	Integer*2	Ilength				!
	Integer*4	Istatus,Icontext		!
	INTEGER*4	Index_number			! Number of index
	INTEGER*4	Prnt_Indx			!
	Integer*4 	RFA_addr			!
	Integer*4	Icount				!
	DATA	Cnull	/0/				!
	DATA	Cesc	/27/				!

	COMMON	/COUNTER/	ICOUNT,Outline
	EXTERNAL	Prnt_Indx
	INCLUDE 'SYS$LIBRARY:LBRDEF.FOR/NOLIST'		! 
	INCLUDE 'SYS$LIBRARY:RMSDEF.FOR/NOLIST'		!
	Cbold=Cesc//'[1m'				!
	Cnorm=Cesc//'[0m'				!

	Istatus=LIB$GET_FOREIGN(Command_Line,'File folder: ',Ilength)
	IF (Ilength.EQ.0) 		       GOTO 9999! Exit if no command
	Ctitle=Cnull					! Set to null
	Ipos=Index(Command_Line(1:Ilength),'|"')	! Find delim sep title
	IF(Ipos.EQ.0) 			THEN		! If none then just
	    Ipos=LEN(Csearch)+1				!   use search string
	    IF(Ipos.GT.Ilength) Ipos=Ilength+1		!
	ELSE						! Else
	    Ctitle=Command_Line(Ipos+2:Ilength-1)	!   set title line
	END IF						!
	Csearch=Command_Line(1:Ipos-1)			!
							!
10	Istatus = LBR$INI_CONTROL(Library_Index,	! Initialize library
     -		                  LBR$C_READ,LIB$C_TYP_TXT)! routines to read
	IF(.NOT. Istatus) 			THEN	! a text lib.  If fail
	  TYPE *,'VPW -- LBR$INI_CONTROL failed in FOLDRINDX.'!  warn and exit
	GOTO 9999
	END IF						!

	Istatus=LBR$OPEN(Library_Index,Csearch)		! Open library
	IF(.NOT.ISTATUS) 			THEN	! If menu can not be
	  WRITE(*,20) Cbold,Csearch(1:Ipos-1),Cnorm	!  output then exit
20	  FORMAT(' VPW -- Fatal, File folder 'A,A,A,	!
     -		 ' could not be opened')		!
	  GOTO 9999					!
	END IF						!

	IF(Ctitle(1:1).NE.Cnull)		THEN	!
	   TYPE *,Ctitle(1:Ilength-Ipos-2)		!
	   TYPE *,' '					!
	END IF
	Outline=' '					! Blank fill
	Index_number=1					!
	Icount=0					!
50	Istatus=LBR$GET_INDEX(Library_index,Index_number,Prnt_indx)
	Istatus=LBR$CLOSE(Library_Index)		! close when done
	IF(Icount.GT.0)		THEN			!
	    Ipos=Icount*20-5				!
	    TYPE *,OutLine(1:Ipos)			!
	    Icount=0					! Reset for posterity
	    Outline=' '					!
	END IF						!

9999	CALL EXIT
	END


	INTEGER FUNCTION Prnt_Indx(Cbuffer,RFA_addr)

	Character*(*)	Cbuffer
	Character*80	Outline	
	Integer*4 	RFA_addr
	Integer*4	Icount	/0/
	COMMON /COUNTER/	Icount,OutLine
	Icount=Icount+1
	Ilen=LEN(Cbuffer)
	Ipos=(Icount*20)-15
	OutLine(Ipos:Ipos+Ilen)=Cbuffer
	IF(Icount.EQ.4)		THEN
	   TYPE *,OutLine
	   OutLine=' '
	   Icount=0
	END IF
	Prnt_Indx=1
	RETURN
	END

