C+
C	Get_Program
C
C	This subroutine is to be used with the Professional Notebook
C	to see if the program was invoked as an external DCL command.
C	If it was not, it then prompts for the program name to use
C	for loading the control files from the text library.  If there
C	is no name, it exits.  If a command line exists it parses it.
C	The parsing is very simple minded.  One or two spaces should
C	exist seperating the program name, the Form number and the 
C	search string. If either either of the Search_string or form
C	number are null, the program defaults to interactive mode.
C	
C	Program_Name Iform_DCL Search string......
C
C	The program name can have up to 20 characters.  The form number
C	must be a number from 1 to 20.  And the search string can be
C	nearly anything the terminal will pass. (not control characters).
C
C	Writen by:
C			James G. Downward
C			KMS Fusion, Inc.
C			P.O. Box 1567
C			Ann Arbor, Mich. 48106
C			18-Jan-1983
C
C-

	SUBROUTINE Get_Program(Cprogram,Csearch_String,Iform_DCL)

	CHARACTER*(*)	Cprogram		! Program name
	CHARACTER*(*)	Csearch_String		!
	CHARACTER*255	Cbuffer			! For command line
	INTEGER*4	Iform_DCL,Istatus	!
	INTEGER*4	LIB$GET_FOREIGN		!
	
	Csearch_String=' '			! Blank fill
	Istatus=LIB$GET_FOREIGN(Cbuffer,'NoteBook program: ',Ilength)
	IF(Ilength.EQ.0)	THEN		!
	  TYPE *,'NoteBook -- Program name is absolutely required. Exiting'
	  CALL EXIT				!
	END IF					!
	IPOS=INDEX(Cbuffer(1:Ilength),' ')	! Have we a space
	IF(Ipos.EQ.0)			THEN	!
	  IF(Ilength.GT.LEN(Cprogram))  GOTO 9000!
	  Cprogram=Cbuffer(1:Ilength)		!
	  RETURN				!
	ELSE					!
	  Ilen=Ipos-1				!
	  IF(Ilen.GT.LEN(Cprogram))     GOTO 9000! If name too long
	  Cprogram=Cbuffer(1:Ilen)		! Transfer name
	END IF					!
	Ipos2=INDEX(Cbuffer(Ipos+1:Ilength),' ')! Another space
	IF(Ipos2.EQ.0)			RETURN	! If EQ 0, no
	Ipos2=Ipos2+Ipos			! Absolute position
	READ(Cbuffer(Ipos+1:Ipos2-1),10,ERR=9100)Iform_DCL
10	FORMAT(I2)				!
	IF(Ipos2.EQ.Ilength)		THEN	! Input missing, 
	  Iform_DCL=0				!  force interactive
	  RETURN				!
	END IF
	Csearch_string=Cbuffer(Ipos2+1:Ilength)	! Get search string (if any)
	RETURN

9000    TYPE *,'NoteBook -- Fatal. Program name > 20 characters.'
	CALL EXIT				!
9100	WRITE(*,9110)Cbuffer(Ipos+1:Ipos2-1)
9110	FORMAT(' NoteBook -- Fatal. Error converting Form Field: ',A)
	CALL EXIT
	END
