C+
C	VPW_Load_Forms
C	
C	This subroutine is designed to load the forms from the text 
C	library into the form common block.  The text library is 
C			SYS$VPWFILES:VPW.TLB.  
C	The format of the call is to specify the name of the form module
C	desired to use.  The format of a form text entry is
C
C		Form_name
C		(Fortran_format_string)
C		Inumber_of_items,Iposition_item_1,Iposition_item_2......
C	
C	Up to 20 forms may be specified. Each form may have up to
C	have 20 seperate items. This value may easily be increased
C	by increasing the value of Isize.
C
C	Example:	CALL VPW_Load_Forms('PHONEBOOK_FORMS')
C
C	Please note that the common block is required not only in this
C	module, but in all modules referencing either the record definitions,
C	the help, or the prompts.
C
C-

	SUBROUTINE VPW_Load_Forms(Cname)

	IMPLICIT INTEGER*4	(A-Z)
	CHARACTER*(*)		Cname
	CHARACTER*1		Cesc,Cbell,Cnull
	CHARACTER*4		Cbold,Cnorm
	CHARACTER*40		Clibfile
	CHARACTER*132		Crecord
C 
C -------------------------------------------------------
	PARAMETER		(Isize=20)

	CHARACTER*50		Cform_name
	CHARACTER*132		Cform
	INTEGER*4		Number_of_Forms
	INTEGER*4		Number_of_Items
	INTEGER*4		Iorder_of_Items


	COMMON	/FORMS/		Number_of_Forms,
     -				Number_of_Items(Isize),
     -				Iorder_of_Items(Isize,Isize),
     -				Cform(Isize),
     -				Cform_name(Isize)

	COMMON	/Constants/	Cesc,Cbell,Cnull,Cbold,Cnorm

C ----------------------------------------------------------------
C

	INTEGER*4	IPTR(2)				! For LBR$ routine
	INTEGER*4	Outdes(2)			! Output string descrip
	INCLUDE 'SYS$LIBRARY:LBRDEF.FOR/NOLIST'		! 
	INCLUDE 'SYS$LIBRARY:RMSDEF.FOR/NOLIST'		!

	Clibfile='SYS$VPWFILES:VPW.TLB'
	IF(Ichar(Cbell).NE.7)			THEN	! See if common blk in
	  TYPE *,' VPW -- Common block /Constants/ not loaded'
	  GOTO 9000					!
	END IF
	CALL STRING_LENGTH(Cname,Iname_Length)		! Get string length
10	Istatus = LBR$INI_CONTROL(Library_Index,	! Initialize library
     -		                  LBR$C_READ,LIB$C_TYP_TXT)! routines to read
	IF(.NOT. Istatus) 			THEN	! a text lib.  If fail
	  TYPE *,'VPW -- LBR$INI_CONTROL failed.'	!  warn user and exit
	  GOTO 9000					!
	END IF						!

	Istatus=LBR$OPEN(Library_Index,Clibfile)	! Open up the library
	IF(.NOT.ISTATUS) 			THEN	! If menu can not be
	  WRITE(*,20) Clibfile				!  output then exit
20	  FORMAT(' VPW -- Fatal, ',A,/,			!
     -	         '        can not be opened to extract form table.')!
	  GOTO 9000					!
	END IF						!
							!
	Istatus = LBR$LOOKUP_KEY(Library_Index,		! Find the txt module 
     -			         Cname(1:Iname_Length),Iptr)! in the library
	IF(.NOT.Istatus)			THEN	! If fails warn user
	  WRITE(*,30)Cname(1:Iname_Length),Clibfile	! and exit
30	  FORMAT(' VPW -- Fatal, Form module, ',A,' can',/,	!
     -           '        not be found in ',A)		!
	  GOTO 9000					!
	END IF

	Number_of_Forms=0				!
C 
C .. First get form name
C
100	Istatus=LBR$GET_RECORD(Library_Index,Crecord,Outdes)	! Read LBR rec
	IF(Istatus.EQ.RMS$_EOF		.OR.		! If EOF or if some
     -     Istatus.NE.1)		       GOTO 200	!  other error, stop
	N=Outdes(1)					! Number of characters
	IF(N.EQ.0)			GOTO 100	! Skip null records
	IF(Crecord(1:1).EQ.'!')		GOTO 100	! Skip Comments
	Number_of_Forms=Number_of_Forms+1		! Count # of records
	Cform_Name(Number_of_forms)=Crecord(1:N)	! Get form name
C
C .. Now get the form itself
C
105	Istatus=LBR$GET_RECORD(Library_Index,Crecord,Outdes)	! Read LBR rec
	IF(Istatus.EQ.RMS$_EOF		.OR.		! If EOF or if some
     -     Istatus.NE.1)		    GOTO 8050	!  other error, stop
	N=Outdes(1)					! Number of characters
	IF(N.EQ.0)			GOTO 105	! Skip null records
	IF(Crecord(1:1).EQ.'!')		GOTO 105	! Skip Comments
	Cform(Number_of_forms)=Crecord(1:N)		!

	Inum=Number_of_Forms				! for convenience
C
C .. Now get the item ordering information
C
	Istatus=LBR$GET_RECORD(Library_Index,Crecord,Outdes)	! Read LBR rec
	IF(Istatus.EQ.RMS$_EOF		.OR.		! If EOF or if some
     -     Istatus.NE.1)		       GOTO 8000!  other error, stop
	
	N=Outdes(1)					!
	READ(Crecord(1:N),110)Items,
     -			      (Iorder_of_Items(Inum,I), I=1,Items)!
110	FORMAT(I3,<Items>I3)				!
	Number_of_Items(Inum)=Items			!
c	type *,'number of items =',Items
c	TYPE *,Cform(Number_of_forms)	!*****
c	write(*,120)(Iorder_of_Items(Inum,I),I=1,Items)
c120	format(' ',<Items>i5)

	GOTO 100

200	Istatus=LBR$CLOSE(Library_Index)		! close when done

1000	RETURN						! All done
8000	TYPE *,'VPW_Lod_Forms -- Fatal, Display-order line missing'
	GOTO 9000
8050	TYPE *,'VPW_Lod_Forms -- Fatal, Form field missing'
	GOTO 9000
9000	TYPE *,' '
	TYPE *,'Press '//Cbold//'RETURN'//Cnorm//' to continue'
	READ(*,9010,END=9999)Cans
9010	FORMAT(A)
	GOTO 9999

9999	CALL EXIT
	END
