c+		The Professional Notebook
C
C	The Professional Notebook is designed to fill a gap between
C	big, but very versitile data base systems (DTR, etc) and the
C	professionals needs for simple, easy to use, scratch pad data
C	bases.  ProNoteBook is designed as a core program which is 
C	driven from external data files.  Once the name of the program
C	is available to ProNoteBook, it can determine how it is to behave
C	based on the contents of data files in SYS$VPWFILES:VPW.TLB.
C
C	At it core, ProNoteBook, can create, add records to, delete records
C	from, modify records in, or display records in the data bases defined
C	in the controll files.  The records may have up to ISIZE seperately
C	defined fields( Isize is currently set at 20) with a combined record
C	size of 512 bytes.  The data is stored in ASCII byte format.  Each
C	field may be a sort field (up to 10) and the records are automatically
C	kept in sorted condition it such is desired.
C
C	ProNoteBook is designed to run on a VT100, though it also should run
C	on a hardcopy terminal.  On a VT100 terminal, the keypad is set to
C	alternate keypad mode and can be used in obtaining on line help or 
C	keypad display, and alternate command mode screen at most times.  Other
C	keys are used to speed the data entry process.
c
C	The alternate command mode screen can be used to reenter DCL to do
C	some work, leaving the interrupted work in progress at a known state.
C	Typing ^Z to exit the aternate ocmmand mode screen, allows the
C	user to continue where they left off.  Because, various DEC utilities
C	do not preserve the VT100 scrolling region when invoked, the 
C	altername command screen, behaves as a non-DEC CRT, not a VT100.
C
C	Data may be displayed in a variety of stored forms.  Up to 20 stored
C	forms may be defined.  Each form may specify both the order of display
C	and the method of the fields.  Each field has a name for use in 
C	selecting it.
C
C	For display purposes ProNoteBook will accept a DCL command line
C	specify the form to use for display, the search string to use
C	for selecting records, and the name of the control files to use.
C
C	If the name of the function to be done is XXX, the control files
C	would be named	XXX
C			XXX_PROMPTS
C			XXX_FORMS
C			XXX_SORT
C	and would be contained in VPW.TLB on SYS$VPWFILES.  HELP files would
C	EXIST as XXX in SYS$VPWFILES.VPW.HLB.
C
C Writen by:
C			James G. Downward
C			KMS Fusion, Inc
C			P.O. Box 1567
C			Ann Arbor, Mich. 48104
C			(313)-769-8500
C
C Modified by:
C		JGD1	V 2.1		18-May-83	Fix Delete bug
C		JGD2	V 2.2		26-May-83	Fix Output to Scratch
C							file bug
C	
C
C-

C	IDENT	/V2.2/
	PROGRAM ProNoteBook

	CHARACTER*1	Cesc,Cnull,Cbell
	CHARACTER*4	Cbold,Cnorm			!
	CHARACTER*5	Cident				!
	CHARACTER*6	Choice				!
	CHARACTER*12	Cuser				!
	CHARACTER*20	Cprogram			!
	CHARACTER*50	Cfile				!
	CHARACTER*80	Cmessage			!
	CHARACTER*80	Ctitle				!
	CHARACTER*80	Csearch_String			!
	CHARACTER*255	Ctmp				!
	LOGICAL*1	Is_Found,Ierror_Flag		!
	INTEGER*2	TTchan				!
	INTEGER*2	Key_Info			! For sort routine
	INTEGER*4	SYS$ASSIGN			!
	INTEGER*4 	Iterminal


	COMMON	/Terminal/	TTchan			!
	COMMON	/SORT/		Key_Info(41)		! Sort Key Information
	COMMON	/Constants/	Cesc,Cbell,Cnull,Cbold,Cnorm
	COMMON	/Control/	Cfile,Ctitle		!
	COMMON	/Program/	Cprogram		! Program name
	COMMON	/Screen/	Iline,Itop_Line,Ibot_Line
	COMMON	/Display/	Iform			! Form to use for dsply

	
	DATA Cnull	/0/				!
	DATA Cbell	/7/				!
	DATA Cesc	/27/				!
	DATA Ierror_Flag /.FALSE./			!

	Cident='V 2.2'					! Program Ident
	Ctitle=' '					! blank fill
	Cprogram=' '					!
	CALL Get_Termtype(Iterminal)			! Get terminal type
	IF(Iterminal.GT.0)			THEN	! If have a real term
	   Istatus = SYS$ASSIGN('SYS$INPUT',TTchan,,)	!   Get chnl for input
	ELSE						! Else flag TTchan 
	   TTchan=-1					!  so won't use it
	END IF						!

	IF (Iterminal.LT.96)			THEN	! If not VT100
	  Cbold=Cnull//Cnull//Cnull//Cnull		! Set video attributes
	  Cnorm=Cbold					!   if any
	ELSE						!
	  Cbold=Cesc//'[1m'				!
	  Cnorm=Cesc//'[0m'				!
	  WRITE(*,5)Cesc				! Set keypad appl mode
5	  FORMAT(' ',A,'=',$)				!
	END IF						!
	CALL Get_Program(Cprogram,Csearch_String,Iform_DCL) ! Command line
	CALL STRING_LENGTH(Csearch_String,Istrlen)	!
	IF(Iform_DCL.EQ.0	.AND.			! If interact & term
     -	   Iterminal.GT.0)CALL Exit_VPW(Iterminal,TTchan)! Establish Exit hndlr
	CALL Get_Username(Cuser,Ilength)		! Get users name
	CALL STRING_LENGTH(Cprogram,J)			! Get name length
	CALL VPW_Load_Prompts(Cprogram(1:J)//'_PROMPTS')! Load Input prompts
	CALL VPW_Load_Forms(Cprogram(1:J)//'_FORMS')	! Load forms

	CALL VPW_Load_Sort(Cprogram(1:J)//'_SORT')	! Load sort control
	CALL String_Length(Ctitle,Ititle)		! Title length
	Iform=1						! Display using form 1
	IF(Iform_DCL.GT.0)		THEN		!
	  CALL Display_Entries(Iterminal,Cfile,		! Do display fcn
     -		       	       Csearch_string(1:Istrlen),
     -			       Iform_DCL)		!
	  CALL EXIT					! Once only
	END IF						!
10	CALL PAGE					! Erase screen
	CALL VPW_Scroll(Iterminal,1,24,0)		!
	CALL VPW_Title(Ctitle(1:Ititle),Cident,Iterminal)! Display title
	CALL VPW_MENU(CPROGRAM(1:J),Choice,Nchar,Iterminal,10,1,1)!
	IF(Choice(1:Nchar).EQ.'A') 			! Add function
     -		CALL Add_Entries(Iterminal,Cfile)	!
	IF(Choice(1:Nchar).EQ.'DE')			! Delete function
     -		CALL Delete_Entries(Iterminal,Cfile)	!
	IF(Choice(1:Nchar).EQ.'DI')			! Display function
     -          CALL Display_Entries(Iterminal,Cfile,	!
     -				    Csearch_string,Iform_DCL)!
	IF(Choice(1:Nchar).EQ.'M')			! Modify function
     -		CALL Modify_Entries(Iterminal,Cfile)	!
	IF(Choice(1:Nchar).EQ.'U')			! If Use file function
     -          CALL Set_File(Iterminal,Cfile)		!
	IF(Choice(1:Nchar).EQ.'E')	      GOTO 9999	! Exit
	GOTO 10						! More?
	
9999	CALL EXIT					! and exit (via the
	END						!  exit handler



	SUBROUTINE Add_Entries(Iterminal,Cfile)		!
	CHARACTER*1		Cans,Cesc,Cnull,Cbell	!
	CHARACTER*4		Cbold,Cnorm		!
	CHARACTER*20		Cprogram		! Program name
	CHARACTER*80		Ctmp			!
	Character*512		Record			!
	CHARACTER*(*)		Cfile			! File name
	LOGICAL*1		Lsort_Flag		! True if must sort
	INTEGER*4		Record_Length		!
	INTEGER*4		Iterminal		!
	COMMON	/Record_buf/	Record_Length,Record	!
	COMMON	/Constants/	Cesc,Cbell,Cnull,Cbold,Cnorm
	COMMON	/Screen/	Iline,Itop_Line,Ibot_Line
	COMMON	/Program/	Cprogram		!
	COMMON	/Display/	Iform

	LUN_File = 1					!
	Lsort_Flag=.FALSE.				! Assume do not sort
	Record= ' '					! Fill with spaces
	CALL PAGE					! Erase screen
	CALL SCREEN('Add Entries',Iterminal,1,35,1)	! Title page
	IF(Iterminal.LT.96)	TYPE *,' '		!
	OPEN(	Unit	   = LUN_File,			! Open up our data
     -		Name	   = Cfile,			!  file
     -		Status	   = 'Unknown',			!
     -		Form	   = 'Formatted',		!
     -		Access	   = 'Append',			!
     -	        Recordsize = 512,			! Max size of record
     -		CarriageControl = 'List',		!
     -		Err 	   = 9000)			!
c	Iform=1						!
	Imode=1						! Add mode
10	CALL Get_Record(Iterminal,Imode,Iform,Istatus)	!
	IF(Istatus.GE.1)		THEN		! 2=>sort, 1=>nosort
	  CALL Display_Record(Iform)
	  WRITE(*,50)
50	  Format(' ',/,' Is this entry correct [Y/N]: ',$)
	  CALL Read_String(Cans,NN)			! Read value
	  IF(NN.EQ.-1)			GOTO 1000	! If ^Z input
	ELSE 						!
	  CLOSE (UNIT=LUN_FILE)				! close file
	  IF(Lsort_Flag) CALL File_Sort(Cfile,Iterminal,Istatus)! Sort file
	  RETURN					! All done
	END IF						!
	IF(Cans.NE.'Y'		.AND.			!
     -	   Cans.NE.'y')				GOTO 10	!

c	write file
	  WRITE(Lun_file,100)Record(1:Record_Length)	!
100	  FORMAT(A)					!
	  Record=' '					! Blank it out
	  Lsort_Flag=.TRUE.				! Added rec=> sort file
	  GOTO 10					!

1000	CLOSE (UNIT=LUN_FILE)				! close file
	IF(Lsort_Flag) CALL File_Sort(Cfile,Iterminal,Istatus)	! Sort file
	RETURN						! All done

9000	Ctmp='VPW_Add -- Error opening file '//Cbold//
     -	      Cfile//Cnorm//Cbell			!
	CALL STRING_LENGTH(Ctmp,Nchar)			!
	WRITE(*,9010)Ctmp(1:Nchar)			!
9010	FORMAT(' ',A)
	TYPE *,' '					!
	TYPE *,'Type '//Cbold//'RETURN'//Cnorm//' to continue'		!
	CALL Read_String(Cans,NN)			! Read value
	IF(NN.EQ.-1)			GOTO 9030	! If ^Z input
9030	RETURN
	END



	SUBROUTINE Delete_Entries(Iterminal,Cfile)
C
C Modifications:
C		JGD1	18-May-83	Fix Delete bug
C
	CHARACTER*1		Cans,Cesc,Cnull,Cbell
	CHARACTER*4		Cbold,Cnorm
	CHARACTER*20		Cprogram		!
	CHARACTER*(*)		Cfile			! Data file name
	CHARACTER*132		Ctmp			!
	Character*512		Record			!
	Logical*1		Ldelete_flag		! True if delet done
	INTEGER*4		Isize			!
	COMMON	/Record_buf/	Isize,Record		!
	COMMON	/Constants/	Cesc,Cbell,Cnull,Cbold,Cnorm
	COMMON	/Program/	Cprogram		!
	COMMON	/Screen/	Iline,Itop_Line,Ibot_Line
	COMMON	/Display/	Iform			!

	LUN_File_Read = 1				!
	LUN_File_Write= 2				!
	Itop_line=3					!
	Ibottom_line=24					!
	Record= ' '					! Fill with spaces
	CALL PAGE					!
	CALL SCREEN('Delete Entries',Iterminal,1,33,1)	!

	IF(Iterminal.LT.96)	TYPE *,' '		!
5	Ctmp=' '					! Fill with spaces
	Ldelete_Flag=.FALSE.				! Nodeletion done
	OPEN(	Unit	   = LUN_File_Read,		!
     -		Name	   = Cfile,			!
     -		Status	   = 'Old',			!
     -		Form	   = 'Formatted',		!
     -		CarriageControl = 'List',		!
     -		Err 	   = 9900)			!

	INQUIRE(UNIT	= LUN_File_Read,RECL=Isize)	! Get record size

	OPEN(	Unit	   = LUN_File_Write,		!
     -		Name	   = Cfile,			!
     -		Status	   = 'New',			!
     -		Form	   = 'Formatted',		!
     -		Recordsize = Isize,			!
     -		CarriageControl = 'List',		!
     -		Dispose	   = 'Delete',			!
     -		Err 	   = 9900)			!


	Ierase=4					! Erase EOL only
	Iline=8						!
	CALL String_Length(Cprogram,JJ)			!
10	CALL SCREEN('Search for: ',Iterminal,3,1,Ierase)! Get string
	Ierase=4					! Erase EOL only
	CALL Read_String(Ctmp,Nchar)			! Read value
	CALL SCREEN(Cnull,Iterminal,4,1,1)		! Erase rest of screen
	IF(Nchar.EQ.0)				THEN	! If <CR> on 1st entry
				Istatus=0		! Show <CR> hit
				GOTO 7000		! and close up files
	END IF						!
	IF(Nchar.EQ.-1)				THEN	! If ^Z input
				Istatus=-1		! show problem
				GOTO 7010		!
	END IF						!

C	  CALL CHECK_ESCAPE(Ctmp(1:nchar),Nchar,Iterminal,Helptxt,
C     -			^Z-return,
C     -			Backup_return,
C     -			Done_return,
C     -			Help/VPW_return)
	IF(Nchar.EQ.-2)				THEN	!
	  CALL Check_Escape(Ctmp,Nchar,Iterminal,	!
     -		            Cprogram(1:JJ)//' Search_String',	!
     -			*7010,				! ^z Return
     -			*10,				! Backup Return
     -			*7000,				! Done_return
     -			*12)				! Help/VPW return

          GOTO 7000					! ENTER hit
12	  Ierase=1					! Erase to Screen end
	  GOTO 10					! Reprompt
	END IF						!



15	CALL Upper_Case(Ctmp(1:Nchar))			! Make uppercase
C ..
C ..	Presumably at this point we have a valid record identifier
C ..	Lets start reading/writing files and searching for record
C ..	

20	READ(LUN_File_Read,25,END=2000,ERR=3000)N,Record! Read in the record
25	FORMAT(Q,A)					!
	CALL Upper_Case(Record(1:N))			!
	CALL Match_Strings(Ctmp(1:Nchar),Record(1:N),Imatch)
	IF(Imatch.GT.0)				GOTO 100! If have a match
	WRITE(Lun_File_Write,40)Record(1:N)		!
40	FORMAT(A)					!
	GOTO 20						! Read again

100	CALL SCREEN(' ',Iterminal,5,1,1)		!
	CALL Display_Record(Iform)			!
	WRITE(*,500)					!
500	Format(' ',/,' Delete this record [Y/N]: ',$)	!
	CALL Read_String(Cans,NN)			! Read value
	IF(NN.EQ.-1)				THEN	! If ^Z input
				Istatus=-1		! show problem
				GOTO 8000		!
	END IF						!
c	IF(NN.EQ.-2)				GOTO 100! if ESC seq
	Ierase=1					! Erase next prompt
	IF(Cans.EQ.'Y'	.OR.				! If NO, skip writing
     -	   Cans.EQ.'y')				THEN	!   record out
	  Ldelete_flag=.TRUE.				! Show record deleted
	  GOTO 10					! 
	END IF						!

c	write record to file since record not found
	WRITE(Lun_file_Write,40)Record(1:N)		!
	Record=' '					! Blank it out
	GOTO 20						!
C ..
C ..	End of file on read => record not found.  In this 
C ..    event, Close scratch and input file and then start
C ..    over again.
2000	CONTINUE

	IF(.NOT.Ldelete_Flag)			THEN	! If no deletions  JGD1
	  CLOSE(UNIT=LUN_File_Read)			!  Save Read file  JGD1
	  CLOSE(UNIT=LUN_File_Write) 			!  Delete out file JGD1
	ELSE						! If delet done    JGD1
2010	  READ(LUN_File_Read,25,END=2020,ERR=3000)N,Record! Read in the recJGD1
	  WRITE(Lun_File_Write,40)Record(1:N)		! Write back out   JGD1
	  GOTO 2010					! loop til done    JGD1
2020	  CLOSE(UNIT=LUN_File_Read,DISPOSE='DELETE')	! Close all files  JGD1
	  CLOSE(UNIT=LUN_File_Write,DISPOSE='KEEP')	!  the correct way JGD1
	  Ldelete_Flag=.FALSE.				!  Unset flag      JGD1
	END IF

	CALL SCREEN(' ',Iterminal,5,1,1)		! Position and erase
	Ctmp='VPW_Delete -- Keyword '//Cbold//		!
     -	      Ctmp(1:Nchar)//Cnorm//' not found'//Cbell	!
	CALL STRING_LENGTH(Ctmp,Nchar)			!
	CALL SCREEN(Ctmp(1:Nchar),Iterminal,10,1,1)	! Write out message
	IF(Iterminal.LT.96)	TYPE *,' '		!
	GOTO 5						!
C ..
C ..	An error occured reading the file.  Save what we can
C ..
3000	CLOSE(UNIT=LUN_File_Read)			! This file is saved
	CLOSE(UNIT=LUN_File_Write)			! This file is deleted
	Ctmp='Vpw_Delete -- Error reading data file: '//Cbold//
     -	      Cfile//Cnorm//Cbell			!
	CALL STRING_LENGTH(Ctmp,Nchar)			! Get new length
	CALL SCREEN(Ctmp(1:Nchar),Iterminal,10,1,1)	!
	IF(Iterminal.LT.96)	TYPE *,' '		!
	GOTO 5						!
7000	Istatus=1					! Show success
	GOTO 8000					!
7010	Istatus=-1					! Show ^z
	GOTO 8000					!
8000	continue
	IF(.NOT.Ldelete_Flag)			THEN	! If no deletions done
	  CLOSE(UNIT=LUN_File_Read)			! Close all files 
	  CLOSE(UNIT=LUN_File_Write) 			!  the correct way
	ELSE						! If some delet done
8010	  READ(LUN_File_Read,25,END=8020,ERR=3000)N,Record! Read in the record
	  WRITE(Lun_File_Write,40)Record(1:N)		! Write back out
	  GOTO 8010					! Tight loop arn't we
8020	  CLOSE(UNIT=LUN_File_Read,DISPOSE='DELETE')	! Close all files 
	  CLOSE(UNIT=LUN_File_Write,DISPOSE='KEEP')	!  the correct way
	END IF

	RETURN						! return on ^Z

9900	Ctmp='VPW_Delete -- Error opening file: '//Cbold//
     -	      Cfile//Cnorm//Cbell			!
	CALL STRING_LENGTH(Ctmp,Nchar)			!
	CALL SCREEN(Ctmp(1:Nchar),Iterminal,10,1,1)	! Write out message
	TYPE *, ' '					!
	TYPE *, 'Press '//Cbold//'RETURN'//Cnorm//' to continue'!
	CALL Read_String(Cans,NN)			! Read value
	IF(NN.EQ.-1)			GOTO 9999	! If ^Z input
9999	CALL EXIT
	END



	SUBROUTINE Modify_Entries(Iterminal,Cfile)
	CHARACTER*1		Cans,Cesc,Cnull,Cbell
	CHARACTER*4		Cbold,Cnorm
	CHARACTER*20		Cprogram		!
	CHARACTER*(*)		Cfile			! Data file name
	CHARACTER*132		Ctmp			!
	Character*512		Record			!
	CHARACTER*512		Tmp_Record		!
	Logical*1		Lmodify_flag		! True if mod done
	Logical*1		Lsort_Flag		! True if must sort
	INTEGER*2		Key_Info		! For sort routine
	INTEGER*4		Isize			!

	COMMON	/Constants/	Cesc,Cbell,Cnull,Cbold,Cnorm
	COMMON	/Display/	Iform			! For record display
	COMMON	/Program/	Cprogram		! Program name
	COMMON	/Screen/	Iline,Itop_Line,Ibot_Line
	COMMON	/SORT/		Key_Info(41)		! Sort Key Information
	COMMON	/Record_buf/	Isize,Record		!

	LUN_File_Read = 1				!
	Itop_line=3					!
	Ibottom_line=24					!
	Record= ' '					! Fill with spaces
	Iline=8						! Start of help display
	CALL PAGE					!
	CALL SCREEN('Modify Entries',Iterminal,1,33,1)	!

	IF(Iterminal.LT.96)			THEN	!
	  TYPE *,' '					!
	ELSE						!
	  CALL SCREEN(' ',Iterminal,3,0,0)		! Just position
	END IF						!	
5	Ctmp=' '					! Fill with spaces
	Lmodify_Flag=.FALSE.				! Nodeletion done
	Lsort_flag=.FALSE.				! Do not sort


	CALL Open_for_Update(LUN_File_Read,Cfile,Istatus)
	IF(Istatus.NE.1)		    GOTO 9900	! Catch open errors
	Ierase=4					! Erase EOL only
	CALL String_Length(Cprogram,JJ)			!
10	CALL SCREEN('Search for: ',Iterminal,3,1,Ierase)! Get string
	Ierase=4					! Erase EOL only
	CALL Read_String(Ctmp,Nchar)			! Read value
	CALL SCREEN(Cnull,Iterminal,4,1,1)		! Erase rest of screen
	IF(Nchar.EQ.0)				THEN	! If <CR> on 1st entry
				Istatus=0		! Show <CR> hit
				GOTO 8000		! and close up files
	END IF						!
	IF(Nchar.EQ.-1)				THEN	! If ^Z input
				Istatus=-1		! show problem
				GOTO 8000		!
	END IF						!

C	  CALL CHECK_ESCAPE(Ctmp(1:nchar),Nchar,Iterminal,Helptxt,
C     -			^Z-return,
C     -			Backup_return,
C     -			Done_return,
C     -			Help/VPW_return)
	IF(Nchar.EQ.-2)				THEN	! If escape seq
	  CALL Check_Escape(Ctmp,Nchar,Iterminal,	!
     -	  	            Cprogram(1:JJ)//' Search_String',	!
     -			*7010,				! ^z Return
     -			*10,				! Backup Return
     -			*7000,				! Done_return
     -			*12)				! Help/VPW return

          GOTO 7000					! Enter hit
12	  Ierase=1					! Erase to Screen end
	  GOTO 10					!
	END IF

15	CALL Upper_Case(Ctmp(1:Nchar))			! Make uppercase
C ..
C ..	Presumably at this point we have a valid record identifier
C ..	Lets start reading the record.  We will use VAX BASIC so we
C ..    can do inplace updates
C ..	

C ..  Find the record
	CALL RESTORE(Lun_File_Read)			! Pt to start of file
20	CALL Get_Record_for_Update(LUN_File_Read,Record,N,Istatus)	!
	IF(Istatus.EQ.11)		      GOTO 2000	! If EOF (for BASIC)
	IF(Istatus .NE. 1)		      GOTO 3000	! Some other read err
	Isize=N						! Length of record
	Tmp_Record=Record(1:N)				!
	CALL Upper_Case(Tmp_Record(1:N))		!
	CALL Match_Strings(Ctmp(1:Nchar),Tmp_Record(1:N),Imatch)
	IF(Imatch.GT.0)				GOTO 100! If have a match
40	FORMAT(A)					!
	GOTO 20						! Read again

100	CALL SCREEN(' ',Iterminal,5,1,1)		! Display the found
	CALL Display_Record(Iform)			!  record
	WRITE(*,500)					!
500	Format(' ',/,' Modify this record [Y/N]: ',$)	!

	CALL Read_String(Cans,NN)			! Read value
555	IF(NN.EQ.-1)				THEN	! If ^Z input
				Istatus=-1		! show problem
				GOTO 8000		!
	END IF						!
	IF(NN.EQ.-2)				GOTO 20	! if ESC seq=> CR

	Ierase=1					! Erase next prompt
	IF(Cans.EQ.'Y'	.OR.				! If NO, skip updating
     -	   Cans.EQ.'y')				THEN	!   record out
	  Imode=2					! Update mode
	  CALL Get_Record(Iterminal,Imode,Iform,Istatus)! get updated record
	  IF(Istatus.GE.1)		THEN		!
575	    CALL Display_Record(Iform)			! Show record
	    WRITE(*,600)				!
600	    Format(' ',/,' Is this entry correct [Y/N]: ',$)
	    CALL Read_String(Cans,NN)		! Read value
	    IF(NN.EQ.-1)			THEN	! If ^Z input
				Istatus=-1		! show problem
				GOTO 8000		!
	    END IF					!
c	    IF(NN.EQ.-2)			GOTO 575! if ESC seq
	  ELSE 						! If ^z
	    CALL Close_for_Update(LUN_File_Read)	! close file
	    IF(Lsort_Flag) CALL File_Sort(Cfile,Iterminal,Istatus)! Sort file
	    RETURN					! All done
	  END IF					!

	  IF(Cans.EQ.'Y'	.OR.			!
     -	     Cans.EQ.'y')			THEN	!
	     CALL Update_Record(LUN_File_Read,Record,N,Istat)	! Update file
	     IF(Istat.NE.1)		    GOTO 3000	! Big problems
	     IF(Istatus.EQ.2)Lsort_Flag=.TRUE.		! Added rec=> sort file
	  END IF					!
	  Record=' '					! Blank it out
	  GOTO 10					! Another locator
	END IF						!
	GOTO 20						! get next record

C ..
C ..	End of file on read => record not found.  In this 
C ..    event, Close file and tell user
C ..    
2000	Continue

	CALL Close_for_Update(LUN_File_Read)		! Close the file
	CALL SCREEN(' ',Iterminal,5,1,1)		! Position and erase
	Ctmp='VPW_Modify -- Keyword '//Cbold//	!
     -	      Ctmp(1:Nchar)//Cnorm//' not found'//Cbell	!
	CALL STRING_LENGTH(Ctmp,Nchar)			!
	CALL SCREEN(Ctmp(1:Nchar),Iterminal,10,1,1)	! Write out message
	IF(Iterminal.LT.96)	TYPE *,' '		!
	GOTO 5						!
C ..
C ..	An error occured reading the file.  Save what we can
C ..
3000	Continue
	CALL Close_for_Update(LUN_File_Read)		! Close the file
	Ctmp='Vpw_Modify -- Error reading data file: '//Cbold//
     -	      Cfile//Cnorm//Cbell			!
	CALL STRING_LENGTH(Ctmp,Nchar)			! Get new length
	CALL SCREEN(Ctmp(1:Nchar),Iterminal,10,1,1)	!
	IF(Iterminal.LT.96)	TYPE *,' '		!
	GOTO 5						!
7000	Istatus=0					! Success
	GOTO 8000					!
7010	Istatus=-1					! If ^Z
	GOTO 8000					!
8000	CALL Close_for_Update(Lun_File_Read)		! Close file
	IF(Lsort_Flag) CALL File_Sort(Cfile,Iterminal,Istatus)! Sort file
	RETURN						! and return

9900	Ctmp='VPW_Modify -- Error opening file: '//Cbold//
     -	      Cfile//Cnorm//Cbell			!
	CALL STRING_LENGTH(Ctmp,Nchar)			!
	CALL SCREEN(Ctmp(1:Nchar),Iterminal,10,1,1)	! Write out message
	TYPE *, ' '					!
	TYPE *, 'Press '//Cbold//'RETURN'//Cnorm//' to continue'!
	CALL Read_String(Cans,NN)			! Read value
	IF(NN.EQ.-1)			GOTO 9999	! If ^Z input
9999	CALL EXIT
	END


	SUBROUTINE Display_Entries(Iterminal,Cfile,
     -				   Csearch_string,Iform_DCL)	!
C
C	JGD2	- Bug in outputing to other than TT: caused by
C		  overwriting the search string
C

	PARAMETER		(Isize=20)

	CHARACTER*1		Cans,Cesc,Cnull,Cbell	!
	CHARACTER*4		Cbold,Cnorm		!
	CHARACTER*20		Cprogram		! Program name
	CHARACTER*20		Cout_File		!
	CHARACTER*50		Cform_name
	CHARACTER*50		Cfield_name		! Prompt for input
	CHARACTER*50		Cfield_Help		! Help request string
	CHARACTER*50		Cmatch_String		! Match field

	CHARACTER*80		Csearch_String		!
	CHARACTER*132		Ctmp			!
	CHARACTER*132		Ctmp2			!
	CHARACTER*132		Cform
	Character*512		Record			!
	CHARACTER*512		Tmp_Record		!
	CHARACTER*(*)		Cfile			! File name
	LOGICAL*1		Lall_Flag     /.FALSE./	! True if must sort
	LOGICAL*1		Lnotice	      /.FALSE./	! True if notice posted
	LOGICAL*1		Lonce	      /.FALSE./ ! True if one shot
	LOGICAL*1		Lprint_Flag   /.FALSE./ ! True if -> printer
	LOGICAL*1		Lsave_Flag    /.FALSE./	! True if save prt file
	LOGICAL*1		Lselect_Flag  /.FALSE./ ! T if quest ask 1x
	LOGICAL*1		Lselect_Search_Flag	! T if do sel search
	INTEGER*2		Search_Range(Isize,Isize)! where to search
	INTEGER*4		Record_Length		!
	INTEGER*4		Iterminal		!
	INTEGER*4		Number_of_Forms		!
	INTEGER*4		Number_of_Items		!
	INTEGER*4		Iorder_of_Items		!
	INTEGER*4		Field_name_length	! Length of prompt
	INTEGER*4		Field_Help_Length	! Length of help string
	INTEGER*4		Field_length		! Allowed input length
	INTEGER*4		Number_of_Entries	! # of fields in record
	INTEGER*4		Match_Type		!
	COMMON	/Record_buf/	Record_Length,Record	!
	COMMON	/Constants/	Cesc,Cbell,Cnull,Cbold,Cnorm
	COMMON	/Screen/	Iline,Itop_Line,Ibot_Line
	COMMON	/Program/	Cprogram		!
	COMMON	/Display/	Iform			!

	COMMON	/FORMS/		Number_of_Forms,
     -				Number_of_Items(Isize),
     -				Iorder_of_Items(Isize,Isize),
     -				Cform(Isize),
     -				Cform_name(Isize)

	COMMON	/PROMPTS/	Number_of_Entries,	!
     -				Field_name_length(Isize),!
     -				Field_Length(Isize),	!
     -				Field_Help_Length(Isize),!
     -				Match_Type(Isize),	!
     -				Cfield_name(Isize),	!
     -				Cfield_HELP(Isize),	!
     -				Cmatch_String(Isize)	!


	LUN_File = 1					!
	LUN_File_Write=2				!
	Lselect_Flag=.FALSE.				! Do not use select fld
	Lselect_Search_Flag=.FALSE.			!
	Itop_line=3					!
	Ibot_line=24					!

	DO I=1,Number_of_Entries			!
	  Search_Range(I,1)=0				! Assume not select 
	  Search_Range(I,2)=0				! range
	END DO						!

	Search_Range(1,1)=0				! Set stop flag
	Search_Range(1,2)=0				!
	Record= ' '					! Fill with spaces
	CALL String_Length(Csearch_String,Nchar)	!
	IF(Iform_DCL.NE.0	.AND.			! If in command mode
     -	   Nchar.GE.1)				THEN	!
	   Itop_Line=1					!
	   Ibot_Line=24					!
	   Lonce=.TRUE.					! One pass only
	   Iform=Iform_DCL				!
	   Ctmp=Csearch_string(1:Nchar)			!
	   Lall_Flag=.FALSE.				!
	   Lselect_Search_Flag=.FALSE.			!
	   IF(Ctmp(1:1).EQ.'*') Lall_Flag=.TRUE.	!
	   GOTO 300					!
	END IF						!
	Ibot_Line=21					!
	CALL VPW_SCROLL(Iterminal,Itop_Line,Ibot_Line,1)!

	CALL PAGE					! Erase screen
	CALL SCREEN('Display Entries',Iterminal,1,32,1)	! Title page
	IF(Iterminal.LT.96)	TYPE *,' '		!

5	IF(Number_of_Forms.GT.1)		THEN	!
	  CALL SCREEN('Available display forms:',Iterminal,3,1,1)!
	  IF(Iterminal.LT.96)	TYPE *,' '		!
	  DO I=1,Number_of_Forms			!
	    IF(Iterminal.GE.96)			THEN	!
	      CALL SCREEN(Cnull,Iterminal,3+I,1,0)	! Position cursor
	    END IF					!
	    CALL String_Length(Cform_Name(I),Ilen)	!
	    WRITE(*,10) I,Cform_Name(I)(1:Ilen)		!
10	    FORMAT(' ',10x,I2,'.   ',A)			!
	  END DO					!
	  IF(Iterminal.LT.96) TYPE *,' '		! IF Hard copy
	  Iline=5+I					! needed in common
	  Ierase=0					!
15	  CALL SCREEN('Use Form #: ',Iterminal,5+I,1,Ierase)! Prompt for form
	  CALL Read_String(Ctmp,Nchar)			! Read value
	  IF(Nchar.EQ.0)			RETURN	! If <CR> on 1st entry
	  IF(Nchar.EQ.-1)			RETURN	! If ^Z input

C	  CALL CHECK_ESCAPE(Ctmp,Nchar,Iterminal,Helptxt,
C     -			^Z-return,
C     -			Backup_return,
C     -			Done_return,
C     -			Help/VPW_return)
	  IF(Nchar.EQ.-2)			THEN	! If escape seq
	    CALL Check_Escape(Ctmp,Nchar,Iterminal,	!
     -	  	            Cprogram(1:JJ)//' DISPLAY',	!
     -			*9999,				! ^z Return
     -			*5,				! Backup Return
     -			*9999,				! Done_return
     -			*18)				! Help/VPW return

	    RETURN
18	    Ierase=1					! Erase to Screen end
	    GOTO 15					!
	  END IF
	
	  READ(Ctmp(1:Nchar),20,ERR=5)IFORM		!
20	  FORMAT(I2)					!
	  IF(Iform.LT.1			.OR.		! Check to see it is
     -	     Iform.GT.Number_of_Forms)		THEN	!  within legal range
	    Ctmp='VPW_Display -- Non-existant form selected'//Cbell
	    CALL String_Length(Ctmp,Ilen)		!
	    CALL SCREEN(Ctmp(1:Ilen),Iterminal,24,1,4)	!
	    IF(Iterminal.LT.96)	TYPE *,' '		!
	    GOTO 15					!
	  END IF					!
	  Iline=6+I					!
	ELSE						!
	  Iform=1					! Always must be one
	  Iline=3					!
	END IF						!


	CALL String_Length(Cprogram,JJ)			!
c	Iline=6+I					!
25	Lall_flag=.FALSE.				!
	Ctmp='Search for (* -> ALL): '			!
	CALL String_Length(Ctmp,Ilen)			!
	Ierase=1					!
30	CALL SCREEN(Ctmp(1:Ilen+1),Iterminal,Iline,1,Ierase)! Get string
	Ierase=4					! Erase EOL only
	CALL Read_String(Ctmp,Nchar)			! Read value
	IF(Nchar.EQ.0)				RETURN	! If <CR> on 1st entry
	IF(Nchar.EQ.-1)				RETURN	! If ^Z input

C	  CALL CHECK_ESCAPE(Ctmp,Nchar,Iterminal,Helptxt,
C     -			^Z-return,
C     -			Backup_return,
C     -			Done_return,
C     -			Help/VPW_return)
	IF(Nchar.EQ.-2)				THEN	! If escape seq
	  CALL Check_Escape(Ctmp,Nchar,Iterminal,	!
     -	  	            Cprogram(1:JJ)//' SEARCH_STRING',	!
     -			*9999,				! ^z Return
     -			*5,				! Backup Return
     -			*9999,				! Done_return
     -			*40)				! Help/VPW return

	  RETURN
40	  Ierase=1					! Erase to Screen end
	  GOTO 25					!
	END IF
	IF(Nchar    .GE.1	.AND. 			!
     -	   Ctmp(1:1).EQ.'*')	 Lall_Flag=.TRUE.	!


	Iline=Iline+1					!
60	Lprint_Flag=.FALSE.				! Assume no output to LP
	Lsave_Flag =.FALSE.				! Assume not scratch file
	Ctmp2=						!
     -	'Output data to printer (P) or Scratch File (S) (<CR> => TT:): '!
	CALL String_Length(Ctmp2,Ilen)			!
	Ierase=1					!
	CALL SCREEN(Ctmp2(1:Ilen+1),Iterminal,Iline,1,Ierase)! Get string
	Ierase=4					! Erase EOL only
	CALL Read_String(Ctmp2,Nmbr)			! Read value
	IF(Nmbr.EQ.-1)				RETURN	! If ^Z input
	IF(Nmbr.EQ.0)				GOTO 90	! <CR> same as No

C	  CALL CHECK_ESCAPE(Ctmp,Nchar,Iterminal,Helptxt,
C     -			^Z-return,
C     -			Backup_return,
C     -			Done_return,
C     -			Help/VPW_return)
	IF(Nmbr.EQ.-2)				THEN	! If escape seq
	  CALL Check_Escape(Ctmp2,Nmbr,Iterminal,	!
     -	  	            Cprogram(1:JJ)//' PRINT',	!
     -			*9999,				! ^z Return
     -			*25,				! Backup Return
     -			*90,				! Done_return
     -			*80)				! Help/VPW return

	  GOTO 90					! Enter hit
80	  Ierase=1					! Erase to Screen end
	  GOTO 60					!
	END IF
	IF(Ctmp2(1:1) .EQ. 'P'	.OR.			!
     -	   Ctmp2(1:1) .EQ. 'p') Lprint_Flag=.TRUE.	! If spool output
	IF(Ctmp2(1:1) .EQ. 'S'	.OR.			!
     -	   Ctmp2(1:1) .EQ. 's') 	THEN		!
		Lsave_Flag=.TRUE.			! If to scratch file
		Lnotice_Flag=.TRUE.			! Show notice posted
	END IF


90	IF(Lselect_Flag)			GOTO 300!
	Iline=Iline+1
100	IF(Lall_flag)				THEN	!
	   Lselect_Flag=.TRUE.
	   GOTO 300
	END IF
	Ctmp2='Search on selected fields [Y/N]'		!
	Lselect_Flag=.TRUE.				! Show we were here
	CALL String_Length(Ctmp2,Ilen)			!
	Ierase=1					!
	CALL SCREEN(Ctmp2(1:Ilen+1),Iterminal,Iline,1,Ierase)! Get string
	Ierase=4					! Erase EOL only
	CALL Read_String(Ctmp2,Nmbr)			! Read value
	IF(Nmbr.EQ.-1)				RETURN	! If ^Z input
	IF(Nmbr.EQ.0)				GOTO 130! <CR> -> NO

C	  CALL CHECK_ESCAPE(Ctmp,Nchar,Iterminal,Helptxt,
C     -			^Z-return,
C     -			Backup_return,
C     -			Done_return,
C     -			Help/VPW_return)
	IF(Nmbr.EQ.-2)				THEN	! If escape seq
	  CALL Check_Escape(Ctmp2,Nmbr,Iterminal,	!
     -	  	            Cprogram(1:JJ)//' PRINT',	!
     -			*9999,				! ^z Return
     -			*125,				! Backup Return
     -			*130,				! Done_return
     -			*120)				! Help/VPW return

	  GOTO 130					! Enter hit
120	  Ierase=1					! Erase to Screen end
	  GOTO 120					!
125	  Lselect_Flag=.FALSE.				! Say we were not here
	  GOTO 60					! Try again
	END IF
130	IF(Ctmp2(1:1) .NE. 'Y'	.AND.			!
     -	   Ctmp2(1:1) .NE. 'y')			GOTO 300! If NO sel search

	Lselect_Search_Flag=.TRUE.			!
	Iline_start=Iline				!
	Istart=1					! First pos of record
	DO Iloop=1,Number_of_Entries			! check each field

	  Iline=Iline+1					!
	  K=Iloop
200	  CALL String_Length(Cfield_name(K),Ilen)	!
	  Ctmp2='Search field: '//Cbold//Cfield_name(K)(1:Ilen)//
     -	         Cnorm//' [Y/N]: '			!
	  IF(Iline     .EQ.Ibot_Line	.AND.		!
     -       Iterminal .GE.96)		TYPE *,' '	!
	  CALL String_Length(Ctmp2,Ilen)		!

	  Ierase=1					!
	  CALL SCREEN(Ctmp2(1:Ilen+1),Iterminal,Iline,1,Ierase)! Get string
	  Ierase=4					! Erase EOL only
	  CALL Read_String(Ctmp2,Nmbr)			! Read value
	  IF(Nmbr.EQ.-1)			RETURN	! If ^Z input
	  IF(Nchar.EQ.0)			GOTO 230! <CR> -> No
C	  CALL CHECK_ESCAPE(Ctmp,Nchar,Iterminal,Helptxt,
C     -			^Z-return,
C     -			Backup_return,
C     -			Done_return,
C     -			Help/VPW_return)
	  IF(Nmbr.EQ.-2)			THEN	! If escape seq
	    CALL Check_Escape(Ctmp2,Nmbr,Iterminal,	!
     -	  	            Cprogram(1:JJ)//' PRINT',	!
     -			*9999,				! ^z Return
     -			*210,				! Backup Return
     -			*300,				! Done_return
     -			*220)				! Help/VPW return

	    GOTO 230
210	    IF(Iline.LT.Iline_start)		GOTO 60	! back to prev section
	    K=K-1					! Back up pointer
	    GOTO 200					!
220	    Ierase=1					! Erase to Screen end
	    GOTO 200					!
	  END IF					!

	  Istop=Istart+Field_Length(K)-1		! Last char pos
	  IF(Ctmp2(1:1).EQ.'Y' .or.			!
     -	     Ctmp2(1:1).eq.'y')			THEN	!
	     Search_Range(k,1)=Istart			!
	     Search_Range(K,2)=Istop			!
	  END IF					!
230	  Istart=Istop+1				! Point at next field
	END DO

300	IF(Lprint_Flag)				THEN	!
c	   Lprint_Flag=.TRUE.				!
	   Ctmp2='VPW_Display -- Data being output to line printer'	! JGD2
	   Cout_File='LP.LIS'				!
	   OPEN(Unit	   = LUN_File_Write,		!
     -		Name	   = Cout_File,			!
     -		Status	   = 'New',			!
     -		Form	   = 'Formatted',		!
     -		Recordsize = 512,			!
     -		CarriageControl = 'List',		!
     -		Dispose	   = 'Print/Delete',		!
     -		Err 	   = 9900)			!
	ELSE IF (Lsave_Flag)			THEN	! if scratch file
	   Ctmp2='VPW_Display -- Data being stored in '//Cbold// ! jgd2
     -	        'SCRATCH.FIL'//Cnorm			!
	   Cout_File='SCRATCH.FIL'			!
	   OPEN(Unit	   = LUN_File_Write,		!
     -		Name	   = Cout_File,			!
     -		Status	   = 'UNKNOWN',			!
     -		Form	   = 'Formatted',		!
     -		Recordsize = 512,			!
     -		CarriageControl = 'List',		!
     -		Err 	   = 9900)			!

	ELSE						!Output to SYS$OUTPUT
	   OPEN(Unit	   = LUN_File_Write,		!
     -		Name	   = 'SYS$OUTPUT',		!
     -		Status	   = 'Unknown')			!
	END IF						!

	OPEN(	Unit	   = LUN_File,			! Open up our data
     -		Name	   = Cfile,			!  file
     -		Status	   = 'OLD',			!
     -		Form	   = 'Formatted',		!
     -		CarriageControl = 'List',		!
     -		Readonly,				!
     -		Err 	   = 9000)			!



	IF(.NOT.Lonce)				THEN	! If interactive
	  CALL SCREEN(' ',Iterminal,Itop_Line,1,1)	!
	  IF(Lprint_Flag .OR. Lsave_Flag)	THEN	!
    	    CALL STRING_LENGTH(Ctmp2,Ilen)		!
	    CALL SCREEN(Ctmp2(1:Ilen),Iterminal,24,1,1)	!
	  END IF					!
	END IF						!
500	READ(Lun_File,505,END=5000)Record_Length,Record	!
505	FORMAT(Q,A)					!


C ..  Find the record
	IF(.NOT.Lall_Flag)			THEN	!
	  CALL Upper_Case(Ctmp(1:Nchar))		! Make uppercase
	  Tmp_Record=Record(1:Record_Length)		!
	  CALL Upper_Case(Tmp_Record(1:Record_length))	!
	  IF(.NOT.Lselect_Search_Flag)		THEN	! If no search ranges
	     CALL Match_Strings(Ctmp(1:Nchar),		!  search whole record
     -			        Tmp_Record(1:Record_Length),Imatch)
	     IF(Imatch.EQ.0)			GOTO 500! If no match
	  ELSE						!
	     DO Iloop=1,Number_of_Entries		!
c		type *,Iloop,Search_range(Iloop,1),search_Range(Iloop,2) !*****
	       Istart=Search_Range(Iloop,1)		!
	       IF(Istart.GT.0)			THEN	!
	          Istop=Search_Range(Iloop,2)		!
c	        TYPE *, '*',Ctmp(1:Nchar),'*'	!***
c		type *,'**',Tmp_Record(Istart:Istop),'**'!****
	     	  CALL Match_Strings(Ctmp(1:Nchar),	!  search whole record
     -			        Tmp_Record(Istart:Istop),Imatch)
	          IF(Imatch.GT.0)		GOTO 600! If no match	  
	       END IF					!
 	     END DO					!
	     GOTO 500					! Read again
	  END IF					!
	END IF						!
600	IF(.NOT.Lprint_Flag .AND. .NOT. Lsave_Flag)THEN	!
	  CALL Display_Record(Iform)			! display record
	ELSE
	  CALL Display_Record(Iform,Lun_File_Write)	! Write to data file
	END IF						!
	GOTO 500

5000	CLOSE (UNIT=LUN_FILE)				! close file
	CLOSE (UNIT=Lun_File_Write)			!
	IF(Lonce)			RETURN		!
	TYPE *,' '					!
	Ctmp='Type '//Cbold//'RETURN'//Cnorm//' to continue'
    	CALL STRING_LENGTH(Ctmp,Ilen)		!
	CALL SCREEN(Ctmp(1:Ilen),Iterminal,24,1,1)	!
c	TYPE *,'Type '//Cbold//'RETURN'//Cnorm//' to continue'	!
	CALL Read_String(Cans,NN)			! Read value
	IF(NN.EQ.-1)				THEN	!
	CALL VPW_SCROLL(Iterminal,1,24,0)		! Reset jump scroll
			RETURN				! If ^Z input
	END IF						!
	ILINE=23
	GOTO 25						! More


9000	CLOSE(UNIT=Lun_File_Write,Dispose='Delete')	!
	CALL STRING_LENGTH(Cfile,JJ)			!
	Ctmp='VPW_Display -- Error opening file '//	!
     -	      Cbold//Cfile(1:JJ)//Cnorm//Cbell		!
	CALL STRING_LENGTH(Ctmp,Nchar)			!
9005	WRITE(*,9010)Ctmp(1:Nchar)			!
9010	FORMAT(' ',A)					!
	GOTO 9950					!

9500	Ctmp='VPW_Display -- Non-numeric form #s not allowed.'//Cbell
	CALL STRING_LENGTH(Ctmp,Ilen)
	CALL SCREEN(Ctmp(1:Ilen),Iterminal,24,1,1)	!
	IF(Iterminal.LT.96)	TYPE *,' '		!
	GOTO 15
9900	CALL String_Length(Cout_File,JJ)		!
	Ctmp='VPW_Display -- Error opening output file '//
     -	      Cbold//Cout_file(1:JJ)//Cnorm//Cbell	!
	CALL STRING_LENGTH(Ctmp,Nchar)			!	
	WRITE(*,9010)Ctmp(1:Nchar)			!
	GOTO 9950					! 

9950	TYPE *,' '					!
	TYPE *,'Type '//Cbold//'RETURN'//Cnorm//' to continue'		!
	CALL Read_String(Cans,NN)			! Read value
	IF(NN.EQ.-1)			RETURN		! If ^Z input
9999	RETURN
	END

	SUBROUTINE Set_File(Iterminal,Cfile)

	Character*(*)		Cfile			! File name
	CHARACTER*1		Cans,Cesc,Cnull,Cbell	!
	CHARACTER*4		Cbold,Cnorm		!
	CHARACTER*20		Cprogram		! Program name
	Character*80		Ctmp			! Tmp file name
	COMMON	/Constants/	Cesc,Cbell,Cnull,Cbold,Cnorm
	COMMON	/Program/	Cprogram		! Program name
	COMMON	/Screen/	Iline,Itop_Line,Ibot_Line
	Itop_Line=4					! Establish window
	Ibot_Line=24					!
	Iline=4						!
	CALL STRING_LENGTH(Cprogram,JJ)			!
	CALL PAGE					! Erase screen
	CALL SCREEN('Change Default File',Iterminal,1,28,1)! Title page
	IF(Iterminal.LT.96)	TYPE *,' '		!

	CALL STRING_LENGTH(Cfile,I)			!
10	Ctmp='File name (<CR> -> '//Cbold//Cfile(1:I)//Cnorm//'): '
	CALL STRING_LENGTH(Ctmp,Nchar)			!
	CALL SCREEN(Ctmp(1:Nchar+1),Iterminal,4,1,0)	! Get string
	CALL Read_String(Ctmp,Nchar)			! Read value
	IF(Nchar.EQ.0)				THEN	! If <CR> on RETURN
				GOTO 7000		!  with name unchanged
	END IF						!
	IF(Nchar.EQ.-1)				THEN	! If ^Z input
				GOTO 7000		!   also give up
	END IF						!

C	  CALL CHECK_ESCAPE(Ctmp(1:nchar),Nchar,Iterminal,Helptxt,
C     -			^Z-return,
C     -			Backup_return,
C     -			Done_return,
C     -			Help/VPW_return)
	IF(Nchar.EQ.-2)				THEN	!
	  CALL Check_Escape(Ctmp,Nchar,Iterminal,	!
     -		            Cprogram(1:JJ)//' File_Name',!
     -			*7000,				! ^z Return
     -			*10,				! Backup Return
     -			*7000,				! Done_return
     -			*10)				! Help/VPW return

          GOTO 7000					! ENTER hit
	END IF						!

	CALL Upper_Case(Ctmp(1:Nchar))			! Make uppercase
	DO J=1,I					!
	  Cfile(1:J)=Cnull				!
	END DO						!
	Cfile(1:Nchar+1)=Ctmp(1:Nchar)//Cnull		! Set in new name


7000	RETURN						!
	END
