	PROGRAM VPWDIRECT
C+		Ident /1/
C
C	Provide a program which will provide a formatted directory
C	listing of names only.  VPWDIRECT is designed to be used
C	as a foreign commmand.  The command line passes both the
C	directory wild card search string, and the title to display
C	if any files are found.
C
C	VPWDIRECT  Search_String[|"Title...Title....Title"]
C				__                      _
C	Note that  the _" and the trailing " in the title line
C	are required if a title is present. The title is optional.
C
C	The display is set to 
C
C		Title...Title...Title
C	
C	File1		File2		File3		File4
C	File5		File6		File7		File8
C	File9		File10		file11		File12
C
C Written by:	Version 1.0
C		April 8,1983
C		James G. Downward
C		KMS Fusion, Inc.
C		P.O. Box 1567
C		Ann Arbor, Mich. 48106
C		(#13)-769-8500
C
C-
	Logical*1 	Ltitle_Flag	/.False./	! Assume not printed
	Logical*1	Lfound_one	/.False./	! Assume no files found
	CHARACTER*1	Cnull		/0/		! null byte
	character*80	cfile				! File name string
	CHARACTER*30	Csearch				! File search string
	Character*80	Ctitle				! Title to display
	Character*80	Outline				! Output display line
	Character*132	Command_Line			! Input
	Integer*2	Ilength				!
	Integer*4	Istatus,Icontext		!

	Istatus=LIB$GET_FOREIGN(Command_Line,'Command: ',Ilength)
	IF (Ilength.EQ.0) 		       GOTO 9999! Exit if no command
	Ctitle=Cnull					! Set to null
	Ipos=Index(Command_Line(1:Ilength),'|"')	! Find delim sep title
	IF(Ipos.EQ.0) 			THEN		! If none then just
	    Ipos=LEN(Csearch)+1				!   use search string
	ELSE						! Else
	    Ctitle=Command_Line(Ipos+2:Ilength-1)	!   set title line
	END IF						!
	Csearch=Command_Line(1:Ipos-1)			!
	Outline=' '					! Blank fill
	Icntr=0						! start counter at 0
50	Istatus=lib$find_file(Csearch,cfile,Icontext)	! Get next file spec
	IF(.NOT.Istatus)	GOTO 200		! If done, finish up
	Lfound_one=.TRUE.				! Show found at least 1
	Icntr=Icntr+1					! Point to dsp position
	Ipos1=Index(Cfile,']')				! find end of [] string
	Ipos2=Index(Cfile(Ipos1:80),'.')		! find start of type
	Ipos2=Ipos1+Ipos2-1				!
	Iloc=Icntr*20-15				! find output location
	Outline(Iloc:)=Cfile(Ipos1+1:Ipos2-1)		! Set in name
	IF (Icntr.LT. 4)		THEN		! Only dsply 4 columns
	    GOTO 50					! If not there get next
	ELSE						! If there
	    IF(.NOT.Ltitle_Flag		.AND.		!  Write title one time
     -	        Ctitle(1:1).NE.Cnull)		THEN	! If title not null
		CALL String_Length(Ctitle,Ilength)	! Find total length
		WRITE(*,80)Ctitle(1:Ilength)		!  only, if present
80	        FORMAT(' ',A,/)				!
	        Ltitle_Flag=.TRUE.			!  Show we wrote it
	    END IF					!
	    CALL String_Length(Outline,Ilength)		!
	    WRITE(*,100) Outline(1:Ilength)		! output the names
100	    format(' 'A)				!
	    Outline=' '					! Reset to all blanks
	    Icntr=0					! Reset counter
	    GOTO 50					! Back for more
	END IF						!
200	IF(.NOT. Ltitle_Flag 	.AND. 			! Last time through
     -		 Lfound_one	.AND.			! write title if not
     -	   Ctitle(1:1).NE.Cnull) 		THEN	!
		CALL String_Length(Ctitle,Ilength)	! Find total length
		WRITE(*,80)Ctitle(1:Ilength)		!  written before
	END IF						!
	CALL String_Length(Outline,Ilength)		!
	IF(Icntr.GT.0) WRITE(*,100)OutLine(1:Ilength)	! write outline if nec

9999	end						! all done
