C+		Program REMINDER
C		   IDENT /3.3/
C
C
C	The function of REMINDER is to leave reminder messages for users
C	of VAX systems.  The user is prompted for a name to send a reminder
C	to.  By default, one sends reminders to one's self.  Next one is 
C	prompted for the date to remind the user on.  The default date is
C	the current date.  Next one is prompted for the time (24 hour clock)
C	and finally for  the message to send.  
C
C	REMINDER then submits a command to SYS$SYSDEVICE:[VPW]REMINDUSR
C	for execution at the specified date and time.  The VAX REMINDER System
C	thus requires for opperation the following tasks and command files
C	
C	SYS$SYSDEVICE:[VPW]REMINDUSR.COM
C	SYS$SYSDEVICE:[SYSUTL]REMINDER    -  Installed with SYSPRV   privilege
C	SYS$SYSDEVICE:[SYSUTL]BROADCAST   -  Installed with OPER     privilege
C
C	When REMINDER prompts for a user to remind, and the user types a name
C	REMINDER verifies the name against the list of valid usernames
C	(the name you log on with) in the VAX user authorization file 
C	SYS$SYSTEM:SYSUAF.DAT.  If the target of the reminder is not found,
C	the user is allowed to retry or to have displayed a list of all
C	non-system users listed within the account file.
C
C	The reminder system uses BROADCAST to find users (if they are on
C	the system) and to send them a notice.  If they are not on the
C	system (ie BROADCAST fails to find them), a mail message is sent
C	which will be recieved by the user when they next log on the
C	system.
C
C-

	PROGRAM REMINDER

	CHARACTER*1	Cesc,Cnull,Cbell
	CHARACTER*4	Cbold,Cnorm
	CHARACTER*5	Ctime
	CHARACTER*11	Cdate
	CHARACTER*12	Cuser,Cname
	CHARACTER*80	Cans
	CHARACTER*80	Cmessage
	CHARACTER*255	Ctmp
	INTEGER*2	TTchan
	INTEGER*4	SYS$ASSIGN
	LOGICAL*1	Is_Found,Ierror_Flag
	DATA Cnull	/0/
	DATA Cbell	/7/
	DATA Cesc	/27/
	DATA Ierror_Flag /.FALSE./
	COMMON	/Terminal/	TTchan			! Chan # for SYS$INPUT

	Cbold=Cesc//'[1m'
	Cnorm=Cesc//'[0m'
	Istatus = SYS$ASSIGN('SYS$INPUT',TTchan,,)	! Get channel for input
	IF(.NOT.Istatus)		THEN		!
	  WRITE(*,5)Istatus				!
5	  FORMAT(' REMINDER -- SYS$INPUT could not be assigned, Exiting.')
	  CALL EXIT					!
	END IF						!
	CALL PAGE					! Erase screen
	CALL Get_Termtype(Iterminal)			! Get terminal type
	CALL Exit_VPW(Iterminal,TTchan)			! Establish Exit hndlr
	CALL Get_Username(Cuser,Ilength)		! Get users name
	CALL VPW_Title('The VAX Reminder System','V 2.3',Iterminal)! Disp title
	IF (Iterminal.LT.96)			THEN	! If not VT100
	  Cbold=Cnull//Cnull//Cnull//Cnull		!
	  Cnorm=Cbold					!
	END IF						!
10	Ctmp='Send reminder to whom (<CR>-> '		!
     -	      //Cuser(1:Ilength)//'):'			!
	CALL STRING_LENGTH(Ctmp,Istr_Len)		! Get length of string
	CALL SCREEN(Ctmp(1:Istr_Len),Iterminal,10,1,0)	! Write out prompt
	Ixpos=Istr_Len+1				! Where to put space
	Ctmp='REMINDER'					! Use this help text
20	CALL SCREEN(' ',Iterminal,10,Ixpos,1)		! Position for prompt
	CALL READ_STRING(Cname,N)			! Get string
50	format(Q,a)					!
	IF(N.EQ.-1)			      GOTO 9999 ! Exit if Control Z
	IF(N.EQ.-2)				THEN	! If have ESC seq
	  IF(Cname(1:1).EQ.'Q')			THEN	! If HELP key pressed
	     CALL DISPLAY_HELP(Ctmp,Iterminal,11,22)	! Show display info
	  ELSE IF(Cname(1:1).EQ.'S')		THEN	!   If ALT screen key
	    CALL Command_Screen(Iterminal,11,24)	!    Create cmd screen
	    TYPE *,' '					!
	    CALL Screen(' ',Iterminal,11,1,1)		!    erase help info
	  END IF					!
	  IF(Iterminal.GE.96)			THEN	! If a VT100
	    GOTO 20					! Reprompt
	  ELSE						!
	    GOTO 10					! If NBI/LA36 type
	  END IF					!
	END IF						!
	Ctmp='REMINDER NAME'				!
	IF(N.eq.0) 				THEN	! If <CR>
		Cname(1:Ilength)=Cuser(1:Ilength)	!   use default name
		N=Ilength				!   and length
	END IF						!
C	ELSE						!Else 
C		Ilength=N				!   set correct length
C	END IF						!
	CALL Check_UAF(Cname,N,Is_Found,Ierror)		! a valid user?
	Name_Length=N					! Save for command
	IF(Ierror.EQ.-1)			GOTO 90	! If can't open UAF
	IF(.NOT.Is_Found)			THEN	! If not found
	   Ierror_Flag=.TRUE.				! Show error occ
	   Ctmp='REMINDER -- User '//Cbold//Cname(1:N)	!
     -	        //Cnorm//' not found.'//Cbell		!
	   CALL STRING_LENGTH(Ctmp,Istr_Len)		!
	   CALL SCREEN(Ctmp(1:Istr_Len),Iterminal,22,0,1)!
	   IF(Iterminal.LT.96)  TYPE *,' '
	   CALL SCREEN('Would you like to see a list of users [Y/N]: ',
     -			Iterminal,23,0,1)
	   CALL READ_STRING(Cans,N)			! Get answer
	   IF(N.EQ.-1)			       GOTO 9999! ^Z EXIT
	   Ctmp='REMINDER NAME'				!
	   IF(Cans(1:1).NE.'Y'	.AND.			! If not Yes
     -	      Cans(1:1).NE.'y')			THEN	!
	     IF(Iterminal.GE.96)		THEN	!
	        GOTO 20					! Reprompt for name
	     ELSE					!
	        TYPE *,' '				!
	        GOTO 10					!
	     END IF					!
	   END IF					!
	   Ierror_Flag=.FALSE.				! No need to clr screen
	   Ctmp=' '					! Create a blank line
	   CALL SCREEN(Ctmp(1:1),Iterminal,11,0,1)	! Erase to end of Sc
	   CALL VPW_SCROLL(Iterminal,12,21,1)		! scroll window/smooth
	   CALL SCREEN(CTMP(1:1),ITERMINAL,12,0,0)	! Position to start
	   CALL Display_Users(Ier)			!
	   IF(Ier.EQ.-1)		THEN		!
90	     Ctmp='REMINDER -- Fatal, SYSUAF.DAT can not be opened.'//Cbell
	     CALL SCREEN(Ctmp,Iterminal,23,0,0)		!
	     CALL EXIT					!
	   END IF					!
	   IF(Iterminal.LT.96)		TYPE *, ' '
	   Ctmp='Press '//Cbold//'RETURN'//Cnorm//' to continue'
	   CALL STRING_LENGTH(Ctmp,Istr_Len)		!
	   IF(Iterminal.LT.96)		TYPE *,' '	!
	   CALL SCREEN(Ctmp(1:Istr_Len),Iterminal,24,0,0)!
	   CALL READ_STRING(Cans,N)			!
	   IF(N.EQ.-1)			      GOTO 9999 ! ^Z exit
	   CALL VPW_Scroll(Iterminal,1,24,0)		! Scroll full window
	   IF(Iterminal.GE.96)CALL SCREEN(' ',Iterminal,11,1,0)	! For VT100 bug
	   Ctmp='REMINDER NAME'				!
	   IF(Iterminal.GE.96)			THEN	! If VT100
	     GOTO 20					!
	   ELSE						!
	     GOTO 10					! If LA36/NBI
	   END IF					!

	END IF
C
C .. Ok we found the user now get the date to remind on
C
	Ictl=4						! Erase to Eol
100	Ctmp='Remind user on what day (dd-Mon-Year, <CR>->TODAY):'
	CALL STRING_LENGTH(Ctmp,Istr_Len)		!
	CALL Screen(Ctmp(1:Istr_Len+1),Iterminal,11,1,0)! No control
	Ixpos=Istr_Len+1				!
110	CALL Screen(' ',Iterminal,11,Ixpos,Ictl)	! Clr to EOL or screen
	Ictl=4						! Reset in case
	CALL READ_STRING(Cdate,N)			! Get string
	IF(N.EQ.-1)			      GOTO 9999 ! Exit if Control Z
	IF(N.EQ.-2)				THEN	! If ESC sequence
          IF(Cdate(1:1).EQ.'Q')			THEN	! If help key pressed
	     Ctmp='REMINDER DATE'			!  use this help text
	     CALL DISPLAY_HELP(Ctmp,Iterminal,12,22)	!  display it
	     Ictl=1					!  Erase it when done
	  ELSE IF(Cdate(1:1).EQ.'S')		THEN	!   If ALT screen key
	    CALL Command_Screen(Iterminal,12,24)	!    Create cmd screen
	    Ictl=1					!    Erase when done
	  ELSE IF(Cdate(1:1).EQ.'A')		THEN	!  If up-arror key
	    Ictl=4					!   erase to eol
	    GOTO 10					!   Back to prev prmpt
	  END IF					!  set flag for erase
	  IF(Iterminal.GE.96)			THEN	! If VT100
	    GOTO 110					! always reprompt
	  ELSE						! If LA36/NBI
	    GOTO 100					!
	  END IF					!
	END IF						!
	IF(N.EQ.0)				THEN	! Default to today's
	     Istatus = LIB$DATE_TIME(Cdate)		!  date
	     GOTO 130					!  skip date check
	END IF						!
	CALL Check_Date(Cdate,N,Ierror)			! See if date OK
	IF (Ierror.LT.0)			THEN	! If date error
	  Ctmp='REMINDER -- Invalid date format.'//	!
     -         '  Dates must be entered as DD-MMM-YYYY'//Cbell !
	  IF(Iterminal.LT.96)	TYPE *,' '		!
	  CALL STRING_LENGTH(Ctmp,Istr_Len)		!
	  CALL Screen(Ctmp(1:Istr_Len),Iterminal,23,0,1)! display error msg
	  IF(Iterminal.LT.96)	TYPE *,' '		!
	  Ctmp='For Example, 11-FEB-1982'		!
	  CALL STRING_LENGTH(Ctmp,Istr_Len)		!
	  CALL Screen(Ctmp(1:Istr_Len),Iterminal,24,13,0)! last part of msg
	  Ierror_Flag=.TRUE.				!
	  Ictl=4					!
	  IF(Iterminal.GE.96)			THEN	! If a VT100
	    GOTO 110					! Reprompt
	  ELSE						!
	    TYPE *, ' '					! 
	    GOTO 100					! If LA36/NBI
	  END IF					!
	END IF						!
130	IF(.NOT.Ierror_Flag)			THEN	! If no err msgs then
	  Ictl=4					!   Erase to EOL
	ELSE						! else if error msg
	  Ictl=1					!   Erase to EOS
	  Ierror_Flag=.FALSE.				!   Clear the flag
	END IF						! End if
150	Ctmp='Remind at what time (0:0 - 23:59):'	!
	CALL STRING_LENGTH(Ctmp,Istr_Len)		!
	CALL Screen(Ctmp(1:Istr_Len),Iterminal,12,0,0)	! Prompt msg
	Ixpos=Istr_Len+1				!
160	CALL Screen(' ',Iterminal,12,Ixpos,Ictl)	! Posit to read
	CALL READ_STRING(Ctime,N)			! Get string
	IF(N.EQ.-1)			      GOTO 9999 ! Exit if Control Z
	IF(N.EQ.-2)				THEN	! If ESC sequence
          IF(Ctime(1:1).EQ.'Q')			THEN	! If help key pressed
	     Ctmp='REMINDER TIME'			!  use this help text
	     CALL DISPLAY_HELP(Ctmp,Iterminal,13,22)	!  display it
	     Ictl=1					!  Erase it when done
	  ELSE IF(Ctime(1:1).EQ.'S')		THEN	!   If ALT screen key
	    CALL Command_Screen(Iterminal,13,24)	!    Create cmd screen
	    Ictl=1					!    Erase when done
	  ELSE IF(Ctime(1:1).EQ.'A')		THEN	!   If up-arrow key
	    Ictl=4					!    Erase EoL
	    GOTO 100					!    prev prompt
	  END IF					!  set flag for erase
	  IF(Iterminal.GE.96)			THEN	! If VT100
	     GOTO 160					! always reprompt
	  ELSE						!
	     TYPE *,' '					!
	     GOTO 150					! If LA36/NBI
	  END IF					!
	END IF						!
	CALL Check_Time(Ctime,N,Ierror)			! Check input
	IF (Ierror.LT.0)			THEN	! If date error
	  Ctmp='REMINDER -- Invalid time format.'//	!
     -         '  Times must be entered as HH:MM'//Cbell !
	  CALL STRING_LENGTH(Ctmp,Istr_Len)		!
	  CALL Screen(Ctmp(1:Istr_Len),Iterminal,23,0,1)! display error msg
	  IF(Iterminal.LT.96)	TYPE *,' '		!
	  Ctmp='For Example, 9:30 or 14:30'		!
	  CALL STRING_LENGTH(Ctmp,Istr_Len)		!
	  CALL Screen(Ctmp(1:Istr_Len),Iterminal,24,13,0)! last part of msg
	  Ierror_Flag=.TRUE.				!
	  Ictl=4					! Erase to eol
	  IF(Iterminal.GE.96)			THEN	! If VT100 term
	    GOTO 160					! Reprompt
	  ELSE						!
	    TYPE *,' '					!
	    GOTO 150					!
	  END IF
	END IF						!
	IF(.NOT.Ierror_Flag)			THEN	! If no err msgs then
	  Ictl=4					!   Erase to EOL
	ELSE						! else if error msg
	  Ictl=1					!   Erase to EOS
	  Ierror_Flag=.FALSE.				!   Clear the flag
	END IF						! End if

200	CALL Screen('Message: ',Iterminal,13,0,Ictl)	!
	CALL READ_STRING(Cmessage,N)			! Get string
	IF(N.EQ.-1)			      GOTO 9999 ! Exit if Control Z
	IF(N.EQ.-2)				THEN	! If ESC sequence
          IF(Cmessage(1:1).EQ.'Q')		THEN	! If help key pressed
	     Ctmp='REMINDER MESSAGE'			!  use this help text
	     CALL DISPLAY_HELP(Ctmp,Iterminal,14,22)	!  display it
	     Ictl=1					!  Erase it when done
	  ELSE IF(Cmessage(1:1).EQ.'S')		THEN	!   If ALT screen key
	    CALL Command_Screen(Iterminal,14,24)	!    Create cmd screen
	    Ictl=1					!    Erase when done
	  ELSE IF(Cmessage(1:1).EQ.'A')		THEN	!   If uparror key
	    Ictl=4					!    Erase EOL
	    GOTO 150					!    back to prev prmpt
	  END IF					!  set flag for erase
	  IF(Iterminal.LT.96)		TYPE *,' '	!
	  GOTO 200					! always reprompt
	END IF						!

C
C .. Spawn off command line to DCL
C
	Ctmp='SUB/PAR=(SUBMIT,'//CNAME(1:Name_Length)//
     -       ',"'//Cmessage(1:N)//'")/NOLOG/NOIDE/AFT='//
     -        Cdate//':'//Ctime//' SYS$SYSDEVICE:[VPW]REMINDUSR'
	CALL STRING_LENGTH(Ctmp,Istr_Len)		!
250	Istatus=LIB$SET_SYMBOL('VPW_REMINDER_LINE',Ctmp(1:Istr_Len))
	Ispawn_flags=2					!
	Istatus = LIB$SPAWN('VPW_REMINDER_LINE')	!
	IF(Istatus.NE.1)		THEN		!
	   CALL PAGE					!
	   WRITE(*,300)Istatus				!
300	   FORMAT(' REMINDER -- FATAL. SPAWN failed. Istatus = ',Z10)
	   CALL EXIT					!
	END IF
	Istatus = LIB$DELETE_SYMBOL('VPW_REMINDER_LINE')!
350	Ctmp='Send another message to the same user [Y/N]: '!
	CALL STRING_LENGTH(Ctmp,Istr_Len)		!
	CALL Screen(Ctmp(1:Istr_Len+1),Iterminal,16,0,4)!
	CALL Read_String(Cans,N)			!
	IF(N.EQ.-1)			      GOTO 9999 ! Exit if Control Z
	IF(N.EQ.-2)				THEN	! If ESC sequence
	  IF(Cans(1:1).EQ.'S')			THEN	!   If ALT screen key
	    CALL Command_Screen(Iterminal,16,24)	!    Create cmd screen
	    Ictl=1					!    Erase when done
	  END IF					!  set flag for erase
	  IF(Iterminal.LT.96)		TYPE *,' '	!
	  GOTO 350					! always reprompt
	END IF						!

c	READ(*,50,END=9999)N,Cans			!
	IF(Cans(1:1).NE.'Y'	.AND.			! If answer not yes
     -     Cans(1:1).NE.'y')		      GOTO 9999	! Then exit
400	Ctmp='Send on same date [Y/N]: '		!
	CALL STRING_LENGTH(Ctmp,Istr_Len)		!
	CALL Screen(Ctmp(1:Istr_Len+1),Iterminal,17,0,4)!
c	READ(*,50,END=9999)N,Cans			!
	CALL Read_String(Cans,N)			!
	IF(N.EQ.-1)			      GOTO 9999 ! Exit if Control Z
	Ictl=1						! always erase
	IF(N.EQ.-2)				THEN	! If ESC sequence
	  IF(Cans(1:1).EQ.'S')			THEN	!   If ALT screen key
	    CALL Command_Screen(Iterminal,17,24)	!    Create cmd screen
	  END IF					!  set flag for erase
	  IF(Iterminal.LT.96)		TYPE *,' '	!
	  GOTO 400					! always reprompt
	END IF						!
	IF(Cans(1:1).NE.'Y'	.AND.			! If answer not yes
     -     Cans(1:1).NE.'y')		      THEN	!   Then go get date
	   GOTO 100					!   Go get the date
	ELSE						! Else
	   GOTO 150					!   just get time/msg
	END IF						!
	
9999	CALL EXIT					! and exit (via the
	END						!  exit handler


C+
C  Check_UAF		Check the User Authorization File to see if
C			the specified user has an account on this system.
C
C	CALL Check_UAF(Cname,Ilength,Is_Found,Ierror)
C
C	Where:
C		Cname 	  Character*12	User name
C		Ilength	  I*4		length of name
C		Is_Found  Logical*1	.FALSE.  if not found
C					.TRUE.   if found
C		Ierror	  Integer*4	=  0 if success opening SYSUAF.DAT
C					= -1 if SYSUAF.DAT can not be opened
C
C	Modified:	14-Jul-1983	J. Downward
C			JGD1		Force exact match on names
C-
	SUBROUTINE CHECK_UAF(Cname,Ilength,Is_Found,Ierror)
	LOGICAL*1 Is_Found				! If user found
	CHARACTER*12  Cname				! User name
	CHARACTER*256 CSTRING				! Data buffer

	OPEN(UNIT=1,NAME='SYS$SYSTEM:SYSUAF.DAT',	! The UAF
     -		     STATUS='OLD',			!   is an OLD file
     -		     READONLY,				!   with read only
     -		     SHARED,				!   shared access
     -		     ORGANIZATION='INDEXED',		!   Indexed and will
     -		     RECORDTYPE='VARIABLE',		!   search via the
     -		     ACCESS='KEYED',			!   first key
     -		     KEY=(1:12:CHARACTER),		!   the user's name
     -		     ERR=9900)				! Exit on error
	CALL Upper_Case(Cname(1:Ilength))		! Make upper case
	READ(UNIT=1,KEYEQ=cname(1:Ilength),		! Unformatted read
     -              KEYID=0,				! on key 0
     -              ERR  =9020) CSTRING			! Error -> key not fnd
	IF(Ilength.LT.12)Cname(Ilength+1:12)=' '	! Pad with spaces  JGD1
	IF(Cname(1:12).NE.Cstring(1:12)) GOTO 9020	! Force exact matchJGD1
	CLOSE(UNIT=1)					! Close SYSUAF.DAT
	Is_found=1					! User found
	RETURN						! Done
9020	Is_Found=0					! User not found
	CLOSE(Unit=1)					! Close SYSUAF.DAT
	Ierror=0					! SYSUAF.DAT opened ok
	RETURN						! Done
9900	Ierror=-1					! Error opening file
	RETURN						!
	END						!

C+
C  Display_Users
C
C	Subroutine to display all current users in the VAX account
C	file.  No check is made as to whether or not the users can
C	receive mail (ie they have adequate disk quota) or that the
C	'user' is not a phantom account present to let accounting work
C	more smoothly.  If the account file can not be opened, Ier=-1
C	is returned.  Otherwise, Ier=0
C
C		CALL Display_Users(Ier)
C-
	SUBROUTINE Display_Users(Ier)
	CHARACTER*12	Cname			! User name
	CHARACTER*80	Outline			! Output line
	CHARACTER*256	CSTRING			! Data buffer
	INTEGER*2	Igrp(2),Imem(2)		! Group, member of uic
	INTEGER*4	Igroup,Imember		! Group, member of UIC
	EQUIVALENCE	(Igroup,Igrp(1))	! make equivalent
	EQUIVALENCE	(Imember,Imem(1))	!
C
C .. Implied FORM='UNFORMATTED'
C
	OPEN(UNIT=1,				! Open the System Account
     -		     NAME='SYS$SYSTEM:SYSUAF.DAT',! file
     -		     STATUS='OLD',		! It must exit
     -		     READONLY,			! we can only read it
     -		     SHARED,			!   as a shared file
     -		     ORGANIZATION='INDEXED',	! It is indexed with
     -		     RECORDTYPE='VARIABLE',	!  variable length records
     -		     ACCESS='KEYED',		!  access it by keys
     -		     KEY=(1:12:CHARACTER),	! First key is user name
     -		     ERR=9900)			! In case we can't open file
	Idx=1					!
	Outline=' '				! Fill line with blanks
10	READ(UNIT=1,END=9020)CSTRING		! Read till end of file
 	Ipos=INDEX(CSTRING(1:12),'NETPRIV')	! Skip DECNET
 	IF(Ipos.GT.0)			GOTO 10	!   "    "
 	Ipos=INDEX(Cstring(1:12),'NETNONPRIV')	!   "    "
	IF(Ipos.GT.0)			GOTO 10	!   "    "
	Igrp(1)=ICHAR(CSTRING(31:31))		!
	Igrp(2)=ICHAR(CSTRING(32:32))		!
	IF(Igroup.LE.10)		GOTO 10	! No display if system
	Imem(1)=ICHAR(CSTRING(29:29))		!
	Imem(2)=ICHAR(CSTRING(30:30))		!
	Iptr=1+(Idx-1)*15			!
	Outline(Iptr:Iptr+12)=CString(1:12)	!
	IF(Idx.EQ.5)			THEN	!
	   WRITE(*,30)OUTLINE			!
30	   FORMAT(' 'A)				!
	   Outline=' '				!
	   Idx=0				!
	END IF					!
	Idx=Idx+1				!
	GOTO 10					!
9020	IF(Idx.GT.1) WRITE(*,30)Outline		!
	CLOSE(UNIT=1)				! Always close file
	Ier=0					! Show success
	RETURN					!
9900	Ier=-1					! Fatal, can't open acnt file
	RETURN					!
	END					!

