$! Create JCL for tape transfer file
$	VER='F$VERIFY(0)'			!
$	SET NOON				! Don't abort on errors
$	TESTFILE SYS$SYSDEVICE:[SYSUTL]AVATU.EXE!
$	IF $STATUS .NE.1 THEN GOTO AVATU_MISSING
$	Mounted="F"				! Assume tape not mounted
$	Option=""				! No option selected
$	Process_Flag="F"			! No need to process, yet
$	ON CONTROL_Y THEN GOTO Clean_UP		! Clean up on ^Y
$	Menu="Start"				!
$	Return:="START"				! Subroutine return point
$	GOTO Set_Escape_Symbols			! Set up escape sequences
$Start:						!
$	PAGE
$	TYPE SYS$INPUT
[0;0H[?5l #4[7m                                      [0m
 #3[7m [0m The VAX/IBM Tape Transfer Facility [0;7m [0m
 #4[7m [0m The VAX/IBM Tape Transfer Facility [0;7m [0m
  [7m                                 V1.02                                      [0m



You may choose:
		[1mR[0mead        -    Read tape with files written by IBM
		[1mW[0mrite       -    Write tape with files to transfer to IBM
		[1mE[0mxit        -    Exit menu and use VAX directly
		[1m<ret>[0m       -    Return to the main menu
		[7;4mPF2[0m         -    HELP 
		[7mPF4[0m         -    VPW Command Screen
$Function_1:					! prompt
$	ASK/UPPER Choice "''EraseL16'Choice: "	! for an allowed input
$Function_1A:					!
$	Option[0,1]:='Choice'
$	Option2[0,2]:='Choice'
$	IF Choice  .EQS. ""        THEN GOTO Clean_Up
$	IF Option  .EQS. ""     THEN GOTO Check_Escape_Seq
$	IF Option  .EQS. "E"         THEN GOTO Clean_Up
$	IF Option  .EQS. "H"	     THEN GOTO Get_HELP
$	IF Option  .EQS. "W"         THEN GOTO VAX_To_IBM
$	IF Option  .EQS. "R"	     THEN GOTO IBM_To_VAX
$	IF Option  .EQS. " "	     THEN GOTO Clean_Up
$	WRITE SYS$OUTPUT "''EraseL23'''Bold'''Choice'''No_bold' is not a valid choice, try again"
$	GOTO Function_1				! Function not found, reprompt
$Check_Escape_Seq:				! Got Escape seq, which one
$	IF Choice .EQS. "OS" -		!
			THEN GOTO Command_Screen! If PF4, goto command screen
$	IF Choice .EQS. "OQ" -		! If PF2, goto HELP
			THEN GOTO Get_Help	!
$	GOTO 'Menu'				! Back to menu in any event
$Get_Help:
$	PAGE					!
$	ASSIGN/USER SYS$COMMAND SYS$INPUT	!
$	HELP/LIBRARY=SYS$VPWFILES:VPW TAPEXFER	!
$	WRITE SYS$OUTPUT "" 			!
$	ASK/UPPER RDY "Press RETURN to continue ..."
$	GOTO 'Menu'
$Command_Screen:				! Allow user to spawn off 
$	PAGE					!    commands
$	WRITE SYS$OUTPUT -
"[0;0H---------------- VPW Command Screen (Type Control-Z to exit) ------------------"
$	WRITE SYS$OUTPUT "[3;24r[2;1H"! Establish limited scroll reg
$	@SYS$SYSVPWFILES:VPWCMDPAG.COM		! start up cmd proc to spawn
$	WRITE SYS$OUTPUT "[0;24r"		! restore terminal window
$	GOTO 'Menu'				! Back to menu

$VAX_to_IBM:					!
$	PAGE					! A clean slate
$	PDS="F"					! Not part. data set
$	TYPE SYS$INPUT
     Three types of VAX to IBM tapes can be generated depending on
whether you want:

	[1mD[0mataset  --  Place the files into a partitioned dataset
	[1mP[0mrint    --  Print files on IBM without saving
	[1mT[0mransfer --  Transfer files to individually named IBM files

$VAX_To_IBM_1:
$	ASK/UPPER Choice "''EraseL09'Choice: "	! for an allowed input
$	Option[0,1]:='Choice'			!
$	IF Choice  .EQS. ""        THEN GOTO Clean_Up
$	IF Option  .EQS. ""     THEN GOTO Check_Escape_Seq
$	IF Option  .EQS. "P"         THEN GOTO VAX_to_IBM_3
$	IF Option  .EQS. "T"	     THEN GOTO VAX_to_IBM_3
$	If Option  .EQS. "D"	     THEN GOTO VAX_to_IBM_2
$	IF Option  .EQS. " "	     THEN GOTO 'Menu'
$	WRITE SYS$OUTPUT "''EraseL23'''Bold'''Choice'''No_bold' is not a valid choice, try again"
$	GOTO VAX_to_IBM_1			! Function not found, reprompt
$Vax_to_IBM_2:					!
$	PDS="T"					! Show is partitioned data set
$	ASK/UPPER PDS_Name "''EraseL10'Enter IBM PDS Name (e.g.,JFM.DEC.FORT):  "
$	IF PDS_Name .EQS. ""    THEN GOTO Clean_Up
$	IF PDS_Name .EQS. ""     THEN GOTO Vax_to_IBM_2
$	Proc_Name="DECPDS"
$VAX_to_IBM_3:					!
$	IF Option .EQS."T" THEN Proc_Name="DECDISK"
$	IF Option .EQS."P" THEN Proc_Name="DECPRINT"
$	PAGE					!
$	TYPE SYS$INPUT
     The VAX/IBM transfer tape must now be mounted.  The process of placing
new data on the tape will erase any old data.  If the old data is important,
use a different tape.

$	ASK/UPPER RDY "Place a tape on MSA0:.  Press RETURN when ready"
$	IF RDY .EQS. ""        THEN GOTO Clean_Up
$	MOUNT MSA0:/FOR/NOASSIST		! Die if tape not ready
$	IF .NOT.$Status THEN GOTO Mount_Error	! clean up if problem
$	Mounted="T"				! Show we are mounted
$	WRITE SYS$OUTPUT ""			! Write out a header
$	Error_Flag="F"				! No error, so far
$	N=0					! 0 files xfered 
$	Vol_Ser=999999				! The IBM wants this value
$	OPEN/WRITE Outfile_1 AVATU.IBM		! This is AVATU command file
$	WRITE OUTFILE_1 "$RUN SYS$SYSDEVICE:[SYSUTL]AVATU"
$	WRITE OUTFILE_1 "1"			! VAX to IBM
$	WRITE OUTFILE_1	"YES"			! Initialize the tape
$	WRITE OUTFILE_1	"0"			! Tape unit 0
$	WRITE OUTFILE_1	"''Vol_Ser',"		! Set serial #
$	WRITE OUTFILE_1 "IBMJCL.DAT"		! infile and dataset name
$	WRITE OUTFILE_1 "IBMJCL.DAT"		! are the same
$	WRITE OUTFILE_1 "80"			! make blocked 80byte record
$	OPEN/WRITE Outfile_JCL IBMJCL.DAT	! start creating the JCL file
$	WRITE Outfile_JCL "//KMSDEC   JOB 340001,SYSP,MSGCLASS=A,CLASS=A"
$
$	WRITE SYS$OUTPUT ""			! Write out a header
$	WRITE SYS$OUTPUT -			!
"                      Select Files for Transfer to IBM"
$Get_file_name:					! 
$	IF Process_Flag  THEN WRITE SYS$OUTPUT "''EraseL22'"! clean off msg
$	READ/END=Clean_UP-			! Prompt for name
	/PROMPT="''EraseL15'File name (<CR> => done): " SYS$COMMAND File_Name
$	IF Error_Flag    THEN WRITE SYS$OUTPUT "''EraseL23'"! clean off old err
$	IF File_Name .EQS. "" THEN GOTO Close_Up! Give up if CR typed
$	Device="''F$PARSE(File_Name,,,"DEVICE")'"!
$	Device_OK="''F$GETDVI(Device,"EXISTS")'"! Is device real
$	IF .NOT. Device_OK THEN GOTO No_Such_Device
$	TMP=""					!
$	IPOS=F$LOCATE(";",File_Name)		! Version numbers are not 
$	IF IPOS.GE.F$LENGTH(File_Name) THEN GOTO Length_OK! allowed
$	WRITE SYS$OUTPUT -			! Catch them and warn user
"''EraseL23'Make_IBM_Tape -- Version numbers are not allowed"
$	Error_Flag="T"				! Show error found
$	GOTO Get_File_Name			!  and reprompt
$Length_OK:					!
$	File_Name="''File_Name'"+";0"		! Force only highest version
$LOOP:
$						! Find all files (if wildcards
$	File_spec="''F$SEARCH(File_name)'"	!  were used)
$	IF TMP.EQS.FILE_SPEC THEN -		! If .EQS. search is don
		GOTO Get_file_name 		!   so reprompt
$	TMP="''FILE_SPEC'"			! Start search at next pt
$	IF FILE_SPEC.EQS. "" THEN -		!
		GOTO Get_file_name 		! reprompt if done
$	NODE="''F$PARSE(FILE_SPEC,,,"NODE")'"	! 
$	Device="''F$PARSE(FILE_SPEC,,,"DEVICE")'"!
$	Devicex="''F$LOGICAL(Device)'"		!
$	IF Devicex.NES. "" THEN Device="''Devicex'"
$	Directory="''F$PARSE(FILE_SPEC,,,"DIRECTORY")'"
$	Name="''F$PARSE(FILE_SPEC,,,"NAME")'"	!
$	Name_2="''Name'"			!
$	Nam_len=F$LENGTH(NAME)			!
$	IF Nam_Len.LE.8 THEN GOTO GET_TYPE	!
$! Here we have a major system incompatability.  DEC file names
$! can be 9 (soon to be 39) characters long.  IBM names can be only
$! 8 characters long.  The following KLUDGE tries to insure that
$! the occasional file with a 9 character name still gets transfered
$! albeit with a strange IBM name.  Hence the IBM Name on transfer
$! will look like  <DEC_NAME>.<Overflow_characters>.TYPE where
$! <DEC_NAME> is the first 8 characters, and TYPE is the standard
$! FILES-11 file type.  Note.  Files must have a file type or the
$! IBM will not like the name.  This KLUDGE will also not work on
$! VMS V4.0 with names longer than 16 characters.
$	IF PDS THEN GOTO Name_Too_Long		!
$	NAME_2="''F$EXTRACT(0,8,NAME)'"+"."+"''F$EXTRACT(8,Nam_Len,Name)'"
$GET_TYPE:					! Parse name so 9 char DEC
$	FTYPE="''F$PARSE(FILE_SPEC,,,"TYPE")'"	!  name fits in IBM 8 char/name
$	DEC_Name="''Node'''Device'''Directory'''NAME'''FTYPE'"! convention
$	IBM_Name="''NAME_2'''FTYPE'"		! See above for explanation
$	IF PDS THEN IBM_Member="''NAME_2'"	! If going into a PDS ** PV02
$	TESTFILE 'DEC_Name'			! Be sure file exists or 
$	IF $STATUS.EQ.1 THEN GOTO File_Exists	! politely bomb out
$	WRITE SYS$OUTPUT -			!
"''EraseL23'Make_IBM_Tape -- ''Bold'''DEC_Name'''No_Bold' does not exist"
$	Error_Flag="T"				! No file, show error 
$	GOTO Get_File_Name			!	and reprompt
$Name_Too_Long:
$	WRITE SYS$OUTPUT -			!
"''EraseL22'Make_IBM_Tape -- Warning, name ''Bold'''Name'''No_Bold' is to long to transfer to a PDS"
$	WAIT 00:00:04				! Hang around awhile
$	Process_Flag="T"			! No file, show error 
$	GOTO Loop				!   and continue
$No_Such_Device:
$	WRITE SYS$OUTPUT -			!
"''EraseL23'Make_IBM_Tape -- Device ''Bold'''Device'''No_Bold' does not exist"
$	Error_Flag="T"				! No file, show error 
$	GOTO Get_File_Name			!	and reprompt
$File_Exists:					! File exist, add it to
$	WRITE SYS$OUTPUT -			!  the JCL for the tape
"''EraseL22'Make_IBM_Tape -- Processing ''Bold'''DEC_Name'''No_Bold'"
$	Process_Flag="T"			! Show we got one to add
$	IF N.EQ.0 THEN  N=N+1			!
$	WRITE Outfile_1 "''DEC_Name'"		!
$	WRITE Outfile_1 "''IBM_Name'"		!
$	WRITE Outfile_1 "512"			! 512 bytes/block
$						! Generalize procedure **PV02+
$	WRITE Outfile_JCL "//STEP''N'     EXEC ''Proc_Name',DSN='",''IBM_NAME',"'," 
$	IF PDS THEN WRITE Outfile_JCL "//             PDS=''PDS_Name',"
$	IF PDS THEN WRITE Outfile_JCL "//             MEMBER=''IBM_Member',"
$						! 			**PV02-
$	WRITE Outfile_JCL "//             VOLSER=''Vol_Ser',"
$	N=N+1					!
$	WRITE OUTFILE_JCL "//             FILE=''N'"
$	GOTO Loop				!
$Close_UP:					!
$	WRITE Outfile_1 "$EXIT"			!
$	CLOSE Outfile_1				!
$	CLOSE Outfile_JCL			!
$! Now convert to 80 byte fixed length records (Make IBM happy)
$! Actually, they would be far happier if all the files transfered 
$! were so converted.  However, enough is enough.  The records will be
$! padded with spaces at the end.  Note, that I can see a situation in
$! which the DEC name got so long that the JCL record might exceed 80 
$! characters.  Motto:  Keep the names short but sweet.
$	CONVERT/FDL=SYS$SYSVPWFILES:FIXEDSIZ.FDL/PAD=%O40 IBMJCL.DAT IBMJCL.DAT
$	SET MESSAGE/NOTEXT/NOIDENT/NOFACILITY/NOSEVERITY
$	PURGE AVATU.IBM,IBMJCL.*		!
$	WRITE SYS$OUTPUT " "			!
$	WRITE SYS$OUTPUT "Starting Transfer of Files to Tape"
$	@AVATU.IBM				! Stick files on tape
$	IF Mounted THEN DISMOUNT MSA0:/NOUNLOAD	!
$	WRITE SYS$OUTPUT ""
$	WRITE SYS$OUTPUT "File Transfer Complete"! all done
$	WRITE SYS$OUTPUT "Please remove the tape from the tape drive"
$	WRITE SYS$OUTPUT "Give the tape to the IBM operator."
$	WAIT 00:00:04				! Let user see msg
$	PRINT/DELETE/NOIDENT IBMJCL.DAT		!
$	DELETE AVATU.IBM;*			!
$	SET MESSAGE/TEXT/IDENT/FACILITY/SEVERITY!
$	GOTO START				! Back for more
$IBM_To_VAX:					!
$	PAGE					! A clean slate
$	TYPE SYS$INPUT
     The IBM/VAX transfer tape must now be mounted. Tapes created with
     IEBGENER on the IBM side are known to transfer correctly.
     The tape must have been written as a 1600 BPI tape by the IBM.

$	ASK/UPPER RDY "Place a tape on MSA0:.  Press RETURN when ready"
$	IF RDY .EQS. ""        THEN GOTO Clean_Up
$	MOUNT MSA0:/FOR/NOASSIST		! Die if tape not ready
$	IF .NOT.$Status THEN GOTO Mount_Error	! clean up if problem
$	Mounted="T"				! Show we are mounted
$	WRITE SYS$OUTPUT ""			! Write out a header
$	WRITE SYS$OUTPUT -			!
"                      Select Files for Transfer to the VAX"
$	WRITE SYS$OUTPUT ""
$	ASSIGN/USER SYS$COMMAND SYS$INPUT
$	RUN SYS$SYSDEVICE:[SYSUTL]AVATU
$	IF Mounted THEN DISMOUNT MSA0:/NOUNLOAD	!
$	WRITE SYS$OUTPUT ""
$	WRITE SYS$OUTPUT "File Transfer Complete"! all done
$	WRITE SYS$OUTPUT "Please remove the tape from the tape drive"
$	WAIT 00:00:04				! Let user see msg
$	GOTO Start
$Clean_UP:
$	PAGE
$	SET NOCONTROL_Y
$	SET MESSAGE/NOTEXT/NOIDENT/NOFACILITY/NOSEVERITY
$	Close Outfile_1
$	CLOSE Outfile_JCL
$	IF Mounted THEN DISMOUNT MSA0:/NOUNLOAD
$	DELETE IBMJCL.DAT;*,AVATU.IBM;*
$	SET MESSAGE/TEXT/IDENT/FACILITY/SEVERITY
$	SET CONTROL_Y
$	Ver='F$VERIFY(Ver)'
$	IF Option .EQS. "E" THEN STOP
$	EXIT
$Mount_Error:
$	PAGE 
$	Type SYS$INPUT

	The tape did not mount.  Either the tape is new and has never
been initialized, or the tape was not correctly mounted on the tape
drive.  If the tape is new, get an operator to initialize it for you.
Otherwise, check to see if the tape is correctly threaded in the tape
drive, and that the proper buttons were pushed to load the tape and to
place it on line.

$	INQUIRE Again "Do you wish to try again [Y/N]"
$	IF Again THEN GOTO Start
$	GOTO Clean_Up
$Set_Escape_Symbols:
$	IF Terminal_Type .NES. "VT100" THEN GOTO Not_VT100
$	VT100="T"
$	EraseL01="[01;1H[2K"
$	EraseL02="[02;1H[2K"
$	EraseL03="[03;1H[2K"
$	EraseL04="[04;1H[2K"
$	EraseL05="[05;1H[2K"
$	EraseL06="[06;1H[2K"
$	EraseL07="[07;1H[2K"
$	EraseL08="[08;1H[2K"
$	EraseL09="[09;1H[2K"
$	EraseL10="[10;1H[2K"
$	EraseL11="[11;1H[2K"
$	EraseL12="[12;1H[2K"
$	EraseL13="[13;1H[2K"
$	EraseL14="[14;1H[2K"
$	EraseL15="[15;1H[2K"
$	EraseL16="[16;1H[2K"
$	EraseL17="[17;1H[2K"
$	EraseL18="[18;1H[2K"
$	EraseL19="[19;1H[2K"
$	EraseL20="[20;1H[2K"
$	EraseL21="[21;1H[2K"
$	EraseL22="[22;1H[2K"
$	EraseL23="[23;1H[2K"
$	PositL01="[01;1H"
$	PositL02="[02;1H"
$	PositL03="[03;1H"
$	PositL04="[04;1H"
$	PositL05="[05;1H"
$	PositL06="[06;1H"
$	PositL07="[07;1H"
$	PositL08="[08;1H"
$	PositL09="[09;1H"
$	PositL10="[10;1H"
$	PositL11="[11;1H"
$	PositL12="[12;1H"
$	PositL13="[13;1H"
$	PositL14="[14;1H"
$	PositL15="[15;1H"
$	PositL16="[16;1H"
$	PositL17="[17;1H"
$	PositL18="[18;1H"
$	PositL19="[19;1H"
$	PositL20="[20;1H"
$	PositL21="[21;1H"
$	PositL22="[22;1H"
$	PositL23="[23;1H"
$	Bold="[1m"
$	No_Bold="[0m"
$	Clear_Window:="[5;0H[J"		! clear line 5 to bot
$	GOTO 'Return'
$Not_VT100:
$	VT100="F"
$	EraseL01=""
$	EraseL02=""
$	EraseL03=""
$	EraseL04=""
$	EraseL05=""
$	EraseL06=""
$	EraseL07=""
$	EraseL08=""
$	EraseL09=""
$	EraseL10=""
$	EraseL11=""
$	EraseL12=""
$	EraseL13=""
$	EraseL14=""
$	EraseL15=""
$	EraseL16=""
$	EraseL17=""
$	EraseL18=""
$	EraseL19=""
$	EraseL20=""
$	EraseL21=""
$	EraseL22=""
$	EraseL23=""
$	PositL01=""
$	PositL02=""
$	PositL03=""
$	PositL04=""
$	PositL05=""
$	PositL06=""
$	PositL07=""
$	PositL08=""
$	PositL09=""
$	PositL10=""
$	PositL11=""
$	PositL12=""
$	PositL13=""
$	PositL14=""
$	PositL15=""
$	PositL16=""
$	PositL17=""
$	PositL18=""
$	PositL19=""
$	PositL20=""
$	PositL21=""
$	PositL22=""
$	PositL23=""
$	Bold=""
$	No_Bold=""
$	Clear_Window:=""		! Dummy out
$	GOTO 'Return'
$AVATU_Missing:
$	PAGE
$	TYPE SYS$INPUT



		AVATU.EXE IS MISSING

TAPEXFER.COM requires that SYS$SYSDEVICE:[SYSUTL]AVATU.EXE exist.
Please find out where it went, and put have it put back!!



$	wait 00:00:04
$	EXIT
$!
$!  File Name:  TAPEXFER
$!  Author:	James G. Downward
$!  Date:	07-June-1983
$!  Function:	Provide a facility to transfer data via 9-track 1600 bpi
$!		tapes between the IBM and the VAX machines.  This routine
$!		uses the AVATU tape utility as modified to pass blank lines.
$!
$!  Modified:	
$!		14-OCT-1983 - P.Vavra - **PV02
$!			      Permit selection of IBM procedure for files.
$!			      Transfer for printing, transfer as individual
$!			      files, or place into a Partitioned Data Set
$!			      (PDS).
$!
$!		18-Oct-1983   J. Downward
$!			      Fix bugs.  Trap invalid device names. Add
$!			      control-Z exits.  Use menu for write mode
$!			      selection.  Disallow file names longer than
$!			      eight characters for partitioned data sets.
