ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c									c
			Program Send
c									c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c	Purpose : This little utility is used to send broadcast
c		messages to other terminals. It's chief purpose
c		is to allow communication with non-VT100 terminals.
c
c	History : SEND was originally a DECUS submission (I think...)
c		and has been extensively modified to the point that
c		it resembles the original version only in title and
c		basic function.
c
c			Dave Cook
c		Ball Aerospace Systems Division
c			23-Aug-82
c
	implicit integer (a - z)

	external	ss$_normal
	external	cli$_present, cli$_defaulted
	external	jpi$_username, jpi$_curpriv
	external	prv$v_bypass
	external	brdcst$m_screen, brdcst$m_bottom
	external	brdcst$m_refrsh

	character	message*200, from*50
	character	input*12	/'SYS$INPUT:'/
	character*12	term, temp, tran, userbuf, pid
	character	timebuf*8
	integer		priv_mask(2)

	logical		anon, dialog, bell, cont_line, term_qual

	integer*2	item_list2(14)
	integer*4	item_list4(7)
	equivalence	(item_list2, item_list4)

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c									c
c	Get the terminal to send to first, since if it is invalid,
c	there is no point in continuing with this farce.
c									c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c	Check for PID qualifier present which overrides terminal spec.
c
	istat = cli$present ('identification')
	if (istat .eq. %loc(cli$_present)) then
	   call cli$get_value ('identification', pid)
	   np = nblank (pid)
	   read (pid(1:np), 3000) jpid
3000	   format (z8)
	   if (.not. get_pid (jpid, term)) then
	      type *, pid,' is not logged on the system.'
	      stop ' '
	   end if
	   len1 = nblank (term)
	   term_qual = .true.
	else
	   term_qual = .false.
	end if
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c									c
c	If no identification qualifier, P1 is the terminal.
c									c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

	if (.not. term_qual) then
	   istat = cli$present ('param1')
	   if (istat .eq. %loc(cli$_present)) then
	      call cli$get_value ('param1', term)
	      len1 = nblank (term)
	   else
50	      type 1010
1010	      format ('$To: ')
	      accept 2000, len1, term
	      if (len1 .eq. 0) go to 50
	      call str$upcase (term, term)
	   end if

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c									c
c	See if username specified instead of terminal name.
c		Convert to terminal name if so.
c									c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

	   if ( (term(1:2) .ne. 'TT') .and.
	1	(term(1:2) .ne. 'OP') .and.
	2	(term(1:1) .ne. '_' ) ) then
	      if (.not. get_term (term, temp)) then
	         type *, term(1:len1),' is not logged on the system.'
	         go to 999
	      end if
	   else
	      call logtrans (term, temp, len1)
	   end if
	   term = temp
	   len1 = nblank (term)
	end if

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c									c
c	Terminal spec is ok, now form the banner message.
c									c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c	Form Get_jpi item list.
c
	item_list2(1) = 12
	item_list2(2) = %loc(jpi$_username)
	item_list4(2) = %loc(userbuf)
	item_list4(3) = 0

	item_list2(7) = 8
	item_list2(8) = %loc(jpi$_curpriv)
	item_list4(5) = %loc(priv_mask)
	item_list4(6) = 0

	item_list4(7) = 0
c
c	Get our username to send along to the other guy.
c
	call iferr ( sys$getjpi(,,,item_list2,,,),
	1	'Getjpi error.')
c
c	Translate our terminal name to send also.
c
	call iferr ( logtrans (input, tran, length),
	1	'Logtrans error.')
c
c	Form the banner message.
c
	from = '	From '//tran(1:length)
	1	//'  '//userbuf//'    '
	nf = nblank (from) + 4
c
c	Prepare the broadcast modifiers.
c
c	Add  %val(flags) to the sys$brdcst call
c	if going to DEC_CRT's only.
c
c1	flags = (4 .or. %loc(brdcst$m_screen)) .and.
c1	1	( .not. %loc(brdcst$m_refrsh))

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c									c
c		Now go for the qualifiers.
c									c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

	istat = cli$present ('anonymous')
	if (istat .eq. %loc(cli$_present)) then
c
c	The requirements for anon privledge are current bypass
c	and not being an operator (for example, OPER_TIM).
c
	   ipriv = priv_mask(1) .and. 2**%loc(prv$v_bypass)
	   if ( (ipriv .ne. 0) .and.
	1	(userbuf(1:4) .ne. 'OPER')) anon = .true.
	else
	   anon = .false.
	end if

	istat = cli$present ('dialog')
	if (istat .eq. %loc(cli$_present)) then
	   dialog = .true.
	   type *,' Terminal in dialog mode to ',
	1	term(1:len1),' exit via a  ^Z'
	else
	   dialog = .false.
	end if

	istat = cli$present ('bell')
	if ( (istat .eq. %loc(cli$_present)) .or.
	1    (istat .eq. %loc(cli$_defaulted)) ) then
	   bell = .true.
	   from = char(7)//from
	   nf = nf + 1
	else
	   bell = .false.
	end if

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c									c
c			Parse off message part.
c	If identification qualifier is present, message is
c	first parameter, else P1 is terminal and p2 message
c									c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

	if (term_qual) then
	   istat = cli$present ('param1')
	   if (istat .eq. %loc(cli$_present)) then
	      call cli$get_value ('param1', message)
	      len2 = nblank (message)
	   else
c
c	No message present, go get it.
c
	      go to 100
	   end if
	else
	   istat = cli$present ('param2')
	   if (istat .eq. %loc(cli$_present)) then
	      call cli$get_value ('param2', message)
	      len2 = nblank (message)
	   else
c
c	No message present, go get it.
c
	      go to 100
	   end if
	end if
c
c	Enter with all info, send message immediately
c
	go to 200

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c									c
c			Main loop.
c									c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

100	continue
	type 1000
1000	format ('$Message: ')
	read (5, 2000, end = 999) len2, message
2000	format (q, a)
c
c	See if continuation line desired.
c		Get rid of + sign
c
200	if ((message(len2:len2) .eq. '+') .and.
	1	(dialog .ne. .true. ))
	2		then
	   len2 = len2 - 1
	   cont_line = .true.
	else
	   cont_line = .false.
	end if
c
c	See if conversational mode desired.
c	Get rid of * sign, if so.
c
	if ((message(len2:len2) .eq. '*') .and.
	1	(.not. dialog)) then
	   dialog = .true.
	   type *,' Terminal in dialog mode to ',
	1	term(1:len1),' exit via a  ^Z'
	   len2 = len2 - 1
	end if
c
c		Form the banner message.
c	Everything is already present except the current time.
c
	if (.not. anon) then
	   call time (timebuf)
	   from = from(1:nf)//timebuf
	   nff = nblank (from)
c
c		Send the message.
c
	   icode =  sys$brdcst (from(1:nff), term(1:len1))
	   if (icode .ne. %loc(ss$_normal)) then
	      type *,'Term = ', term(1:len1)
c1	      call iferr (icode,'Broadcast header error.')
	      call errmes (icode)
	      type *,'Broadcast header error.'
	   end if

	end if
c
c	Allow for bell if anon message
c
	if (anon .and. bell) then
	   message = char(7)//message
	   len2 = len2 + 1
	end if

	icode = sys$brdcst(message(1:len2), term(1:len1))
	   if (icode .ne. %loc(ss$_normal)) then
	      type *,'Term = ', term(1:len1)
c1	      call iferr (icode,'Broadcast message error.')
	      call errmes (icode)
	      type *,'Broadcast message error.'
	   end if
c
c	Loop for another line, else exit.
c
	if ((cont_line) .or. (dialog)) go to 100
c
c	Exit from dialog mode via ^Z comes to here.
c	End without stop statement so that no blank lines
c	are added upon program exit.
c
999	continue

	end
