CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C	STAT = DELAY( MILLISECONDS )
C	INTEGER*4 STAT, DELAY, MILLISECONDS
C
C	This procedure schedules a wakeup, then hibernates.
C
C	Notes:
C
C	1.	Since only the least significant longword of the delta
C		time buffer is used, the delay time can't be much greater
C		than about 7 minutes.  To achieve times longer than 3.5
C		minutes, it is necessary to compile with /ckeck=noover.
C
C	2.	Delta time is expressed in quadword which is a negative
C		number of 100-nanosecond units.
C
C	04-Oct-83 Jesse Black	Texas Instruments.
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
		! declaration.
	INTEGER*4 FUNCTION DELAY( MSEC )
	INTEGER*4 MSEC
		! externals.
	INTEGER*4 SYS$SCHDWK
		! internal stuff.
	INTEGER*4 DELTA(2), STAT, MILLISECONDS
		! begin function delay.
		! don't let time be negative.
	MILLISECONDS = MSEC
	IF ( MILLISECONDS .LT. 0 ) MILLISECONDS = 0
		! convert milliseconds (10^-3) to 100 nanoseconds (10^-7)
	DELTA(1) = -MILLISECONDS * 1000 * 10
	DELTA(2) = 0
		! sign-extend the longword through the rest of the quadword.
	IF ( MILLISECONDS .GT. 0 ) DELTA(2) = -1
		! schedule a wakeup for after the specified time.
	STAT = SYS$SCHDWK( , , DELTA, )
		! hibernate until wakeup.
	IF ( STAT ) CALL SYS$HIBER
		! return status code.
	DELAY = STAT
	RETURN
	END
